/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* DAG Instruction Selector for the WebAssembly target                        *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

// *** NOTE: This file is #included into the middle of the target
// *** instruction selector class.  These functions are really methods.

// If GET_DAGISEL_DECL is #defined with any value, only function
// declarations will be included when this file is included.
// If GET_DAGISEL_BODY is #defined, its value should be the name of
// the instruction selector class. Function bodies will be emitted
// and each function's name will be qualified with the name of the
// class.
//
// When neither of the GET_DAGISEL* macros is defined, the functions
// are emitted inline.

#if defined(GET_DAGISEL_DECL) && defined(GET_DAGISEL_BODY)
#error GET_DAGISEL_DECL and GET_DAGISEL_BODY cannot be both defined, undef both for inline definitions
#endif

#ifdef GET_DAGISEL_BODY
#define LOCAL_DAGISEL_STRINGIZE(X) LOCAL_DAGISEL_STRINGIZE_(X)
#define LOCAL_DAGISEL_STRINGIZE_(X) #X
static_assert(sizeof(LOCAL_DAGISEL_STRINGIZE(GET_DAGISEL_BODY)) > 1,
   "GET_DAGISEL_BODY is empty: it should be defined with the class name");
#undef LOCAL_DAGISEL_STRINGIZE_
#undef LOCAL_DAGISEL_STRINGIZE
#endif

#if !defined(GET_DAGISEL_DECL) && !defined(GET_DAGISEL_BODY)
#define DAGISEL_INLINE 1
#else
#define DAGISEL_INLINE 0
#endif

#if !DAGISEL_INLINE
#define DAGISEL_CLASS_COLONCOLON GET_DAGISEL_BODY ::
#else
#define DAGISEL_CLASS_COLONCOLON
#endif

#ifdef GET_DAGISEL_DECL
void SelectCode(SDNode *N);
#endif
#if defined(GET_DAGISEL_BODY) || DAGISEL_INLINE
void DAGISEL_CLASS_COLONCOLON SelectCode(SDNode *N)
{
  // Some target values are emitted as 2 bytes, TARGET_VAL handles
  // this.
  #define TARGET_VAL(X) X & 255, unsigned(X) >> 8
  static const unsigned char MatcherTable[] = {
/*     0*/ OPC_SwitchOpcode /*116 cases */, 5|128,11/*1413*/, TARGET_VAL(ISD::ZERO_EXTEND),// ->1418
/*     5*/  OPC_Scope, 120|128,10/*1400*/, /*->1408*/ // 2 children in Scope
/*     8*/   OPC_MoveChild0,
/*     9*/   OPC_SwitchOpcode /*9 cases */, 16|128,1/*144*/, TARGET_VAL(ISD::AssertZext),// ->158
/*    14*/    OPC_MoveChild0,
/*    15*/    OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_CMP_SWAP),
/*    18*/    OPC_RecordMemRef,
/*    19*/    OPC_RecordNode, // #0 = 'atomic_cmp_swap' chained node
/*    20*/    OPC_CheckFoldableChainNode,
/*    21*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*    22*/    OPC_Scope, 66, /*->90*/ // 2 children in Scope
/*    24*/     OPC_CheckChild1Type, MVT::i32,
/*    26*/     OPC_MoveChild2,
/*    27*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*    30*/     OPC_RecordChild0, // #2 = $exp
/*    31*/     OPC_MoveParent,
/*    32*/     OPC_MoveChild3,
/*    33*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*    36*/     OPC_RecordChild0, // #3 = $new
/*    37*/     OPC_MoveParent,
/*    38*/     OPC_Scope, 24, /*->64*/ // 2 children in Scope
/*    40*/      OPC_CheckPredicate, 0, // Predicate_atomic_cmp_swap_8
/*    42*/      OPC_MoveParent,
/*    43*/      OPC_MoveParent,
/*    44*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*    46*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*    49*/      OPC_EmitMergeInputChains1_0,
/*    50*/      OPC_EmitInteger, MVT::i32, 0, 
/*    53*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_8>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*    64*/     /*Scope*/ 24, /*->89*/
/*    65*/      OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_16
/*    67*/      OPC_MoveParent,
/*    68*/      OPC_MoveParent,
/*    69*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*    71*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*    74*/      OPC_EmitMergeInputChains1_0,
/*    75*/      OPC_EmitInteger, MVT::i32, 0, 
/*    78*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_16>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*    89*/     0, /*End of Scope*/
/*    90*/    /*Scope*/ 66, /*->157*/
/*    91*/     OPC_CheckChild1Type, MVT::i64,
/*    93*/     OPC_MoveChild2,
/*    94*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*    97*/     OPC_RecordChild0, // #2 = $exp
/*    98*/     OPC_MoveParent,
/*    99*/     OPC_MoveChild3,
/*   100*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   103*/     OPC_RecordChild0, // #3 = $new
/*   104*/     OPC_MoveParent,
/*   105*/     OPC_Scope, 24, /*->131*/ // 2 children in Scope
/*   107*/      OPC_CheckPredicate, 0, // Predicate_atomic_cmp_swap_8
/*   109*/      OPC_MoveParent,
/*   110*/      OPC_MoveParent,
/*   111*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   113*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*   116*/      OPC_EmitMergeInputChains1_0,
/*   117*/      OPC_EmitInteger, MVT::i32, 0, 
/*   120*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_8>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*   131*/     /*Scope*/ 24, /*->156*/
/*   132*/      OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_16
/*   134*/      OPC_MoveParent,
/*   135*/      OPC_MoveParent,
/*   136*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   138*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*   141*/      OPC_EmitMergeInputChains1_0,
/*   142*/      OPC_EmitInteger, MVT::i32, 0, 
/*   145*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_16>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*   156*/     0, /*End of Scope*/
/*   157*/    0, /*End of Scope*/
/*   158*/   /*SwitchOpcode*/ 81, TARGET_VAL(ISD::ATOMIC_CMP_SWAP),// ->242
/*   161*/    OPC_RecordMemRef,
/*   162*/    OPC_RecordNode, // #0 = 'atomic_cmp_swap' chained node
/*   163*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*   164*/    OPC_Scope, 37, /*->203*/ // 2 children in Scope
/*   166*/     OPC_CheckChild1Type, MVT::i32,
/*   168*/     OPC_MoveChild2,
/*   169*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   172*/     OPC_RecordChild0, // #2 = $exp
/*   173*/     OPC_MoveParent,
/*   174*/     OPC_MoveChild3,
/*   175*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   178*/     OPC_RecordChild0, // #3 = $new
/*   179*/     OPC_MoveParent,
/*   180*/     OPC_CheckPredicate, 2, // Predicate_atomic_cmp_swap_32
/*   182*/     OPC_MoveParent,
/*   183*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   185*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*   188*/     OPC_EmitMergeInputChains1_0,
/*   189*/     OPC_EmitInteger, MVT::i32, 0, 
/*   192*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i64, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (zext:{ *:[i64] } (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_32>>) - Complexity = 22
               // Dst: (ATOMIC_RMW32_U_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*   203*/    /*Scope*/ 37, /*->241*/
/*   204*/     OPC_CheckChild1Type, MVT::i64,
/*   206*/     OPC_MoveChild2,
/*   207*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   210*/     OPC_RecordChild0, // #2 = $exp
/*   211*/     OPC_MoveParent,
/*   212*/     OPC_MoveChild3,
/*   213*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   216*/     OPC_RecordChild0, // #3 = $new
/*   217*/     OPC_MoveParent,
/*   218*/     OPC_CheckPredicate, 2, // Predicate_atomic_cmp_swap_32
/*   220*/     OPC_MoveParent,
/*   221*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   223*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*   226*/     OPC_EmitMergeInputChains1_0,
/*   227*/     OPC_EmitInteger, MVT::i32, 0, 
/*   230*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i64, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (zext:{ *:[i64] } (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_32>>) - Complexity = 22
               // Dst: (ATOMIC_RMW32_U_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*   241*/    0, /*End of Scope*/
/*   242*/   /*SwitchOpcode*/ 37|128,1/*165*/, TARGET_VAL(ISD::ATOMIC_LOAD_ADD),// ->411
/*   246*/    OPC_RecordMemRef,
/*   247*/    OPC_RecordNode, // #0 = 'atomic_load_add' chained node
/*   248*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*   249*/    OPC_Scope, 79, /*->330*/ // 2 children in Scope
/*   251*/     OPC_CheckChild1Type, MVT::i32,
/*   253*/     OPC_MoveChild2,
/*   254*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   257*/     OPC_RecordChild0, // #2 = $val
/*   258*/     OPC_MoveParent,
/*   259*/     OPC_Scope, 22, /*->283*/ // 3 children in Scope
/*   261*/      OPC_CheckPredicate, 0, // Predicate_atomic_load_add_8
/*   263*/      OPC_MoveParent,
/*   264*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   266*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   269*/      OPC_EmitMergeInputChains1_0,
/*   270*/      OPC_EmitInteger, MVT::i32, 0, 
/*   273*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   283*/     /*Scope*/ 22, /*->306*/
/*   284*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_add_16
/*   286*/      OPC_MoveParent,
/*   287*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   289*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   292*/      OPC_EmitMergeInputChains1_0,
/*   293*/      OPC_EmitInteger, MVT::i32, 0, 
/*   296*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   306*/     /*Scope*/ 22, /*->329*/
/*   307*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_add_32
/*   309*/      OPC_MoveParent,
/*   310*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   312*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   315*/      OPC_EmitMergeInputChains1_0,
/*   316*/      OPC_EmitInteger, MVT::i32, 0, 
/*   319*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   329*/     0, /*End of Scope*/
/*   330*/    /*Scope*/ 79, /*->410*/
/*   331*/     OPC_CheckChild1Type, MVT::i64,
/*   333*/     OPC_MoveChild2,
/*   334*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   337*/     OPC_RecordChild0, // #2 = $val
/*   338*/     OPC_MoveParent,
/*   339*/     OPC_Scope, 22, /*->363*/ // 3 children in Scope
/*   341*/      OPC_CheckPredicate, 0, // Predicate_atomic_load_add_8
/*   343*/      OPC_MoveParent,
/*   344*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   346*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   349*/      OPC_EmitMergeInputChains1_0,
/*   350*/      OPC_EmitInteger, MVT::i32, 0, 
/*   353*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   363*/     /*Scope*/ 22, /*->386*/
/*   364*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_add_16
/*   366*/      OPC_MoveParent,
/*   367*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   369*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   372*/      OPC_EmitMergeInputChains1_0,
/*   373*/      OPC_EmitInteger, MVT::i32, 0, 
/*   376*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   386*/     /*Scope*/ 22, /*->409*/
/*   387*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_add_32
/*   389*/      OPC_MoveParent,
/*   390*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   392*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   395*/      OPC_EmitMergeInputChains1_0,
/*   396*/      OPC_EmitInteger, MVT::i32, 0, 
/*   399*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   409*/     0, /*End of Scope*/
/*   410*/    0, /*End of Scope*/
/*   411*/   /*SwitchOpcode*/ 37|128,1/*165*/, TARGET_VAL(ISD::ATOMIC_LOAD_SUB),// ->580
/*   415*/    OPC_RecordMemRef,
/*   416*/    OPC_RecordNode, // #0 = 'atomic_load_sub' chained node
/*   417*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*   418*/    OPC_Scope, 79, /*->499*/ // 2 children in Scope
/*   420*/     OPC_CheckChild1Type, MVT::i32,
/*   422*/     OPC_MoveChild2,
/*   423*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   426*/     OPC_RecordChild0, // #2 = $val
/*   427*/     OPC_MoveParent,
/*   428*/     OPC_Scope, 22, /*->452*/ // 3 children in Scope
/*   430*/      OPC_CheckPredicate, 0, // Predicate_atomic_load_sub_8
/*   432*/      OPC_MoveParent,
/*   433*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   435*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   438*/      OPC_EmitMergeInputChains1_0,
/*   439*/      OPC_EmitInteger, MVT::i32, 0, 
/*   442*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   452*/     /*Scope*/ 22, /*->475*/
/*   453*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_16
/*   455*/      OPC_MoveParent,
/*   456*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   458*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   461*/      OPC_EmitMergeInputChains1_0,
/*   462*/      OPC_EmitInteger, MVT::i32, 0, 
/*   465*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   475*/     /*Scope*/ 22, /*->498*/
/*   476*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_sub_32
/*   478*/      OPC_MoveParent,
/*   479*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   481*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   484*/      OPC_EmitMergeInputChains1_0,
/*   485*/      OPC_EmitInteger, MVT::i32, 0, 
/*   488*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   498*/     0, /*End of Scope*/
/*   499*/    /*Scope*/ 79, /*->579*/
/*   500*/     OPC_CheckChild1Type, MVT::i64,
/*   502*/     OPC_MoveChild2,
/*   503*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   506*/     OPC_RecordChild0, // #2 = $val
/*   507*/     OPC_MoveParent,
/*   508*/     OPC_Scope, 22, /*->532*/ // 3 children in Scope
/*   510*/      OPC_CheckPredicate, 0, // Predicate_atomic_load_sub_8
/*   512*/      OPC_MoveParent,
/*   513*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   515*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   518*/      OPC_EmitMergeInputChains1_0,
/*   519*/      OPC_EmitInteger, MVT::i32, 0, 
/*   522*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   532*/     /*Scope*/ 22, /*->555*/
/*   533*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_16
/*   535*/      OPC_MoveParent,
/*   536*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   538*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   541*/      OPC_EmitMergeInputChains1_0,
/*   542*/      OPC_EmitInteger, MVT::i32, 0, 
/*   545*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   555*/     /*Scope*/ 22, /*->578*/
/*   556*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_sub_32
/*   558*/      OPC_MoveParent,
/*   559*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   561*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   564*/      OPC_EmitMergeInputChains1_0,
/*   565*/      OPC_EmitInteger, MVT::i32, 0, 
/*   568*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   578*/     0, /*End of Scope*/
/*   579*/    0, /*End of Scope*/
/*   580*/   /*SwitchOpcode*/ 37|128,1/*165*/, TARGET_VAL(ISD::ATOMIC_LOAD_AND),// ->749
/*   584*/    OPC_RecordMemRef,
/*   585*/    OPC_RecordNode, // #0 = 'atomic_load_and' chained node
/*   586*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*   587*/    OPC_Scope, 79, /*->668*/ // 2 children in Scope
/*   589*/     OPC_CheckChild1Type, MVT::i32,
/*   591*/     OPC_MoveChild2,
/*   592*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   595*/     OPC_RecordChild0, // #2 = $val
/*   596*/     OPC_MoveParent,
/*   597*/     OPC_Scope, 22, /*->621*/ // 3 children in Scope
/*   599*/      OPC_CheckPredicate, 0, // Predicate_atomic_load_and_8
/*   601*/      OPC_MoveParent,
/*   602*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   604*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   607*/      OPC_EmitMergeInputChains1_0,
/*   608*/      OPC_EmitInteger, MVT::i32, 0, 
/*   611*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   621*/     /*Scope*/ 22, /*->644*/
/*   622*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_and_16
/*   624*/      OPC_MoveParent,
/*   625*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   627*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   630*/      OPC_EmitMergeInputChains1_0,
/*   631*/      OPC_EmitInteger, MVT::i32, 0, 
/*   634*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   644*/     /*Scope*/ 22, /*->667*/
/*   645*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_and_32
/*   647*/      OPC_MoveParent,
/*   648*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   650*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   653*/      OPC_EmitMergeInputChains1_0,
/*   654*/      OPC_EmitInteger, MVT::i32, 0, 
/*   657*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   667*/     0, /*End of Scope*/
/*   668*/    /*Scope*/ 79, /*->748*/
/*   669*/     OPC_CheckChild1Type, MVT::i64,
/*   671*/     OPC_MoveChild2,
/*   672*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   675*/     OPC_RecordChild0, // #2 = $val
/*   676*/     OPC_MoveParent,
/*   677*/     OPC_Scope, 22, /*->701*/ // 3 children in Scope
/*   679*/      OPC_CheckPredicate, 0, // Predicate_atomic_load_and_8
/*   681*/      OPC_MoveParent,
/*   682*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   684*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   687*/      OPC_EmitMergeInputChains1_0,
/*   688*/      OPC_EmitInteger, MVT::i32, 0, 
/*   691*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   701*/     /*Scope*/ 22, /*->724*/
/*   702*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_and_16
/*   704*/      OPC_MoveParent,
/*   705*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   707*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   710*/      OPC_EmitMergeInputChains1_0,
/*   711*/      OPC_EmitInteger, MVT::i32, 0, 
/*   714*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   724*/     /*Scope*/ 22, /*->747*/
/*   725*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_and_32
/*   727*/      OPC_MoveParent,
/*   728*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   730*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   733*/      OPC_EmitMergeInputChains1_0,
/*   734*/      OPC_EmitInteger, MVT::i32, 0, 
/*   737*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   747*/     0, /*End of Scope*/
/*   748*/    0, /*End of Scope*/
/*   749*/   /*SwitchOpcode*/ 37|128,1/*165*/, TARGET_VAL(ISD::ATOMIC_LOAD_OR),// ->918
/*   753*/    OPC_RecordMemRef,
/*   754*/    OPC_RecordNode, // #0 = 'atomic_load_or' chained node
/*   755*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*   756*/    OPC_Scope, 79, /*->837*/ // 2 children in Scope
/*   758*/     OPC_CheckChild1Type, MVT::i32,
/*   760*/     OPC_MoveChild2,
/*   761*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   764*/     OPC_RecordChild0, // #2 = $val
/*   765*/     OPC_MoveParent,
/*   766*/     OPC_Scope, 22, /*->790*/ // 3 children in Scope
/*   768*/      OPC_CheckPredicate, 0, // Predicate_atomic_load_or_8
/*   770*/      OPC_MoveParent,
/*   771*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   773*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   776*/      OPC_EmitMergeInputChains1_0,
/*   777*/      OPC_EmitInteger, MVT::i32, 0, 
/*   780*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   790*/     /*Scope*/ 22, /*->813*/
/*   791*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_or_16
/*   793*/      OPC_MoveParent,
/*   794*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   796*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   799*/      OPC_EmitMergeInputChains1_0,
/*   800*/      OPC_EmitInteger, MVT::i32, 0, 
/*   803*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   813*/     /*Scope*/ 22, /*->836*/
/*   814*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_or_32
/*   816*/      OPC_MoveParent,
/*   817*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   819*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   822*/      OPC_EmitMergeInputChains1_0,
/*   823*/      OPC_EmitInteger, MVT::i32, 0, 
/*   826*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   836*/     0, /*End of Scope*/
/*   837*/    /*Scope*/ 79, /*->917*/
/*   838*/     OPC_CheckChild1Type, MVT::i64,
/*   840*/     OPC_MoveChild2,
/*   841*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   844*/     OPC_RecordChild0, // #2 = $val
/*   845*/     OPC_MoveParent,
/*   846*/     OPC_Scope, 22, /*->870*/ // 3 children in Scope
/*   848*/      OPC_CheckPredicate, 0, // Predicate_atomic_load_or_8
/*   850*/      OPC_MoveParent,
/*   851*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   853*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   856*/      OPC_EmitMergeInputChains1_0,
/*   857*/      OPC_EmitInteger, MVT::i32, 0, 
/*   860*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   870*/     /*Scope*/ 22, /*->893*/
/*   871*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_or_16
/*   873*/      OPC_MoveParent,
/*   874*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   876*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   879*/      OPC_EmitMergeInputChains1_0,
/*   880*/      OPC_EmitInteger, MVT::i32, 0, 
/*   883*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   893*/     /*Scope*/ 22, /*->916*/
/*   894*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_or_32
/*   896*/      OPC_MoveParent,
/*   897*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   899*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   902*/      OPC_EmitMergeInputChains1_0,
/*   903*/      OPC_EmitInteger, MVT::i32, 0, 
/*   906*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   916*/     0, /*End of Scope*/
/*   917*/    0, /*End of Scope*/
/*   918*/   /*SwitchOpcode*/ 37|128,1/*165*/, TARGET_VAL(ISD::ATOMIC_LOAD_XOR),// ->1087
/*   922*/    OPC_RecordMemRef,
/*   923*/    OPC_RecordNode, // #0 = 'atomic_load_xor' chained node
/*   924*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*   925*/    OPC_Scope, 79, /*->1006*/ // 2 children in Scope
/*   927*/     OPC_CheckChild1Type, MVT::i32,
/*   929*/     OPC_MoveChild2,
/*   930*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   933*/     OPC_RecordChild0, // #2 = $val
/*   934*/     OPC_MoveParent,
/*   935*/     OPC_Scope, 22, /*->959*/ // 3 children in Scope
/*   937*/      OPC_CheckPredicate, 0, // Predicate_atomic_load_xor_8
/*   939*/      OPC_MoveParent,
/*   940*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   942*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   945*/      OPC_EmitMergeInputChains1_0,
/*   946*/      OPC_EmitInteger, MVT::i32, 0, 
/*   949*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   959*/     /*Scope*/ 22, /*->982*/
/*   960*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_16
/*   962*/      OPC_MoveParent,
/*   963*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   965*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   968*/      OPC_EmitMergeInputChains1_0,
/*   969*/      OPC_EmitInteger, MVT::i32, 0, 
/*   972*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   982*/     /*Scope*/ 22, /*->1005*/
/*   983*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_xor_32
/*   985*/      OPC_MoveParent,
/*   986*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   988*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   991*/      OPC_EmitMergeInputChains1_0,
/*   992*/      OPC_EmitInteger, MVT::i32, 0, 
/*   995*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1005*/     0, /*End of Scope*/
/*  1006*/    /*Scope*/ 79, /*->1086*/
/*  1007*/     OPC_CheckChild1Type, MVT::i64,
/*  1009*/     OPC_MoveChild2,
/*  1010*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1013*/     OPC_RecordChild0, // #2 = $val
/*  1014*/     OPC_MoveParent,
/*  1015*/     OPC_Scope, 22, /*->1039*/ // 3 children in Scope
/*  1017*/      OPC_CheckPredicate, 0, // Predicate_atomic_load_xor_8
/*  1019*/      OPC_MoveParent,
/*  1020*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1022*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1025*/      OPC_EmitMergeInputChains1_0,
/*  1026*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1029*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1039*/     /*Scope*/ 22, /*->1062*/
/*  1040*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_16
/*  1042*/      OPC_MoveParent,
/*  1043*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1045*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1048*/      OPC_EmitMergeInputChains1_0,
/*  1049*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1052*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1062*/     /*Scope*/ 22, /*->1085*/
/*  1063*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_xor_32
/*  1065*/      OPC_MoveParent,
/*  1066*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1068*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1071*/      OPC_EmitMergeInputChains1_0,
/*  1072*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1075*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1085*/     0, /*End of Scope*/
/*  1086*/    0, /*End of Scope*/
/*  1087*/   /*SwitchOpcode*/ 37|128,1/*165*/, TARGET_VAL(ISD::ATOMIC_SWAP),// ->1256
/*  1091*/    OPC_RecordMemRef,
/*  1092*/    OPC_RecordNode, // #0 = 'atomic_swap' chained node
/*  1093*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1094*/    OPC_Scope, 79, /*->1175*/ // 2 children in Scope
/*  1096*/     OPC_CheckChild1Type, MVT::i32,
/*  1098*/     OPC_MoveChild2,
/*  1099*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1102*/     OPC_RecordChild0, // #2 = $val
/*  1103*/     OPC_MoveParent,
/*  1104*/     OPC_Scope, 22, /*->1128*/ // 3 children in Scope
/*  1106*/      OPC_CheckPredicate, 0, // Predicate_atomic_swap_8
/*  1108*/      OPC_MoveParent,
/*  1109*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1111*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1114*/      OPC_EmitMergeInputChains1_0,
/*  1115*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1118*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1128*/     /*Scope*/ 22, /*->1151*/
/*  1129*/      OPC_CheckPredicate, 1, // Predicate_atomic_swap_16
/*  1131*/      OPC_MoveParent,
/*  1132*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1134*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1137*/      OPC_EmitMergeInputChains1_0,
/*  1138*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1141*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1151*/     /*Scope*/ 22, /*->1174*/
/*  1152*/      OPC_CheckPredicate, 2, // Predicate_atomic_swap_32
/*  1154*/      OPC_MoveParent,
/*  1155*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1157*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1160*/      OPC_EmitMergeInputChains1_0,
/*  1161*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1164*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1174*/     0, /*End of Scope*/
/*  1175*/    /*Scope*/ 79, /*->1255*/
/*  1176*/     OPC_CheckChild1Type, MVT::i64,
/*  1178*/     OPC_MoveChild2,
/*  1179*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1182*/     OPC_RecordChild0, // #2 = $val
/*  1183*/     OPC_MoveParent,
/*  1184*/     OPC_Scope, 22, /*->1208*/ // 3 children in Scope
/*  1186*/      OPC_CheckPredicate, 0, // Predicate_atomic_swap_8
/*  1188*/      OPC_MoveParent,
/*  1189*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1191*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1194*/      OPC_EmitMergeInputChains1_0,
/*  1195*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1198*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1208*/     /*Scope*/ 22, /*->1231*/
/*  1209*/      OPC_CheckPredicate, 1, // Predicate_atomic_swap_16
/*  1211*/      OPC_MoveParent,
/*  1212*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1214*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1217*/      OPC_EmitMergeInputChains1_0,
/*  1218*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1221*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1231*/     /*Scope*/ 22, /*->1254*/
/*  1232*/      OPC_CheckPredicate, 2, // Predicate_atomic_swap_32
/*  1234*/      OPC_MoveParent,
/*  1235*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1237*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1240*/      OPC_EmitMergeInputChains1_0,
/*  1241*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1244*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1254*/     0, /*End of Scope*/
/*  1255*/    0, /*End of Scope*/
/*  1256*/   /*SwitchOpcode*/ 19|128,1/*147*/, TARGET_VAL(ISD::ATOMIC_LOAD),// ->1407
/*  1260*/    OPC_RecordMemRef,
/*  1261*/    OPC_RecordNode, // #0 = 'atomic_load' chained node
/*  1262*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1263*/    OPC_Scope, 70, /*->1335*/ // 2 children in Scope
/*  1265*/     OPC_CheckChild1Type, MVT::i32,
/*  1267*/     OPC_Scope, 21, /*->1290*/ // 3 children in Scope
/*  1269*/      OPC_CheckPredicate, 0, // Predicate_atomic_load_8
/*  1271*/      OPC_MoveParent,
/*  1272*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  1274*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  1277*/      OPC_EmitMergeInputChains1_0,
/*  1278*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1281*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_8>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD8_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  1290*/     /*Scope*/ 21, /*->1312*/
/*  1291*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_16
/*  1293*/      OPC_MoveParent,
/*  1294*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  1296*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  1299*/      OPC_EmitMergeInputChains1_0,
/*  1300*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1303*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_16>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD16_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  1312*/     /*Scope*/ 21, /*->1334*/
/*  1313*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_32
/*  1315*/      OPC_MoveParent,
/*  1316*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  1318*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  1321*/      OPC_EmitMergeInputChains1_0,
/*  1322*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1325*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD32_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_32>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD32_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  1334*/     0, /*End of Scope*/
/*  1335*/    /*Scope*/ 70, /*->1406*/
/*  1336*/     OPC_CheckChild1Type, MVT::i64,
/*  1338*/     OPC_Scope, 21, /*->1361*/ // 3 children in Scope
/*  1340*/      OPC_CheckPredicate, 0, // Predicate_atomic_load_8
/*  1342*/      OPC_MoveParent,
/*  1343*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  1345*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  1348*/      OPC_EmitMergeInputChains1_0,
/*  1349*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1352*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_8>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD8_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  1361*/     /*Scope*/ 21, /*->1383*/
/*  1362*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_16
/*  1364*/      OPC_MoveParent,
/*  1365*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  1367*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  1370*/      OPC_EmitMergeInputChains1_0,
/*  1371*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1374*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_16>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD16_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  1383*/     /*Scope*/ 21, /*->1405*/
/*  1384*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_32
/*  1386*/      OPC_MoveParent,
/*  1387*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  1389*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  1392*/      OPC_EmitMergeInputChains1_0,
/*  1393*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1396*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD32_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_32>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD32_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  1405*/     0, /*End of Scope*/
/*  1406*/    0, /*End of Scope*/
/*  1407*/   0, // EndSwitchOpcode
/*  1408*/  /*Scope*/ 8, /*->1417*/
/*  1409*/   OPC_RecordChild0, // #0 = $src
/*  1410*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I64_EXTEND_U_I32), 0,
                 MVT::i64, 1/*#Ops*/, 0, 
             // Src: (zext:{ *:[i64] } I32:{ *:[i32] }:$src) - Complexity = 3
             // Dst: (I64_EXTEND_U_I32:{ *:[i64] } I32:{ *:[i32] }:$src)
/*  1417*/  0, /*End of Scope*/
/*  1418*/ /*SwitchOpcode*/ 106|128,7/*1002*/, TARGET_VAL(ISD::ANY_EXTEND),// ->2424
/*  1422*/  OPC_Scope, 93|128,7/*989*/, /*->2414*/ // 2 children in Scope
/*  1425*/   OPC_MoveChild0,
/*  1426*/   OPC_SwitchOpcode /*8 cases */, 16|128,1/*144*/, TARGET_VAL(ISD::AssertZext),// ->1575
/*  1431*/    OPC_MoveChild0,
/*  1432*/    OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_CMP_SWAP),
/*  1435*/    OPC_RecordMemRef,
/*  1436*/    OPC_RecordNode, // #0 = 'atomic_cmp_swap' chained node
/*  1437*/    OPC_CheckFoldableChainNode,
/*  1438*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1439*/    OPC_Scope, 66, /*->1507*/ // 2 children in Scope
/*  1441*/     OPC_CheckChild1Type, MVT::i32,
/*  1443*/     OPC_MoveChild2,
/*  1444*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1447*/     OPC_RecordChild0, // #2 = $exp
/*  1448*/     OPC_MoveParent,
/*  1449*/     OPC_MoveChild3,
/*  1450*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1453*/     OPC_RecordChild0, // #3 = $new
/*  1454*/     OPC_MoveParent,
/*  1455*/     OPC_Scope, 24, /*->1481*/ // 2 children in Scope
/*  1457*/      OPC_CheckPredicate, 0, // Predicate_atomic_cmp_swap_8
/*  1459*/      OPC_MoveParent,
/*  1460*/      OPC_MoveParent,
/*  1461*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1463*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  1466*/      OPC_EmitMergeInputChains1_0,
/*  1467*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1470*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_8>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*  1481*/     /*Scope*/ 24, /*->1506*/
/*  1482*/      OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_16
/*  1484*/      OPC_MoveParent,
/*  1485*/      OPC_MoveParent,
/*  1486*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1488*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  1491*/      OPC_EmitMergeInputChains1_0,
/*  1492*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1495*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_16>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*  1506*/     0, /*End of Scope*/
/*  1507*/    /*Scope*/ 66, /*->1574*/
/*  1508*/     OPC_CheckChild1Type, MVT::i64,
/*  1510*/     OPC_MoveChild2,
/*  1511*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1514*/     OPC_RecordChild0, // #2 = $exp
/*  1515*/     OPC_MoveParent,
/*  1516*/     OPC_MoveChild3,
/*  1517*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1520*/     OPC_RecordChild0, // #3 = $new
/*  1521*/     OPC_MoveParent,
/*  1522*/     OPC_Scope, 24, /*->1548*/ // 2 children in Scope
/*  1524*/      OPC_CheckPredicate, 0, // Predicate_atomic_cmp_swap_8
/*  1526*/      OPC_MoveParent,
/*  1527*/      OPC_MoveParent,
/*  1528*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1530*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  1533*/      OPC_EmitMergeInputChains1_0,
/*  1534*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1537*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_8>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*  1548*/     /*Scope*/ 24, /*->1573*/
/*  1549*/      OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_16
/*  1551*/      OPC_MoveParent,
/*  1552*/      OPC_MoveParent,
/*  1553*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1555*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  1558*/      OPC_EmitMergeInputChains1_0,
/*  1559*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1562*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_16>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*  1573*/     0, /*End of Scope*/
/*  1574*/    0, /*End of Scope*/
/*  1575*/   /*SwitchOpcode*/ 119, TARGET_VAL(ISD::ATOMIC_LOAD_ADD),// ->1697
/*  1578*/    OPC_RecordMemRef,
/*  1579*/    OPC_RecordNode, // #0 = 'atomic_load_add' chained node
/*  1580*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1581*/    OPC_Scope, 56, /*->1639*/ // 2 children in Scope
/*  1583*/     OPC_CheckChild1Type, MVT::i32,
/*  1585*/     OPC_MoveChild2,
/*  1586*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1589*/     OPC_RecordChild0, // #2 = $val
/*  1590*/     OPC_MoveParent,
/*  1591*/     OPC_Scope, 22, /*->1615*/ // 2 children in Scope
/*  1593*/      OPC_CheckPredicate, 0, // Predicate_atomic_load_add_8
/*  1595*/      OPC_MoveParent,
/*  1596*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1598*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1601*/      OPC_EmitMergeInputChains1_0,
/*  1602*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1605*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1615*/     /*Scope*/ 22, /*->1638*/
/*  1616*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_add_16
/*  1618*/      OPC_MoveParent,
/*  1619*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1621*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1624*/      OPC_EmitMergeInputChains1_0,
/*  1625*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1628*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1638*/     0, /*End of Scope*/
/*  1639*/    /*Scope*/ 56, /*->1696*/
/*  1640*/     OPC_CheckChild1Type, MVT::i64,
/*  1642*/     OPC_MoveChild2,
/*  1643*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1646*/     OPC_RecordChild0, // #2 = $val
/*  1647*/     OPC_MoveParent,
/*  1648*/     OPC_Scope, 22, /*->1672*/ // 2 children in Scope
/*  1650*/      OPC_CheckPredicate, 0, // Predicate_atomic_load_add_8
/*  1652*/      OPC_MoveParent,
/*  1653*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1655*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1658*/      OPC_EmitMergeInputChains1_0,
/*  1659*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1662*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1672*/     /*Scope*/ 22, /*->1695*/
/*  1673*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_add_16
/*  1675*/      OPC_MoveParent,
/*  1676*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1678*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1681*/      OPC_EmitMergeInputChains1_0,
/*  1682*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1685*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1695*/     0, /*End of Scope*/
/*  1696*/    0, /*End of Scope*/
/*  1697*/   /*SwitchOpcode*/ 119, TARGET_VAL(ISD::ATOMIC_LOAD_SUB),// ->1819
/*  1700*/    OPC_RecordMemRef,
/*  1701*/    OPC_RecordNode, // #0 = 'atomic_load_sub' chained node
/*  1702*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1703*/    OPC_Scope, 56, /*->1761*/ // 2 children in Scope
/*  1705*/     OPC_CheckChild1Type, MVT::i32,
/*  1707*/     OPC_MoveChild2,
/*  1708*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1711*/     OPC_RecordChild0, // #2 = $val
/*  1712*/     OPC_MoveParent,
/*  1713*/     OPC_Scope, 22, /*->1737*/ // 2 children in Scope
/*  1715*/      OPC_CheckPredicate, 0, // Predicate_atomic_load_sub_8
/*  1717*/      OPC_MoveParent,
/*  1718*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1720*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1723*/      OPC_EmitMergeInputChains1_0,
/*  1724*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1727*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1737*/     /*Scope*/ 22, /*->1760*/
/*  1738*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_16
/*  1740*/      OPC_MoveParent,
/*  1741*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1743*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1746*/      OPC_EmitMergeInputChains1_0,
/*  1747*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1750*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1760*/     0, /*End of Scope*/
/*  1761*/    /*Scope*/ 56, /*->1818*/
/*  1762*/     OPC_CheckChild1Type, MVT::i64,
/*  1764*/     OPC_MoveChild2,
/*  1765*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1768*/     OPC_RecordChild0, // #2 = $val
/*  1769*/     OPC_MoveParent,
/*  1770*/     OPC_Scope, 22, /*->1794*/ // 2 children in Scope
/*  1772*/      OPC_CheckPredicate, 0, // Predicate_atomic_load_sub_8
/*  1774*/      OPC_MoveParent,
/*  1775*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1777*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1780*/      OPC_EmitMergeInputChains1_0,
/*  1781*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1784*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1794*/     /*Scope*/ 22, /*->1817*/
/*  1795*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_16
/*  1797*/      OPC_MoveParent,
/*  1798*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1800*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1803*/      OPC_EmitMergeInputChains1_0,
/*  1804*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1807*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1817*/     0, /*End of Scope*/
/*  1818*/    0, /*End of Scope*/
/*  1819*/   /*SwitchOpcode*/ 119, TARGET_VAL(ISD::ATOMIC_LOAD_AND),// ->1941
/*  1822*/    OPC_RecordMemRef,
/*  1823*/    OPC_RecordNode, // #0 = 'atomic_load_and' chained node
/*  1824*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1825*/    OPC_Scope, 56, /*->1883*/ // 2 children in Scope
/*  1827*/     OPC_CheckChild1Type, MVT::i32,
/*  1829*/     OPC_MoveChild2,
/*  1830*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1833*/     OPC_RecordChild0, // #2 = $val
/*  1834*/     OPC_MoveParent,
/*  1835*/     OPC_Scope, 22, /*->1859*/ // 2 children in Scope
/*  1837*/      OPC_CheckPredicate, 0, // Predicate_atomic_load_and_8
/*  1839*/      OPC_MoveParent,
/*  1840*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1842*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1845*/      OPC_EmitMergeInputChains1_0,
/*  1846*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1849*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1859*/     /*Scope*/ 22, /*->1882*/
/*  1860*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_and_16
/*  1862*/      OPC_MoveParent,
/*  1863*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1865*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1868*/      OPC_EmitMergeInputChains1_0,
/*  1869*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1872*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1882*/     0, /*End of Scope*/
/*  1883*/    /*Scope*/ 56, /*->1940*/
/*  1884*/     OPC_CheckChild1Type, MVT::i64,
/*  1886*/     OPC_MoveChild2,
/*  1887*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1890*/     OPC_RecordChild0, // #2 = $val
/*  1891*/     OPC_MoveParent,
/*  1892*/     OPC_Scope, 22, /*->1916*/ // 2 children in Scope
/*  1894*/      OPC_CheckPredicate, 0, // Predicate_atomic_load_and_8
/*  1896*/      OPC_MoveParent,
/*  1897*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1899*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1902*/      OPC_EmitMergeInputChains1_0,
/*  1903*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1906*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1916*/     /*Scope*/ 22, /*->1939*/
/*  1917*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_and_16
/*  1919*/      OPC_MoveParent,
/*  1920*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1922*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1925*/      OPC_EmitMergeInputChains1_0,
/*  1926*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1929*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1939*/     0, /*End of Scope*/
/*  1940*/    0, /*End of Scope*/
/*  1941*/   /*SwitchOpcode*/ 119, TARGET_VAL(ISD::ATOMIC_LOAD_OR),// ->2063
/*  1944*/    OPC_RecordMemRef,
/*  1945*/    OPC_RecordNode, // #0 = 'atomic_load_or' chained node
/*  1946*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1947*/    OPC_Scope, 56, /*->2005*/ // 2 children in Scope
/*  1949*/     OPC_CheckChild1Type, MVT::i32,
/*  1951*/     OPC_MoveChild2,
/*  1952*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1955*/     OPC_RecordChild0, // #2 = $val
/*  1956*/     OPC_MoveParent,
/*  1957*/     OPC_Scope, 22, /*->1981*/ // 2 children in Scope
/*  1959*/      OPC_CheckPredicate, 0, // Predicate_atomic_load_or_8
/*  1961*/      OPC_MoveParent,
/*  1962*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1964*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1967*/      OPC_EmitMergeInputChains1_0,
/*  1968*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1971*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1981*/     /*Scope*/ 22, /*->2004*/
/*  1982*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_or_16
/*  1984*/      OPC_MoveParent,
/*  1985*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1987*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1990*/      OPC_EmitMergeInputChains1_0,
/*  1991*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1994*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  2004*/     0, /*End of Scope*/
/*  2005*/    /*Scope*/ 56, /*->2062*/
/*  2006*/     OPC_CheckChild1Type, MVT::i64,
/*  2008*/     OPC_MoveChild2,
/*  2009*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  2012*/     OPC_RecordChild0, // #2 = $val
/*  2013*/     OPC_MoveParent,
/*  2014*/     OPC_Scope, 22, /*->2038*/ // 2 children in Scope
/*  2016*/      OPC_CheckPredicate, 0, // Predicate_atomic_load_or_8
/*  2018*/      OPC_MoveParent,
/*  2019*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  2021*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  2024*/      OPC_EmitMergeInputChains1_0,
/*  2025*/      OPC_EmitInteger, MVT::i32, 0, 
/*  2028*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  2038*/     /*Scope*/ 22, /*->2061*/
/*  2039*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_or_16
/*  2041*/      OPC_MoveParent,
/*  2042*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  2044*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  2047*/      OPC_EmitMergeInputChains1_0,
/*  2048*/      OPC_EmitInteger, MVT::i32, 0, 
/*  2051*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  2061*/     0, /*End of Scope*/
/*  2062*/    0, /*End of Scope*/
/*  2063*/   /*SwitchOpcode*/ 119, TARGET_VAL(ISD::ATOMIC_LOAD_XOR),// ->2185
/*  2066*/    OPC_RecordMemRef,
/*  2067*/    OPC_RecordNode, // #0 = 'atomic_load_xor' chained node
/*  2068*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  2069*/    OPC_Scope, 56, /*->2127*/ // 2 children in Scope
/*  2071*/     OPC_CheckChild1Type, MVT::i32,
/*  2073*/     OPC_MoveChild2,
/*  2074*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  2077*/     OPC_RecordChild0, // #2 = $val
/*  2078*/     OPC_MoveParent,
/*  2079*/     OPC_Scope, 22, /*->2103*/ // 2 children in Scope
/*  2081*/      OPC_CheckPredicate, 0, // Predicate_atomic_load_xor_8
/*  2083*/      OPC_MoveParent,
/*  2084*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  2086*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  2089*/      OPC_EmitMergeInputChains1_0,
/*  2090*/      OPC_EmitInteger, MVT::i32, 0, 
/*  2093*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  2103*/     /*Scope*/ 22, /*->2126*/
/*  2104*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_16
/*  2106*/      OPC_MoveParent,
/*  2107*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  2109*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  2112*/      OPC_EmitMergeInputChains1_0,
/*  2113*/      OPC_EmitInteger, MVT::i32, 0, 
/*  2116*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  2126*/     0, /*End of Scope*/
/*  2127*/    /*Scope*/ 56, /*->2184*/
/*  2128*/     OPC_CheckChild1Type, MVT::i64,
/*  2130*/     OPC_MoveChild2,
/*  2131*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  2134*/     OPC_RecordChild0, // #2 = $val
/*  2135*/     OPC_MoveParent,
/*  2136*/     OPC_Scope, 22, /*->2160*/ // 2 children in Scope
/*  2138*/      OPC_CheckPredicate, 0, // Predicate_atomic_load_xor_8
/*  2140*/      OPC_MoveParent,
/*  2141*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  2143*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  2146*/      OPC_EmitMergeInputChains1_0,
/*  2147*/      OPC_EmitInteger, MVT::i32, 0, 
/*  2150*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  2160*/     /*Scope*/ 22, /*->2183*/
/*  2161*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_16
/*  2163*/      OPC_MoveParent,
/*  2164*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  2166*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  2169*/      OPC_EmitMergeInputChains1_0,
/*  2170*/      OPC_EmitInteger, MVT::i32, 0, 
/*  2173*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  2183*/     0, /*End of Scope*/
/*  2184*/    0, /*End of Scope*/
/*  2185*/   /*SwitchOpcode*/ 119, TARGET_VAL(ISD::ATOMIC_SWAP),// ->2307
/*  2188*/    OPC_RecordMemRef,
/*  2189*/    OPC_RecordNode, // #0 = 'atomic_swap' chained node
/*  2190*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  2191*/    OPC_Scope, 56, /*->2249*/ // 2 children in Scope
/*  2193*/     OPC_CheckChild1Type, MVT::i32,
/*  2195*/     OPC_MoveChild2,
/*  2196*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  2199*/     OPC_RecordChild0, // #2 = $val
/*  2200*/     OPC_MoveParent,
/*  2201*/     OPC_Scope, 22, /*->2225*/ // 2 children in Scope
/*  2203*/      OPC_CheckPredicate, 0, // Predicate_atomic_swap_8
/*  2205*/      OPC_MoveParent,
/*  2206*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  2208*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  2211*/      OPC_EmitMergeInputChains1_0,
/*  2212*/      OPC_EmitInteger, MVT::i32, 0, 
/*  2215*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  2225*/     /*Scope*/ 22, /*->2248*/
/*  2226*/      OPC_CheckPredicate, 1, // Predicate_atomic_swap_16
/*  2228*/      OPC_MoveParent,
/*  2229*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  2231*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  2234*/      OPC_EmitMergeInputChains1_0,
/*  2235*/      OPC_EmitInteger, MVT::i32, 0, 
/*  2238*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  2248*/     0, /*End of Scope*/
/*  2249*/    /*Scope*/ 56, /*->2306*/
/*  2250*/     OPC_CheckChild1Type, MVT::i64,
/*  2252*/     OPC_MoveChild2,
/*  2253*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  2256*/     OPC_RecordChild0, // #2 = $val
/*  2257*/     OPC_MoveParent,
/*  2258*/     OPC_Scope, 22, /*->2282*/ // 2 children in Scope
/*  2260*/      OPC_CheckPredicate, 0, // Predicate_atomic_swap_8
/*  2262*/      OPC_MoveParent,
/*  2263*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  2265*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  2268*/      OPC_EmitMergeInputChains1_0,
/*  2269*/      OPC_EmitInteger, MVT::i32, 0, 
/*  2272*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  2282*/     /*Scope*/ 22, /*->2305*/
/*  2283*/      OPC_CheckPredicate, 1, // Predicate_atomic_swap_16
/*  2285*/      OPC_MoveParent,
/*  2286*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  2288*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  2291*/      OPC_EmitMergeInputChains1_0,
/*  2292*/      OPC_EmitInteger, MVT::i32, 0, 
/*  2295*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  2305*/     0, /*End of Scope*/
/*  2306*/    0, /*End of Scope*/
/*  2307*/   /*SwitchOpcode*/ 103, TARGET_VAL(ISD::ATOMIC_LOAD),// ->2413
/*  2310*/    OPC_RecordMemRef,
/*  2311*/    OPC_RecordNode, // #0 = 'atomic_load' chained node
/*  2312*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  2313*/    OPC_Scope, 48, /*->2363*/ // 2 children in Scope
/*  2315*/     OPC_CheckChild1Type, MVT::i32,
/*  2317*/     OPC_Scope, 21, /*->2340*/ // 2 children in Scope
/*  2319*/      OPC_CheckPredicate, 0, // Predicate_atomic_load_8
/*  2321*/      OPC_MoveParent,
/*  2322*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  2324*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  2327*/      OPC_EmitMergeInputChains1_0,
/*  2328*/      OPC_EmitInteger, MVT::i32, 0, 
/*  2331*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_8>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD8_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  2340*/     /*Scope*/ 21, /*->2362*/
/*  2341*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_16
/*  2343*/      OPC_MoveParent,
/*  2344*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  2346*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  2349*/      OPC_EmitMergeInputChains1_0,
/*  2350*/      OPC_EmitInteger, MVT::i32, 0, 
/*  2353*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_16>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD16_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  2362*/     0, /*End of Scope*/
/*  2363*/    /*Scope*/ 48, /*->2412*/
/*  2364*/     OPC_CheckChild1Type, MVT::i64,
/*  2366*/     OPC_Scope, 21, /*->2389*/ // 2 children in Scope
/*  2368*/      OPC_CheckPredicate, 0, // Predicate_atomic_load_8
/*  2370*/      OPC_MoveParent,
/*  2371*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  2373*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  2376*/      OPC_EmitMergeInputChains1_0,
/*  2377*/      OPC_EmitInteger, MVT::i32, 0, 
/*  2380*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_8>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD8_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  2389*/     /*Scope*/ 21, /*->2411*/
/*  2390*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_16
/*  2392*/      OPC_MoveParent,
/*  2393*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  2395*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  2398*/      OPC_EmitMergeInputChains1_0,
/*  2399*/      OPC_EmitInteger, MVT::i32, 0, 
/*  2402*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_16>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD16_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  2411*/     0, /*End of Scope*/
/*  2412*/    0, /*End of Scope*/
/*  2413*/   0, // EndSwitchOpcode
/*  2414*/  /*Scope*/ 8, /*->2423*/
/*  2415*/   OPC_RecordChild0, // #0 = $src
/*  2416*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I64_EXTEND_U_I32), 0,
                 MVT::i64, 1/*#Ops*/, 0, 
             // Src: (anyext:{ *:[i64] } I32:{ *:[i32] }:$src) - Complexity = 3
             // Dst: (I64_EXTEND_U_I32:{ *:[i64] } I32:{ *:[i32] }:$src)
/*  2423*/  0, /*End of Scope*/
/*  2424*/ /*SwitchOpcode*/ 106|128,8/*1130*/, TARGET_VAL(ISD::STORE),// ->3558
/*  2428*/  OPC_RecordMemRef,
/*  2429*/  OPC_RecordNode, // #0 = 'st' chained node
/*  2430*/  OPC_Scope, 59|128,2/*315*/, /*->2748*/ // 2 children in Scope
/*  2433*/   OPC_MoveChild1,
/*  2434*/   OPC_CheckOpcode, TARGET_VAL(ISD::EXTRACT_VECTOR_ELT),
/*  2437*/   OPC_RecordChild0, // #1 = $vec
/*  2438*/   OPC_Scope, 78, /*->2518*/ // 4 children in Scope
/*  2440*/    OPC_CheckChild0Type, MVT::v16i8,
/*  2442*/    OPC_RecordChild1, // #2 = $idx
/*  2443*/    OPC_MoveChild1,
/*  2444*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  2447*/    OPC_CheckPredicate, 3, // Predicate_LaneIdx16
/*  2449*/    OPC_CheckType, MVT::i32,
/*  2451*/    OPC_MoveParent,
/*  2452*/    OPC_CheckType, MVT::i32,
/*  2454*/    OPC_MoveParent,
/*  2455*/    OPC_RecordChild2, // #3 = $AddrOps32:offset:addr
/*  2456*/    OPC_Scope, 29, /*->2487*/ // 2 children in Scope
/*  2458*/     OPC_CheckChild2Type, MVT::i32,
/*  2460*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*  2462*/     OPC_CheckPredicate, 5, // Predicate_truncstore
/*  2464*/     OPC_CheckPredicate, 6, // Predicate_truncstorei8
/*  2466*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  2468*/     OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddrOperands32:$ #4 #5
/*  2471*/     OPC_EmitMergeInputChains1_0,
/*  2472*/     OPC_EmitInteger, MVT::i32, 0, 
/*  2475*/     OPC_EmitConvertToTarget, 2,
/*  2477*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I8x16_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx), (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 21
               // Dst: (STORE_LANE_I8x16_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v16i8] }:$vec)
/*  2487*/    /*Scope*/ 29, /*->2517*/
/*  2488*/     OPC_CheckChild2Type, MVT::i64,
/*  2490*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*  2492*/     OPC_CheckPredicate, 5, // Predicate_truncstore
/*  2494*/     OPC_CheckPredicate, 6, // Predicate_truncstorei8
/*  2496*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  2498*/     OPC_CheckComplexPat, /*CP*/1, /*#*/3, // SelectAddrOperands64:$ #4 #5
/*  2501*/     OPC_EmitMergeInputChains1_0,
/*  2502*/     OPC_EmitInteger, MVT::i32, 0, 
/*  2505*/     OPC_EmitConvertToTarget, 2,
/*  2507*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I8x16_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx), (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 21
               // Dst: (STORE_LANE_I8x16_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v16i8] }:$vec)
/*  2517*/    0, /*End of Scope*/
/*  2518*/   /*Scope*/ 78, /*->2597*/
/*  2519*/    OPC_CheckChild0Type, MVT::v8i16,
/*  2521*/    OPC_RecordChild1, // #2 = $idx
/*  2522*/    OPC_MoveChild1,
/*  2523*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  2526*/    OPC_CheckPredicate, 7, // Predicate_LaneIdx8
/*  2528*/    OPC_CheckType, MVT::i32,
/*  2530*/    OPC_MoveParent,
/*  2531*/    OPC_CheckType, MVT::i32,
/*  2533*/    OPC_MoveParent,
/*  2534*/    OPC_RecordChild2, // #3 = $AddrOps32:offset:addr
/*  2535*/    OPC_Scope, 29, /*->2566*/ // 2 children in Scope
/*  2537*/     OPC_CheckChild2Type, MVT::i32,
/*  2539*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*  2541*/     OPC_CheckPredicate, 5, // Predicate_truncstore
/*  2543*/     OPC_CheckPredicate, 8, // Predicate_truncstorei16
/*  2545*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  2547*/     OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddrOperands32:$ #4 #5
/*  2550*/     OPC_EmitMergeInputChains1_0,
/*  2551*/     OPC_EmitInteger, MVT::i32, 0, 
/*  2554*/     OPC_EmitConvertToTarget, 2,
/*  2556*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I16x8_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx), (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 21
               // Dst: (STORE_LANE_I16x8_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v8i16] }:$vec)
/*  2566*/    /*Scope*/ 29, /*->2596*/
/*  2567*/     OPC_CheckChild2Type, MVT::i64,
/*  2569*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*  2571*/     OPC_CheckPredicate, 5, // Predicate_truncstore
/*  2573*/     OPC_CheckPredicate, 8, // Predicate_truncstorei16
/*  2575*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  2577*/     OPC_CheckComplexPat, /*CP*/1, /*#*/3, // SelectAddrOperands64:$ #4 #5
/*  2580*/     OPC_EmitMergeInputChains1_0,
/*  2581*/     OPC_EmitInteger, MVT::i32, 0, 
/*  2584*/     OPC_EmitConvertToTarget, 2,
/*  2586*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I16x8_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx), (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 21
               // Dst: (STORE_LANE_I16x8_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v8i16] }:$vec)
/*  2596*/    0, /*End of Scope*/
/*  2597*/   /*Scope*/ 74, /*->2672*/
/*  2598*/    OPC_CheckChild0Type, MVT::v4i32,
/*  2600*/    OPC_RecordChild1, // #2 = $idx
/*  2601*/    OPC_MoveChild1,
/*  2602*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  2605*/    OPC_CheckPredicate, 9, // Predicate_LaneIdx4
/*  2607*/    OPC_CheckType, MVT::i32,
/*  2609*/    OPC_MoveParent,
/*  2610*/    OPC_CheckType, MVT::i32,
/*  2612*/    OPC_MoveParent,
/*  2613*/    OPC_RecordChild2, // #3 = $AddrOps32:offset:addr
/*  2614*/    OPC_Scope, 27, /*->2643*/ // 2 children in Scope
/*  2616*/     OPC_CheckChild2Type, MVT::i32,
/*  2618*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*  2620*/     OPC_CheckPredicate, 10, // Predicate_store
/*  2622*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  2624*/     OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddrOperands32:$ #4 #5
/*  2627*/     OPC_EmitMergeInputChains1_0,
/*  2628*/     OPC_EmitInteger, MVT::i32, 0, 
/*  2631*/     OPC_EmitConvertToTarget, 2,
/*  2633*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx), (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 21
               // Dst: (STORE_LANE_I32x4_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v4i32] }:$vec)
/*  2643*/    /*Scope*/ 27, /*->2671*/
/*  2644*/     OPC_CheckChild2Type, MVT::i64,
/*  2646*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*  2648*/     OPC_CheckPredicate, 10, // Predicate_store
/*  2650*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  2652*/     OPC_CheckComplexPat, /*CP*/1, /*#*/3, // SelectAddrOperands64:$ #4 #5
/*  2655*/     OPC_EmitMergeInputChains1_0,
/*  2656*/     OPC_EmitInteger, MVT::i32, 0, 
/*  2659*/     OPC_EmitConvertToTarget, 2,
/*  2661*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx), (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 21
               // Dst: (STORE_LANE_I32x4_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v4i32] }:$vec)
/*  2671*/    0, /*End of Scope*/
/*  2672*/   /*Scope*/ 74, /*->2747*/
/*  2673*/    OPC_CheckChild0Type, MVT::v2i64,
/*  2675*/    OPC_RecordChild1, // #2 = $idx
/*  2676*/    OPC_MoveChild1,
/*  2677*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  2680*/    OPC_CheckPredicate, 11, // Predicate_LaneIdx2
/*  2682*/    OPC_CheckType, MVT::i32,
/*  2684*/    OPC_MoveParent,
/*  2685*/    OPC_CheckType, MVT::i64,
/*  2687*/    OPC_MoveParent,
/*  2688*/    OPC_RecordChild2, // #3 = $AddrOps32:offset:addr
/*  2689*/    OPC_Scope, 27, /*->2718*/ // 2 children in Scope
/*  2691*/     OPC_CheckChild2Type, MVT::i32,
/*  2693*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*  2695*/     OPC_CheckPredicate, 10, // Predicate_store
/*  2697*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  2699*/     OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddrOperands32:$ #4 #5
/*  2702*/     OPC_EmitMergeInputChains1_0,
/*  2703*/     OPC_EmitInteger, MVT::i32, 0, 
/*  2706*/     OPC_EmitConvertToTarget, 2,
/*  2708*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx), (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 21
               // Dst: (STORE_LANE_I64x2_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v2i64] }:$vec)
/*  2718*/    /*Scope*/ 27, /*->2746*/
/*  2719*/     OPC_CheckChild2Type, MVT::i64,
/*  2721*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*  2723*/     OPC_CheckPredicate, 10, // Predicate_store
/*  2725*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  2727*/     OPC_CheckComplexPat, /*CP*/1, /*#*/3, // SelectAddrOperands64:$ #4 #5
/*  2730*/     OPC_EmitMergeInputChains1_0,
/*  2731*/     OPC_EmitInteger, MVT::i32, 0, 
/*  2734*/     OPC_EmitConvertToTarget, 2,
/*  2736*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx), (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 21
               // Dst: (STORE_LANE_I64x2_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v2i64] }:$vec)
/*  2746*/    0, /*End of Scope*/
/*  2747*/   0, /*End of Scope*/
/*  2748*/  /*Scope*/ 39|128,6/*807*/, /*->3557*/
/*  2750*/   OPC_RecordChild1, // #1 = $val
/*  2751*/   OPC_Scope, 27|128,1/*155*/, /*->2909*/ // 10 children in Scope
/*  2754*/    OPC_CheckChild1Type, MVT::i32,
/*  2756*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2757*/    OPC_Scope, 74, /*->2833*/ // 2 children in Scope
/*  2759*/     OPC_CheckChild2Type, MVT::i32,
/*  2761*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*  2763*/     OPC_Scope, 20, /*->2785*/ // 2 children in Scope
/*  2765*/      OPC_CheckPredicate, 10, // Predicate_store
/*  2767*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  2769*/      OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2772*/      OPC_EmitMergeInputChains1_0,
/*  2773*/      OPC_EmitInteger, MVT::i32, 0, 
/*  2776*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (st i32:{ *:[i32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
                // Dst: (STORE_I32_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/*  2785*/     /*Scope*/ 46, /*->2832*/
/*  2786*/      OPC_CheckPredicate, 5, // Predicate_truncstore
/*  2788*/      OPC_Scope, 20, /*->2810*/ // 2 children in Scope
/*  2790*/       OPC_CheckPredicate, 6, // Predicate_truncstorei8
/*  2792*/       OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  2794*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2797*/       OPC_EmitMergeInputChains1_0,
/*  2798*/       OPC_EmitInteger, MVT::i32, 0, 
/*  2801*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i32:{ *:[i32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 13
                 // Dst: (STORE8_I32_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/*  2810*/      /*Scope*/ 20, /*->2831*/
/*  2811*/       OPC_CheckPredicate, 8, // Predicate_truncstorei16
/*  2813*/       OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  2815*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2818*/       OPC_EmitMergeInputChains1_0,
/*  2819*/       OPC_EmitInteger, MVT::i32, 0, 
/*  2822*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i32:{ *:[i32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 13
                 // Dst: (STORE16_I32_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/*  2831*/      0, /*End of Scope*/
/*  2832*/     0, /*End of Scope*/
/*  2833*/    /*Scope*/ 74, /*->2908*/
/*  2834*/     OPC_CheckChild2Type, MVT::i64,
/*  2836*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*  2838*/     OPC_Scope, 20, /*->2860*/ // 2 children in Scope
/*  2840*/      OPC_CheckPredicate, 10, // Predicate_store
/*  2842*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  2844*/      OPC_CheckComplexPat, /*CP*/1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2847*/      OPC_EmitMergeInputChains1_0,
/*  2848*/      OPC_EmitInteger, MVT::i32, 0, 
/*  2851*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (st i32:{ *:[i32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
                // Dst: (STORE_I32_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/*  2860*/     /*Scope*/ 46, /*->2907*/
/*  2861*/      OPC_CheckPredicate, 5, // Predicate_truncstore
/*  2863*/      OPC_Scope, 20, /*->2885*/ // 2 children in Scope
/*  2865*/       OPC_CheckPredicate, 6, // Predicate_truncstorei8
/*  2867*/       OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  2869*/       OPC_CheckComplexPat, /*CP*/1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2872*/       OPC_EmitMergeInputChains1_0,
/*  2873*/       OPC_EmitInteger, MVT::i32, 0, 
/*  2876*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i32:{ *:[i32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 13
                 // Dst: (STORE8_I32_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/*  2885*/      /*Scope*/ 20, /*->2906*/
/*  2886*/       OPC_CheckPredicate, 8, // Predicate_truncstorei16
/*  2888*/       OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  2890*/       OPC_CheckComplexPat, /*CP*/1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2893*/       OPC_EmitMergeInputChains1_0,
/*  2894*/       OPC_EmitInteger, MVT::i32, 0, 
/*  2897*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i32:{ *:[i32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 13
                 // Dst: (STORE16_I32_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/*  2906*/      0, /*End of Scope*/
/*  2907*/     0, /*End of Scope*/
/*  2908*/    0, /*End of Scope*/
/*  2909*/   /*Scope*/ 69|128,1/*197*/, /*->3108*/
/*  2911*/    OPC_CheckChild1Type, MVT::i64,
/*  2913*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2914*/    OPC_Scope, 95, /*->3011*/ // 2 children in Scope
/*  2916*/     OPC_CheckChild2Type, MVT::i32,
/*  2918*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*  2920*/     OPC_Scope, 20, /*->2942*/ // 2 children in Scope
/*  2922*/      OPC_CheckPredicate, 10, // Predicate_store
/*  2924*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  2926*/      OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2929*/      OPC_EmitMergeInputChains1_0,
/*  2930*/      OPC_EmitInteger, MVT::i32, 0, 
/*  2933*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (st i64:{ *:[i64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
                // Dst: (STORE_I64_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  2942*/     /*Scope*/ 67, /*->3010*/
/*  2943*/      OPC_CheckPredicate, 5, // Predicate_truncstore
/*  2945*/      OPC_Scope, 20, /*->2967*/ // 3 children in Scope
/*  2947*/       OPC_CheckPredicate, 6, // Predicate_truncstorei8
/*  2949*/       OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  2951*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2954*/       OPC_EmitMergeInputChains1_0,
/*  2955*/       OPC_EmitInteger, MVT::i32, 0, 
/*  2958*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i64:{ *:[i64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 13
                 // Dst: (STORE8_I64_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  2967*/      /*Scope*/ 20, /*->2988*/
/*  2968*/       OPC_CheckPredicate, 8, // Predicate_truncstorei16
/*  2970*/       OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  2972*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2975*/       OPC_EmitMergeInputChains1_0,
/*  2976*/       OPC_EmitInteger, MVT::i32, 0, 
/*  2979*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i64:{ *:[i64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 13
                 // Dst: (STORE16_I64_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  2988*/      /*Scope*/ 20, /*->3009*/
/*  2989*/       OPC_CheckPredicate, 12, // Predicate_truncstorei32
/*  2991*/       OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  2993*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2996*/       OPC_EmitMergeInputChains1_0,
/*  2997*/       OPC_EmitInteger, MVT::i32, 0, 
/*  3000*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE32_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i64:{ *:[i64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>> - Complexity = 13
                 // Dst: (STORE32_I64_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  3009*/      0, /*End of Scope*/
/*  3010*/     0, /*End of Scope*/
/*  3011*/    /*Scope*/ 95, /*->3107*/
/*  3012*/     OPC_CheckChild2Type, MVT::i64,
/*  3014*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*  3016*/     OPC_Scope, 20, /*->3038*/ // 2 children in Scope
/*  3018*/      OPC_CheckPredicate, 10, // Predicate_store
/*  3020*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  3022*/      OPC_CheckComplexPat, /*CP*/1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3025*/      OPC_EmitMergeInputChains1_0,
/*  3026*/      OPC_EmitInteger, MVT::i32, 0, 
/*  3029*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (st i64:{ *:[i64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
                // Dst: (STORE_I64_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  3038*/     /*Scope*/ 67, /*->3106*/
/*  3039*/      OPC_CheckPredicate, 5, // Predicate_truncstore
/*  3041*/      OPC_Scope, 20, /*->3063*/ // 3 children in Scope
/*  3043*/       OPC_CheckPredicate, 6, // Predicate_truncstorei8
/*  3045*/       OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  3047*/       OPC_CheckComplexPat, /*CP*/1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3050*/       OPC_EmitMergeInputChains1_0,
/*  3051*/       OPC_EmitInteger, MVT::i32, 0, 
/*  3054*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i64:{ *:[i64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 13
                 // Dst: (STORE8_I64_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  3063*/      /*Scope*/ 20, /*->3084*/
/*  3064*/       OPC_CheckPredicate, 8, // Predicate_truncstorei16
/*  3066*/       OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  3068*/       OPC_CheckComplexPat, /*CP*/1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3071*/       OPC_EmitMergeInputChains1_0,
/*  3072*/       OPC_EmitInteger, MVT::i32, 0, 
/*  3075*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i64:{ *:[i64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 13
                 // Dst: (STORE16_I64_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  3084*/      /*Scope*/ 20, /*->3105*/
/*  3085*/       OPC_CheckPredicate, 12, // Predicate_truncstorei32
/*  3087*/       OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  3089*/       OPC_CheckComplexPat, /*CP*/1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3092*/       OPC_EmitMergeInputChains1_0,
/*  3093*/       OPC_EmitInteger, MVT::i32, 0, 
/*  3096*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE32_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i64:{ *:[i64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>> - Complexity = 13
                 // Dst: (STORE32_I64_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  3105*/      0, /*End of Scope*/
/*  3106*/     0, /*End of Scope*/
/*  3107*/    0, /*End of Scope*/
/*  3108*/   /*Scope*/ 55, /*->3164*/
/*  3109*/    OPC_CheckChild1Type, MVT::f32,
/*  3111*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  3112*/    OPC_Scope, 24, /*->3138*/ // 2 children in Scope
/*  3114*/     OPC_CheckChild2Type, MVT::i32,
/*  3116*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*  3118*/     OPC_CheckPredicate, 10, // Predicate_store
/*  3120*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  3122*/     OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3125*/     OPC_EmitMergeInputChains1_0,
/*  3126*/     OPC_EmitInteger, MVT::i32, 0, 
/*  3129*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st f32:{ *:[f32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_F32_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, f32:{ *:[f32] }:$val)
/*  3138*/    /*Scope*/ 24, /*->3163*/
/*  3139*/     OPC_CheckChild2Type, MVT::i64,
/*  3141*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*  3143*/     OPC_CheckPredicate, 10, // Predicate_store
/*  3145*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  3147*/     OPC_CheckComplexPat, /*CP*/1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3150*/     OPC_EmitMergeInputChains1_0,
/*  3151*/     OPC_EmitInteger, MVT::i32, 0, 
/*  3154*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st f32:{ *:[f32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_F32_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, f32:{ *:[f32] }:$val)
/*  3163*/    0, /*End of Scope*/
/*  3164*/   /*Scope*/ 55, /*->3220*/
/*  3165*/    OPC_CheckChild1Type, MVT::f64,
/*  3167*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  3168*/    OPC_Scope, 24, /*->3194*/ // 2 children in Scope
/*  3170*/     OPC_CheckChild2Type, MVT::i32,
/*  3172*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*  3174*/     OPC_CheckPredicate, 10, // Predicate_store
/*  3176*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  3178*/     OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3181*/     OPC_EmitMergeInputChains1_0,
/*  3182*/     OPC_EmitInteger, MVT::i32, 0, 
/*  3185*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st f64:{ *:[f64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_F64_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, f64:{ *:[f64] }:$val)
/*  3194*/    /*Scope*/ 24, /*->3219*/
/*  3195*/     OPC_CheckChild2Type, MVT::i64,
/*  3197*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*  3199*/     OPC_CheckPredicate, 10, // Predicate_store
/*  3201*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  3203*/     OPC_CheckComplexPat, /*CP*/1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3206*/     OPC_EmitMergeInputChains1_0,
/*  3207*/     OPC_EmitInteger, MVT::i32, 0, 
/*  3210*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st f64:{ *:[f64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_F64_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, f64:{ *:[f64] }:$val)
/*  3219*/    0, /*End of Scope*/
/*  3220*/   /*Scope*/ 55, /*->3276*/
/*  3221*/    OPC_CheckChild1Type, MVT::v16i8,
/*  3223*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  3224*/    OPC_Scope, 24, /*->3250*/ // 2 children in Scope
/*  3226*/     OPC_CheckChild2Type, MVT::i32,
/*  3228*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*  3230*/     OPC_CheckPredicate, 10, // Predicate_store
/*  3232*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  3234*/     OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3237*/     OPC_EmitMergeInputChains1_0,
/*  3238*/     OPC_EmitInteger, MVT::i32, 0, 
/*  3241*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v16i8:{ *:[v16i8] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, v16i8:{ *:[v16i8] }:$val)
/*  3250*/    /*Scope*/ 24, /*->3275*/
/*  3251*/     OPC_CheckChild2Type, MVT::i64,
/*  3253*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*  3255*/     OPC_CheckPredicate, 10, // Predicate_store
/*  3257*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  3259*/     OPC_CheckComplexPat, /*CP*/1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3262*/     OPC_EmitMergeInputChains1_0,
/*  3263*/     OPC_EmitInteger, MVT::i32, 0, 
/*  3266*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v16i8:{ *:[v16i8] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, v16i8:{ *:[v16i8] }:$val)
/*  3275*/    0, /*End of Scope*/
/*  3276*/   /*Scope*/ 55, /*->3332*/
/*  3277*/    OPC_CheckChild1Type, MVT::v8i16,
/*  3279*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  3280*/    OPC_Scope, 24, /*->3306*/ // 2 children in Scope
/*  3282*/     OPC_CheckChild2Type, MVT::i32,
/*  3284*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*  3286*/     OPC_CheckPredicate, 10, // Predicate_store
/*  3288*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  3290*/     OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3293*/     OPC_EmitMergeInputChains1_0,
/*  3294*/     OPC_EmitInteger, MVT::i32, 0, 
/*  3297*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v8i16:{ *:[v8i16] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, v8i16:{ *:[v8i16] }:$val)
/*  3306*/    /*Scope*/ 24, /*->3331*/
/*  3307*/     OPC_CheckChild2Type, MVT::i64,
/*  3309*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*  3311*/     OPC_CheckPredicate, 10, // Predicate_store
/*  3313*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  3315*/     OPC_CheckComplexPat, /*CP*/1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3318*/     OPC_EmitMergeInputChains1_0,
/*  3319*/     OPC_EmitInteger, MVT::i32, 0, 
/*  3322*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v8i16:{ *:[v8i16] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, v8i16:{ *:[v8i16] }:$val)
/*  3331*/    0, /*End of Scope*/
/*  3332*/   /*Scope*/ 55, /*->3388*/
/*  3333*/    OPC_CheckChild1Type, MVT::v4i32,
/*  3335*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  3336*/    OPC_Scope, 24, /*->3362*/ // 2 children in Scope
/*  3338*/     OPC_CheckChild2Type, MVT::i32,
/*  3340*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*  3342*/     OPC_CheckPredicate, 10, // Predicate_store
/*  3344*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  3346*/     OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3349*/     OPC_EmitMergeInputChains1_0,
/*  3350*/     OPC_EmitInteger, MVT::i32, 0, 
/*  3353*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v4i32:{ *:[v4i32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, v4i32:{ *:[v4i32] }:$val)
/*  3362*/    /*Scope*/ 24, /*->3387*/
/*  3363*/     OPC_CheckChild2Type, MVT::i64,
/*  3365*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*  3367*/     OPC_CheckPredicate, 10, // Predicate_store
/*  3369*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  3371*/     OPC_CheckComplexPat, /*CP*/1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3374*/     OPC_EmitMergeInputChains1_0,
/*  3375*/     OPC_EmitInteger, MVT::i32, 0, 
/*  3378*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v4i32:{ *:[v4i32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, v4i32:{ *:[v4i32] }:$val)
/*  3387*/    0, /*End of Scope*/
/*  3388*/   /*Scope*/ 55, /*->3444*/
/*  3389*/    OPC_CheckChild1Type, MVT::v2i64,
/*  3391*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  3392*/    OPC_Scope, 24, /*->3418*/ // 2 children in Scope
/*  3394*/     OPC_CheckChild2Type, MVT::i32,
/*  3396*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*  3398*/     OPC_CheckPredicate, 10, // Predicate_store
/*  3400*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  3402*/     OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3405*/     OPC_EmitMergeInputChains1_0,
/*  3406*/     OPC_EmitInteger, MVT::i32, 0, 
/*  3409*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v2i64:{ *:[v2i64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, v2i64:{ *:[v2i64] }:$val)
/*  3418*/    /*Scope*/ 24, /*->3443*/
/*  3419*/     OPC_CheckChild2Type, MVT::i64,
/*  3421*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*  3423*/     OPC_CheckPredicate, 10, // Predicate_store
/*  3425*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  3427*/     OPC_CheckComplexPat, /*CP*/1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3430*/     OPC_EmitMergeInputChains1_0,
/*  3431*/     OPC_EmitInteger, MVT::i32, 0, 
/*  3434*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v2i64:{ *:[v2i64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, v2i64:{ *:[v2i64] }:$val)
/*  3443*/    0, /*End of Scope*/
/*  3444*/   /*Scope*/ 55, /*->3500*/
/*  3445*/    OPC_CheckChild1Type, MVT::v4f32,
/*  3447*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  3448*/    OPC_Scope, 24, /*->3474*/ // 2 children in Scope
/*  3450*/     OPC_CheckChild2Type, MVT::i32,
/*  3452*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*  3454*/     OPC_CheckPredicate, 10, // Predicate_store
/*  3456*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  3458*/     OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3461*/     OPC_EmitMergeInputChains1_0,
/*  3462*/     OPC_EmitInteger, MVT::i32, 0, 
/*  3465*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v4f32:{ *:[v4f32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, v4f32:{ *:[v4f32] }:$val)
/*  3474*/    /*Scope*/ 24, /*->3499*/
/*  3475*/     OPC_CheckChild2Type, MVT::i64,
/*  3477*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*  3479*/     OPC_CheckPredicate, 10, // Predicate_store
/*  3481*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  3483*/     OPC_CheckComplexPat, /*CP*/1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3486*/     OPC_EmitMergeInputChains1_0,
/*  3487*/     OPC_EmitInteger, MVT::i32, 0, 
/*  3490*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v4f32:{ *:[v4f32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, v4f32:{ *:[v4f32] }:$val)
/*  3499*/    0, /*End of Scope*/
/*  3500*/   /*Scope*/ 55, /*->3556*/
/*  3501*/    OPC_CheckChild1Type, MVT::v2f64,
/*  3503*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  3504*/    OPC_Scope, 24, /*->3530*/ // 2 children in Scope
/*  3506*/     OPC_CheckChild2Type, MVT::i32,
/*  3508*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*  3510*/     OPC_CheckPredicate, 10, // Predicate_store
/*  3512*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  3514*/     OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3517*/     OPC_EmitMergeInputChains1_0,
/*  3518*/     OPC_EmitInteger, MVT::i32, 0, 
/*  3521*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v2f64:{ *:[v2f64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, v2f64:{ *:[v2f64] }:$val)
/*  3530*/    /*Scope*/ 24, /*->3555*/
/*  3531*/     OPC_CheckChild2Type, MVT::i64,
/*  3533*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*  3535*/     OPC_CheckPredicate, 10, // Predicate_store
/*  3537*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  3539*/     OPC_CheckComplexPat, /*CP*/1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3542*/     OPC_EmitMergeInputChains1_0,
/*  3543*/     OPC_EmitInteger, MVT::i32, 0, 
/*  3546*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v2f64:{ *:[v2f64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, v2f64:{ *:[v2f64] }:$val)
/*  3555*/    0, /*End of Scope*/
/*  3556*/   0, /*End of Scope*/
/*  3557*/  0, /*End of Scope*/
/*  3558*/ /*SwitchOpcode*/ 55|128,1/*183*/, TARGET_VAL(ISD::INTRINSIC_VOID),// ->3745
/*  3562*/  OPC_RecordNode, // #0 = 'intrinsic_void' chained node
/*  3563*/  OPC_Scope, 42, /*->3607*/ // 6 children in Scope
/*  3565*/   OPC_CheckChild1Integer, 46|128,57|128,1/*23726*/, 
/*  3569*/   OPC_MoveChild2,
/*  3570*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3573*/   OPC_RecordChild0, // #1 = $table1
/*  3574*/   OPC_MoveChild0,
/*  3575*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3578*/   OPC_MoveParent,
/*  3579*/   OPC_MoveParent,
/*  3580*/   OPC_MoveChild3,
/*  3581*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3584*/   OPC_RecordChild0, // #2 = $table2
/*  3585*/   OPC_MoveChild0,
/*  3586*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3589*/   OPC_MoveParent,
/*  3590*/   OPC_MoveParent,
/*  3591*/   OPC_RecordChild4, // #3 = $d
/*  3592*/   OPC_RecordChild5, // #4 = $s
/*  3593*/   OPC_RecordChild6, // #5 = $n
/*  3594*/   OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/*  3596*/   OPC_EmitMergeInputChains1_0,
/*  3597*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::TABLE_COPY), 0|OPFL_Chain,
                 5/*#Ops*/, 1, 2, 3, 4, 5, 
             // Src: (intrinsic_void 11863:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table1), (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table2), I32:{ *:[i32] }:$d, I32:{ *:[i32] }:$s, I32:{ *:[i32] }:$n) - Complexity = 20
             // Dst: (TABLE_COPY (tglobaladdr:{ *:[i32] }):$table1, (tglobaladdr:{ *:[i32] }):$table2, I32:{ *:[i32] }:$d, I32:{ *:[i32] }:$s, I32:{ *:[i32] }:$n)
/*  3607*/  /*Scope*/ 28, /*->3636*/
/*  3608*/   OPC_CheckChild1Integer, 62|128,57|128,1/*23742*/, 
/*  3612*/   OPC_MoveChild2,
/*  3613*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3616*/   OPC_RecordChild0, // #1 = $table
/*  3617*/   OPC_MoveChild0,
/*  3618*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3621*/   OPC_MoveParent,
/*  3622*/   OPC_MoveParent,
/*  3623*/   OPC_RecordChild3, // #2 = $i
/*  3624*/   OPC_RecordChild4, // #3 = $val
/*  3625*/   OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/*  3627*/   OPC_EmitMergeInputChains1_0,
/*  3628*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::TABLE_SET_FUNCREF), 0|OPFL_Chain,
                 3/*#Ops*/, 1, 2, 3, 
             // Src: (intrinsic_void 11871:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i, FUNCREF:{ *:[funcref] }:$val) - Complexity = 14
             // Dst: (TABLE_SET_FUNCREF (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i, FUNCREF:{ *:[funcref] }:$val)
/*  3636*/  /*Scope*/ 30, /*->3667*/
/*  3637*/   OPC_CheckChild1Integer, 50|128,57|128,1/*23730*/, 
/*  3641*/   OPC_MoveChild2,
/*  3642*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3645*/   OPC_RecordChild0, // #1 = $table
/*  3646*/   OPC_MoveChild0,
/*  3647*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3650*/   OPC_MoveParent,
/*  3651*/   OPC_MoveParent,
/*  3652*/   OPC_RecordChild3, // #2 = $i
/*  3653*/   OPC_RecordChild4, // #3 = $val
/*  3654*/   OPC_RecordChild5, // #4 = $n
/*  3655*/   OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/*  3657*/   OPC_EmitMergeInputChains1_0,
/*  3658*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::TABLE_FILL_FUNCREF), 0|OPFL_Chain,
                 4/*#Ops*/, 1, 2, 3, 4, 
             // Src: (intrinsic_void 11865:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i, FUNCREF:{ *:[funcref] }:$val, I32:{ *:[i32] }:$n) - Complexity = 14
             // Dst: (TABLE_FILL_FUNCREF (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i, FUNCREF:{ *:[funcref] }:$val, I32:{ *:[i32] }:$n)
/*  3667*/  /*Scope*/ 28, /*->3696*/
/*  3668*/   OPC_CheckChild1Integer, 60|128,57|128,1/*23740*/, 
/*  3672*/   OPC_MoveChild2,
/*  3673*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3676*/   OPC_RecordChild0, // #1 = $table
/*  3677*/   OPC_MoveChild0,
/*  3678*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3681*/   OPC_MoveParent,
/*  3682*/   OPC_MoveParent,
/*  3683*/   OPC_RecordChild3, // #2 = $i
/*  3684*/   OPC_RecordChild4, // #3 = $val
/*  3685*/   OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/*  3687*/   OPC_EmitMergeInputChains1_0,
/*  3688*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::TABLE_SET_EXTERNREF), 0|OPFL_Chain,
                 3/*#Ops*/, 1, 2, 3, 
             // Src: (intrinsic_void 11870:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i, EXTERNREF:{ *:[externref] }:$val) - Complexity = 14
             // Dst: (TABLE_SET_EXTERNREF (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i, EXTERNREF:{ *:[externref] }:$val)
/*  3696*/  /*Scope*/ 30, /*->3727*/
/*  3697*/   OPC_CheckChild1Integer, 48|128,57|128,1/*23728*/, 
/*  3701*/   OPC_MoveChild2,
/*  3702*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3705*/   OPC_RecordChild0, // #1 = $table
/*  3706*/   OPC_MoveChild0,
/*  3707*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3710*/   OPC_MoveParent,
/*  3711*/   OPC_MoveParent,
/*  3712*/   OPC_RecordChild3, // #2 = $i
/*  3713*/   OPC_RecordChild4, // #3 = $val
/*  3714*/   OPC_RecordChild5, // #4 = $n
/*  3715*/   OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/*  3717*/   OPC_EmitMergeInputChains1_0,
/*  3718*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::TABLE_FILL_EXTERNREF), 0|OPFL_Chain,
                 4/*#Ops*/, 1, 2, 3, 4, 
             // Src: (intrinsic_void 11864:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i, EXTERNREF:{ *:[externref] }:$val, I32:{ *:[i32] }:$n) - Complexity = 14
             // Dst: (TABLE_FILL_EXTERNREF (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i, EXTERNREF:{ *:[externref] }:$val, I32:{ *:[i32] }:$n)
/*  3727*/  /*Scope*/ 16, /*->3744*/
/*  3728*/   OPC_CheckChild1Integer, 36|128,57|128,1/*23716*/, 
/*  3732*/   OPC_CheckPatternPredicate, 5, // (Subtarget->hasExceptionHandling())
/*  3734*/   OPC_EmitMergeInputChains1_0,
/*  3735*/   OPC_EmitInteger, MVT::i32, 0, 
/*  3738*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::RETHROW), 0|OPFL_Chain,
                 1/*#Ops*/, 1, 
             // Src: (intrinsic_void 11858:{ *:[iPTR] }) - Complexity = 8
             // Dst: (RETHROW 0:{ *:[i32] })
/*  3744*/  0, /*End of Scope*/
/*  3745*/ /*SwitchOpcode*/ 22|128,3/*406*/, TARGET_VAL(ISD::INTRINSIC_W_CHAIN),// ->4155
/*  3749*/  OPC_Scope, 46|128,1/*174*/, /*->3926*/ // 2 children in Scope
/*  3752*/   OPC_RecordMemRef,
/*  3753*/   OPC_RecordNode, // #0 = 'intrinsic_w_chain' chained node
/*  3754*/   OPC_Scope, 53, /*->3809*/ // 3 children in Scope
/*  3756*/    OPC_CheckChild1Integer, 108|128,56|128,1/*23660*/, 
/*  3760*/    OPC_RecordChild2, // #1 = $AddrOps32:offset:addr
/*  3761*/    OPC_Scope, 22, /*->3785*/ // 2 children in Scope
/*  3763*/     OPC_CheckChild2Type, MVT::i32,
/*  3765*/     OPC_RecordChild3, // #2 = $count
/*  3766*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3768*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  3771*/     OPC_EmitMergeInputChains1_0,
/*  3772*/     OPC_EmitInteger, MVT::i32, 0, 
/*  3775*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_NOTIFY_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 11830:{ *:[iPTR] }, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), I32:{ *:[i32] }:$count) - Complexity = 17
               // Dst: (MEMORY_ATOMIC_NOTIFY_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$count)
/*  3785*/    /*Scope*/ 22, /*->3808*/
/*  3786*/     OPC_CheckChild2Type, MVT::i64,
/*  3788*/     OPC_RecordChild3, // #2 = $count
/*  3789*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3791*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  3794*/     OPC_EmitMergeInputChains1_0,
/*  3795*/     OPC_EmitInteger, MVT::i32, 0, 
/*  3798*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_NOTIFY_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 11830:{ *:[iPTR] }, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), I32:{ *:[i32] }:$count) - Complexity = 17
               // Dst: (MEMORY_ATOMIC_NOTIFY_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$count)
/*  3808*/    0, /*End of Scope*/
/*  3809*/   /*Scope*/ 57, /*->3867*/
/*  3810*/    OPC_CheckChild1Integer, 110|128,56|128,1/*23662*/, 
/*  3814*/    OPC_RecordChild2, // #1 = $AddrOps32:offset:addr
/*  3815*/    OPC_Scope, 24, /*->3841*/ // 2 children in Scope
/*  3817*/     OPC_CheckChild2Type, MVT::i32,
/*  3819*/     OPC_RecordChild3, // #2 = $exp
/*  3820*/     OPC_RecordChild4, // #3 = $timeout
/*  3821*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3823*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  3826*/     OPC_EmitMergeInputChains1_0,
/*  3827*/     OPC_EmitInteger, MVT::i32, 0, 
/*  3830*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_WAIT32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 11831:{ *:[iPTR] }, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 17
               // Dst: (MEMORY_ATOMIC_WAIT32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i64] }:$timeout)
/*  3841*/    /*Scope*/ 24, /*->3866*/
/*  3842*/     OPC_CheckChild2Type, MVT::i64,
/*  3844*/     OPC_RecordChild3, // #2 = $exp
/*  3845*/     OPC_RecordChild4, // #3 = $timeout
/*  3846*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3848*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  3851*/     OPC_EmitMergeInputChains1_0,
/*  3852*/     OPC_EmitInteger, MVT::i32, 0, 
/*  3855*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_WAIT32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 11831:{ *:[iPTR] }, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 17
               // Dst: (MEMORY_ATOMIC_WAIT32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i64] }:$timeout)
/*  3866*/    0, /*End of Scope*/
/*  3867*/   /*Scope*/ 57, /*->3925*/
/*  3868*/    OPC_CheckChild1Integer, 112|128,56|128,1/*23664*/, 
/*  3872*/    OPC_RecordChild2, // #1 = $AddrOps32:offset:addr
/*  3873*/    OPC_Scope, 24, /*->3899*/ // 2 children in Scope
/*  3875*/     OPC_CheckChild2Type, MVT::i32,
/*  3877*/     OPC_RecordChild3, // #2 = $exp
/*  3878*/     OPC_RecordChild4, // #3 = $timeout
/*  3879*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3881*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  3884*/     OPC_EmitMergeInputChains1_0,
/*  3885*/     OPC_EmitInteger, MVT::i32, 0, 
/*  3888*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_WAIT64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 11832:{ *:[iPTR] }, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 17
               // Dst: (MEMORY_ATOMIC_WAIT64_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$timeout)
/*  3899*/    /*Scope*/ 24, /*->3924*/
/*  3900*/     OPC_CheckChild2Type, MVT::i64,
/*  3902*/     OPC_RecordChild3, // #2 = $exp
/*  3903*/     OPC_RecordChild4, // #3 = $timeout
/*  3904*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3906*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  3909*/     OPC_EmitMergeInputChains1_0,
/*  3910*/     OPC_EmitInteger, MVT::i32, 0, 
/*  3913*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_WAIT64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 11832:{ *:[iPTR] }, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 17
               // Dst: (MEMORY_ATOMIC_WAIT64_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$timeout)
/*  3924*/    0, /*End of Scope*/
/*  3925*/   0, /*End of Scope*/
/*  3926*/  /*Scope*/ 98|128,1/*226*/, /*->4154*/
/*  3928*/   OPC_RecordNode, // #0 = 'intrinsic_w_chain' chained node
/*  3929*/   OPC_Scope, 27, /*->3958*/ // 7 children in Scope
/*  3931*/    OPC_CheckChild1Integer, 54|128,57|128,1/*23734*/, 
/*  3935*/    OPC_MoveChild2,
/*  3936*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3939*/    OPC_RecordChild0, // #1 = $table
/*  3940*/    OPC_MoveChild0,
/*  3941*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3944*/    OPC_MoveParent,
/*  3945*/    OPC_MoveParent,
/*  3946*/    OPC_RecordChild3, // #2 = $i
/*  3947*/    OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/*  3949*/    OPC_EmitMergeInputChains1_0,
/*  3950*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::TABLE_GET_FUNCREF), 0|OPFL_Chain,
                  MVT::funcref, 2/*#Ops*/, 1, 2, 
              // Src: (intrinsic_w_chain:{ *:[funcref] } 11867:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i) - Complexity = 14
              // Dst: (TABLE_GET_FUNCREF:{ *:[funcref] } (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i)
/*  3958*/   /*Scope*/ 29, /*->3988*/
/*  3959*/    OPC_CheckChild1Integer, 58|128,57|128,1/*23738*/, 
/*  3963*/    OPC_MoveChild2,
/*  3964*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3967*/    OPC_RecordChild0, // #1 = $table
/*  3968*/    OPC_MoveChild0,
/*  3969*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3972*/    OPC_MoveParent,
/*  3973*/    OPC_MoveParent,
/*  3974*/    OPC_RecordChild3, // #2 = $val
/*  3975*/    OPC_RecordChild4, // #3 = $n
/*  3976*/    OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/*  3978*/    OPC_EmitMergeInputChains1_0,
/*  3979*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::TABLE_GROW_FUNCREF), 0|OPFL_Chain,
                  MVT::i32, 3/*#Ops*/, 1, 2, 3, 
              // Src: (intrinsic_w_chain:{ *:[i32] } 11869:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), FUNCREF:{ *:[funcref] }:$val, I32:{ *:[i32] }:$n) - Complexity = 14
              // Dst: (TABLE_GROW_FUNCREF:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$table, FUNCREF:{ *:[funcref] }:$val, I32:{ *:[i32] }:$n)
/*  3988*/   /*Scope*/ 27, /*->4016*/
/*  3989*/    OPC_CheckChild1Integer, 52|128,57|128,1/*23732*/, 
/*  3993*/    OPC_MoveChild2,
/*  3994*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3997*/    OPC_RecordChild0, // #1 = $table
/*  3998*/    OPC_MoveChild0,
/*  3999*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  4002*/    OPC_MoveParent,
/*  4003*/    OPC_MoveParent,
/*  4004*/    OPC_RecordChild3, // #2 = $i
/*  4005*/    OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/*  4007*/    OPC_EmitMergeInputChains1_0,
/*  4008*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::TABLE_GET_EXTERNREF), 0|OPFL_Chain,
                  MVT::externref, 2/*#Ops*/, 1, 2, 
              // Src: (intrinsic_w_chain:{ *:[externref] } 11866:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i) - Complexity = 14
              // Dst: (TABLE_GET_EXTERNREF:{ *:[externref] } (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i)
/*  4016*/   /*Scope*/ 29, /*->4046*/
/*  4017*/    OPC_CheckChild1Integer, 56|128,57|128,1/*23736*/, 
/*  4021*/    OPC_MoveChild2,
/*  4022*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  4025*/    OPC_RecordChild0, // #1 = $table
/*  4026*/    OPC_MoveChild0,
/*  4027*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  4030*/    OPC_MoveParent,
/*  4031*/    OPC_MoveParent,
/*  4032*/    OPC_RecordChild3, // #2 = $val
/*  4033*/    OPC_RecordChild4, // #3 = $n
/*  4034*/    OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/*  4036*/    OPC_EmitMergeInputChains1_0,
/*  4037*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::TABLE_GROW_EXTERNREF), 0|OPFL_Chain,
                  MVT::i32, 3/*#Ops*/, 1, 2, 3, 
              // Src: (intrinsic_w_chain:{ *:[i32] } 11868:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), EXTERNREF:{ *:[externref] }:$val, I32:{ *:[i32] }:$n) - Complexity = 14
              // Dst: (TABLE_GROW_EXTERNREF:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$table, EXTERNREF:{ *:[externref] }:$val, I32:{ *:[i32] }:$n)
/*  4046*/   /*Scope*/ 25, /*->4072*/
/*  4047*/    OPC_CheckChild1Integer, 64|128,57|128,1/*23744*/, 
/*  4051*/    OPC_MoveChild2,
/*  4052*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  4055*/    OPC_RecordChild0, // #1 = $table
/*  4056*/    OPC_MoveChild0,
/*  4057*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  4060*/    OPC_MoveParent,
/*  4061*/    OPC_MoveParent,
/*  4062*/    OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/*  4064*/    OPC_EmitMergeInputChains1_0,
/*  4065*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::TABLE_SIZE), 0|OPFL_Chain,
                  MVT::i32, 1/*#Ops*/, 1, 
              // Src: (intrinsic_w_chain:{ *:[i32] } 11872:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table)) - Complexity = 14
              // Dst: (TABLE_SIZE:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$table)
/*  4072*/   /*Scope*/ 36, /*->4109*/
/*  4073*/    OPC_CheckChild1Integer, 116|128,56|128,1/*23668*/, 
/*  4077*/    OPC_RecordChild2, // #1 = $flags
/*  4078*/    OPC_MoveChild2,
/*  4079*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  4082*/    OPC_MoveParent,
/*  4083*/    OPC_SwitchType /*2 cases */, 10, MVT::i32,// ->4096
/*  4086*/     OPC_EmitMergeInputChains1_0,
/*  4087*/     OPC_EmitConvertToTarget, 1,
/*  4089*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::anonymous_7137MEMORY_SIZE_A32), 0|OPFL_Chain,
                   MVT::i32, 1/*#Ops*/, 2, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 11834:{ *:[iPTR] }, (imm:{ *:[i32] }):$flags) - Complexity = 11
               // Dst: (anonymous_7137MEMORY_SIZE_A32:{ *:[i32] } (imm:{ *:[i32] }):$flags)
/*  4096*/    /*SwitchType*/ 10, MVT::i64,// ->4108
/*  4098*/     OPC_EmitMergeInputChains1_0,
/*  4099*/     OPC_EmitConvertToTarget, 1,
/*  4101*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::anonymous_7138MEMORY_SIZE_A64), 0|OPFL_Chain,
                   MVT::i64, 1/*#Ops*/, 2, 
               // Src: (intrinsic_w_chain:{ *:[i64] } 11834:{ *:[iPTR] }, (imm:{ *:[i32] }):$flags) - Complexity = 11
               // Dst: (anonymous_7138MEMORY_SIZE_A64:{ *:[i64] } (imm:{ *:[i32] }):$flags)
/*  4108*/    0, // EndSwitchType
/*  4109*/   /*Scope*/ 43, /*->4153*/
/*  4110*/    OPC_CheckChild1Integer, 114|128,56|128,1/*23666*/, 
/*  4114*/    OPC_RecordChild2, // #1 = $flags
/*  4115*/    OPC_MoveChild2,
/*  4116*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  4119*/    OPC_MoveParent,
/*  4120*/    OPC_RecordChild3, // #2 = $delta
/*  4121*/    OPC_SwitchType /*2 cases */, 13, MVT::i32,// ->4137
/*  4124*/     OPC_CheckChild3Type, MVT::i32,
/*  4126*/     OPC_EmitMergeInputChains1_0,
/*  4127*/     OPC_EmitConvertToTarget, 1,
/*  4129*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::anonymous_7137MEMORY_GROW_A32), 0|OPFL_Chain,
                   MVT::i32, 2/*#Ops*/, 3, 2, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 11833:{ *:[iPTR] }, (imm:{ *:[i32] }):$flags, I32:{ *:[i32] }:$delta) - Complexity = 11
               // Dst: (anonymous_7137MEMORY_GROW_A32:{ *:[i32] } (imm:{ *:[i32] }):$flags, I32:{ *:[i32] }:$delta)
/*  4137*/    /*SwitchType*/ 13, MVT::i64,// ->4152
/*  4139*/     OPC_CheckChild3Type, MVT::i64,
/*  4141*/     OPC_EmitMergeInputChains1_0,
/*  4142*/     OPC_EmitConvertToTarget, 1,
/*  4144*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::anonymous_7138MEMORY_GROW_A64), 0|OPFL_Chain,
                   MVT::i64, 2/*#Ops*/, 3, 2, 
               // Src: (intrinsic_w_chain:{ *:[i64] } 11833:{ *:[iPTR] }, (imm:{ *:[i32] }):$flags, I64:{ *:[i64] }:$delta) - Complexity = 11
               // Dst: (anonymous_7138MEMORY_GROW_A64:{ *:[i64] } (imm:{ *:[i32] }):$flags, I64:{ *:[i64] }:$delta)
/*  4152*/    0, // EndSwitchType
/*  4153*/   0, /*End of Scope*/
/*  4154*/  0, /*End of Scope*/
/*  4155*/ /*SwitchOpcode*/ 95|128,2/*351*/, TARGET_VAL(ISD::ATOMIC_STORE),// ->4510
/*  4159*/  OPC_RecordMemRef,
/*  4160*/  OPC_RecordNode, // #0 = 'atomic_store' chained node
/*  4161*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  4162*/  OPC_Scope, 43|128,1/*171*/, /*->4336*/ // 2 children in Scope
/*  4165*/   OPC_CheckChild1Type, MVT::i32,
/*  4167*/   OPC_Scope, 71, /*->4240*/ // 2 children in Scope
/*  4169*/    OPC_MoveChild2,
/*  4170*/    OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  4173*/    OPC_RecordChild0, // #2 = $val
/*  4174*/    OPC_MoveParent,
/*  4175*/    OPC_Scope, 20, /*->4197*/ // 3 children in Scope
/*  4177*/     OPC_CheckPredicate, 0, // Predicate_atomic_store_8
/*  4179*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4181*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  4184*/     OPC_EmitMergeInputChains1_0,
/*  4185*/     OPC_EmitInteger, MVT::i32, 0, 
/*  4188*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_store (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_store_8>> - Complexity = 16
               // Dst: (ATOMIC_STORE8_I64_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  4197*/    /*Scope*/ 20, /*->4218*/
/*  4198*/     OPC_CheckPredicate, 1, // Predicate_atomic_store_16
/*  4200*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4202*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  4205*/     OPC_EmitMergeInputChains1_0,
/*  4206*/     OPC_EmitInteger, MVT::i32, 0, 
/*  4209*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_store (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_store_16>> - Complexity = 16
               // Dst: (ATOMIC_STORE16_I64_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  4218*/    /*Scope*/ 20, /*->4239*/
/*  4219*/     OPC_CheckPredicate, 2, // Predicate_atomic_store_32
/*  4221*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4223*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  4226*/     OPC_EmitMergeInputChains1_0,
/*  4227*/     OPC_EmitInteger, MVT::i32, 0, 
/*  4230*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE32_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_store (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_store_32>> - Complexity = 16
               // Dst: (ATOMIC_STORE32_I64_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  4239*/    0, /*End of Scope*/
/*  4240*/   /*Scope*/ 94, /*->4335*/
/*  4241*/    OPC_RecordChild2, // #2 = $val
/*  4242*/    OPC_Scope, 67, /*->4311*/ // 2 children in Scope
/*  4244*/     OPC_CheckChild2Type, MVT::i32,
/*  4246*/     OPC_Scope, 20, /*->4268*/ // 3 children in Scope
/*  4248*/      OPC_CheckPredicate, 2, // Predicate_atomic_store_32
/*  4250*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4252*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  4255*/      OPC_EmitMergeInputChains1_0,
/*  4256*/      OPC_EmitInteger, MVT::i32, 0, 
/*  4259*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (atomic_store (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_store_32>> - Complexity = 13
                // Dst: (ATOMIC_STORE_I32_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  4268*/     /*Scope*/ 20, /*->4289*/
/*  4269*/      OPC_CheckPredicate, 0, // Predicate_atomic_store_8
/*  4271*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4273*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  4276*/      OPC_EmitMergeInputChains1_0,
/*  4277*/      OPC_EmitInteger, MVT::i32, 0, 
/*  4280*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (atomic_store (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_store_8>> - Complexity = 13
                // Dst: (ATOMIC_STORE8_I32_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  4289*/     /*Scope*/ 20, /*->4310*/
/*  4290*/      OPC_CheckPredicate, 1, // Predicate_atomic_store_16
/*  4292*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4294*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  4297*/      OPC_EmitMergeInputChains1_0,
/*  4298*/      OPC_EmitInteger, MVT::i32, 0, 
/*  4301*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (atomic_store (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_store_16>> - Complexity = 13
                // Dst: (ATOMIC_STORE16_I32_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  4310*/     0, /*End of Scope*/
/*  4311*/    /*Scope*/ 22, /*->4334*/
/*  4312*/     OPC_CheckChild2Type, MVT::i64,
/*  4314*/     OPC_CheckPredicate, 13, // Predicate_atomic_store_64
/*  4316*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4318*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  4321*/     OPC_EmitMergeInputChains1_0,
/*  4322*/     OPC_EmitInteger, MVT::i32, 0, 
/*  4325*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_store (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_store_64>> - Complexity = 13
               // Dst: (ATOMIC_STORE_I64_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  4334*/    0, /*End of Scope*/
/*  4335*/   0, /*End of Scope*/
/*  4336*/  /*Scope*/ 43|128,1/*171*/, /*->4509*/
/*  4338*/   OPC_CheckChild1Type, MVT::i64,
/*  4340*/   OPC_Scope, 71, /*->4413*/ // 2 children in Scope
/*  4342*/    OPC_MoveChild2,
/*  4343*/    OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  4346*/    OPC_RecordChild0, // #2 = $val
/*  4347*/    OPC_MoveParent,
/*  4348*/    OPC_Scope, 20, /*->4370*/ // 3 children in Scope
/*  4350*/     OPC_CheckPredicate, 0, // Predicate_atomic_store_8
/*  4352*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4354*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  4357*/     OPC_EmitMergeInputChains1_0,
/*  4358*/     OPC_EmitInteger, MVT::i32, 0, 
/*  4361*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_store (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_store_8>> - Complexity = 16
               // Dst: (ATOMIC_STORE8_I64_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  4370*/    /*Scope*/ 20, /*->4391*/
/*  4371*/     OPC_CheckPredicate, 1, // Predicate_atomic_store_16
/*  4373*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4375*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  4378*/     OPC_EmitMergeInputChains1_0,
/*  4379*/     OPC_EmitInteger, MVT::i32, 0, 
/*  4382*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_store (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_store_16>> - Complexity = 16
               // Dst: (ATOMIC_STORE16_I64_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  4391*/    /*Scope*/ 20, /*->4412*/
/*  4392*/     OPC_CheckPredicate, 2, // Predicate_atomic_store_32
/*  4394*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4396*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  4399*/     OPC_EmitMergeInputChains1_0,
/*  4400*/     OPC_EmitInteger, MVT::i32, 0, 
/*  4403*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE32_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_store (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_store_32>> - Complexity = 16
               // Dst: (ATOMIC_STORE32_I64_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  4412*/    0, /*End of Scope*/
/*  4413*/   /*Scope*/ 94, /*->4508*/
/*  4414*/    OPC_RecordChild2, // #2 = $val
/*  4415*/    OPC_Scope, 67, /*->4484*/ // 2 children in Scope
/*  4417*/     OPC_CheckChild2Type, MVT::i32,
/*  4419*/     OPC_Scope, 20, /*->4441*/ // 3 children in Scope
/*  4421*/      OPC_CheckPredicate, 2, // Predicate_atomic_store_32
/*  4423*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4425*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  4428*/      OPC_EmitMergeInputChains1_0,
/*  4429*/      OPC_EmitInteger, MVT::i32, 0, 
/*  4432*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (atomic_store (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_store_32>> - Complexity = 13
                // Dst: (ATOMIC_STORE_I32_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  4441*/     /*Scope*/ 20, /*->4462*/
/*  4442*/      OPC_CheckPredicate, 0, // Predicate_atomic_store_8
/*  4444*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4446*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  4449*/      OPC_EmitMergeInputChains1_0,
/*  4450*/      OPC_EmitInteger, MVT::i32, 0, 
/*  4453*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (atomic_store (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_store_8>> - Complexity = 13
                // Dst: (ATOMIC_STORE8_I32_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  4462*/     /*Scope*/ 20, /*->4483*/
/*  4463*/      OPC_CheckPredicate, 1, // Predicate_atomic_store_16
/*  4465*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4467*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  4470*/      OPC_EmitMergeInputChains1_0,
/*  4471*/      OPC_EmitInteger, MVT::i32, 0, 
/*  4474*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (atomic_store (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_store_16>> - Complexity = 13
                // Dst: (ATOMIC_STORE16_I32_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  4483*/     0, /*End of Scope*/
/*  4484*/    /*Scope*/ 22, /*->4507*/
/*  4485*/     OPC_CheckChild2Type, MVT::i64,
/*  4487*/     OPC_CheckPredicate, 13, // Predicate_atomic_store_64
/*  4489*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4491*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  4494*/     OPC_EmitMergeInputChains1_0,
/*  4495*/     OPC_EmitInteger, MVT::i32, 0, 
/*  4498*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_store (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_store_64>> - Complexity = 13
               // Dst: (ATOMIC_STORE_I64_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  4507*/    0, /*End of Scope*/
/*  4508*/   0, /*End of Scope*/
/*  4509*/  0, /*End of Scope*/
/*  4510*/ /*SwitchOpcode*/ 120|128,2/*376*/, TARGET_VAL(ISD::AND),// ->4890
/*  4514*/  OPC_Scope, 126, /*->4642*/ // 6 children in Scope
/*  4516*/   OPC_MoveChild0,
/*  4517*/   OPC_CheckOpcode, TARGET_VAL(ISD::INTRINSIC_WO_CHAIN),
/*  4520*/   OPC_Scope, 59, /*->4581*/ // 2 children in Scope
/*  4522*/    OPC_CheckChild0Integer, 84|128,56|128,1/*23636*/, 
/*  4526*/    OPC_RecordChild1, // #0 = $x
/*  4527*/    OPC_Scope, 12, /*->4541*/ // 4 children in Scope
/*  4529*/     OPC_CheckChild1Type, MVT::v16i8,
/*  4531*/     OPC_MoveParent,
/*  4532*/     OPC_CheckChild1Integer, 2, 
/*  4534*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ANYTRUE), 0,
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 11818:{ *:[iPTR] }, V128:{ *:[v16i8] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v16i8] }:$x)
/*  4541*/    /*Scope*/ 12, /*->4554*/
/*  4542*/     OPC_CheckChild1Type, MVT::v8i16,
/*  4544*/     OPC_MoveParent,
/*  4545*/     OPC_CheckChild1Integer, 2, 
/*  4547*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ANYTRUE), 0,
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 11818:{ *:[iPTR] }, V128:{ *:[v8i16] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v8i16] }:$x)
/*  4554*/    /*Scope*/ 12, /*->4567*/
/*  4555*/     OPC_CheckChild1Type, MVT::v4i32,
/*  4557*/     OPC_MoveParent,
/*  4558*/     OPC_CheckChild1Integer, 2, 
/*  4560*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ANYTRUE), 0,
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 11818:{ *:[iPTR] }, V128:{ *:[v4i32] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v4i32] }:$x)
/*  4567*/    /*Scope*/ 12, /*->4580*/
/*  4568*/     OPC_CheckChild1Type, MVT::v2i64,
/*  4570*/     OPC_MoveParent,
/*  4571*/     OPC_CheckChild1Integer, 2, 
/*  4573*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ANYTRUE), 0,
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 11818:{ *:[iPTR] }, V128:{ *:[v2i64] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v2i64] }:$x)
/*  4580*/    0, /*End of Scope*/
/*  4581*/   /*Scope*/ 59, /*->4641*/
/*  4582*/    OPC_CheckChild0Integer, 82|128,56|128,1/*23634*/, 
/*  4586*/    OPC_RecordChild1, // #0 = $x
/*  4587*/    OPC_Scope, 12, /*->4601*/ // 4 children in Scope
/*  4589*/     OPC_CheckChild1Type, MVT::v16i8,
/*  4591*/     OPC_MoveParent,
/*  4592*/     OPC_CheckChild1Integer, 2, 
/*  4594*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ALLTRUE_I8x16), 0,
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 11817:{ *:[iPTR] }, V128:{ *:[v16i8] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ALLTRUE_I8x16:{ *:[i32] } ?:{ *:[v16i8] }:$x)
/*  4601*/    /*Scope*/ 12, /*->4614*/
/*  4602*/     OPC_CheckChild1Type, MVT::v8i16,
/*  4604*/     OPC_MoveParent,
/*  4605*/     OPC_CheckChild1Integer, 2, 
/*  4607*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ALLTRUE_I16x8), 0,
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 11817:{ *:[iPTR] }, V128:{ *:[v8i16] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ALLTRUE_I16x8:{ *:[i32] } ?:{ *:[v8i16] }:$x)
/*  4614*/    /*Scope*/ 12, /*->4627*/
/*  4615*/     OPC_CheckChild1Type, MVT::v4i32,
/*  4617*/     OPC_MoveParent,
/*  4618*/     OPC_CheckChild1Integer, 2, 
/*  4620*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ALLTRUE_I32x4), 0,
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 11817:{ *:[iPTR] }, V128:{ *:[v4i32] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ALLTRUE_I32x4:{ *:[i32] } ?:{ *:[v4i32] }:$x)
/*  4627*/    /*Scope*/ 12, /*->4640*/
/*  4628*/     OPC_CheckChild1Type, MVT::v2i64,
/*  4630*/     OPC_MoveParent,
/*  4631*/     OPC_CheckChild1Integer, 2, 
/*  4633*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ALLTRUE_I64x2), 0,
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 11817:{ *:[iPTR] }, V128:{ *:[v2i64] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ALLTRUE_I64x2:{ *:[i32] } ?:{ *:[v2i64] }:$x)
/*  4640*/    0, /*End of Scope*/
/*  4641*/   0, /*End of Scope*/
/*  4642*/  /*Scope*/ 33, /*->4676*/
/*  4643*/   OPC_CheckAndImm, 127|128,1/*255*/, 
/*  4646*/   OPC_MoveChild0,
/*  4647*/   OPC_CheckOpcode, TARGET_VAL(ISD::EXTRACT_VECTOR_ELT),
/*  4650*/   OPC_RecordChild0, // #0 = $vec
/*  4651*/   OPC_CheckChild0Type, MVT::v16i8,
/*  4653*/   OPC_RecordChild1, // #1 = $idx
/*  4654*/   OPC_MoveChild1,
/*  4655*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  4658*/   OPC_CheckPredicate, 3, // Predicate_LaneIdx16
/*  4660*/   OPC_CheckType, MVT::i32,
/*  4662*/   OPC_MoveParent,
/*  4663*/   OPC_MoveParent,
/*  4664*/   OPC_CheckType, MVT::i32,
/*  4666*/   OPC_EmitConvertToTarget, 1,
/*  4668*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTRACT_LANE_I8x16_u), 0,
                 MVT::i32, 2/*#Ops*/, 0, 2, 
             // Src: (and:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx), 255:{ *:[i32] }) - Complexity = 15
             // Dst: (EXTRACT_LANE_I8x16_u:{ *:[i32] } ?:{ *:[v16i8] }:$vec, (imm:{ *:[i32] }):$idx)
/*  4676*/  /*Scope*/ 34, /*->4711*/
/*  4677*/   OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  4681*/   OPC_MoveChild0,
/*  4682*/   OPC_CheckOpcode, TARGET_VAL(ISD::EXTRACT_VECTOR_ELT),
/*  4685*/   OPC_RecordChild0, // #0 = $vec
/*  4686*/   OPC_CheckChild0Type, MVT::v8i16,
/*  4688*/   OPC_RecordChild1, // #1 = $idx
/*  4689*/   OPC_MoveChild1,
/*  4690*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  4693*/   OPC_CheckPredicate, 7, // Predicate_LaneIdx8
/*  4695*/   OPC_CheckType, MVT::i32,
/*  4697*/   OPC_MoveParent,
/*  4698*/   OPC_MoveParent,
/*  4699*/   OPC_CheckType, MVT::i32,
/*  4701*/   OPC_EmitConvertToTarget, 1,
/*  4703*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTRACT_LANE_I16x8_u), 0,
                 MVT::i32, 2/*#Ops*/, 0, 2, 
             // Src: (and:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx), 65535:{ *:[i32] }) - Complexity = 15
             // Dst: (EXTRACT_LANE_I16x8_u:{ *:[i32] } ?:{ *:[v8i16] }:$vec, (imm:{ *:[i32] }):$idx)
/*  4711*/  /*Scope*/ 79, /*->4791*/
/*  4712*/   OPC_RecordChild0, // #0 = $lhs
/*  4713*/   OPC_Scope, 23, /*->4738*/ // 2 children in Scope
/*  4715*/    OPC_RecordChild1, // #1 = $rhs
/*  4716*/    OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->4727
/*  4719*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::AND_I32), 0,
                   MVT::i32, 2/*#Ops*/, 0, 1, 
               // Src: (and:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
               // Dst: (AND_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4727*/    /*SwitchType*/ 8, MVT::i64,// ->4737
/*  4729*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::AND_I64), 0,
                   MVT::i64, 2/*#Ops*/, 0, 1, 
               // Src: (and:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
               // Dst: (AND_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4737*/    0, // EndSwitchType
/*  4738*/   /*Scope*/ 51, /*->4790*/
/*  4739*/    OPC_MoveChild1,
/*  4740*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/*  4743*/    OPC_RecordChild0, // #1 = $rhs
/*  4744*/    OPC_MoveChild1,
/*  4745*/    OPC_CheckImmAllOnesV,
/*  4746*/    OPC_MoveParent,
/*  4747*/    OPC_MoveParent,
/*  4748*/    OPC_SwitchType /*4 cases */, 8, MVT::v16i8,// ->4759
/*  4751*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ANDNOT), 0,
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$rhs, immAllOnesV:{ *:[v16i8] })) - Complexity = 10
               // Dst: (ANDNOT:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/*  4759*/    /*SwitchType*/ 8, MVT::v8i16,// ->4769
/*  4761*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ANDNOT), 0,
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$rhs, immAllOnesV:{ *:[v8i16] })) - Complexity = 10
               // Dst: (ANDNOT:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/*  4769*/    /*SwitchType*/ 8, MVT::v4i32,// ->4779
/*  4771*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ANDNOT), 0,
                   MVT::v4i32, 2/*#Ops*/, 0, 1, 
               // Src: (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$rhs, immAllOnesV:{ *:[v4i32] })) - Complexity = 10
               // Dst: (ANDNOT:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/*  4779*/    /*SwitchType*/ 8, MVT::v2i64,// ->4789
/*  4781*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ANDNOT), 0,
                   MVT::v2i64, 2/*#Ops*/, 0, 1, 
               // Src: (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$rhs, immAllOnesV:{ *:[v2i64] })) - Complexity = 10
               // Dst: (ANDNOT:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/*  4789*/    0, // EndSwitchType
/*  4790*/   0, /*End of Scope*/
/*  4791*/  /*Scope*/ 52, /*->4844*/
/*  4792*/   OPC_MoveChild0,
/*  4793*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/*  4796*/   OPC_RecordChild0, // #0 = $rhs
/*  4797*/   OPC_MoveChild1,
/*  4798*/   OPC_CheckImmAllOnesV,
/*  4799*/   OPC_MoveParent,
/*  4800*/   OPC_MoveParent,
/*  4801*/   OPC_RecordChild1, // #1 = $lhs
/*  4802*/   OPC_SwitchType /*4 cases */, 8, MVT::v16i8,// ->4813
/*  4805*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ANDNOT), 0,
                  MVT::v16i8, 2/*#Ops*/, 1, 0, 
              // Src: (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$rhs, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$lhs) - Complexity = 10
              // Dst: (ANDNOT:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/*  4813*/   /*SwitchType*/ 8, MVT::v8i16,// ->4823
/*  4815*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ANDNOT), 0,
                  MVT::v8i16, 2/*#Ops*/, 1, 0, 
              // Src: (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$rhs, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$lhs) - Complexity = 10
              // Dst: (ANDNOT:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/*  4823*/   /*SwitchType*/ 8, MVT::v4i32,// ->4833
/*  4825*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ANDNOT), 0,
                  MVT::v4i32, 2/*#Ops*/, 1, 0, 
              // Src: (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$rhs, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$lhs) - Complexity = 10
              // Dst: (ANDNOT:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/*  4833*/   /*SwitchType*/ 8, MVT::v2i64,// ->4843
/*  4835*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ANDNOT), 0,
                  MVT::v2i64, 2/*#Ops*/, 1, 0, 
              // Src: (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$rhs, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$lhs) - Complexity = 10
              // Dst: (ANDNOT:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/*  4843*/   0, // EndSwitchType
/*  4844*/  /*Scope*/ 44, /*->4889*/
/*  4845*/   OPC_RecordChild0, // #0 = $lhs
/*  4846*/   OPC_RecordChild1, // #1 = $rhs
/*  4847*/   OPC_SwitchType /*4 cases */, 8, MVT::v16i8,// ->4858
/*  4850*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::AND), 0,
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
              // Dst: (AND:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/*  4858*/   /*SwitchType*/ 8, MVT::v8i16,// ->4868
/*  4860*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::AND), 0,
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
              // Dst: (AND:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/*  4868*/   /*SwitchType*/ 8, MVT::v4i32,// ->4878
/*  4870*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::AND), 0,
                  MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
              // Dst: (AND:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/*  4878*/   /*SwitchType*/ 8, MVT::v2i64,// ->4888
/*  4880*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::AND), 0,
                  MVT::v2i64, 2/*#Ops*/, 0, 1, 
              // Src: (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
              // Dst: (AND:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/*  4888*/   0, // EndSwitchType
/*  4889*/  0, /*End of Scope*/
/*  4890*/ /*SwitchOpcode*/ 109|128,12/*1645*/, TARGET_VAL(ISD::SETCC),// ->6539
/*  4894*/  OPC_Scope, 24|128,2/*280*/, /*->5177*/ // 2 children in Scope
/*  4897*/   OPC_MoveChild0,
/*  4898*/   OPC_CheckOpcode, TARGET_VAL(ISD::INTRINSIC_WO_CHAIN),
/*  4901*/   OPC_Scope, 7|128,1/*135*/, /*->5039*/ // 2 children in Scope
/*  4904*/    OPC_CheckChild0Integer, 84|128,56|128,1/*23636*/, 
/*  4908*/    OPC_RecordChild1, // #0 = $x
/*  4909*/    OPC_Scope, 31, /*->4942*/ // 4 children in Scope
/*  4911*/     OPC_CheckChild1Type, MVT::v16i8,
/*  4913*/     OPC_MoveParent,
/*  4914*/     OPC_CheckType, MVT::i32,
/*  4916*/     OPC_Scope, 11, /*->4929*/ // 2 children in Scope
/*  4918*/      OPC_CheckChild1Integer, 0, 
/*  4920*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4922*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ANYTRUE), 0,
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 11818:{ *:[iPTR] }, V128:{ *:[v16i8] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v16i8] }:$x)
/*  4929*/     /*Scope*/ 11, /*->4941*/
/*  4930*/      OPC_CheckChild1Integer, 2, 
/*  4932*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4934*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ANYTRUE), 0,
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 11818:{ *:[iPTR] }, V128:{ *:[v16i8] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v16i8] }:$x)
/*  4941*/     0, /*End of Scope*/
/*  4942*/    /*Scope*/ 31, /*->4974*/
/*  4943*/     OPC_CheckChild1Type, MVT::v8i16,
/*  4945*/     OPC_MoveParent,
/*  4946*/     OPC_CheckType, MVT::i32,
/*  4948*/     OPC_Scope, 11, /*->4961*/ // 2 children in Scope
/*  4950*/      OPC_CheckChild1Integer, 0, 
/*  4952*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4954*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ANYTRUE), 0,
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 11818:{ *:[iPTR] }, V128:{ *:[v8i16] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v8i16] }:$x)
/*  4961*/     /*Scope*/ 11, /*->4973*/
/*  4962*/      OPC_CheckChild1Integer, 2, 
/*  4964*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4966*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ANYTRUE), 0,
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 11818:{ *:[iPTR] }, V128:{ *:[v8i16] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v8i16] }:$x)
/*  4973*/     0, /*End of Scope*/
/*  4974*/    /*Scope*/ 31, /*->5006*/
/*  4975*/     OPC_CheckChild1Type, MVT::v4i32,
/*  4977*/     OPC_MoveParent,
/*  4978*/     OPC_CheckType, MVT::i32,
/*  4980*/     OPC_Scope, 11, /*->4993*/ // 2 children in Scope
/*  4982*/      OPC_CheckChild1Integer, 0, 
/*  4984*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4986*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ANYTRUE), 0,
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 11818:{ *:[iPTR] }, V128:{ *:[v4i32] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v4i32] }:$x)
/*  4993*/     /*Scope*/ 11, /*->5005*/
/*  4994*/      OPC_CheckChild1Integer, 2, 
/*  4996*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4998*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ANYTRUE), 0,
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 11818:{ *:[iPTR] }, V128:{ *:[v4i32] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v4i32] }:$x)
/*  5005*/     0, /*End of Scope*/
/*  5006*/    /*Scope*/ 31, /*->5038*/
/*  5007*/     OPC_CheckChild1Type, MVT::v2i64,
/*  5009*/     OPC_MoveParent,
/*  5010*/     OPC_CheckType, MVT::i32,
/*  5012*/     OPC_Scope, 11, /*->5025*/ // 2 children in Scope
/*  5014*/      OPC_CheckChild1Integer, 0, 
/*  5016*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  5018*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ANYTRUE), 0,
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 11818:{ *:[iPTR] }, V128:{ *:[v2i64] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v2i64] }:$x)
/*  5025*/     /*Scope*/ 11, /*->5037*/
/*  5026*/      OPC_CheckChild1Integer, 2, 
/*  5028*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5030*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ANYTRUE), 0,
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 11818:{ *:[iPTR] }, V128:{ *:[v2i64] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v2i64] }:$x)
/*  5037*/     0, /*End of Scope*/
/*  5038*/    0, /*End of Scope*/
/*  5039*/   /*Scope*/ 7|128,1/*135*/, /*->5176*/
/*  5041*/    OPC_CheckChild0Integer, 82|128,56|128,1/*23634*/, 
/*  5045*/    OPC_RecordChild1, // #0 = $x
/*  5046*/    OPC_Scope, 31, /*->5079*/ // 4 children in Scope
/*  5048*/     OPC_CheckChild1Type, MVT::v16i8,
/*  5050*/     OPC_MoveParent,
/*  5051*/     OPC_CheckType, MVT::i32,
/*  5053*/     OPC_Scope, 11, /*->5066*/ // 2 children in Scope
/*  5055*/      OPC_CheckChild1Integer, 0, 
/*  5057*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  5059*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ALLTRUE_I8x16), 0,
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 11817:{ *:[iPTR] }, V128:{ *:[v16i8] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I8x16:{ *:[i32] } ?:{ *:[v16i8] }:$x)
/*  5066*/     /*Scope*/ 11, /*->5078*/
/*  5067*/      OPC_CheckChild1Integer, 2, 
/*  5069*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5071*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ALLTRUE_I8x16), 0,
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 11817:{ *:[iPTR] }, V128:{ *:[v16i8] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I8x16:{ *:[i32] } ?:{ *:[v16i8] }:$x)
/*  5078*/     0, /*End of Scope*/
/*  5079*/    /*Scope*/ 31, /*->5111*/
/*  5080*/     OPC_CheckChild1Type, MVT::v8i16,
/*  5082*/     OPC_MoveParent,
/*  5083*/     OPC_CheckType, MVT::i32,
/*  5085*/     OPC_Scope, 11, /*->5098*/ // 2 children in Scope
/*  5087*/      OPC_CheckChild1Integer, 0, 
/*  5089*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  5091*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ALLTRUE_I16x8), 0,
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 11817:{ *:[iPTR] }, V128:{ *:[v8i16] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I16x8:{ *:[i32] } ?:{ *:[v8i16] }:$x)
/*  5098*/     /*Scope*/ 11, /*->5110*/
/*  5099*/      OPC_CheckChild1Integer, 2, 
/*  5101*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5103*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ALLTRUE_I16x8), 0,
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 11817:{ *:[iPTR] }, V128:{ *:[v8i16] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I16x8:{ *:[i32] } ?:{ *:[v8i16] }:$x)
/*  5110*/     0, /*End of Scope*/
/*  5111*/    /*Scope*/ 31, /*->5143*/
/*  5112*/     OPC_CheckChild1Type, MVT::v4i32,
/*  5114*/     OPC_MoveParent,
/*  5115*/     OPC_CheckType, MVT::i32,
/*  5117*/     OPC_Scope, 11, /*->5130*/ // 2 children in Scope
/*  5119*/      OPC_CheckChild1Integer, 0, 
/*  5121*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  5123*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ALLTRUE_I32x4), 0,
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 11817:{ *:[iPTR] }, V128:{ *:[v4i32] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I32x4:{ *:[i32] } ?:{ *:[v4i32] }:$x)
/*  5130*/     /*Scope*/ 11, /*->5142*/
/*  5131*/      OPC_CheckChild1Integer, 2, 
/*  5133*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5135*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ALLTRUE_I32x4), 0,
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 11817:{ *:[iPTR] }, V128:{ *:[v4i32] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I32x4:{ *:[i32] } ?:{ *:[v4i32] }:$x)
/*  5142*/     0, /*End of Scope*/
/*  5143*/    /*Scope*/ 31, /*->5175*/
/*  5144*/     OPC_CheckChild1Type, MVT::v2i64,
/*  5146*/     OPC_MoveParent,
/*  5147*/     OPC_CheckType, MVT::i32,
/*  5149*/     OPC_Scope, 11, /*->5162*/ // 2 children in Scope
/*  5151*/      OPC_CheckChild1Integer, 0, 
/*  5153*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  5155*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ALLTRUE_I64x2), 0,
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 11817:{ *:[iPTR] }, V128:{ *:[v2i64] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I64x2:{ *:[i32] } ?:{ *:[v2i64] }:$x)
/*  5162*/     /*Scope*/ 11, /*->5174*/
/*  5163*/      OPC_CheckChild1Integer, 2, 
/*  5165*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5167*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ALLTRUE_I64x2), 0,
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 11817:{ *:[iPTR] }, V128:{ *:[v2i64] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I64x2:{ *:[i32] } ?:{ *:[v2i64] }:$x)
/*  5174*/     0, /*End of Scope*/
/*  5175*/    0, /*End of Scope*/
/*  5176*/   0, /*End of Scope*/
/*  5177*/  /*Scope*/ 79|128,10/*1359*/, /*->6538*/
/*  5179*/   OPC_RecordChild0, // #0 = $src
/*  5180*/   OPC_SwitchType /*5 cases */, 32|128,4/*544*/, MVT::i32,// ->5728
/*  5184*/    OPC_Scope, 2|128,1/*130*/, /*->5317*/ // 4 children in Scope
/*  5187*/     OPC_CheckChild0Type, MVT::i32,
/*  5189*/     OPC_Scope, 11, /*->5202*/ // 2 children in Scope
/*  5191*/      OPC_CheckChild1Integer, 0, 
/*  5193*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5195*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EQZ_I32), 0,
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$src, 0:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 8
                // Dst: (EQZ_I32:{ *:[i32] } I32:{ *:[i32] }:$src)
/*  5202*/     /*Scope*/ 113, /*->5316*/
/*  5203*/      OPC_RecordChild1, // #1 = $rhs
/*  5204*/      OPC_Scope, 10, /*->5216*/ // 10 children in Scope
/*  5206*/       OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5208*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EQ_I32), 0,
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                 // Dst: (EQ_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  5216*/      /*Scope*/ 10, /*->5227*/
/*  5217*/       OPC_CheckChild2CondCode, ISD::SETNE,
/*  5219*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NE_I32), 0,
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                 // Dst: (NE_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  5227*/      /*Scope*/ 10, /*->5238*/
/*  5228*/       OPC_CheckChild2CondCode, ISD::SETLT,
/*  5230*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LT_S_I32), 0,
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                 // Dst: (LT_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  5238*/      /*Scope*/ 10, /*->5249*/
/*  5239*/       OPC_CheckChild2CondCode, ISD::SETULT,
/*  5241*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LT_U_I32), 0,
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETULT:{ *:[Other] }) - Complexity = 3
                 // Dst: (LT_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  5249*/      /*Scope*/ 10, /*->5260*/
/*  5250*/       OPC_CheckChild2CondCode, ISD::SETGT,
/*  5252*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GT_S_I32), 0,
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                 // Dst: (GT_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  5260*/      /*Scope*/ 10, /*->5271*/
/*  5261*/       OPC_CheckChild2CondCode, ISD::SETUGT,
/*  5263*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GT_U_I32), 0,
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETUGT:{ *:[Other] }) - Complexity = 3
                 // Dst: (GT_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  5271*/      /*Scope*/ 10, /*->5282*/
/*  5272*/       OPC_CheckChild2CondCode, ISD::SETLE,
/*  5274*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LE_S_I32), 0,
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                 // Dst: (LE_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  5282*/      /*Scope*/ 10, /*->5293*/
/*  5283*/       OPC_CheckChild2CondCode, ISD::SETULE,
/*  5285*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LE_U_I32), 0,
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETULE:{ *:[Other] }) - Complexity = 3
                 // Dst: (LE_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  5293*/      /*Scope*/ 10, /*->5304*/
/*  5294*/       OPC_CheckChild2CondCode, ISD::SETGE,
/*  5296*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GE_S_I32), 0,
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                 // Dst: (GE_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  5304*/      /*Scope*/ 10, /*->5315*/
/*  5305*/       OPC_CheckChild2CondCode, ISD::SETUGE,
/*  5307*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GE_U_I32), 0,
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETUGE:{ *:[Other] }) - Complexity = 3
                 // Dst: (GE_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  5315*/      0, /*End of Scope*/
/*  5316*/     0, /*End of Scope*/
/*  5317*/    /*Scope*/ 2|128,1/*130*/, /*->5449*/
/*  5319*/     OPC_CheckChild0Type, MVT::i64,
/*  5321*/     OPC_Scope, 11, /*->5334*/ // 2 children in Scope
/*  5323*/      OPC_CheckChild1Integer, 0, 
/*  5325*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5327*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EQZ_I64), 0,
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$src, 0:{ *:[i64] }, SETEQ:{ *:[Other] }) - Complexity = 8
                // Dst: (EQZ_I64:{ *:[i32] } I64:{ *:[i64] }:$src)
/*  5334*/     /*Scope*/ 113, /*->5448*/
/*  5335*/      OPC_RecordChild1, // #1 = $rhs
/*  5336*/      OPC_Scope, 10, /*->5348*/ // 10 children in Scope
/*  5338*/       OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5340*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EQ_I64), 0,
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                 // Dst: (EQ_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  5348*/      /*Scope*/ 10, /*->5359*/
/*  5349*/       OPC_CheckChild2CondCode, ISD::SETNE,
/*  5351*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NE_I64), 0,
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                 // Dst: (NE_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  5359*/      /*Scope*/ 10, /*->5370*/
/*  5360*/       OPC_CheckChild2CondCode, ISD::SETLT,
/*  5362*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LT_S_I64), 0,
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                 // Dst: (LT_S_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  5370*/      /*Scope*/ 10, /*->5381*/
/*  5371*/       OPC_CheckChild2CondCode, ISD::SETULT,
/*  5373*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LT_U_I64), 0,
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETULT:{ *:[Other] }) - Complexity = 3
                 // Dst: (LT_U_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  5381*/      /*Scope*/ 10, /*->5392*/
/*  5382*/       OPC_CheckChild2CondCode, ISD::SETGT,
/*  5384*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GT_S_I64), 0,
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                 // Dst: (GT_S_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  5392*/      /*Scope*/ 10, /*->5403*/
/*  5393*/       OPC_CheckChild2CondCode, ISD::SETUGT,
/*  5395*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GT_U_I64), 0,
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETUGT:{ *:[Other] }) - Complexity = 3
                 // Dst: (GT_U_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  5403*/      /*Scope*/ 10, /*->5414*/
/*  5404*/       OPC_CheckChild2CondCode, ISD::SETLE,
/*  5406*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LE_S_I64), 0,
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                 // Dst: (LE_S_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  5414*/      /*Scope*/ 10, /*->5425*/
/*  5415*/       OPC_CheckChild2CondCode, ISD::SETULE,
/*  5417*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LE_U_I64), 0,
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETULE:{ *:[Other] }) - Complexity = 3
                 // Dst: (LE_U_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  5425*/      /*Scope*/ 10, /*->5436*/
/*  5426*/       OPC_CheckChild2CondCode, ISD::SETGE,
/*  5428*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GE_S_I64), 0,
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                 // Dst: (GE_S_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  5436*/      /*Scope*/ 10, /*->5447*/
/*  5437*/       OPC_CheckChild2CondCode, ISD::SETUGE,
/*  5439*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GE_U_I64), 0,
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETUGE:{ *:[Other] }) - Complexity = 3
                 // Dst: (GE_U_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  5447*/      0, /*End of Scope*/
/*  5448*/     0, /*End of Scope*/
/*  5449*/    /*Scope*/ 9|128,1/*137*/, /*->5588*/
/*  5451*/     OPC_CheckChild0Type, MVT::f32,
/*  5453*/     OPC_RecordChild1, // #1 = $rhs
/*  5454*/     OPC_Scope, 10, /*->5466*/ // 12 children in Scope
/*  5456*/      OPC_CheckChild2CondCode, ISD::SETOEQ,
/*  5458*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EQ_F32), 0,
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, SETOEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F32:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/*  5466*/     /*Scope*/ 10, /*->5477*/
/*  5467*/      OPC_CheckChild2CondCode, ISD::SETUNE,
/*  5469*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NE_F32), 0,
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, SETUNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F32:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/*  5477*/     /*Scope*/ 10, /*->5488*/
/*  5478*/      OPC_CheckChild2CondCode, ISD::SETOLT,
/*  5480*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LT_F32), 0,
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, SETOLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F32:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/*  5488*/     /*Scope*/ 10, /*->5499*/
/*  5489*/      OPC_CheckChild2CondCode, ISD::SETOLE,
/*  5491*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LE_F32), 0,
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, SETOLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F32:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/*  5499*/     /*Scope*/ 10, /*->5510*/
/*  5500*/      OPC_CheckChild2CondCode, ISD::SETOGT,
/*  5502*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GT_F32), 0,
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, SETOGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F32:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/*  5510*/     /*Scope*/ 10, /*->5521*/
/*  5511*/      OPC_CheckChild2CondCode, ISD::SETOGE,
/*  5513*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GE_F32), 0,
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, SETOGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F32:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/*  5521*/     /*Scope*/ 10, /*->5532*/
/*  5522*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5524*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EQ_F32), 0,
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F32:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
/*  5532*/     /*Scope*/ 10, /*->5543*/
/*  5533*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  5535*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NE_F32), 0,
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F32:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
/*  5543*/     /*Scope*/ 10, /*->5554*/
/*  5544*/      OPC_CheckChild2CondCode, ISD::SETLT,
/*  5546*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LT_F32), 0,
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F32:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
/*  5554*/     /*Scope*/ 10, /*->5565*/
/*  5555*/      OPC_CheckChild2CondCode, ISD::SETLE,
/*  5557*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LE_F32), 0,
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F32:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
/*  5565*/     /*Scope*/ 10, /*->5576*/
/*  5566*/      OPC_CheckChild2CondCode, ISD::SETGT,
/*  5568*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GT_F32), 0,
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F32:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
/*  5576*/     /*Scope*/ 10, /*->5587*/
/*  5577*/      OPC_CheckChild2CondCode, ISD::SETGE,
/*  5579*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GE_F32), 0,
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F32:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
/*  5587*/     0, /*End of Scope*/
/*  5588*/    /*Scope*/ 9|128,1/*137*/, /*->5727*/
/*  5590*/     OPC_CheckChild0Type, MVT::f64,
/*  5592*/     OPC_RecordChild1, // #1 = $rhs
/*  5593*/     OPC_Scope, 10, /*->5605*/ // 12 children in Scope
/*  5595*/      OPC_CheckChild2CondCode, ISD::SETOEQ,
/*  5597*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EQ_F64), 0,
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, SETOEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F64:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/*  5605*/     /*Scope*/ 10, /*->5616*/
/*  5606*/      OPC_CheckChild2CondCode, ISD::SETUNE,
/*  5608*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NE_F64), 0,
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, SETUNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F64:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/*  5616*/     /*Scope*/ 10, /*->5627*/
/*  5617*/      OPC_CheckChild2CondCode, ISD::SETOLT,
/*  5619*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LT_F64), 0,
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, SETOLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F64:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/*  5627*/     /*Scope*/ 10, /*->5638*/
/*  5628*/      OPC_CheckChild2CondCode, ISD::SETOLE,
/*  5630*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LE_F64), 0,
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, SETOLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F64:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/*  5638*/     /*Scope*/ 10, /*->5649*/
/*  5639*/      OPC_CheckChild2CondCode, ISD::SETOGT,
/*  5641*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GT_F64), 0,
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, SETOGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F64:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/*  5649*/     /*Scope*/ 10, /*->5660*/
/*  5650*/      OPC_CheckChild2CondCode, ISD::SETOGE,
/*  5652*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GE_F64), 0,
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, SETOGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F64:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/*  5660*/     /*Scope*/ 10, /*->5671*/
/*  5661*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5663*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EQ_F64), 0,
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F64:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
/*  5671*/     /*Scope*/ 10, /*->5682*/
/*  5672*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  5674*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NE_F64), 0,
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F64:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
/*  5682*/     /*Scope*/ 10, /*->5693*/
/*  5683*/      OPC_CheckChild2CondCode, ISD::SETLT,
/*  5685*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LT_F64), 0,
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F64:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
/*  5693*/     /*Scope*/ 10, /*->5704*/
/*  5694*/      OPC_CheckChild2CondCode, ISD::SETLE,
/*  5696*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LE_F64), 0,
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F64:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
/*  5704*/     /*Scope*/ 10, /*->5715*/
/*  5705*/      OPC_CheckChild2CondCode, ISD::SETGT,
/*  5707*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GT_F64), 0,
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F64:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
/*  5715*/     /*Scope*/ 10, /*->5726*/
/*  5716*/      OPC_CheckChild2CondCode, ISD::SETGE,
/*  5718*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GE_F64), 0,
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F64:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
/*  5726*/     0, /*End of Scope*/
/*  5727*/    0, /*End of Scope*/
/*  5728*/   /*SwitchType*/ 7|128,1/*135*/, MVT::v16i8,// ->5866
/*  5731*/    OPC_CheckChild0Type, MVT::v16i8,
/*  5733*/    OPC_RecordChild1, // #1 = $rhs
/*  5734*/    OPC_Scope, 12, /*->5748*/ // 10 children in Scope
/*  5736*/     OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5738*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  5740*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EQ_I8x16), 0,
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
               // Dst: (EQ_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5748*/    /*Scope*/ 12, /*->5761*/
/*  5749*/     OPC_CheckChild2CondCode, ISD::SETNE,
/*  5751*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  5753*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NE_I8x16), 0,
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
               // Dst: (NE_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5761*/    /*Scope*/ 12, /*->5774*/
/*  5762*/     OPC_CheckChild2CondCode, ISD::SETLT,
/*  5764*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  5766*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LT_S_I8x16), 0,
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
               // Dst: (LT_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5774*/    /*Scope*/ 12, /*->5787*/
/*  5775*/     OPC_CheckChild2CondCode, ISD::SETULT,
/*  5777*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  5779*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LT_U_I8x16), 0,
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETULT:{ *:[Other] }) - Complexity = 3
               // Dst: (LT_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5787*/    /*Scope*/ 12, /*->5800*/
/*  5788*/     OPC_CheckChild2CondCode, ISD::SETGT,
/*  5790*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  5792*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GT_S_I8x16), 0,
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
               // Dst: (GT_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5800*/    /*Scope*/ 12, /*->5813*/
/*  5801*/     OPC_CheckChild2CondCode, ISD::SETUGT,
/*  5803*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  5805*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GT_U_I8x16), 0,
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETUGT:{ *:[Other] }) - Complexity = 3
               // Dst: (GT_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5813*/    /*Scope*/ 12, /*->5826*/
/*  5814*/     OPC_CheckChild2CondCode, ISD::SETLE,
/*  5816*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  5818*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LE_S_I8x16), 0,
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
               // Dst: (LE_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5826*/    /*Scope*/ 12, /*->5839*/
/*  5827*/     OPC_CheckChild2CondCode, ISD::SETULE,
/*  5829*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  5831*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LE_U_I8x16), 0,
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETULE:{ *:[Other] }) - Complexity = 3
               // Dst: (LE_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5839*/    /*Scope*/ 12, /*->5852*/
/*  5840*/     OPC_CheckChild2CondCode, ISD::SETGE,
/*  5842*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  5844*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GE_S_I8x16), 0,
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
               // Dst: (GE_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5852*/    /*Scope*/ 12, /*->5865*/
/*  5853*/     OPC_CheckChild2CondCode, ISD::SETUGE,
/*  5855*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  5857*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GE_U_I8x16), 0,
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETUGE:{ *:[Other] }) - Complexity = 3
               // Dst: (GE_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5865*/    0, /*End of Scope*/
/*  5866*/   /*SwitchType*/ 7|128,1/*135*/, MVT::v8i16,// ->6004
/*  5869*/    OPC_CheckChild0Type, MVT::v8i16,
/*  5871*/    OPC_RecordChild1, // #1 = $rhs
/*  5872*/    OPC_Scope, 12, /*->5886*/ // 10 children in Scope
/*  5874*/     OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5876*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  5878*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EQ_I16x8), 0,
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
               // Dst: (EQ_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5886*/    /*Scope*/ 12, /*->5899*/
/*  5887*/     OPC_CheckChild2CondCode, ISD::SETNE,
/*  5889*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  5891*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NE_I16x8), 0,
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
               // Dst: (NE_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5899*/    /*Scope*/ 12, /*->5912*/
/*  5900*/     OPC_CheckChild2CondCode, ISD::SETLT,
/*  5902*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  5904*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LT_S_I16x8), 0,
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
               // Dst: (LT_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5912*/    /*Scope*/ 12, /*->5925*/
/*  5913*/     OPC_CheckChild2CondCode, ISD::SETULT,
/*  5915*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  5917*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LT_U_I16x8), 0,
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETULT:{ *:[Other] }) - Complexity = 3
               // Dst: (LT_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5925*/    /*Scope*/ 12, /*->5938*/
/*  5926*/     OPC_CheckChild2CondCode, ISD::SETGT,
/*  5928*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  5930*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GT_S_I16x8), 0,
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
               // Dst: (GT_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5938*/    /*Scope*/ 12, /*->5951*/
/*  5939*/     OPC_CheckChild2CondCode, ISD::SETUGT,
/*  5941*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  5943*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GT_U_I16x8), 0,
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETUGT:{ *:[Other] }) - Complexity = 3
               // Dst: (GT_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5951*/    /*Scope*/ 12, /*->5964*/
/*  5952*/     OPC_CheckChild2CondCode, ISD::SETLE,
/*  5954*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  5956*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LE_S_I16x8), 0,
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
               // Dst: (LE_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5964*/    /*Scope*/ 12, /*->5977*/
/*  5965*/     OPC_CheckChild2CondCode, ISD::SETULE,
/*  5967*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  5969*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LE_U_I16x8), 0,
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETULE:{ *:[Other] }) - Complexity = 3
               // Dst: (LE_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5977*/    /*Scope*/ 12, /*->5990*/
/*  5978*/     OPC_CheckChild2CondCode, ISD::SETGE,
/*  5980*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  5982*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GE_S_I16x8), 0,
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
               // Dst: (GE_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5990*/    /*Scope*/ 12, /*->6003*/
/*  5991*/     OPC_CheckChild2CondCode, ISD::SETUGE,
/*  5993*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  5995*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GE_U_I16x8), 0,
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETUGE:{ *:[Other] }) - Complexity = 3
               // Dst: (GE_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  6003*/    0, /*End of Scope*/
/*  6004*/   /*SwitchType*/ 34|128,2/*290*/, MVT::v4i32,// ->6297
/*  6007*/    OPC_Scope, 7|128,1/*135*/, /*->6145*/ // 2 children in Scope
/*  6010*/     OPC_CheckChild0Type, MVT::v4i32,
/*  6012*/     OPC_RecordChild1, // #1 = $rhs
/*  6013*/     OPC_Scope, 12, /*->6027*/ // 10 children in Scope
/*  6015*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  6017*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  6019*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EQ_I32x4), 0,
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  6027*/     /*Scope*/ 12, /*->6040*/
/*  6028*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  6030*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  6032*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NE_I32x4), 0,
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  6040*/     /*Scope*/ 12, /*->6053*/
/*  6041*/      OPC_CheckChild2CondCode, ISD::SETLT,
/*  6043*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  6045*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LT_S_I32x4), 0,
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  6053*/     /*Scope*/ 12, /*->6066*/
/*  6054*/      OPC_CheckChild2CondCode, ISD::SETULT,
/*  6056*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  6058*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LT_U_I32x4), 0,
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETULT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  6066*/     /*Scope*/ 12, /*->6079*/
/*  6067*/      OPC_CheckChild2CondCode, ISD::SETGT,
/*  6069*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  6071*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GT_S_I32x4), 0,
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  6079*/     /*Scope*/ 12, /*->6092*/
/*  6080*/      OPC_CheckChild2CondCode, ISD::SETUGT,
/*  6082*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  6084*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GT_U_I32x4), 0,
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETUGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  6092*/     /*Scope*/ 12, /*->6105*/
/*  6093*/      OPC_CheckChild2CondCode, ISD::SETLE,
/*  6095*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  6097*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LE_S_I32x4), 0,
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  6105*/     /*Scope*/ 12, /*->6118*/
/*  6106*/      OPC_CheckChild2CondCode, ISD::SETULE,
/*  6108*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  6110*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LE_U_I32x4), 0,
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETULE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  6118*/     /*Scope*/ 12, /*->6131*/
/*  6119*/      OPC_CheckChild2CondCode, ISD::SETGE,
/*  6121*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  6123*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GE_S_I32x4), 0,
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  6131*/     /*Scope*/ 12, /*->6144*/
/*  6132*/      OPC_CheckChild2CondCode, ISD::SETUGE,
/*  6134*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  6136*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GE_U_I32x4), 0,
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETUGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  6144*/     0, /*End of Scope*/
/*  6145*/    /*Scope*/ 21|128,1/*149*/, /*->6296*/
/*  6147*/     OPC_CheckChild0Type, MVT::v4f32,
/*  6149*/     OPC_RecordChild1, // #1 = $rhs
/*  6150*/     OPC_Scope, 12, /*->6164*/ // 12 children in Scope
/*  6152*/      OPC_CheckChild2CondCode, ISD::SETOEQ,
/*  6154*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  6156*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EQ_F32x4), 0,
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/*  6164*/     /*Scope*/ 12, /*->6177*/
/*  6165*/      OPC_CheckChild2CondCode, ISD::SETUNE,
/*  6167*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  6169*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NE_F32x4), 0,
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETUNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/*  6177*/     /*Scope*/ 12, /*->6190*/
/*  6178*/      OPC_CheckChild2CondCode, ISD::SETOLT,
/*  6180*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  6182*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LT_F32x4), 0,
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/*  6190*/     /*Scope*/ 12, /*->6203*/
/*  6191*/      OPC_CheckChild2CondCode, ISD::SETOGT,
/*  6193*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  6195*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GT_F32x4), 0,
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/*  6203*/     /*Scope*/ 12, /*->6216*/
/*  6204*/      OPC_CheckChild2CondCode, ISD::SETOLE,
/*  6206*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  6208*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LE_F32x4), 0,
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/*  6216*/     /*Scope*/ 12, /*->6229*/
/*  6217*/      OPC_CheckChild2CondCode, ISD::SETOGE,
/*  6219*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  6221*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GE_F32x4), 0,
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/*  6229*/     /*Scope*/ 10, /*->6240*/
/*  6230*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  6232*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EQ_F32x4), 0,
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs)
/*  6240*/     /*Scope*/ 10, /*->6251*/
/*  6241*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  6243*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NE_F32x4), 0,
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs)
/*  6251*/     /*Scope*/ 10, /*->6262*/
/*  6252*/      OPC_CheckChild2CondCode, ISD::SETLT,
/*  6254*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LT_F32x4), 0,
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs)
/*  6262*/     /*Scope*/ 10, /*->6273*/
/*  6263*/      OPC_CheckChild2CondCode, ISD::SETGT,
/*  6265*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GT_F32x4), 0,
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs)
/*  6273*/     /*Scope*/ 10, /*->6284*/
/*  6274*/      OPC_CheckChild2CondCode, ISD::SETLE,
/*  6276*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LE_F32x4), 0,
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs)
/*  6284*/     /*Scope*/ 10, /*->6295*/
/*  6285*/      OPC_CheckChild2CondCode, ISD::SETGE,
/*  6287*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GE_F32x4), 0,
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs)
/*  6295*/     0, /*End of Scope*/
/*  6296*/    0, /*End of Scope*/
/*  6297*/   /*SwitchType*/ 109|128,1/*237*/, MVT::v2i64,// ->6537
/*  6300*/    OPC_Scope, 83, /*->6385*/ // 2 children in Scope
/*  6302*/     OPC_CheckChild0Type, MVT::v2i64,
/*  6304*/     OPC_RecordChild1, // #1 = $rhs
/*  6305*/     OPC_Scope, 12, /*->6319*/ // 6 children in Scope
/*  6307*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  6309*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  6311*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EQ_I64x2), 0,
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/*  6319*/     /*Scope*/ 12, /*->6332*/
/*  6320*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  6322*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  6324*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NE_I64x2), 0,
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/*  6332*/     /*Scope*/ 12, /*->6345*/
/*  6333*/      OPC_CheckChild2CondCode, ISD::SETLT,
/*  6335*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  6337*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LT_S_I64x2), 0,
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/*  6345*/     /*Scope*/ 12, /*->6358*/
/*  6346*/      OPC_CheckChild2CondCode, ISD::SETGT,
/*  6348*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  6350*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GT_S_I64x2), 0,
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/*  6358*/     /*Scope*/ 12, /*->6371*/
/*  6359*/      OPC_CheckChild2CondCode, ISD::SETLE,
/*  6361*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  6363*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LE_S_I64x2), 0,
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/*  6371*/     /*Scope*/ 12, /*->6384*/
/*  6372*/      OPC_CheckChild2CondCode, ISD::SETGE,
/*  6374*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  6376*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GE_S_I64x2), 0,
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/*  6384*/     0, /*End of Scope*/
/*  6385*/    /*Scope*/ 21|128,1/*149*/, /*->6536*/
/*  6387*/     OPC_CheckChild0Type, MVT::v2f64,
/*  6389*/     OPC_RecordChild1, // #1 = $rhs
/*  6390*/     OPC_Scope, 12, /*->6404*/ // 12 children in Scope
/*  6392*/      OPC_CheckChild2CondCode, ISD::SETOEQ,
/*  6394*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  6396*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EQ_F64x2), 0,
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F64x2:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/*  6404*/     /*Scope*/ 12, /*->6417*/
/*  6405*/      OPC_CheckChild2CondCode, ISD::SETUNE,
/*  6407*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  6409*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NE_F64x2), 0,
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETUNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F64x2:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/*  6417*/     /*Scope*/ 12, /*->6430*/
/*  6418*/      OPC_CheckChild2CondCode, ISD::SETOLT,
/*  6420*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  6422*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LT_F64x2), 0,
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F64x2:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/*  6430*/     /*Scope*/ 12, /*->6443*/
/*  6431*/      OPC_CheckChild2CondCode, ISD::SETOGT,
/*  6433*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  6435*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GT_F64x2), 0,
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F64x2:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/*  6443*/     /*Scope*/ 12, /*->6456*/
/*  6444*/      OPC_CheckChild2CondCode, ISD::SETOLE,
/*  6446*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  6448*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LE_F64x2), 0,
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F64x2:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/*  6456*/     /*Scope*/ 12, /*->6469*/
/*  6457*/      OPC_CheckChild2CondCode, ISD::SETOGE,
/*  6459*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  6461*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GE_F64x2), 0,
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F64x2:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/*  6469*/     /*Scope*/ 10, /*->6480*/
/*  6470*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  6472*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EQ_F64x2), 0,
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F64x2:{ *:[v2i64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs)
/*  6480*/     /*Scope*/ 10, /*->6491*/
/*  6481*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  6483*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NE_F64x2), 0,
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F64x2:{ *:[v2i64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs)
/*  6491*/     /*Scope*/ 10, /*->6502*/
/*  6492*/      OPC_CheckChild2CondCode, ISD::SETLT,
/*  6494*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LT_F64x2), 0,
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F64x2:{ *:[v2i64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs)
/*  6502*/     /*Scope*/ 10, /*->6513*/
/*  6503*/      OPC_CheckChild2CondCode, ISD::SETGT,
/*  6505*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GT_F64x2), 0,
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F64x2:{ *:[v2i64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs)
/*  6513*/     /*Scope*/ 10, /*->6524*/
/*  6514*/      OPC_CheckChild2CondCode, ISD::SETLE,
/*  6516*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LE_F64x2), 0,
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F64x2:{ *:[v2i64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs)
/*  6524*/     /*Scope*/ 10, /*->6535*/
/*  6525*/      OPC_CheckChild2CondCode, ISD::SETGE,
/*  6527*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GE_F64x2), 0,
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F64x2:{ *:[v2i64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs)
/*  6535*/     0, /*End of Scope*/
/*  6536*/    0, /*End of Scope*/
/*  6537*/   0, // EndSwitchType
/*  6538*/  0, /*End of Scope*/
/*  6539*/ /*SwitchOpcode*/ 11|128,13/*1675*/, TARGET_VAL(ISD::LOAD),// ->8218
/*  6543*/  OPC_RecordMemRef,
/*  6544*/  OPC_RecordNode, // #0 = 'ld' chained node
/*  6545*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  6546*/  OPC_Scope, 65|128,6/*833*/, /*->7382*/ // 2 children in Scope
/*  6549*/   OPC_CheckChild1Type, MVT::i32,
/*  6551*/   OPC_CheckPredicate, 14, // Predicate_unindexedload
/*  6553*/   OPC_Scope, 44, /*->6599*/ // 16 children in Scope
/*  6555*/    OPC_CheckPredicate, 15, // Predicate_load
/*  6557*/    OPC_SwitchType /*2 cases */, 18, MVT::i32,// ->6578
/*  6560*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  6562*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6565*/     OPC_EmitMergeInputChains1_0,
/*  6566*/     OPC_EmitInteger, MVT::i32, 0, 
/*  6569*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6578*/    /*SwitchType*/ 18, MVT::i64,// ->6598
/*  6580*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  6582*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6585*/     OPC_EmitMergeInputChains1_0,
/*  6586*/     OPC_EmitInteger, MVT::i32, 0, 
/*  6589*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6598*/    0, // EndSwitchType
/*  6599*/   /*Scope*/ 117, /*->6717*/
/*  6600*/    OPC_CheckPredicate, 16, // Predicate_sextload
/*  6602*/    OPC_SwitchType /*2 cases */, 44, MVT::i32,// ->6649
/*  6605*/     OPC_Scope, 20, /*->6627*/ // 2 children in Scope
/*  6607*/      OPC_CheckPredicate, 0, // Predicate_sextloadi8
/*  6609*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  6611*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6614*/      OPC_EmitMergeInputChains1_0,
/*  6615*/      OPC_EmitInteger, MVT::i32, 0, 
/*  6618*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 13
                // Dst: (LOAD8_S_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6627*/     /*Scope*/ 20, /*->6648*/
/*  6628*/      OPC_CheckPredicate, 1, // Predicate_sextloadi16
/*  6630*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  6632*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6635*/      OPC_EmitMergeInputChains1_0,
/*  6636*/      OPC_EmitInteger, MVT::i32, 0, 
/*  6639*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 13
                // Dst: (LOAD16_S_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6648*/     0, /*End of Scope*/
/*  6649*/    /*SwitchType*/ 65, MVT::i64,// ->6716
/*  6651*/     OPC_Scope, 20, /*->6673*/ // 3 children in Scope
/*  6653*/      OPC_CheckPredicate, 0, // Predicate_sextloadi8
/*  6655*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  6657*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6660*/      OPC_EmitMergeInputChains1_0,
/*  6661*/      OPC_EmitInteger, MVT::i32, 0, 
/*  6664*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 13
                // Dst: (LOAD8_S_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6673*/     /*Scope*/ 20, /*->6694*/
/*  6674*/      OPC_CheckPredicate, 1, // Predicate_sextloadi16
/*  6676*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  6678*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6681*/      OPC_EmitMergeInputChains1_0,
/*  6682*/      OPC_EmitInteger, MVT::i32, 0, 
/*  6685*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 13
                // Dst: (LOAD16_S_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6694*/     /*Scope*/ 20, /*->6715*/
/*  6695*/      OPC_CheckPredicate, 2, // Predicate_sextloadi32
/*  6697*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  6699*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6702*/      OPC_EmitMergeInputChains1_0,
/*  6703*/      OPC_EmitInteger, MVT::i32, 0, 
/*  6706*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_S_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>> - Complexity = 13
                // Dst: (LOAD32_S_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6715*/     0, /*End of Scope*/
/*  6716*/    0, // EndSwitchType
/*  6717*/   /*Scope*/ 117, /*->6835*/
/*  6718*/    OPC_CheckPredicate, 17, // Predicate_zextload
/*  6720*/    OPC_SwitchType /*2 cases */, 44, MVT::i32,// ->6767
/*  6723*/     OPC_Scope, 20, /*->6745*/ // 2 children in Scope
/*  6725*/      OPC_CheckPredicate, 0, // Predicate_zextloadi8
/*  6727*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  6729*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6732*/      OPC_EmitMergeInputChains1_0,
/*  6733*/      OPC_EmitInteger, MVT::i32, 0, 
/*  6736*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6745*/     /*Scope*/ 20, /*->6766*/
/*  6746*/      OPC_CheckPredicate, 1, // Predicate_zextloadi16
/*  6748*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  6750*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6753*/      OPC_EmitMergeInputChains1_0,
/*  6754*/      OPC_EmitInteger, MVT::i32, 0, 
/*  6757*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6766*/     0, /*End of Scope*/
/*  6767*/    /*SwitchType*/ 65, MVT::i64,// ->6834
/*  6769*/     OPC_Scope, 20, /*->6791*/ // 3 children in Scope
/*  6771*/      OPC_CheckPredicate, 0, // Predicate_zextloadi8
/*  6773*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  6775*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6778*/      OPC_EmitMergeInputChains1_0,
/*  6779*/      OPC_EmitInteger, MVT::i32, 0, 
/*  6782*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6791*/     /*Scope*/ 20, /*->6812*/
/*  6792*/      OPC_CheckPredicate, 1, // Predicate_zextloadi16
/*  6794*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  6796*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6799*/      OPC_EmitMergeInputChains1_0,
/*  6800*/      OPC_EmitInteger, MVT::i32, 0, 
/*  6803*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6812*/     /*Scope*/ 20, /*->6833*/
/*  6813*/      OPC_CheckPredicate, 2, // Predicate_zextloadi32
/*  6815*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  6817*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6820*/      OPC_EmitMergeInputChains1_0,
/*  6821*/      OPC_EmitInteger, MVT::i32, 0, 
/*  6824*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>> - Complexity = 13
                // Dst: (LOAD32_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6833*/     0, /*End of Scope*/
/*  6834*/    0, // EndSwitchType
/*  6835*/   /*Scope*/ 117, /*->6953*/
/*  6836*/    OPC_CheckPredicate, 18, // Predicate_extload
/*  6838*/    OPC_SwitchType /*2 cases */, 44, MVT::i32,// ->6885
/*  6841*/     OPC_Scope, 20, /*->6863*/ // 2 children in Scope
/*  6843*/      OPC_CheckPredicate, 0, // Predicate_extloadi8
/*  6845*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  6847*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6850*/      OPC_EmitMergeInputChains1_0,
/*  6851*/      OPC_EmitInteger, MVT::i32, 0, 
/*  6854*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6863*/     /*Scope*/ 20, /*->6884*/
/*  6864*/      OPC_CheckPredicate, 1, // Predicate_extloadi16
/*  6866*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  6868*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6871*/      OPC_EmitMergeInputChains1_0,
/*  6872*/      OPC_EmitInteger, MVT::i32, 0, 
/*  6875*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6884*/     0, /*End of Scope*/
/*  6885*/    /*SwitchType*/ 65, MVT::i64,// ->6952
/*  6887*/     OPC_Scope, 20, /*->6909*/ // 3 children in Scope
/*  6889*/      OPC_CheckPredicate, 0, // Predicate_extloadi8
/*  6891*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  6893*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6896*/      OPC_EmitMergeInputChains1_0,
/*  6897*/      OPC_EmitInteger, MVT::i32, 0, 
/*  6900*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6909*/     /*Scope*/ 20, /*->6930*/
/*  6910*/      OPC_CheckPredicate, 1, // Predicate_extloadi16
/*  6912*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  6914*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6917*/      OPC_EmitMergeInputChains1_0,
/*  6918*/      OPC_EmitInteger, MVT::i32, 0, 
/*  6921*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6930*/     /*Scope*/ 20, /*->6951*/
/*  6931*/      OPC_CheckPredicate, 2, // Predicate_extloadi32
/*  6933*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  6935*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6938*/      OPC_EmitMergeInputChains1_0,
/*  6939*/      OPC_EmitInteger, MVT::i32, 0, 
/*  6942*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>> - Complexity = 13
                // Dst: (LOAD32_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6951*/     0, /*End of Scope*/
/*  6952*/    0, // EndSwitchType
/*  6953*/   /*Scope*/ 124, /*->7078*/
/*  6954*/    OPC_CheckPredicate, 15, // Predicate_load
/*  6956*/    OPC_SwitchType /*6 cases */, 18, MVT::f32,// ->6977
/*  6959*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  6961*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6964*/     OPC_EmitMergeInputChains1_0,
/*  6965*/     OPC_EmitInteger, MVT::i32, 0, 
/*  6968*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::f32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[f32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_F32_A32:{ *:[f32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6977*/    /*SwitchType*/ 18, MVT::f64,// ->6997
/*  6979*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  6981*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6984*/     OPC_EmitMergeInputChains1_0,
/*  6985*/     OPC_EmitInteger, MVT::i32, 0, 
/*  6988*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::f64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[f64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_F64_A32:{ *:[f64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6997*/    /*SwitchType*/ 18, MVT::v16i8,// ->7017
/*  6999*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  7001*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  7004*/     OPC_EmitMergeInputChains1_0,
/*  7005*/     OPC_EmitInteger, MVT::i32, 0, 
/*  7008*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v16i8, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v16i8] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A32:{ *:[v16i8] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  7017*/    /*SwitchType*/ 18, MVT::v8i16,// ->7037
/*  7019*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  7021*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  7024*/     OPC_EmitMergeInputChains1_0,
/*  7025*/     OPC_EmitInteger, MVT::i32, 0, 
/*  7028*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v8i16, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v8i16] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A32:{ *:[v8i16] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  7037*/    /*SwitchType*/ 18, MVT::v4i32,// ->7057
/*  7039*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  7041*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  7044*/     OPC_EmitMergeInputChains1_0,
/*  7045*/     OPC_EmitInteger, MVT::i32, 0, 
/*  7048*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v4i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A32:{ *:[v4i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  7057*/    /*SwitchType*/ 18, MVT::v2i64,// ->7077
/*  7059*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  7061*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  7064*/     OPC_EmitMergeInputChains1_0,
/*  7065*/     OPC_EmitInteger, MVT::i32, 0, 
/*  7068*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v2i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A32:{ *:[v2i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  7077*/    0, // EndSwitchType
/*  7078*/   /*Scope*/ 24, /*->7103*/
/*  7079*/    OPC_CheckPredicate, 16, // Predicate_sextload
/*  7081*/    OPC_CheckPredicate, 19, // Predicate_sextloadvi8
/*  7083*/    OPC_CheckType, MVT::v8i16,
/*  7085*/    OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  7087*/    OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  7090*/    OPC_EmitMergeInputChains1_0,
/*  7091*/    OPC_EmitInteger, MVT::i32, 0, 
/*  7094*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I16x8_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v8i16, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v8i16] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi8>> - Complexity = 13
              // Dst: (LOAD_EXTEND_S_I16x8_A32:{ *:[v8i16] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  7103*/   /*Scope*/ 24, /*->7128*/
/*  7104*/    OPC_CheckPredicate, 17, // Predicate_zextload
/*  7106*/    OPC_CheckPredicate, 19, // Predicate_zextloadvi8
/*  7108*/    OPC_CheckType, MVT::v8i16,
/*  7110*/    OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  7112*/    OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  7115*/    OPC_EmitMergeInputChains1_0,
/*  7116*/    OPC_EmitInteger, MVT::i32, 0, 
/*  7119*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I16x8_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v8i16, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v8i16] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi8>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I16x8_A32:{ *:[v8i16] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  7128*/   /*Scope*/ 24, /*->7153*/
/*  7129*/    OPC_CheckPredicate, 18, // Predicate_extload
/*  7131*/    OPC_CheckPredicate, 19, // Predicate_extloadvi8
/*  7133*/    OPC_CheckType, MVT::v8i16,
/*  7135*/    OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  7137*/    OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  7140*/    OPC_EmitMergeInputChains1_0,
/*  7141*/    OPC_EmitInteger, MVT::i32, 0, 
/*  7144*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I16x8_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v8i16, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v8i16] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi8>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I16x8_A32:{ *:[v8i16] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  7153*/   /*Scope*/ 24, /*->7178*/
/*  7154*/    OPC_CheckPredicate, 16, // Predicate_sextload
/*  7156*/    OPC_CheckPredicate, 20, // Predicate_sextloadvi16
/*  7158*/    OPC_CheckType, MVT::v4i32,
/*  7160*/    OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  7162*/    OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  7165*/    OPC_EmitMergeInputChains1_0,
/*  7166*/    OPC_EmitInteger, MVT::i32, 0, 
/*  7169*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v4i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi16>> - Complexity = 13
              // Dst: (LOAD_EXTEND_S_I32x4_A32:{ *:[v4i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  7178*/   /*Scope*/ 24, /*->7203*/
/*  7179*/    OPC_CheckPredicate, 17, // Predicate_zextload
/*  7181*/    OPC_CheckPredicate, 20, // Predicate_zextloadvi16
/*  7183*/    OPC_CheckType, MVT::v4i32,
/*  7185*/    OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  7187*/    OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  7190*/    OPC_EmitMergeInputChains1_0,
/*  7191*/    OPC_EmitInteger, MVT::i32, 0, 
/*  7194*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v4i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi16>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I32x4_A32:{ *:[v4i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  7203*/   /*Scope*/ 24, /*->7228*/
/*  7204*/    OPC_CheckPredicate, 18, // Predicate_extload
/*  7206*/    OPC_CheckPredicate, 20, // Predicate_extloadvi16
/*  7208*/    OPC_CheckType, MVT::v4i32,
/*  7210*/    OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  7212*/    OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  7215*/    OPC_EmitMergeInputChains1_0,
/*  7216*/    OPC_EmitInteger, MVT::i32, 0, 
/*  7219*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v4i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi16>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I32x4_A32:{ *:[v4i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  7228*/   /*Scope*/ 24, /*->7253*/
/*  7229*/    OPC_CheckPredicate, 16, // Predicate_sextload
/*  7231*/    OPC_CheckPredicate, 21, // Predicate_sextloadvi32
/*  7233*/    OPC_CheckType, MVT::v2i64,
/*  7235*/    OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  7237*/    OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  7240*/    OPC_EmitMergeInputChains1_0,
/*  7241*/    OPC_EmitInteger, MVT::i32, 0, 
/*  7244*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v2i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi32>> - Complexity = 13
              // Dst: (LOAD_EXTEND_S_I64x2_A32:{ *:[v2i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  7253*/   /*Scope*/ 24, /*->7278*/
/*  7254*/    OPC_CheckPredicate, 17, // Predicate_zextload
/*  7256*/    OPC_CheckPredicate, 21, // Predicate_zextloadvi32
/*  7258*/    OPC_CheckType, MVT::v2i64,
/*  7260*/    OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  7262*/    OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  7265*/    OPC_EmitMergeInputChains1_0,
/*  7266*/    OPC_EmitInteger, MVT::i32, 0, 
/*  7269*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v2i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi32>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I64x2_A32:{ *:[v2i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  7278*/   /*Scope*/ 24, /*->7303*/
/*  7279*/    OPC_CheckPredicate, 18, // Predicate_extload
/*  7281*/    OPC_CheckPredicate, 21, // Predicate_extloadvi32
/*  7283*/    OPC_CheckType, MVT::v2i64,
/*  7285*/    OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  7287*/    OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  7290*/    OPC_EmitMergeInputChains1_0,
/*  7291*/    OPC_EmitInteger, MVT::i32, 0, 
/*  7294*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v2i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi32>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I64x2_A32:{ *:[v2i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  7303*/   /*Scope*/ 44, /*->7348*/
/*  7304*/    OPC_CheckPredicate, 15, // Predicate_load
/*  7306*/    OPC_SwitchType /*2 cases */, 18, MVT::v4f32,// ->7327
/*  7309*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  7311*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  7314*/     OPC_EmitMergeInputChains1_0,
/*  7315*/     OPC_EmitInteger, MVT::i32, 0, 
/*  7318*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v4f32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v4f32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A32:{ *:[v4f32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  7327*/    /*SwitchType*/ 18, MVT::v2f64,// ->7347
/*  7329*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  7331*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  7334*/     OPC_EmitMergeInputChains1_0,
/*  7335*/     OPC_EmitInteger, MVT::i32, 0, 
/*  7338*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v2f64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v2f64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A32:{ *:[v2f64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  7347*/    0, // EndSwitchType
/*  7348*/   /*Scope*/ 32, /*->7381*/
/*  7349*/    OPC_CheckPredicate, 18, // Predicate_extload
/*  7351*/    OPC_CheckType, MVT::v2f64,
/*  7353*/    OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  7355*/    OPC_EmitMergeInputChains1_0,
/*  7356*/    OPC_EmitInteger, MVT::i32, 0, 
/*  7359*/    OPC_EmitInteger, MVT::i32, 0, 
/*  7362*/    OPC_EmitNode1, TARGET_VAL(WebAssembly::LOAD_ZERO_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v16i8, 3/*#Ops*/, 2, 3, 1,  // Results = #4
/*  7371*/    OPC_EmitNode1, TARGET_VAL(WebAssembly::promote_low_F64x2), 0,
                  MVT::v2f64, 1/*#Ops*/, 4,  // Results = #5
/*  7378*/    OPC_CompleteMatch, 1, 5, 
               // Src: (ld:{ *:[v2f64] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>> - Complexity = 4
               // Dst: (promote_low_F64x2:{ *:[v2f64] } (LOAD_ZERO_I64x2_A32:{ *:[v16i8] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr))
/*  7381*/   0, /*End of Scope*/
/*  7382*/  /*Scope*/ 65|128,6/*833*/, /*->8217*/
/*  7384*/   OPC_CheckChild1Type, MVT::i64,
/*  7386*/   OPC_CheckPredicate, 14, // Predicate_unindexedload
/*  7388*/   OPC_Scope, 44, /*->7434*/ // 16 children in Scope
/*  7390*/    OPC_CheckPredicate, 15, // Predicate_load
/*  7392*/    OPC_SwitchType /*2 cases */, 18, MVT::i32,// ->7413
/*  7395*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7397*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7400*/     OPC_EmitMergeInputChains1_0,
/*  7401*/     OPC_EmitInteger, MVT::i32, 0, 
/*  7404*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7413*/    /*SwitchType*/ 18, MVT::i64,// ->7433
/*  7415*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7417*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7420*/     OPC_EmitMergeInputChains1_0,
/*  7421*/     OPC_EmitInteger, MVT::i32, 0, 
/*  7424*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7433*/    0, // EndSwitchType
/*  7434*/   /*Scope*/ 117, /*->7552*/
/*  7435*/    OPC_CheckPredicate, 16, // Predicate_sextload
/*  7437*/    OPC_SwitchType /*2 cases */, 44, MVT::i32,// ->7484
/*  7440*/     OPC_Scope, 20, /*->7462*/ // 2 children in Scope
/*  7442*/      OPC_CheckPredicate, 0, // Predicate_sextloadi8
/*  7444*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7446*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7449*/      OPC_EmitMergeInputChains1_0,
/*  7450*/      OPC_EmitInteger, MVT::i32, 0, 
/*  7453*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 13
                // Dst: (LOAD8_S_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7462*/     /*Scope*/ 20, /*->7483*/
/*  7463*/      OPC_CheckPredicate, 1, // Predicate_sextloadi16
/*  7465*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7467*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7470*/      OPC_EmitMergeInputChains1_0,
/*  7471*/      OPC_EmitInteger, MVT::i32, 0, 
/*  7474*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 13
                // Dst: (LOAD16_S_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7483*/     0, /*End of Scope*/
/*  7484*/    /*SwitchType*/ 65, MVT::i64,// ->7551
/*  7486*/     OPC_Scope, 20, /*->7508*/ // 3 children in Scope
/*  7488*/      OPC_CheckPredicate, 0, // Predicate_sextloadi8
/*  7490*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7492*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7495*/      OPC_EmitMergeInputChains1_0,
/*  7496*/      OPC_EmitInteger, MVT::i32, 0, 
/*  7499*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 13
                // Dst: (LOAD8_S_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7508*/     /*Scope*/ 20, /*->7529*/
/*  7509*/      OPC_CheckPredicate, 1, // Predicate_sextloadi16
/*  7511*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7513*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7516*/      OPC_EmitMergeInputChains1_0,
/*  7517*/      OPC_EmitInteger, MVT::i32, 0, 
/*  7520*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 13
                // Dst: (LOAD16_S_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7529*/     /*Scope*/ 20, /*->7550*/
/*  7530*/      OPC_CheckPredicate, 2, // Predicate_sextloadi32
/*  7532*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7534*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7537*/      OPC_EmitMergeInputChains1_0,
/*  7538*/      OPC_EmitInteger, MVT::i32, 0, 
/*  7541*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_S_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>> - Complexity = 13
                // Dst: (LOAD32_S_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7550*/     0, /*End of Scope*/
/*  7551*/    0, // EndSwitchType
/*  7552*/   /*Scope*/ 117, /*->7670*/
/*  7553*/    OPC_CheckPredicate, 17, // Predicate_zextload
/*  7555*/    OPC_SwitchType /*2 cases */, 44, MVT::i32,// ->7602
/*  7558*/     OPC_Scope, 20, /*->7580*/ // 2 children in Scope
/*  7560*/      OPC_CheckPredicate, 0, // Predicate_zextloadi8
/*  7562*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7564*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7567*/      OPC_EmitMergeInputChains1_0,
/*  7568*/      OPC_EmitInteger, MVT::i32, 0, 
/*  7571*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7580*/     /*Scope*/ 20, /*->7601*/
/*  7581*/      OPC_CheckPredicate, 1, // Predicate_zextloadi16
/*  7583*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7585*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7588*/      OPC_EmitMergeInputChains1_0,
/*  7589*/      OPC_EmitInteger, MVT::i32, 0, 
/*  7592*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7601*/     0, /*End of Scope*/
/*  7602*/    /*SwitchType*/ 65, MVT::i64,// ->7669
/*  7604*/     OPC_Scope, 20, /*->7626*/ // 3 children in Scope
/*  7606*/      OPC_CheckPredicate, 0, // Predicate_zextloadi8
/*  7608*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7610*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7613*/      OPC_EmitMergeInputChains1_0,
/*  7614*/      OPC_EmitInteger, MVT::i32, 0, 
/*  7617*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7626*/     /*Scope*/ 20, /*->7647*/
/*  7627*/      OPC_CheckPredicate, 1, // Predicate_zextloadi16
/*  7629*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7631*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7634*/      OPC_EmitMergeInputChains1_0,
/*  7635*/      OPC_EmitInteger, MVT::i32, 0, 
/*  7638*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7647*/     /*Scope*/ 20, /*->7668*/
/*  7648*/      OPC_CheckPredicate, 2, // Predicate_zextloadi32
/*  7650*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7652*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7655*/      OPC_EmitMergeInputChains1_0,
/*  7656*/      OPC_EmitInteger, MVT::i32, 0, 
/*  7659*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>> - Complexity = 13
                // Dst: (LOAD32_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7668*/     0, /*End of Scope*/
/*  7669*/    0, // EndSwitchType
/*  7670*/   /*Scope*/ 117, /*->7788*/
/*  7671*/    OPC_CheckPredicate, 18, // Predicate_extload
/*  7673*/    OPC_SwitchType /*2 cases */, 44, MVT::i32,// ->7720
/*  7676*/     OPC_Scope, 20, /*->7698*/ // 2 children in Scope
/*  7678*/      OPC_CheckPredicate, 0, // Predicate_extloadi8
/*  7680*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7682*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7685*/      OPC_EmitMergeInputChains1_0,
/*  7686*/      OPC_EmitInteger, MVT::i32, 0, 
/*  7689*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7698*/     /*Scope*/ 20, /*->7719*/
/*  7699*/      OPC_CheckPredicate, 1, // Predicate_extloadi16
/*  7701*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7703*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7706*/      OPC_EmitMergeInputChains1_0,
/*  7707*/      OPC_EmitInteger, MVT::i32, 0, 
/*  7710*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7719*/     0, /*End of Scope*/
/*  7720*/    /*SwitchType*/ 65, MVT::i64,// ->7787
/*  7722*/     OPC_Scope, 20, /*->7744*/ // 3 children in Scope
/*  7724*/      OPC_CheckPredicate, 0, // Predicate_extloadi8
/*  7726*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7728*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7731*/      OPC_EmitMergeInputChains1_0,
/*  7732*/      OPC_EmitInteger, MVT::i32, 0, 
/*  7735*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7744*/     /*Scope*/ 20, /*->7765*/
/*  7745*/      OPC_CheckPredicate, 1, // Predicate_extloadi16
/*  7747*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7749*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7752*/      OPC_EmitMergeInputChains1_0,
/*  7753*/      OPC_EmitInteger, MVT::i32, 0, 
/*  7756*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7765*/     /*Scope*/ 20, /*->7786*/
/*  7766*/      OPC_CheckPredicate, 2, // Predicate_extloadi32
/*  7768*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7770*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7773*/      OPC_EmitMergeInputChains1_0,
/*  7774*/      OPC_EmitInteger, MVT::i32, 0, 
/*  7777*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>> - Complexity = 13
                // Dst: (LOAD32_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7786*/     0, /*End of Scope*/
/*  7787*/    0, // EndSwitchType
/*  7788*/   /*Scope*/ 124, /*->7913*/
/*  7789*/    OPC_CheckPredicate, 15, // Predicate_load
/*  7791*/    OPC_SwitchType /*6 cases */, 18, MVT::f32,// ->7812
/*  7794*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7796*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7799*/     OPC_EmitMergeInputChains1_0,
/*  7800*/     OPC_EmitInteger, MVT::i32, 0, 
/*  7803*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::f32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[f32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_F32_A64:{ *:[f32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7812*/    /*SwitchType*/ 18, MVT::f64,// ->7832
/*  7814*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7816*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7819*/     OPC_EmitMergeInputChains1_0,
/*  7820*/     OPC_EmitInteger, MVT::i32, 0, 
/*  7823*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::f64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[f64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_F64_A64:{ *:[f64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7832*/    /*SwitchType*/ 18, MVT::v16i8,// ->7852
/*  7834*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7836*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7839*/     OPC_EmitMergeInputChains1_0,
/*  7840*/     OPC_EmitInteger, MVT::i32, 0, 
/*  7843*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v16i8, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v16i8] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A64:{ *:[v16i8] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7852*/    /*SwitchType*/ 18, MVT::v8i16,// ->7872
/*  7854*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7856*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7859*/     OPC_EmitMergeInputChains1_0,
/*  7860*/     OPC_EmitInteger, MVT::i32, 0, 
/*  7863*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v8i16, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v8i16] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A64:{ *:[v8i16] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7872*/    /*SwitchType*/ 18, MVT::v4i32,// ->7892
/*  7874*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7876*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7879*/     OPC_EmitMergeInputChains1_0,
/*  7880*/     OPC_EmitInteger, MVT::i32, 0, 
/*  7883*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v4i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A64:{ *:[v4i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7892*/    /*SwitchType*/ 18, MVT::v2i64,// ->7912
/*  7894*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7896*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7899*/     OPC_EmitMergeInputChains1_0,
/*  7900*/     OPC_EmitInteger, MVT::i32, 0, 
/*  7903*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v2i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A64:{ *:[v2i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7912*/    0, // EndSwitchType
/*  7913*/   /*Scope*/ 24, /*->7938*/
/*  7914*/    OPC_CheckPredicate, 16, // Predicate_sextload
/*  7916*/    OPC_CheckPredicate, 19, // Predicate_sextloadvi8
/*  7918*/    OPC_CheckType, MVT::v8i16,
/*  7920*/    OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7922*/    OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7925*/    OPC_EmitMergeInputChains1_0,
/*  7926*/    OPC_EmitInteger, MVT::i32, 0, 
/*  7929*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I16x8_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v8i16, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v8i16] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi8>> - Complexity = 13
              // Dst: (LOAD_EXTEND_S_I16x8_A64:{ *:[v8i16] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7938*/   /*Scope*/ 24, /*->7963*/
/*  7939*/    OPC_CheckPredicate, 17, // Predicate_zextload
/*  7941*/    OPC_CheckPredicate, 19, // Predicate_zextloadvi8
/*  7943*/    OPC_CheckType, MVT::v8i16,
/*  7945*/    OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7947*/    OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7950*/    OPC_EmitMergeInputChains1_0,
/*  7951*/    OPC_EmitInteger, MVT::i32, 0, 
/*  7954*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I16x8_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v8i16, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v8i16] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi8>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I16x8_A64:{ *:[v8i16] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7963*/   /*Scope*/ 24, /*->7988*/
/*  7964*/    OPC_CheckPredicate, 18, // Predicate_extload
/*  7966*/    OPC_CheckPredicate, 19, // Predicate_extloadvi8
/*  7968*/    OPC_CheckType, MVT::v8i16,
/*  7970*/    OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7972*/    OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7975*/    OPC_EmitMergeInputChains1_0,
/*  7976*/    OPC_EmitInteger, MVT::i32, 0, 
/*  7979*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I16x8_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v8i16, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v8i16] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi8>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I16x8_A64:{ *:[v8i16] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7988*/   /*Scope*/ 24, /*->8013*/
/*  7989*/    OPC_CheckPredicate, 16, // Predicate_sextload
/*  7991*/    OPC_CheckPredicate, 20, // Predicate_sextloadvi16
/*  7993*/    OPC_CheckType, MVT::v4i32,
/*  7995*/    OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7997*/    OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  8000*/    OPC_EmitMergeInputChains1_0,
/*  8001*/    OPC_EmitInteger, MVT::i32, 0, 
/*  8004*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v4i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi16>> - Complexity = 13
              // Dst: (LOAD_EXTEND_S_I32x4_A64:{ *:[v4i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  8013*/   /*Scope*/ 24, /*->8038*/
/*  8014*/    OPC_CheckPredicate, 17, // Predicate_zextload
/*  8016*/    OPC_CheckPredicate, 20, // Predicate_zextloadvi16
/*  8018*/    OPC_CheckType, MVT::v4i32,
/*  8020*/    OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  8022*/    OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  8025*/    OPC_EmitMergeInputChains1_0,
/*  8026*/    OPC_EmitInteger, MVT::i32, 0, 
/*  8029*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v4i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi16>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I32x4_A64:{ *:[v4i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  8038*/   /*Scope*/ 24, /*->8063*/
/*  8039*/    OPC_CheckPredicate, 18, // Predicate_extload
/*  8041*/    OPC_CheckPredicate, 20, // Predicate_extloadvi16
/*  8043*/    OPC_CheckType, MVT::v4i32,
/*  8045*/    OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  8047*/    OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  8050*/    OPC_EmitMergeInputChains1_0,
/*  8051*/    OPC_EmitInteger, MVT::i32, 0, 
/*  8054*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v4i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi16>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I32x4_A64:{ *:[v4i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  8063*/   /*Scope*/ 24, /*->8088*/
/*  8064*/    OPC_CheckPredicate, 16, // Predicate_sextload
/*  8066*/    OPC_CheckPredicate, 21, // Predicate_sextloadvi32
/*  8068*/    OPC_CheckType, MVT::v2i64,
/*  8070*/    OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  8072*/    OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  8075*/    OPC_EmitMergeInputChains1_0,
/*  8076*/    OPC_EmitInteger, MVT::i32, 0, 
/*  8079*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v2i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi32>> - Complexity = 13
              // Dst: (LOAD_EXTEND_S_I64x2_A64:{ *:[v2i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  8088*/   /*Scope*/ 24, /*->8113*/
/*  8089*/    OPC_CheckPredicate, 17, // Predicate_zextload
/*  8091*/    OPC_CheckPredicate, 21, // Predicate_zextloadvi32
/*  8093*/    OPC_CheckType, MVT::v2i64,
/*  8095*/    OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  8097*/    OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  8100*/    OPC_EmitMergeInputChains1_0,
/*  8101*/    OPC_EmitInteger, MVT::i32, 0, 
/*  8104*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v2i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi32>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I64x2_A64:{ *:[v2i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  8113*/   /*Scope*/ 24, /*->8138*/
/*  8114*/    OPC_CheckPredicate, 18, // Predicate_extload
/*  8116*/    OPC_CheckPredicate, 21, // Predicate_extloadvi32
/*  8118*/    OPC_CheckType, MVT::v2i64,
/*  8120*/    OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  8122*/    OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  8125*/    OPC_EmitMergeInputChains1_0,
/*  8126*/    OPC_EmitInteger, MVT::i32, 0, 
/*  8129*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v2i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi32>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I64x2_A64:{ *:[v2i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  8138*/   /*Scope*/ 44, /*->8183*/
/*  8139*/    OPC_CheckPredicate, 15, // Predicate_load
/*  8141*/    OPC_SwitchType /*2 cases */, 18, MVT::v4f32,// ->8162
/*  8144*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  8146*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  8149*/     OPC_EmitMergeInputChains1_0,
/*  8150*/     OPC_EmitInteger, MVT::i32, 0, 
/*  8153*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v4f32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v4f32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A64:{ *:[v4f32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  8162*/    /*SwitchType*/ 18, MVT::v2f64,// ->8182
/*  8164*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  8166*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  8169*/     OPC_EmitMergeInputChains1_0,
/*  8170*/     OPC_EmitInteger, MVT::i32, 0, 
/*  8173*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v2f64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v2f64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A64:{ *:[v2f64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  8182*/    0, // EndSwitchType
/*  8183*/   /*Scope*/ 32, /*->8216*/
/*  8184*/    OPC_CheckPredicate, 18, // Predicate_extload
/*  8186*/    OPC_CheckType, MVT::v2f64,
/*  8188*/    OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  8190*/    OPC_EmitMergeInputChains1_0,
/*  8191*/    OPC_EmitInteger, MVT::i32, 0, 
/*  8194*/    OPC_EmitInteger, MVT::i64, 0, 
/*  8197*/    OPC_EmitNode1, TARGET_VAL(WebAssembly::LOAD_ZERO_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v16i8, 3/*#Ops*/, 2, 3, 1,  // Results = #4
/*  8206*/    OPC_EmitNode1, TARGET_VAL(WebAssembly::promote_low_F64x2), 0,
                  MVT::v2f64, 1/*#Ops*/, 4,  // Results = #5
/*  8213*/    OPC_CompleteMatch, 1, 5, 
               // Src: (ld:{ *:[v2f64] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>> - Complexity = 4
               // Dst: (promote_low_F64x2:{ *:[v2f64] } (LOAD_ZERO_I64x2_A64:{ *:[v16i8] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr))
/*  8216*/   0, /*End of Scope*/
/*  8217*/  0, /*End of Scope*/
/*  8218*/ /*SwitchOpcode*/ 65|128,1/*193*/, TARGET_VAL(ISD::ATOMIC_LOAD),// ->8415
/*  8222*/  OPC_RecordMemRef,
/*  8223*/  OPC_RecordNode, // #0 = 'atomic_load' chained node
/*  8224*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  8225*/  OPC_Scope, 93, /*->8320*/ // 2 children in Scope
/*  8227*/   OPC_CheckChild1Type, MVT::i32,
/*  8229*/   OPC_SwitchType /*2 cases */, 65, MVT::i32,// ->8297
/*  8232*/    OPC_Scope, 20, /*->8254*/ // 3 children in Scope
/*  8234*/     OPC_CheckPredicate, 2, // Predicate_atomic_load_32
/*  8236*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  8238*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  8241*/     OPC_EmitMergeInputChains1_0,
/*  8242*/     OPC_EmitInteger, MVT::i32, 0, 
/*  8245*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_32>> - Complexity = 13
               // Dst: (ATOMIC_LOAD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  8254*/    /*Scope*/ 20, /*->8275*/
/*  8255*/     OPC_CheckPredicate, 0, // Predicate_atomic_load_8
/*  8257*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  8259*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  8262*/     OPC_EmitMergeInputChains1_0,
/*  8263*/     OPC_EmitInteger, MVT::i32, 0, 
/*  8266*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_8>> - Complexity = 13
               // Dst: (ATOMIC_LOAD8_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  8275*/    /*Scope*/ 20, /*->8296*/
/*  8276*/     OPC_CheckPredicate, 1, // Predicate_atomic_load_16
/*  8278*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  8280*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  8283*/     OPC_EmitMergeInputChains1_0,
/*  8284*/     OPC_EmitInteger, MVT::i32, 0, 
/*  8287*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_16>> - Complexity = 13
               // Dst: (ATOMIC_LOAD16_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  8296*/    0, /*End of Scope*/
/*  8297*/   /*SwitchType*/ 20, MVT::i64,// ->8319
/*  8299*/    OPC_CheckPredicate, 13, // Predicate_atomic_load_64
/*  8301*/    OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  8303*/    OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  8306*/    OPC_EmitMergeInputChains1_0,
/*  8307*/    OPC_EmitInteger, MVT::i32, 0, 
/*  8310*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 3/*#Ops*/, 4, 2, 3, 
              // Src: (atomic_load:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_64>> - Complexity = 13
              // Dst: (ATOMIC_LOAD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  8319*/   0, // EndSwitchType
/*  8320*/  /*Scope*/ 93, /*->8414*/
/*  8321*/   OPC_CheckChild1Type, MVT::i64,
/*  8323*/   OPC_SwitchType /*2 cases */, 65, MVT::i32,// ->8391
/*  8326*/    OPC_Scope, 20, /*->8348*/ // 3 children in Scope
/*  8328*/     OPC_CheckPredicate, 2, // Predicate_atomic_load_32
/*  8330*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  8332*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  8335*/     OPC_EmitMergeInputChains1_0,
/*  8336*/     OPC_EmitInteger, MVT::i32, 0, 
/*  8339*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_32>> - Complexity = 13
               // Dst: (ATOMIC_LOAD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  8348*/    /*Scope*/ 20, /*->8369*/
/*  8349*/     OPC_CheckPredicate, 0, // Predicate_atomic_load_8
/*  8351*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  8353*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  8356*/     OPC_EmitMergeInputChains1_0,
/*  8357*/     OPC_EmitInteger, MVT::i32, 0, 
/*  8360*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_8>> - Complexity = 13
               // Dst: (ATOMIC_LOAD8_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  8369*/    /*Scope*/ 20, /*->8390*/
/*  8370*/     OPC_CheckPredicate, 1, // Predicate_atomic_load_16
/*  8372*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  8374*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  8377*/     OPC_EmitMergeInputChains1_0,
/*  8378*/     OPC_EmitInteger, MVT::i32, 0, 
/*  8381*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_16>> - Complexity = 13
               // Dst: (ATOMIC_LOAD16_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  8390*/    0, /*End of Scope*/
/*  8391*/   /*SwitchType*/ 20, MVT::i64,// ->8413
/*  8393*/    OPC_CheckPredicate, 13, // Predicate_atomic_load_64
/*  8395*/    OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  8397*/    OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  8400*/    OPC_EmitMergeInputChains1_0,
/*  8401*/    OPC_EmitInteger, MVT::i32, 0, 
/*  8404*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 3/*#Ops*/, 4, 2, 3, 
              // Src: (atomic_load:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_64>> - Complexity = 13
              // Dst: (ATOMIC_LOAD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  8413*/   0, // EndSwitchType
/*  8414*/  0, /*End of Scope*/
/*  8415*/ /*SwitchOpcode*/ 37|128,2/*293*/, TARGET_VAL(ISD::ATOMIC_LOAD_ADD),// ->8712
/*  8419*/  OPC_RecordMemRef,
/*  8420*/  OPC_RecordNode, // #0 = 'atomic_load_add' chained node
/*  8421*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  8422*/  OPC_Scope, 14|128,1/*142*/, /*->8567*/ // 2 children in Scope
/*  8425*/   OPC_CheckChild1Type, MVT::i32,
/*  8427*/   OPC_RecordChild2, // #2 = $val
/*  8428*/   OPC_SwitchType /*2 cases */, 112, MVT::i32,// ->8543
/*  8431*/    OPC_Scope, 21, /*->8454*/ // 5 children in Scope
/*  8433*/     OPC_CheckPredicate, 2, // Predicate_atomic_load_add_32
/*  8435*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8437*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8440*/     OPC_EmitMergeInputChains1_0,
/*  8441*/     OPC_EmitInteger, MVT::i32, 0, 
/*  8444*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_ADD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8454*/    /*Scope*/ 21, /*->8476*/
/*  8455*/     OPC_CheckPredicate, 0, // Predicate_atomic_load_add_8
/*  8457*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8459*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8462*/     OPC_EmitMergeInputChains1_0,
/*  8463*/     OPC_EmitInteger, MVT::i32, 0, 
/*  8466*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_ADD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8476*/    /*Scope*/ 21, /*->8498*/
/*  8477*/     OPC_CheckPredicate, 1, // Predicate_atomic_load_add_16
/*  8479*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8481*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8484*/     OPC_EmitMergeInputChains1_0,
/*  8485*/     OPC_EmitInteger, MVT::i32, 0, 
/*  8488*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_ADD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8498*/    /*Scope*/ 21, /*->8520*/
/*  8499*/     OPC_CheckPredicate, 0, // Predicate_atomic_load_add_8
/*  8501*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8503*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8506*/     OPC_EmitMergeInputChains1_0,
/*  8507*/     OPC_EmitInteger, MVT::i32, 0, 
/*  8510*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_ADD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8520*/    /*Scope*/ 21, /*->8542*/
/*  8521*/     OPC_CheckPredicate, 1, // Predicate_atomic_load_add_16
/*  8523*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8525*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8528*/     OPC_EmitMergeInputChains1_0,
/*  8529*/     OPC_EmitInteger, MVT::i32, 0, 
/*  8532*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_ADD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8542*/    0, /*End of Scope*/
/*  8543*/   /*SwitchType*/ 21, MVT::i64,// ->8566
/*  8545*/    OPC_CheckPredicate, 13, // Predicate_atomic_load_add_64
/*  8547*/    OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8549*/    OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8552*/    OPC_EmitMergeInputChains1_0,
/*  8553*/    OPC_EmitInteger, MVT::i32, 0, 
/*  8556*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_add:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_add_64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  8566*/   0, // EndSwitchType
/*  8567*/  /*Scope*/ 14|128,1/*142*/, /*->8711*/
/*  8569*/   OPC_CheckChild1Type, MVT::i64,
/*  8571*/   OPC_RecordChild2, // #2 = $val
/*  8572*/   OPC_SwitchType /*2 cases */, 112, MVT::i32,// ->8687
/*  8575*/    OPC_Scope, 21, /*->8598*/ // 5 children in Scope
/*  8577*/     OPC_CheckPredicate, 2, // Predicate_atomic_load_add_32
/*  8579*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8581*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8584*/     OPC_EmitMergeInputChains1_0,
/*  8585*/     OPC_EmitInteger, MVT::i32, 0, 
/*  8588*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_ADD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8598*/    /*Scope*/ 21, /*->8620*/
/*  8599*/     OPC_CheckPredicate, 0, // Predicate_atomic_load_add_8
/*  8601*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8603*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8606*/     OPC_EmitMergeInputChains1_0,
/*  8607*/     OPC_EmitInteger, MVT::i32, 0, 
/*  8610*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_ADD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8620*/    /*Scope*/ 21, /*->8642*/
/*  8621*/     OPC_CheckPredicate, 1, // Predicate_atomic_load_add_16
/*  8623*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8625*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8628*/     OPC_EmitMergeInputChains1_0,
/*  8629*/     OPC_EmitInteger, MVT::i32, 0, 
/*  8632*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_ADD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8642*/    /*Scope*/ 21, /*->8664*/
/*  8643*/     OPC_CheckPredicate, 0, // Predicate_atomic_load_add_8
/*  8645*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8647*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8650*/     OPC_EmitMergeInputChains1_0,
/*  8651*/     OPC_EmitInteger, MVT::i32, 0, 
/*  8654*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_ADD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8664*/    /*Scope*/ 21, /*->8686*/
/*  8665*/     OPC_CheckPredicate, 1, // Predicate_atomic_load_add_16
/*  8667*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8669*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8672*/     OPC_EmitMergeInputChains1_0,
/*  8673*/     OPC_EmitInteger, MVT::i32, 0, 
/*  8676*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_ADD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8686*/    0, /*End of Scope*/
/*  8687*/   /*SwitchType*/ 21, MVT::i64,// ->8710
/*  8689*/    OPC_CheckPredicate, 13, // Predicate_atomic_load_add_64
/*  8691*/    OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8693*/    OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8696*/    OPC_EmitMergeInputChains1_0,
/*  8697*/    OPC_EmitInteger, MVT::i32, 0, 
/*  8700*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_add:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_add_64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  8710*/   0, // EndSwitchType
/*  8711*/  0, /*End of Scope*/
/*  8712*/ /*SwitchOpcode*/ 37|128,2/*293*/, TARGET_VAL(ISD::ATOMIC_LOAD_SUB),// ->9009
/*  8716*/  OPC_RecordMemRef,
/*  8717*/  OPC_RecordNode, // #0 = 'atomic_load_sub' chained node
/*  8718*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  8719*/  OPC_Scope, 14|128,1/*142*/, /*->8864*/ // 2 children in Scope
/*  8722*/   OPC_CheckChild1Type, MVT::i32,
/*  8724*/   OPC_RecordChild2, // #2 = $val
/*  8725*/   OPC_SwitchType /*2 cases */, 112, MVT::i32,// ->8840
/*  8728*/    OPC_Scope, 21, /*->8751*/ // 5 children in Scope
/*  8730*/     OPC_CheckPredicate, 2, // Predicate_atomic_load_sub_32
/*  8732*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8734*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8737*/     OPC_EmitMergeInputChains1_0,
/*  8738*/     OPC_EmitInteger, MVT::i32, 0, 
/*  8741*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_SUB_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8751*/    /*Scope*/ 21, /*->8773*/
/*  8752*/     OPC_CheckPredicate, 0, // Predicate_atomic_load_sub_8
/*  8754*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8756*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8759*/     OPC_EmitMergeInputChains1_0,
/*  8760*/     OPC_EmitInteger, MVT::i32, 0, 
/*  8763*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_SUB_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8773*/    /*Scope*/ 21, /*->8795*/
/*  8774*/     OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_16
/*  8776*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8778*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8781*/     OPC_EmitMergeInputChains1_0,
/*  8782*/     OPC_EmitInteger, MVT::i32, 0, 
/*  8785*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_SUB_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8795*/    /*Scope*/ 21, /*->8817*/
/*  8796*/     OPC_CheckPredicate, 0, // Predicate_atomic_load_sub_8
/*  8798*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8800*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8803*/     OPC_EmitMergeInputChains1_0,
/*  8804*/     OPC_EmitInteger, MVT::i32, 0, 
/*  8807*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_SUB_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8817*/    /*Scope*/ 21, /*->8839*/
/*  8818*/     OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_16
/*  8820*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8822*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8825*/     OPC_EmitMergeInputChains1_0,
/*  8826*/     OPC_EmitInteger, MVT::i32, 0, 
/*  8829*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_SUB_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8839*/    0, /*End of Scope*/
/*  8840*/   /*SwitchType*/ 21, MVT::i64,// ->8863
/*  8842*/    OPC_CheckPredicate, 13, // Predicate_atomic_load_sub_64
/*  8844*/    OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8846*/    OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8849*/    OPC_EmitMergeInputChains1_0,
/*  8850*/    OPC_EmitInteger, MVT::i32, 0, 
/*  8853*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_sub:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_sub_64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  8863*/   0, // EndSwitchType
/*  8864*/  /*Scope*/ 14|128,1/*142*/, /*->9008*/
/*  8866*/   OPC_CheckChild1Type, MVT::i64,
/*  8868*/   OPC_RecordChild2, // #2 = $val
/*  8869*/   OPC_SwitchType /*2 cases */, 112, MVT::i32,// ->8984
/*  8872*/    OPC_Scope, 21, /*->8895*/ // 5 children in Scope
/*  8874*/     OPC_CheckPredicate, 2, // Predicate_atomic_load_sub_32
/*  8876*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8878*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8881*/     OPC_EmitMergeInputChains1_0,
/*  8882*/     OPC_EmitInteger, MVT::i32, 0, 
/*  8885*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_SUB_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8895*/    /*Scope*/ 21, /*->8917*/
/*  8896*/     OPC_CheckPredicate, 0, // Predicate_atomic_load_sub_8
/*  8898*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8900*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8903*/     OPC_EmitMergeInputChains1_0,
/*  8904*/     OPC_EmitInteger, MVT::i32, 0, 
/*  8907*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_SUB_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8917*/    /*Scope*/ 21, /*->8939*/
/*  8918*/     OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_16
/*  8920*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8922*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8925*/     OPC_EmitMergeInputChains1_0,
/*  8926*/     OPC_EmitInteger, MVT::i32, 0, 
/*  8929*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_SUB_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8939*/    /*Scope*/ 21, /*->8961*/
/*  8940*/     OPC_CheckPredicate, 0, // Predicate_atomic_load_sub_8
/*  8942*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8944*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8947*/     OPC_EmitMergeInputChains1_0,
/*  8948*/     OPC_EmitInteger, MVT::i32, 0, 
/*  8951*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_SUB_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8961*/    /*Scope*/ 21, /*->8983*/
/*  8962*/     OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_16
/*  8964*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8966*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8969*/     OPC_EmitMergeInputChains1_0,
/*  8970*/     OPC_EmitInteger, MVT::i32, 0, 
/*  8973*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_SUB_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8983*/    0, /*End of Scope*/
/*  8984*/   /*SwitchType*/ 21, MVT::i64,// ->9007
/*  8986*/    OPC_CheckPredicate, 13, // Predicate_atomic_load_sub_64
/*  8988*/    OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8990*/    OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8993*/    OPC_EmitMergeInputChains1_0,
/*  8994*/    OPC_EmitInteger, MVT::i32, 0, 
/*  8997*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_sub:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_sub_64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  9007*/   0, // EndSwitchType
/*  9008*/  0, /*End of Scope*/
/*  9009*/ /*SwitchOpcode*/ 37|128,2/*293*/, TARGET_VAL(ISD::ATOMIC_LOAD_AND),// ->9306
/*  9013*/  OPC_RecordMemRef,
/*  9014*/  OPC_RecordNode, // #0 = 'atomic_load_and' chained node
/*  9015*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  9016*/  OPC_Scope, 14|128,1/*142*/, /*->9161*/ // 2 children in Scope
/*  9019*/   OPC_CheckChild1Type, MVT::i32,
/*  9021*/   OPC_RecordChild2, // #2 = $val
/*  9022*/   OPC_SwitchType /*2 cases */, 112, MVT::i32,// ->9137
/*  9025*/    OPC_Scope, 21, /*->9048*/ // 5 children in Scope
/*  9027*/     OPC_CheckPredicate, 2, // Predicate_atomic_load_and_32
/*  9029*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9031*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  9034*/     OPC_EmitMergeInputChains1_0,
/*  9035*/     OPC_EmitInteger, MVT::i32, 0, 
/*  9038*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_AND_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  9048*/    /*Scope*/ 21, /*->9070*/
/*  9049*/     OPC_CheckPredicate, 0, // Predicate_atomic_load_and_8
/*  9051*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9053*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  9056*/     OPC_EmitMergeInputChains1_0,
/*  9057*/     OPC_EmitInteger, MVT::i32, 0, 
/*  9060*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_AND_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  9070*/    /*Scope*/ 21, /*->9092*/
/*  9071*/     OPC_CheckPredicate, 1, // Predicate_atomic_load_and_16
/*  9073*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9075*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  9078*/     OPC_EmitMergeInputChains1_0,
/*  9079*/     OPC_EmitInteger, MVT::i32, 0, 
/*  9082*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_AND_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  9092*/    /*Scope*/ 21, /*->9114*/
/*  9093*/     OPC_CheckPredicate, 0, // Predicate_atomic_load_and_8
/*  9095*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9097*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  9100*/     OPC_EmitMergeInputChains1_0,
/*  9101*/     OPC_EmitInteger, MVT::i32, 0, 
/*  9104*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_AND_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  9114*/    /*Scope*/ 21, /*->9136*/
/*  9115*/     OPC_CheckPredicate, 1, // Predicate_atomic_load_and_16
/*  9117*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9119*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  9122*/     OPC_EmitMergeInputChains1_0,
/*  9123*/     OPC_EmitInteger, MVT::i32, 0, 
/*  9126*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_AND_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  9136*/    0, /*End of Scope*/
/*  9137*/   /*SwitchType*/ 21, MVT::i64,// ->9160
/*  9139*/    OPC_CheckPredicate, 13, // Predicate_atomic_load_and_64
/*  9141*/    OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9143*/    OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  9146*/    OPC_EmitMergeInputChains1_0,
/*  9147*/    OPC_EmitInteger, MVT::i32, 0, 
/*  9150*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_and:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_and_64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  9160*/   0, // EndSwitchType
/*  9161*/  /*Scope*/ 14|128,1/*142*/, /*->9305*/
/*  9163*/   OPC_CheckChild1Type, MVT::i64,
/*  9165*/   OPC_RecordChild2, // #2 = $val
/*  9166*/   OPC_SwitchType /*2 cases */, 112, MVT::i32,// ->9281
/*  9169*/    OPC_Scope, 21, /*->9192*/ // 5 children in Scope
/*  9171*/     OPC_CheckPredicate, 2, // Predicate_atomic_load_and_32
/*  9173*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9175*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  9178*/     OPC_EmitMergeInputChains1_0,
/*  9179*/     OPC_EmitInteger, MVT::i32, 0, 
/*  9182*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_AND_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  9192*/    /*Scope*/ 21, /*->9214*/
/*  9193*/     OPC_CheckPredicate, 0, // Predicate_atomic_load_and_8
/*  9195*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9197*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  9200*/     OPC_EmitMergeInputChains1_0,
/*  9201*/     OPC_EmitInteger, MVT::i32, 0, 
/*  9204*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_AND_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  9214*/    /*Scope*/ 21, /*->9236*/
/*  9215*/     OPC_CheckPredicate, 1, // Predicate_atomic_load_and_16
/*  9217*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9219*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  9222*/     OPC_EmitMergeInputChains1_0,
/*  9223*/     OPC_EmitInteger, MVT::i32, 0, 
/*  9226*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_AND_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  9236*/    /*Scope*/ 21, /*->9258*/
/*  9237*/     OPC_CheckPredicate, 0, // Predicate_atomic_load_and_8
/*  9239*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9241*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  9244*/     OPC_EmitMergeInputChains1_0,
/*  9245*/     OPC_EmitInteger, MVT::i32, 0, 
/*  9248*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_AND_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  9258*/    /*Scope*/ 21, /*->9280*/
/*  9259*/     OPC_CheckPredicate, 1, // Predicate_atomic_load_and_16
/*  9261*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9263*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  9266*/     OPC_EmitMergeInputChains1_0,
/*  9267*/     OPC_EmitInteger, MVT::i32, 0, 
/*  9270*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_AND_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  9280*/    0, /*End of Scope*/
/*  9281*/   /*SwitchType*/ 21, MVT::i64,// ->9304
/*  9283*/    OPC_CheckPredicate, 13, // Predicate_atomic_load_and_64
/*  9285*/    OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9287*/    OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  9290*/    OPC_EmitMergeInputChains1_0,
/*  9291*/    OPC_EmitInteger, MVT::i32, 0, 
/*  9294*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_and:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_and_64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  9304*/   0, // EndSwitchType
/*  9305*/  0, /*End of Scope*/
/*  9306*/ /*SwitchOpcode*/ 37|128,2/*293*/, TARGET_VAL(ISD::ATOMIC_LOAD_OR),// ->9603
/*  9310*/  OPC_RecordMemRef,
/*  9311*/  OPC_RecordNode, // #0 = 'atomic_load_or' chained node
/*  9312*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  9313*/  OPC_Scope, 14|128,1/*142*/, /*->9458*/ // 2 children in Scope
/*  9316*/   OPC_CheckChild1Type, MVT::i32,
/*  9318*/   OPC_RecordChild2, // #2 = $val
/*  9319*/   OPC_SwitchType /*2 cases */, 112, MVT::i32,// ->9434
/*  9322*/    OPC_Scope, 21, /*->9345*/ // 5 children in Scope
/*  9324*/     OPC_CheckPredicate, 2, // Predicate_atomic_load_or_32
/*  9326*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9328*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  9331*/     OPC_EmitMergeInputChains1_0,
/*  9332*/     OPC_EmitInteger, MVT::i32, 0, 
/*  9335*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_OR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  9345*/    /*Scope*/ 21, /*->9367*/
/*  9346*/     OPC_CheckPredicate, 0, // Predicate_atomic_load_or_8
/*  9348*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9350*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  9353*/     OPC_EmitMergeInputChains1_0,
/*  9354*/     OPC_EmitInteger, MVT::i32, 0, 
/*  9357*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_OR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  9367*/    /*Scope*/ 21, /*->9389*/
/*  9368*/     OPC_CheckPredicate, 1, // Predicate_atomic_load_or_16
/*  9370*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9372*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  9375*/     OPC_EmitMergeInputChains1_0,
/*  9376*/     OPC_EmitInteger, MVT::i32, 0, 
/*  9379*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_OR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  9389*/    /*Scope*/ 21, /*->9411*/
/*  9390*/     OPC_CheckPredicate, 0, // Predicate_atomic_load_or_8
/*  9392*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9394*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  9397*/     OPC_EmitMergeInputChains1_0,
/*  9398*/     OPC_EmitInteger, MVT::i32, 0, 
/*  9401*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_OR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  9411*/    /*Scope*/ 21, /*->9433*/
/*  9412*/     OPC_CheckPredicate, 1, // Predicate_atomic_load_or_16
/*  9414*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9416*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  9419*/     OPC_EmitMergeInputChains1_0,
/*  9420*/     OPC_EmitInteger, MVT::i32, 0, 
/*  9423*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_OR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  9433*/    0, /*End of Scope*/
/*  9434*/   /*SwitchType*/ 21, MVT::i64,// ->9457
/*  9436*/    OPC_CheckPredicate, 13, // Predicate_atomic_load_or_64
/*  9438*/    OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9440*/    OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  9443*/    OPC_EmitMergeInputChains1_0,
/*  9444*/    OPC_EmitInteger, MVT::i32, 0, 
/*  9447*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_or:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_or_64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  9457*/   0, // EndSwitchType
/*  9458*/  /*Scope*/ 14|128,1/*142*/, /*->9602*/
/*  9460*/   OPC_CheckChild1Type, MVT::i64,
/*  9462*/   OPC_RecordChild2, // #2 = $val
/*  9463*/   OPC_SwitchType /*2 cases */, 112, MVT::i32,// ->9578
/*  9466*/    OPC_Scope, 21, /*->9489*/ // 5 children in Scope
/*  9468*/     OPC_CheckPredicate, 2, // Predicate_atomic_load_or_32
/*  9470*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9472*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  9475*/     OPC_EmitMergeInputChains1_0,
/*  9476*/     OPC_EmitInteger, MVT::i32, 0, 
/*  9479*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_OR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  9489*/    /*Scope*/ 21, /*->9511*/
/*  9490*/     OPC_CheckPredicate, 0, // Predicate_atomic_load_or_8
/*  9492*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9494*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  9497*/     OPC_EmitMergeInputChains1_0,
/*  9498*/     OPC_EmitInteger, MVT::i32, 0, 
/*  9501*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_OR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  9511*/    /*Scope*/ 21, /*->9533*/
/*  9512*/     OPC_CheckPredicate, 1, // Predicate_atomic_load_or_16
/*  9514*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9516*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  9519*/     OPC_EmitMergeInputChains1_0,
/*  9520*/     OPC_EmitInteger, MVT::i32, 0, 
/*  9523*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_OR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  9533*/    /*Scope*/ 21, /*->9555*/
/*  9534*/     OPC_CheckPredicate, 0, // Predicate_atomic_load_or_8
/*  9536*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9538*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  9541*/     OPC_EmitMergeInputChains1_0,
/*  9542*/     OPC_EmitInteger, MVT::i32, 0, 
/*  9545*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_OR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  9555*/    /*Scope*/ 21, /*->9577*/
/*  9556*/     OPC_CheckPredicate, 1, // Predicate_atomic_load_or_16
/*  9558*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9560*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  9563*/     OPC_EmitMergeInputChains1_0,
/*  9564*/     OPC_EmitInteger, MVT::i32, 0, 
/*  9567*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_OR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  9577*/    0, /*End of Scope*/
/*  9578*/   /*SwitchType*/ 21, MVT::i64,// ->9601
/*  9580*/    OPC_CheckPredicate, 13, // Predicate_atomic_load_or_64
/*  9582*/    OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9584*/    OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  9587*/    OPC_EmitMergeInputChains1_0,
/*  9588*/    OPC_EmitInteger, MVT::i32, 0, 
/*  9591*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_or:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_or_64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  9601*/   0, // EndSwitchType
/*  9602*/  0, /*End of Scope*/
/*  9603*/ /*SwitchOpcode*/ 37|128,2/*293*/, TARGET_VAL(ISD::ATOMIC_LOAD_XOR),// ->9900
/*  9607*/  OPC_RecordMemRef,
/*  9608*/  OPC_RecordNode, // #0 = 'atomic_load_xor' chained node
/*  9609*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  9610*/  OPC_Scope, 14|128,1/*142*/, /*->9755*/ // 2 children in Scope
/*  9613*/   OPC_CheckChild1Type, MVT::i32,
/*  9615*/   OPC_RecordChild2, // #2 = $val
/*  9616*/   OPC_SwitchType /*2 cases */, 112, MVT::i32,// ->9731
/*  9619*/    OPC_Scope, 21, /*->9642*/ // 5 children in Scope
/*  9621*/     OPC_CheckPredicate, 2, // Predicate_atomic_load_xor_32
/*  9623*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9625*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  9628*/     OPC_EmitMergeInputChains1_0,
/*  9629*/     OPC_EmitInteger, MVT::i32, 0, 
/*  9632*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_XOR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  9642*/    /*Scope*/ 21, /*->9664*/
/*  9643*/     OPC_CheckPredicate, 0, // Predicate_atomic_load_xor_8
/*  9645*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9647*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  9650*/     OPC_EmitMergeInputChains1_0,
/*  9651*/     OPC_EmitInteger, MVT::i32, 0, 
/*  9654*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XOR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  9664*/    /*Scope*/ 21, /*->9686*/
/*  9665*/     OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_16
/*  9667*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9669*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  9672*/     OPC_EmitMergeInputChains1_0,
/*  9673*/     OPC_EmitInteger, MVT::i32, 0, 
/*  9676*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XOR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  9686*/    /*Scope*/ 21, /*->9708*/
/*  9687*/     OPC_CheckPredicate, 0, // Predicate_atomic_load_xor_8
/*  9689*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9691*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  9694*/     OPC_EmitMergeInputChains1_0,
/*  9695*/     OPC_EmitInteger, MVT::i32, 0, 
/*  9698*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XOR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  9708*/    /*Scope*/ 21, /*->9730*/
/*  9709*/     OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_16
/*  9711*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9713*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  9716*/     OPC_EmitMergeInputChains1_0,
/*  9717*/     OPC_EmitInteger, MVT::i32, 0, 
/*  9720*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XOR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  9730*/    0, /*End of Scope*/
/*  9731*/   /*SwitchType*/ 21, MVT::i64,// ->9754
/*  9733*/    OPC_CheckPredicate, 13, // Predicate_atomic_load_xor_64
/*  9735*/    OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9737*/    OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  9740*/    OPC_EmitMergeInputChains1_0,
/*  9741*/    OPC_EmitInteger, MVT::i32, 0, 
/*  9744*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_xor:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_xor_64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  9754*/   0, // EndSwitchType
/*  9755*/  /*Scope*/ 14|128,1/*142*/, /*->9899*/
/*  9757*/   OPC_CheckChild1Type, MVT::i64,
/*  9759*/   OPC_RecordChild2, // #2 = $val
/*  9760*/   OPC_SwitchType /*2 cases */, 112, MVT::i32,// ->9875
/*  9763*/    OPC_Scope, 21, /*->9786*/ // 5 children in Scope
/*  9765*/     OPC_CheckPredicate, 2, // Predicate_atomic_load_xor_32
/*  9767*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9769*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  9772*/     OPC_EmitMergeInputChains1_0,
/*  9773*/     OPC_EmitInteger, MVT::i32, 0, 
/*  9776*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_XOR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  9786*/    /*Scope*/ 21, /*->9808*/
/*  9787*/     OPC_CheckPredicate, 0, // Predicate_atomic_load_xor_8
/*  9789*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9791*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  9794*/     OPC_EmitMergeInputChains1_0,
/*  9795*/     OPC_EmitInteger, MVT::i32, 0, 
/*  9798*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XOR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  9808*/    /*Scope*/ 21, /*->9830*/
/*  9809*/     OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_16
/*  9811*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9813*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  9816*/     OPC_EmitMergeInputChains1_0,
/*  9817*/     OPC_EmitInteger, MVT::i32, 0, 
/*  9820*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XOR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  9830*/    /*Scope*/ 21, /*->9852*/
/*  9831*/     OPC_CheckPredicate, 0, // Predicate_atomic_load_xor_8
/*  9833*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9835*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  9838*/     OPC_EmitMergeInputChains1_0,
/*  9839*/     OPC_EmitInteger, MVT::i32, 0, 
/*  9842*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XOR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  9852*/    /*Scope*/ 21, /*->9874*/
/*  9853*/     OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_16
/*  9855*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9857*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  9860*/     OPC_EmitMergeInputChains1_0,
/*  9861*/     OPC_EmitInteger, MVT::i32, 0, 
/*  9864*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XOR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  9874*/    0, /*End of Scope*/
/*  9875*/   /*SwitchType*/ 21, MVT::i64,// ->9898
/*  9877*/    OPC_CheckPredicate, 13, // Predicate_atomic_load_xor_64
/*  9879*/    OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9881*/    OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  9884*/    OPC_EmitMergeInputChains1_0,
/*  9885*/    OPC_EmitInteger, MVT::i32, 0, 
/*  9888*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_xor:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_xor_64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  9898*/   0, // EndSwitchType
/*  9899*/  0, /*End of Scope*/
/*  9900*/ /*SwitchOpcode*/ 37|128,2/*293*/, TARGET_VAL(ISD::ATOMIC_SWAP),// ->10197
/*  9904*/  OPC_RecordMemRef,
/*  9905*/  OPC_RecordNode, // #0 = 'atomic_swap' chained node
/*  9906*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  9907*/  OPC_Scope, 14|128,1/*142*/, /*->10052*/ // 2 children in Scope
/*  9910*/   OPC_CheckChild1Type, MVT::i32,
/*  9912*/   OPC_RecordChild2, // #2 = $val
/*  9913*/   OPC_SwitchType /*2 cases */, 112, MVT::i32,// ->10028
/*  9916*/    OPC_Scope, 21, /*->9939*/ // 5 children in Scope
/*  9918*/     OPC_CheckPredicate, 2, // Predicate_atomic_swap_32
/*  9920*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9922*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  9925*/     OPC_EmitMergeInputChains1_0,
/*  9926*/     OPC_EmitInteger, MVT::i32, 0, 
/*  9929*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_XCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  9939*/    /*Scope*/ 21, /*->9961*/
/*  9940*/     OPC_CheckPredicate, 0, // Predicate_atomic_swap_8
/*  9942*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9944*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  9947*/     OPC_EmitMergeInputChains1_0,
/*  9948*/     OPC_EmitInteger, MVT::i32, 0, 
/*  9951*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  9961*/    /*Scope*/ 21, /*->9983*/
/*  9962*/     OPC_CheckPredicate, 1, // Predicate_atomic_swap_16
/*  9964*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9966*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  9969*/     OPC_EmitMergeInputChains1_0,
/*  9970*/     OPC_EmitInteger, MVT::i32, 0, 
/*  9973*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  9983*/    /*Scope*/ 21, /*->10005*/
/*  9984*/     OPC_CheckPredicate, 0, // Predicate_atomic_swap_8
/*  9986*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9988*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  9991*/     OPC_EmitMergeInputChains1_0,
/*  9992*/     OPC_EmitInteger, MVT::i32, 0, 
/*  9995*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/* 10005*/    /*Scope*/ 21, /*->10027*/
/* 10006*/     OPC_CheckPredicate, 1, // Predicate_atomic_swap_16
/* 10008*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 10010*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/* 10013*/     OPC_EmitMergeInputChains1_0,
/* 10014*/     OPC_EmitInteger, MVT::i32, 0, 
/* 10017*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/* 10027*/    0, /*End of Scope*/
/* 10028*/   /*SwitchType*/ 21, MVT::i64,// ->10051
/* 10030*/    OPC_CheckPredicate, 13, // Predicate_atomic_swap_64
/* 10032*/    OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 10034*/    OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/* 10037*/    OPC_EmitMergeInputChains1_0,
/* 10038*/    OPC_EmitInteger, MVT::i32, 0, 
/* 10041*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_swap:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_swap_64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/* 10051*/   0, // EndSwitchType
/* 10052*/  /*Scope*/ 14|128,1/*142*/, /*->10196*/
/* 10054*/   OPC_CheckChild1Type, MVT::i64,
/* 10056*/   OPC_RecordChild2, // #2 = $val
/* 10057*/   OPC_SwitchType /*2 cases */, 112, MVT::i32,// ->10172
/* 10060*/    OPC_Scope, 21, /*->10083*/ // 5 children in Scope
/* 10062*/     OPC_CheckPredicate, 2, // Predicate_atomic_swap_32
/* 10064*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 10066*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/* 10069*/     OPC_EmitMergeInputChains1_0,
/* 10070*/     OPC_EmitInteger, MVT::i32, 0, 
/* 10073*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_XCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/* 10083*/    /*Scope*/ 21, /*->10105*/
/* 10084*/     OPC_CheckPredicate, 0, // Predicate_atomic_swap_8
/* 10086*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 10088*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/* 10091*/     OPC_EmitMergeInputChains1_0,
/* 10092*/     OPC_EmitInteger, MVT::i32, 0, 
/* 10095*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/* 10105*/    /*Scope*/ 21, /*->10127*/
/* 10106*/     OPC_CheckPredicate, 1, // Predicate_atomic_swap_16
/* 10108*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 10110*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/* 10113*/     OPC_EmitMergeInputChains1_0,
/* 10114*/     OPC_EmitInteger, MVT::i32, 0, 
/* 10117*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/* 10127*/    /*Scope*/ 21, /*->10149*/
/* 10128*/     OPC_CheckPredicate, 0, // Predicate_atomic_swap_8
/* 10130*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 10132*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/* 10135*/     OPC_EmitMergeInputChains1_0,
/* 10136*/     OPC_EmitInteger, MVT::i32, 0, 
/* 10139*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/* 10149*/    /*Scope*/ 21, /*->10171*/
/* 10150*/     OPC_CheckPredicate, 1, // Predicate_atomic_swap_16
/* 10152*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 10154*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/* 10157*/     OPC_EmitMergeInputChains1_0,
/* 10158*/     OPC_EmitInteger, MVT::i32, 0, 
/* 10161*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/* 10171*/    0, /*End of Scope*/
/* 10172*/   /*SwitchType*/ 21, MVT::i64,// ->10195
/* 10174*/    OPC_CheckPredicate, 13, // Predicate_atomic_swap_64
/* 10176*/    OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 10178*/    OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/* 10181*/    OPC_EmitMergeInputChains1_0,
/* 10182*/    OPC_EmitInteger, MVT::i32, 0, 
/* 10185*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_swap:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_swap_64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/* 10195*/   0, // EndSwitchType
/* 10196*/  0, /*End of Scope*/
/* 10197*/ /*SwitchOpcode*/ 51|128,2/*307*/, TARGET_VAL(ISD::ATOMIC_CMP_SWAP),// ->10508
/* 10201*/  OPC_RecordMemRef,
/* 10202*/  OPC_RecordNode, // #0 = 'atomic_cmp_swap' chained node
/* 10203*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/* 10204*/  OPC_Scope, 21|128,1/*149*/, /*->10356*/ // 2 children in Scope
/* 10207*/   OPC_CheckChild1Type, MVT::i32,
/* 10209*/   OPC_RecordChild2, // #2 = $exp
/* 10210*/   OPC_RecordChild3, // #3 = $new
/* 10211*/   OPC_SwitchType /*2 cases */, 117, MVT::i32,// ->10331
/* 10214*/    OPC_Scope, 22, /*->10238*/ // 5 children in Scope
/* 10216*/     OPC_CheckPredicate, 2, // Predicate_atomic_cmp_swap_32
/* 10218*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 10220*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/* 10223*/     OPC_EmitMergeInputChains1_0,
/* 10224*/     OPC_EmitInteger, MVT::i32, 0, 
/* 10227*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_CMPXCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/* 10238*/    /*Scope*/ 22, /*->10261*/
/* 10239*/     OPC_CheckPredicate, 0, // Predicate_atomic_cmp_swap_8
/* 10241*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 10243*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/* 10246*/     OPC_EmitMergeInputChains1_0,
/* 10247*/     OPC_EmitInteger, MVT::i32, 0, 
/* 10250*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/* 10261*/    /*Scope*/ 22, /*->10284*/
/* 10262*/     OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_16
/* 10264*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 10266*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/* 10269*/     OPC_EmitMergeInputChains1_0,
/* 10270*/     OPC_EmitInteger, MVT::i32, 0, 
/* 10273*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/* 10284*/    /*Scope*/ 22, /*->10307*/
/* 10285*/     OPC_CheckPredicate, 0, // Predicate_atomic_cmp_swap_8
/* 10287*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 10289*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/* 10292*/     OPC_EmitMergeInputChains1_0,
/* 10293*/     OPC_EmitInteger, MVT::i32, 0, 
/* 10296*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/* 10307*/    /*Scope*/ 22, /*->10330*/
/* 10308*/     OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_16
/* 10310*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 10312*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/* 10315*/     OPC_EmitMergeInputChains1_0,
/* 10316*/     OPC_EmitInteger, MVT::i32, 0, 
/* 10319*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/* 10330*/    0, /*End of Scope*/
/* 10331*/   /*SwitchType*/ 22, MVT::i64,// ->10355
/* 10333*/    OPC_CheckPredicate, 13, // Predicate_atomic_cmp_swap_64
/* 10335*/    OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 10337*/    OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/* 10340*/    OPC_EmitMergeInputChains1_0,
/* 10341*/    OPC_EmitInteger, MVT::i32, 0, 
/* 10344*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 5/*#Ops*/, 6, 4, 5, 2, 3, 
              // Src: (atomic_cmp_swap:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/* 10355*/   0, // EndSwitchType
/* 10356*/  /*Scope*/ 21|128,1/*149*/, /*->10507*/
/* 10358*/   OPC_CheckChild1Type, MVT::i64,
/* 10360*/   OPC_RecordChild2, // #2 = $exp
/* 10361*/   OPC_RecordChild3, // #3 = $new
/* 10362*/   OPC_SwitchType /*2 cases */, 117, MVT::i32,// ->10482
/* 10365*/    OPC_Scope, 22, /*->10389*/ // 5 children in Scope
/* 10367*/     OPC_CheckPredicate, 2, // Predicate_atomic_cmp_swap_32
/* 10369*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 10371*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/* 10374*/     OPC_EmitMergeInputChains1_0,
/* 10375*/     OPC_EmitInteger, MVT::i32, 0, 
/* 10378*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_CMPXCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/* 10389*/    /*Scope*/ 22, /*->10412*/
/* 10390*/     OPC_CheckPredicate, 0, // Predicate_atomic_cmp_swap_8
/* 10392*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 10394*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/* 10397*/     OPC_EmitMergeInputChains1_0,
/* 10398*/     OPC_EmitInteger, MVT::i32, 0, 
/* 10401*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/* 10412*/    /*Scope*/ 22, /*->10435*/
/* 10413*/     OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_16
/* 10415*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 10417*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/* 10420*/     OPC_EmitMergeInputChains1_0,
/* 10421*/     OPC_EmitInteger, MVT::i32, 0, 
/* 10424*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/* 10435*/    /*Scope*/ 22, /*->10458*/
/* 10436*/     OPC_CheckPredicate, 0, // Predicate_atomic_cmp_swap_8
/* 10438*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 10440*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/* 10443*/     OPC_EmitMergeInputChains1_0,
/* 10444*/     OPC_EmitInteger, MVT::i32, 0, 
/* 10447*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/* 10458*/    /*Scope*/ 22, /*->10481*/
/* 10459*/     OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_16
/* 10461*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 10463*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/* 10466*/     OPC_EmitMergeInputChains1_0,
/* 10467*/     OPC_EmitInteger, MVT::i32, 0, 
/* 10470*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/* 10481*/    0, /*End of Scope*/
/* 10482*/   /*SwitchType*/ 22, MVT::i64,// ->10506
/* 10484*/    OPC_CheckPredicate, 13, // Predicate_atomic_cmp_swap_64
/* 10486*/    OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 10488*/    OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/* 10491*/    OPC_EmitMergeInputChains1_0,
/* 10492*/    OPC_EmitInteger, MVT::i32, 0, 
/* 10495*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 5/*#Ops*/, 6, 4, 5, 2, 3, 
              // Src: (atomic_cmp_swap:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/* 10506*/   0, // EndSwitchType
/* 10507*/  0, /*End of Scope*/
/* 10508*/ /*SwitchOpcode*/ 100, TARGET_VAL(ISD::BRCOND),// ->10611
/* 10511*/  OPC_RecordNode, // #0 = 'brcond' chained node
/* 10512*/  OPC_Scope, 78, /*->10592*/ // 2 children in Scope
/* 10514*/   OPC_MoveChild1,
/* 10515*/   OPC_SwitchOpcode /*2 cases */, 24, TARGET_VAL(ISD::XOR),// ->10543
/* 10519*/    OPC_RecordChild0, // #1 = $cond
/* 10520*/    OPC_MoveChild0,
/* 10521*/    OPC_CheckPredicate, 22, // Predicate_bool_node
/* 10523*/    OPC_MoveParent,
/* 10524*/    OPC_CheckChild1Integer, 2, 
/* 10526*/    OPC_CheckType, MVT::i32,
/* 10528*/    OPC_MoveParent,
/* 10529*/    OPC_RecordChild2, // #2 = $dst
/* 10530*/    OPC_MoveChild2,
/* 10531*/    OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/* 10534*/    OPC_MoveParent,
/* 10535*/    OPC_EmitMergeInputChains1_0,
/* 10536*/    OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::BR_UNLESS), 0|OPFL_Chain,
                  2/*#Ops*/, 2, 1, 
              // Src: (brcond (xor:{ *:[i32] } I32:{ *:[i32] }<<P:Predicate_bool_node>>:$cond, 1:{ *:[i32] }), (bb:{ *:[Other] }):$dst) - Complexity = 12
              // Dst: (BR_UNLESS bb_op:{ *:[Other] }:$dst, I32:{ *:[i32] }:$cond)
/* 10543*/   /*SwitchOpcode*/ 45, TARGET_VAL(ISD::SETCC),// ->10591
/* 10546*/    OPC_RecordChild0, // #1 = $cond
/* 10547*/    OPC_CheckChild0Type, MVT::i32,
/* 10549*/    OPC_CheckChild1Integer, 0, 
/* 10551*/    OPC_CheckType, MVT::i32,
/* 10553*/    OPC_Scope, 17, /*->10572*/ // 2 children in Scope
/* 10555*/     OPC_CheckChild2CondCode, ISD::SETNE,
/* 10557*/     OPC_MoveParent,
/* 10558*/     OPC_RecordChild2, // #2 = $dst
/* 10559*/     OPC_MoveChild2,
/* 10560*/     OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/* 10563*/     OPC_MoveParent,
/* 10564*/     OPC_EmitMergeInputChains1_0,
/* 10565*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::BR_IF), 0|OPFL_Chain,
                   2/*#Ops*/, 2, 1, 
               // Src: (brcond (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), (bb:{ *:[Other] }):$dst) - Complexity = 11
               // Dst: (BR_IF bb_op:{ *:[Other] }:$dst, I32:{ *:[i32] }:$cond)
/* 10572*/    /*Scope*/ 17, /*->10590*/
/* 10573*/     OPC_CheckChild2CondCode, ISD::SETEQ,
/* 10575*/     OPC_MoveParent,
/* 10576*/     OPC_RecordChild2, // #2 = $dst
/* 10577*/     OPC_MoveChild2,
/* 10578*/     OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/* 10581*/     OPC_MoveParent,
/* 10582*/     OPC_EmitMergeInputChains1_0,
/* 10583*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::BR_UNLESS), 0|OPFL_Chain,
                   2/*#Ops*/, 2, 1, 
               // Src: (brcond (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), (bb:{ *:[Other] }):$dst) - Complexity = 11
               // Dst: (BR_UNLESS bb_op:{ *:[Other] }:$dst, I32:{ *:[i32] }:$cond)
/* 10590*/    0, /*End of Scope*/
/* 10591*/   0, // EndSwitchOpcode
/* 10592*/  /*Scope*/ 17, /*->10610*/
/* 10593*/   OPC_RecordChild1, // #1 = $cond
/* 10594*/   OPC_CheckChild1Type, MVT::i32,
/* 10596*/   OPC_RecordChild2, // #2 = $dst
/* 10597*/   OPC_MoveChild2,
/* 10598*/   OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/* 10601*/   OPC_MoveParent,
/* 10602*/   OPC_EmitMergeInputChains1_0,
/* 10603*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::BR_IF), 0|OPFL_Chain,
                 2/*#Ops*/, 2, 1, 
             // Src: (brcond I32:{ *:[i32] }:$cond, (bb:{ *:[Other] }):$dst) - Complexity = 3
             // Dst: (BR_IF (bb:{ *:[Other] }):$dst, I32:{ *:[i32] }:$cond)
/* 10610*/  0, /*End of Scope*/
/* 10611*/ /*SwitchOpcode*/ 67, TARGET_VAL(ISD::SHL),// ->10681
/* 10614*/  OPC_RecordChild0, // #0 = $lhs
/* 10615*/  OPC_Scope, 35, /*->10652*/ // 2 children in Scope
/* 10617*/   OPC_MoveChild1,
/* 10618*/   OPC_SwitchType /*2 cases */, 14, MVT::i32,// ->10635
/* 10621*/    OPC_CheckAndImm, 31, 
/* 10623*/    OPC_RecordChild0, // #1 = $rhs
/* 10624*/    OPC_MoveParent,
/* 10625*/    OPC_CheckType, MVT::i32,
/* 10627*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHL_I32), 0,
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (shl:{ *:[i32] } I32:{ *:[i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (SHL_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 10635*/   /*SwitchType*/ 14, MVT::i64,// ->10651
/* 10637*/    OPC_CheckAndImm, 63, 
/* 10639*/    OPC_RecordChild0, // #1 = $rhs
/* 10640*/    OPC_MoveParent,
/* 10641*/    OPC_CheckType, MVT::i64,
/* 10643*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHL_I64), 0,
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (shl:{ *:[i64] } I64:{ *:[i64] }:$lhs, (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] })) - Complexity = 11
              // Dst: (SHL_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 10651*/   0, // EndSwitchType
/* 10652*/  /*Scope*/ 27, /*->10680*/
/* 10653*/   OPC_RecordChild1, // #1 = $rhs
/* 10654*/   OPC_SwitchType /*2 cases */, 10, MVT::i32,// ->10667
/* 10657*/    OPC_CheckChild1Type, MVT::i32,
/* 10659*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHL_I32), 0,
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (shl:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (SHL_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 10667*/   /*SwitchType*/ 10, MVT::i64,// ->10679
/* 10669*/    OPC_CheckChild1Type, MVT::i64,
/* 10671*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHL_I64), 0,
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (shl:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (SHL_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 10679*/   0, // EndSwitchType
/* 10680*/  0, /*End of Scope*/
/* 10681*/ /*SwitchOpcode*/ 67, TARGET_VAL(ISD::SRA),// ->10751
/* 10684*/  OPC_RecordChild0, // #0 = $lhs
/* 10685*/  OPC_Scope, 35, /*->10722*/ // 2 children in Scope
/* 10687*/   OPC_MoveChild1,
/* 10688*/   OPC_SwitchType /*2 cases */, 14, MVT::i32,// ->10705
/* 10691*/    OPC_CheckAndImm, 31, 
/* 10693*/    OPC_RecordChild0, // #1 = $rhs
/* 10694*/    OPC_MoveParent,
/* 10695*/    OPC_CheckType, MVT::i32,
/* 10697*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_S_I32), 0,
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (sra:{ *:[i32] } I32:{ *:[i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (SHR_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 10705*/   /*SwitchType*/ 14, MVT::i64,// ->10721
/* 10707*/    OPC_CheckAndImm, 63, 
/* 10709*/    OPC_RecordChild0, // #1 = $rhs
/* 10710*/    OPC_MoveParent,
/* 10711*/    OPC_CheckType, MVT::i64,
/* 10713*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_S_I64), 0,
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (sra:{ *:[i64] } I64:{ *:[i64] }:$lhs, (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] })) - Complexity = 11
              // Dst: (SHR_S_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 10721*/   0, // EndSwitchType
/* 10722*/  /*Scope*/ 27, /*->10750*/
/* 10723*/   OPC_RecordChild1, // #1 = $rhs
/* 10724*/   OPC_SwitchType /*2 cases */, 10, MVT::i32,// ->10737
/* 10727*/    OPC_CheckChild1Type, MVT::i32,
/* 10729*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_S_I32), 0,
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (sra:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (SHR_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 10737*/   /*SwitchType*/ 10, MVT::i64,// ->10749
/* 10739*/    OPC_CheckChild1Type, MVT::i64,
/* 10741*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_S_I64), 0,
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (sra:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (SHR_S_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 10749*/   0, // EndSwitchType
/* 10750*/  0, /*End of Scope*/
/* 10751*/ /*SwitchOpcode*/ 67, TARGET_VAL(ISD::SRL),// ->10821
/* 10754*/  OPC_RecordChild0, // #0 = $lhs
/* 10755*/  OPC_Scope, 35, /*->10792*/ // 2 children in Scope
/* 10757*/   OPC_MoveChild1,
/* 10758*/   OPC_SwitchType /*2 cases */, 14, MVT::i32,// ->10775
/* 10761*/    OPC_CheckAndImm, 31, 
/* 10763*/    OPC_RecordChild0, // #1 = $rhs
/* 10764*/    OPC_MoveParent,
/* 10765*/    OPC_CheckType, MVT::i32,
/* 10767*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_U_I32), 0,
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (srl:{ *:[i32] } I32:{ *:[i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (SHR_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 10775*/   /*SwitchType*/ 14, MVT::i64,// ->10791
/* 10777*/    OPC_CheckAndImm, 63, 
/* 10779*/    OPC_RecordChild0, // #1 = $rhs
/* 10780*/    OPC_MoveParent,
/* 10781*/    OPC_CheckType, MVT::i64,
/* 10783*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_U_I64), 0,
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (srl:{ *:[i64] } I64:{ *:[i64] }:$lhs, (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] })) - Complexity = 11
              // Dst: (SHR_U_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 10791*/   0, // EndSwitchType
/* 10792*/  /*Scope*/ 27, /*->10820*/
/* 10793*/   OPC_RecordChild1, // #1 = $rhs
/* 10794*/   OPC_SwitchType /*2 cases */, 10, MVT::i32,// ->10807
/* 10797*/    OPC_CheckChild1Type, MVT::i32,
/* 10799*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_U_I32), 0,
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (srl:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (SHR_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 10807*/   /*SwitchType*/ 10, MVT::i64,// ->10819
/* 10809*/    OPC_CheckChild1Type, MVT::i64,
/* 10811*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_U_I64), 0,
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (srl:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (SHR_U_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 10819*/   0, // EndSwitchType
/* 10820*/  0, /*End of Scope*/
/* 10821*/ /*SwitchOpcode*/ 67, TARGET_VAL(ISD::ROTL),// ->10891
/* 10824*/  OPC_RecordChild0, // #0 = $lhs
/* 10825*/  OPC_Scope, 35, /*->10862*/ // 2 children in Scope
/* 10827*/   OPC_MoveChild1,
/* 10828*/   OPC_SwitchType /*2 cases */, 14, MVT::i32,// ->10845
/* 10831*/    OPC_CheckAndImm, 31, 
/* 10833*/    OPC_RecordChild0, // #1 = $rhs
/* 10834*/    OPC_MoveParent,
/* 10835*/    OPC_CheckType, MVT::i32,
/* 10837*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ROTL_I32), 0,
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (rotl:{ *:[i32] } I32:{ *:[i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (ROTL_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 10845*/   /*SwitchType*/ 14, MVT::i64,// ->10861
/* 10847*/    OPC_CheckAndImm, 63, 
/* 10849*/    OPC_RecordChild0, // #1 = $rhs
/* 10850*/    OPC_MoveParent,
/* 10851*/    OPC_CheckType, MVT::i64,
/* 10853*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ROTL_I64), 0,
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (rotl:{ *:[i64] } I64:{ *:[i64] }:$lhs, (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] })) - Complexity = 11
              // Dst: (ROTL_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 10861*/   0, // EndSwitchType
/* 10862*/  /*Scope*/ 27, /*->10890*/
/* 10863*/   OPC_RecordChild1, // #1 = $rhs
/* 10864*/   OPC_SwitchType /*2 cases */, 10, MVT::i32,// ->10877
/* 10867*/    OPC_CheckChild1Type, MVT::i32,
/* 10869*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ROTL_I32), 0,
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (rotl:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (ROTL_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 10877*/   /*SwitchType*/ 10, MVT::i64,// ->10889
/* 10879*/    OPC_CheckChild1Type, MVT::i64,
/* 10881*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ROTL_I64), 0,
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (rotl:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (ROTL_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 10889*/   0, // EndSwitchType
/* 10890*/  0, /*End of Scope*/
/* 10891*/ /*SwitchOpcode*/ 67, TARGET_VAL(ISD::ROTR),// ->10961
/* 10894*/  OPC_RecordChild0, // #0 = $lhs
/* 10895*/  OPC_Scope, 35, /*->10932*/ // 2 children in Scope
/* 10897*/   OPC_MoveChild1,
/* 10898*/   OPC_SwitchType /*2 cases */, 14, MVT::i32,// ->10915
/* 10901*/    OPC_CheckAndImm, 31, 
/* 10903*/    OPC_RecordChild0, // #1 = $rhs
/* 10904*/    OPC_MoveParent,
/* 10905*/    OPC_CheckType, MVT::i32,
/* 10907*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ROTR_I32), 0,
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (rotr:{ *:[i32] } I32:{ *:[i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (ROTR_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 10915*/   /*SwitchType*/ 14, MVT::i64,// ->10931
/* 10917*/    OPC_CheckAndImm, 63, 
/* 10919*/    OPC_RecordChild0, // #1 = $rhs
/* 10920*/    OPC_MoveParent,
/* 10921*/    OPC_CheckType, MVT::i64,
/* 10923*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ROTR_I64), 0,
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (rotr:{ *:[i64] } I64:{ *:[i64] }:$lhs, (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] })) - Complexity = 11
              // Dst: (ROTR_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 10931*/   0, // EndSwitchType
/* 10932*/  /*Scope*/ 27, /*->10960*/
/* 10933*/   OPC_RecordChild1, // #1 = $rhs
/* 10934*/   OPC_SwitchType /*2 cases */, 10, MVT::i32,// ->10947
/* 10937*/    OPC_CheckChild1Type, MVT::i32,
/* 10939*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ROTR_I32), 0,
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (rotr:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (ROTR_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 10947*/   /*SwitchType*/ 10, MVT::i64,// ->10959
/* 10949*/    OPC_CheckChild1Type, MVT::i64,
/* 10951*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ROTR_I64), 0,
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (rotr:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (ROTR_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 10959*/   0, // EndSwitchType
/* 10960*/  0, /*End of Scope*/
/* 10961*/ /*SwitchOpcode*/ 42|128,4/*554*/, TARGET_VAL(ISD::SELECT),// ->11519
/* 10965*/  OPC_Scope, 117, /*->11084*/ // 8 children in Scope
/* 10967*/   OPC_MoveChild0,
/* 10968*/   OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
/* 10971*/   OPC_RecordChild0, // #0 = $cond
/* 10972*/   OPC_CheckChild0Type, MVT::i32,
/* 10974*/   OPC_CheckChild1Integer, 0, 
/* 10976*/   OPC_CheckType, MVT::i32,
/* 10978*/   OPC_Scope, 51, /*->11031*/ // 2 children in Scope
/* 10980*/    OPC_CheckChild2CondCode, ISD::SETNE,
/* 10982*/    OPC_MoveParent,
/* 10983*/    OPC_RecordChild1, // #1 = $lhs
/* 10984*/    OPC_RecordChild2, // #2 = $rhs
/* 10985*/    OPC_SwitchType /*4 cases */, 9, MVT::i32,// ->10997
/* 10988*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_I32), 0,
                   MVT::i32, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[i32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, I32:{ *:[i32] }:$cond)
/* 10997*/    /*SwitchType*/ 9, MVT::i64,// ->11008
/* 10999*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_I64), 0,
                   MVT::i64, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[i64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, I32:{ *:[i32] }:$cond)
/* 11008*/    /*SwitchType*/ 9, MVT::funcref,// ->11019
/* 11010*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_FUNCREF), 0,
                   MVT::funcref, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[funcref] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), FUNCREF:{ *:[funcref] }:$lhs, FUNCREF:{ *:[funcref] }:$rhs) - Complexity = 11
               // Dst: (SELECT_FUNCREF:{ *:[funcref] } FUNCREF:{ *:[funcref] }:$lhs, FUNCREF:{ *:[funcref] }:$rhs, I32:{ *:[i32] }:$cond)
/* 11019*/    /*SwitchType*/ 9, MVT::externref,// ->11030
/* 11021*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_EXTERNREF), 0,
                   MVT::externref, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[externref] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), EXTERNREF:{ *:[externref] }:$lhs, EXTERNREF:{ *:[externref] }:$rhs) - Complexity = 11
               // Dst: (SELECT_EXTERNREF:{ *:[externref] } EXTERNREF:{ *:[externref] }:$lhs, EXTERNREF:{ *:[externref] }:$rhs, I32:{ *:[i32] }:$cond)
/* 11030*/    0, // EndSwitchType
/* 11031*/   /*Scope*/ 51, /*->11083*/
/* 11032*/    OPC_CheckChild2CondCode, ISD::SETEQ,
/* 11034*/    OPC_MoveParent,
/* 11035*/    OPC_RecordChild1, // #1 = $lhs
/* 11036*/    OPC_RecordChild2, // #2 = $rhs
/* 11037*/    OPC_SwitchType /*4 cases */, 9, MVT::i32,// ->11049
/* 11040*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_I32), 0,
                   MVT::i32, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[i32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_I32:{ *:[i32] } I32:{ *:[i32] }:$rhs, I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$cond)
/* 11049*/    /*SwitchType*/ 9, MVT::i64,// ->11060
/* 11051*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_I64), 0,
                   MVT::i64, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[i64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_I64:{ *:[i64] } I64:{ *:[i64] }:$rhs, I64:{ *:[i64] }:$lhs, I32:{ *:[i32] }:$cond)
/* 11060*/    /*SwitchType*/ 9, MVT::funcref,// ->11071
/* 11062*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_FUNCREF), 0,
                   MVT::funcref, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[funcref] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), FUNCREF:{ *:[funcref] }:$lhs, FUNCREF:{ *:[funcref] }:$rhs) - Complexity = 11
               // Dst: (SELECT_FUNCREF:{ *:[funcref] } FUNCREF:{ *:[funcref] }:$rhs, FUNCREF:{ *:[funcref] }:$lhs, I32:{ *:[i32] }:$cond)
/* 11071*/    /*SwitchType*/ 9, MVT::externref,// ->11082
/* 11073*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_EXTERNREF), 0,
                   MVT::externref, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[externref] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), EXTERNREF:{ *:[externref] }:$lhs, EXTERNREF:{ *:[externref] }:$rhs) - Complexity = 11
               // Dst: (SELECT_EXTERNREF:{ *:[externref] } EXTERNREF:{ *:[externref] }:$rhs, EXTERNREF:{ *:[externref] }:$lhs, I32:{ *:[i32] }:$cond)
/* 11082*/    0, // EndSwitchType
/* 11083*/   0, /*End of Scope*/
/* 11084*/  /*Scope*/ 55, /*->11140*/
/* 11085*/   OPC_RecordChild0, // #0 = $cond
/* 11086*/   OPC_CheckChild0Type, MVT::i32,
/* 11088*/   OPC_RecordChild1, // #1 = $lhs
/* 11089*/   OPC_RecordChild2, // #2 = $rhs
/* 11090*/   OPC_SwitchType /*4 cases */, 9, MVT::i32,// ->11102
/* 11093*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_I32), 0,
                  MVT::i32, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[i32] } I32:{ *:[i32] }:$cond, I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (SELECT_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, I32:{ *:[i32] }:$cond)
/* 11102*/   /*SwitchType*/ 9, MVT::i64,// ->11113
/* 11104*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_I64), 0,
                  MVT::i64, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[i64] } I32:{ *:[i32] }:$cond, I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (SELECT_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, I32:{ *:[i32] }:$cond)
/* 11113*/   /*SwitchType*/ 11, MVT::funcref,// ->11126
/* 11115*/    OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/* 11117*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_FUNCREF), 0,
                  MVT::funcref, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[funcref] } I32:{ *:[i32] }:$cond, FUNCREF:{ *:[funcref] }:$lhs, FUNCREF:{ *:[funcref] }:$rhs) - Complexity = 3
              // Dst: (SELECT_FUNCREF:{ *:[funcref] } FUNCREF:{ *:[funcref] }:$lhs, FUNCREF:{ *:[funcref] }:$rhs, I32:{ *:[i32] }:$cond)
/* 11126*/   /*SwitchType*/ 11, MVT::externref,// ->11139
/* 11128*/    OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/* 11130*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_EXTERNREF), 0,
                  MVT::externref, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[externref] } I32:{ *:[i32] }:$cond, EXTERNREF:{ *:[externref] }:$lhs, EXTERNREF:{ *:[externref] }:$rhs) - Complexity = 3
              // Dst: (SELECT_EXTERNREF:{ *:[externref] } EXTERNREF:{ *:[externref] }:$lhs, EXTERNREF:{ *:[externref] }:$rhs, I32:{ *:[i32] }:$cond)
/* 11139*/   0, // EndSwitchType
/* 11140*/  /*Scope*/ 73, /*->11214*/
/* 11141*/   OPC_MoveChild0,
/* 11142*/   OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
/* 11145*/   OPC_RecordChild0, // #0 = $cond
/* 11146*/   OPC_CheckChild0Type, MVT::i32,
/* 11148*/   OPC_CheckChild1Integer, 0, 
/* 11150*/   OPC_CheckType, MVT::i32,
/* 11152*/   OPC_Scope, 29, /*->11183*/ // 2 children in Scope
/* 11154*/    OPC_CheckChild2CondCode, ISD::SETNE,
/* 11156*/    OPC_MoveParent,
/* 11157*/    OPC_RecordChild1, // #1 = $lhs
/* 11158*/    OPC_RecordChild2, // #2 = $rhs
/* 11159*/    OPC_SwitchType /*2 cases */, 9, MVT::f32,// ->11171
/* 11162*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_F32), 0,
                   MVT::f32, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[f32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, I32:{ *:[i32] }:$cond)
/* 11171*/    /*SwitchType*/ 9, MVT::f64,// ->11182
/* 11173*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_F64), 0,
                   MVT::f64, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[f64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, I32:{ *:[i32] }:$cond)
/* 11182*/    0, // EndSwitchType
/* 11183*/   /*Scope*/ 29, /*->11213*/
/* 11184*/    OPC_CheckChild2CondCode, ISD::SETEQ,
/* 11186*/    OPC_MoveParent,
/* 11187*/    OPC_RecordChild1, // #1 = $lhs
/* 11188*/    OPC_RecordChild2, // #2 = $rhs
/* 11189*/    OPC_SwitchType /*2 cases */, 9, MVT::f32,// ->11201
/* 11192*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_F32), 0,
                   MVT::f32, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[f32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_F32:{ *:[f32] } F32:{ *:[f32] }:$rhs, F32:{ *:[f32] }:$lhs, I32:{ *:[i32] }:$cond)
/* 11201*/    /*SwitchType*/ 9, MVT::f64,// ->11212
/* 11203*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_F64), 0,
                   MVT::f64, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[f64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_F64:{ *:[f64] } F64:{ *:[f64] }:$rhs, F64:{ *:[f64] }:$lhs, I32:{ *:[i32] }:$cond)
/* 11212*/    0, // EndSwitchType
/* 11213*/   0, /*End of Scope*/
/* 11214*/  /*Scope*/ 29, /*->11244*/
/* 11215*/   OPC_RecordChild0, // #0 = $cond
/* 11216*/   OPC_CheckChild0Type, MVT::i32,
/* 11218*/   OPC_RecordChild1, // #1 = $lhs
/* 11219*/   OPC_RecordChild2, // #2 = $rhs
/* 11220*/   OPC_SwitchType /*2 cases */, 9, MVT::f32,// ->11232
/* 11223*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_F32), 0,
                  MVT::f32, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[f32] } I32:{ *:[i32] }:$cond, F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
              // Dst: (SELECT_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, I32:{ *:[i32] }:$cond)
/* 11232*/   /*SwitchType*/ 9, MVT::f64,// ->11243
/* 11234*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_F64), 0,
                  MVT::f64, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[f64] } I32:{ *:[i32] }:$cond, F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
              // Dst: (SELECT_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, I32:{ *:[i32] }:$cond)
/* 11243*/   0, // EndSwitchType
/* 11244*/  /*Scope*/ 117, /*->11362*/
/* 11245*/   OPC_MoveChild0,
/* 11246*/   OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
/* 11249*/   OPC_RecordChild0, // #0 = $cond
/* 11250*/   OPC_CheckChild0Type, MVT::i32,
/* 11252*/   OPC_CheckChild1Integer, 0, 
/* 11254*/   OPC_CheckType, MVT::i32,
/* 11256*/   OPC_Scope, 51, /*->11309*/ // 2 children in Scope
/* 11258*/    OPC_CheckChild2CondCode, ISD::SETNE,
/* 11260*/    OPC_MoveParent,
/* 11261*/    OPC_RecordChild1, // #1 = $lhs
/* 11262*/    OPC_RecordChild2, // #2 = $rhs
/* 11263*/    OPC_SwitchType /*4 cases */, 9, MVT::v16i8,// ->11275
/* 11266*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_V128), 0,
                   MVT::v16i8, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[v16i8] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs, ?:{ *:[i32] }:$cond)
/* 11275*/    /*SwitchType*/ 9, MVT::v8i16,// ->11286
/* 11277*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_V128), 0,
                   MVT::v8i16, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[v8i16] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs, ?:{ *:[i32] }:$cond)
/* 11286*/    /*SwitchType*/ 9, MVT::v4i32,// ->11297
/* 11288*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_V128), 0,
                   MVT::v4i32, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[v4i32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs, ?:{ *:[i32] }:$cond)
/* 11297*/    /*SwitchType*/ 9, MVT::v2i64,// ->11308
/* 11299*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_V128), 0,
                   MVT::v2i64, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[v2i64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs, ?:{ *:[i32] }:$cond)
/* 11308*/    0, // EndSwitchType
/* 11309*/   /*Scope*/ 51, /*->11361*/
/* 11310*/    OPC_CheckChild2CondCode, ISD::SETEQ,
/* 11312*/    OPC_MoveParent,
/* 11313*/    OPC_RecordChild1, // #1 = $lhs
/* 11314*/    OPC_RecordChild2, // #2 = $rhs
/* 11315*/    OPC_SwitchType /*4 cases */, 9, MVT::v16i8,// ->11327
/* 11318*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_V128), 0,
                   MVT::v16i8, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[v16i8] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v16i8] } ?:{ *:[v16i8] }:$rhs, ?:{ *:[v16i8] }:$lhs, ?:{ *:[i32] }:$cond)
/* 11327*/    /*SwitchType*/ 9, MVT::v8i16,// ->11338
/* 11329*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_V128), 0,
                   MVT::v8i16, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[v8i16] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v8i16] } ?:{ *:[v8i16] }:$rhs, ?:{ *:[v8i16] }:$lhs, ?:{ *:[i32] }:$cond)
/* 11338*/    /*SwitchType*/ 9, MVT::v4i32,// ->11349
/* 11340*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_V128), 0,
                   MVT::v4i32, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[v4i32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v4i32] } ?:{ *:[v4i32] }:$rhs, ?:{ *:[v4i32] }:$lhs, ?:{ *:[i32] }:$cond)
/* 11349*/    /*SwitchType*/ 9, MVT::v2i64,// ->11360
/* 11351*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_V128), 0,
                   MVT::v2i64, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[v2i64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v2i64] } ?:{ *:[v2i64] }:$rhs, ?:{ *:[v2i64] }:$lhs, ?:{ *:[i32] }:$cond)
/* 11360*/    0, // EndSwitchType
/* 11361*/   0, /*End of Scope*/
/* 11362*/  /*Scope*/ 51, /*->11414*/
/* 11363*/   OPC_RecordChild0, // #0 = $cond
/* 11364*/   OPC_CheckChild0Type, MVT::i32,
/* 11366*/   OPC_RecordChild1, // #1 = $lhs
/* 11367*/   OPC_RecordChild2, // #2 = $rhs
/* 11368*/   OPC_SwitchType /*4 cases */, 9, MVT::v16i8,// ->11380
/* 11371*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_V128), 0,
                  MVT::v16i8, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[v16i8] } I32:{ *:[i32] }:$cond, V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
              // Dst: (SELECT_V128:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs, ?:{ *:[i32] }:$cond)
/* 11380*/   /*SwitchType*/ 9, MVT::v8i16,// ->11391
/* 11382*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_V128), 0,
                  MVT::v8i16, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[v8i16] } I32:{ *:[i32] }:$cond, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
              // Dst: (SELECT_V128:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs, ?:{ *:[i32] }:$cond)
/* 11391*/   /*SwitchType*/ 9, MVT::v4i32,// ->11402
/* 11393*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_V128), 0,
                  MVT::v4i32, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[v4i32] } I32:{ *:[i32] }:$cond, V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
              // Dst: (SELECT_V128:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs, ?:{ *:[i32] }:$cond)
/* 11402*/   /*SwitchType*/ 9, MVT::v2i64,// ->11413
/* 11404*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_V128), 0,
                  MVT::v2i64, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[v2i64] } I32:{ *:[i32] }:$cond, V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
              // Dst: (SELECT_V128:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs, ?:{ *:[i32] }:$cond)
/* 11413*/   0, // EndSwitchType
/* 11414*/  /*Scope*/ 73, /*->11488*/
/* 11415*/   OPC_MoveChild0,
/* 11416*/   OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
/* 11419*/   OPC_RecordChild0, // #0 = $cond
/* 11420*/   OPC_CheckChild0Type, MVT::i32,
/* 11422*/   OPC_CheckChild1Integer, 0, 
/* 11424*/   OPC_CheckType, MVT::i32,
/* 11426*/   OPC_Scope, 29, /*->11457*/ // 2 children in Scope
/* 11428*/    OPC_CheckChild2CondCode, ISD::SETNE,
/* 11430*/    OPC_MoveParent,
/* 11431*/    OPC_RecordChild1, // #1 = $lhs
/* 11432*/    OPC_RecordChild2, // #2 = $rhs
/* 11433*/    OPC_SwitchType /*2 cases */, 9, MVT::v4f32,// ->11445
/* 11436*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_V128), 0,
                   MVT::v4f32, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[v4f32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v4f32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs, ?:{ *:[i32] }:$cond)
/* 11445*/    /*SwitchType*/ 9, MVT::v2f64,// ->11456
/* 11447*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_V128), 0,
                   MVT::v2f64, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[v2f64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v2f64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs, ?:{ *:[i32] }:$cond)
/* 11456*/    0, // EndSwitchType
/* 11457*/   /*Scope*/ 29, /*->11487*/
/* 11458*/    OPC_CheckChild2CondCode, ISD::SETEQ,
/* 11460*/    OPC_MoveParent,
/* 11461*/    OPC_RecordChild1, // #1 = $lhs
/* 11462*/    OPC_RecordChild2, // #2 = $rhs
/* 11463*/    OPC_SwitchType /*2 cases */, 9, MVT::v4f32,// ->11475
/* 11466*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_V128), 0,
                   MVT::v4f32, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[v4f32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v4f32] } ?:{ *:[v4f32] }:$rhs, ?:{ *:[v4f32] }:$lhs, ?:{ *:[i32] }:$cond)
/* 11475*/    /*SwitchType*/ 9, MVT::v2f64,// ->11486
/* 11477*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_V128), 0,
                   MVT::v2f64, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[v2f64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v2f64] } ?:{ *:[v2f64] }:$rhs, ?:{ *:[v2f64] }:$lhs, ?:{ *:[i32] }:$cond)
/* 11486*/    0, // EndSwitchType
/* 11487*/   0, /*End of Scope*/
/* 11488*/  /*Scope*/ 29, /*->11518*/
/* 11489*/   OPC_RecordChild0, // #0 = $cond
/* 11490*/   OPC_CheckChild0Type, MVT::i32,
/* 11492*/   OPC_RecordChild1, // #1 = $lhs
/* 11493*/   OPC_RecordChild2, // #2 = $rhs
/* 11494*/   OPC_SwitchType /*2 cases */, 9, MVT::v4f32,// ->11506
/* 11497*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_V128), 0,
                  MVT::v4f32, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[v4f32] } I32:{ *:[i32] }:$cond, V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
              // Dst: (SELECT_V128:{ *:[v4f32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs, ?:{ *:[i32] }:$cond)
/* 11506*/   /*SwitchType*/ 9, MVT::v2f64,// ->11517
/* 11508*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_V128), 0,
                  MVT::v2f64, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[v2f64] } I32:{ *:[i32] }:$cond, V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
              // Dst: (SELECT_V128:{ *:[v2f64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs, ?:{ *:[i32] }:$cond)
/* 11517*/   0, // EndSwitchType
/* 11518*/  0, /*End of Scope*/
/* 11519*/ /*SwitchOpcode*/ 16|128,1/*144*/, TARGET_VAL(ISD::SIGN_EXTEND_INREG),// ->11667
/* 11523*/  OPC_Scope, 67, /*->11592*/ // 2 children in Scope
/* 11525*/   OPC_MoveChild0,
/* 11526*/   OPC_CheckOpcode, TARGET_VAL(ISD::EXTRACT_VECTOR_ELT),
/* 11529*/   OPC_RecordChild0, // #0 = $vec
/* 11530*/   OPC_Scope, 29, /*->11561*/ // 2 children in Scope
/* 11532*/    OPC_CheckChild0Type, MVT::v16i8,
/* 11534*/    OPC_RecordChild1, // #1 = $idx
/* 11535*/    OPC_MoveChild1,
/* 11536*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 11539*/    OPC_CheckPredicate, 3, // Predicate_LaneIdx16
/* 11541*/    OPC_CheckType, MVT::i32,
/* 11543*/    OPC_MoveParent,
/* 11544*/    OPC_MoveParent,
/* 11545*/    OPC_MoveChild1,
/* 11546*/    OPC_CheckValueType, MVT::i8,
/* 11548*/    OPC_MoveParent,
/* 11549*/    OPC_CheckType, MVT::i32,
/* 11551*/    OPC_EmitConvertToTarget, 1,
/* 11553*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTRACT_LANE_I8x16_s), 0,
                  MVT::i32, 2/*#Ops*/, 0, 2, 
              // Src: (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx), i8:{ *:[Other] }) - Complexity = 10
              // Dst: (EXTRACT_LANE_I8x16_s:{ *:[i32] } ?:{ *:[v16i8] }:$vec, (imm:{ *:[i32] }):$idx)
/* 11561*/   /*Scope*/ 29, /*->11591*/
/* 11562*/    OPC_CheckChild0Type, MVT::v8i16,
/* 11564*/    OPC_RecordChild1, // #1 = $idx
/* 11565*/    OPC_MoveChild1,
/* 11566*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 11569*/    OPC_CheckPredicate, 7, // Predicate_LaneIdx8
/* 11571*/    OPC_CheckType, MVT::i32,
/* 11573*/    OPC_MoveParent,
/* 11574*/    OPC_MoveParent,
/* 11575*/    OPC_MoveChild1,
/* 11576*/    OPC_CheckValueType, MVT::i16,
/* 11578*/    OPC_MoveParent,
/* 11579*/    OPC_CheckType, MVT::i32,
/* 11581*/    OPC_EmitConvertToTarget, 1,
/* 11583*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTRACT_LANE_I16x8_s), 0,
                  MVT::i32, 2/*#Ops*/, 0, 2, 
              // Src: (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx), i16:{ *:[Other] }) - Complexity = 10
              // Dst: (EXTRACT_LANE_I16x8_s:{ *:[i32] } ?:{ *:[v8i16] }:$vec, (imm:{ *:[i32] }):$idx)
/* 11591*/   0, /*End of Scope*/
/* 11592*/  /*Scope*/ 73, /*->11666*/
/* 11593*/   OPC_RecordChild0, // #0 = $src
/* 11594*/   OPC_MoveChild1,
/* 11595*/   OPC_Scope, 27, /*->11624*/ // 3 children in Scope
/* 11597*/    OPC_CheckValueType, MVT::i8,
/* 11599*/    OPC_MoveParent,
/* 11600*/    OPC_SwitchType /*2 cases */, 9, MVT::i32,// ->11612
/* 11603*/     OPC_CheckPatternPredicate, 7, // (Subtarget->hasSignExt())
/* 11605*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I32_EXTEND8_S_I32), 0,
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (sext_inreg:{ *:[i32] } I32:{ *:[i32] }:$src, i8:{ *:[Other] }) - Complexity = 3
               // Dst: (I32_EXTEND8_S_I32:{ *:[i32] } I32:{ *:[i32] }:$src)
/* 11612*/    /*SwitchType*/ 9, MVT::i64,// ->11623
/* 11614*/     OPC_CheckPatternPredicate, 7, // (Subtarget->hasSignExt())
/* 11616*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I64_EXTEND8_S_I64), 0,
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (sext_inreg:{ *:[i64] } I64:{ *:[i64] }:$src, i8:{ *:[Other] }) - Complexity = 3
               // Dst: (I64_EXTEND8_S_I64:{ *:[i64] } I64:{ *:[i64] }:$src)
/* 11623*/    0, // EndSwitchType
/* 11624*/   /*Scope*/ 27, /*->11652*/
/* 11625*/    OPC_CheckValueType, MVT::i16,
/* 11627*/    OPC_MoveParent,
/* 11628*/    OPC_SwitchType /*2 cases */, 9, MVT::i32,// ->11640
/* 11631*/     OPC_CheckPatternPredicate, 7, // (Subtarget->hasSignExt())
/* 11633*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I32_EXTEND16_S_I32), 0,
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (sext_inreg:{ *:[i32] } I32:{ *:[i32] }:$src, i16:{ *:[Other] }) - Complexity = 3
               // Dst: (I32_EXTEND16_S_I32:{ *:[i32] } I32:{ *:[i32] }:$src)
/* 11640*/    /*SwitchType*/ 9, MVT::i64,// ->11651
/* 11642*/     OPC_CheckPatternPredicate, 7, // (Subtarget->hasSignExt())
/* 11644*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I64_EXTEND16_S_I64), 0,
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (sext_inreg:{ *:[i64] } I64:{ *:[i64] }:$src, i16:{ *:[Other] }) - Complexity = 3
               // Dst: (I64_EXTEND16_S_I64:{ *:[i64] } I64:{ *:[i64] }:$src)
/* 11651*/    0, // EndSwitchType
/* 11652*/   /*Scope*/ 12, /*->11665*/
/* 11653*/    OPC_CheckValueType, MVT::i32,
/* 11655*/    OPC_MoveParent,
/* 11656*/    OPC_CheckPatternPredicate, 7, // (Subtarget->hasSignExt())
/* 11658*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I64_EXTEND32_S_I64), 0,
                  MVT::i64, 1/*#Ops*/, 0, 
              // Src: (sext_inreg:{ *:[i64] } I64:{ *:[i64] }:$src, i32:{ *:[Other] }) - Complexity = 3
              // Dst: (I64_EXTEND32_S_I64:{ *:[i64] } I64:{ *:[i64] }:$src)
/* 11665*/   0, /*End of Scope*/
/* 11666*/  0, /*End of Scope*/
/* 11667*/ /*SwitchOpcode*/ 23|128,1/*151*/, TARGET_VAL(WebAssemblyISD::GLOBAL_GET),// ->11822
/* 11671*/  OPC_RecordMemRef,
/* 11672*/  OPC_RecordNode, // #0 = 'WebAssemblyglobal_get' chained node
/* 11673*/  OPC_MoveChild1,
/* 11674*/  OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 11677*/  OPC_RecordChild0, // #1 = $addr
/* 11678*/  OPC_MoveChild0,
/* 11679*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 11682*/  OPC_MoveParent,
/* 11683*/  OPC_MoveParent,
/* 11684*/  OPC_SwitchType /*12 cases */, 8, MVT::i32,// ->11695
/* 11687*/   OPC_EmitMergeInputChains1_0,
/* 11688*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_I32), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::i32, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[i32] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_I32:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 11695*/  /*SwitchType*/ 8, MVT::i64,// ->11705
/* 11697*/   OPC_EmitMergeInputChains1_0,
/* 11698*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_I64), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::i64, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[i64] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_I64:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr)
/* 11705*/  /*SwitchType*/ 10, MVT::funcref,// ->11717
/* 11707*/   OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/* 11709*/   OPC_EmitMergeInputChains1_0,
/* 11710*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_FUNCREF), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::funcref, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[funcref] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_FUNCREF:{ *:[funcref] } (tglobaladdr:{ *:[i32] }):$addr)
/* 11717*/  /*SwitchType*/ 10, MVT::externref,// ->11729
/* 11719*/   OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/* 11721*/   OPC_EmitMergeInputChains1_0,
/* 11722*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_EXTERNREF), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::externref, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[externref] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_EXTERNREF:{ *:[externref] } (tglobaladdr:{ *:[i32] }):$addr)
/* 11729*/  /*SwitchType*/ 8, MVT::f32,// ->11739
/* 11731*/   OPC_EmitMergeInputChains1_0,
/* 11732*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_F32), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::f32, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[f32] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_F32:{ *:[f32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 11739*/  /*SwitchType*/ 8, MVT::f64,// ->11749
/* 11741*/   OPC_EmitMergeInputChains1_0,
/* 11742*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_F64), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::f64, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[f64] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_F64:{ *:[f64] } (tglobaladdr:{ *:[i32] }):$addr)
/* 11749*/  /*SwitchType*/ 10, MVT::v2i64,// ->11761
/* 11751*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 11753*/   OPC_EmitMergeInputChains1_0,
/* 11754*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::v2i64, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v2i64] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v2i64] } (tglobaladdr:{ *:[i32] }):$addr)
/* 11761*/  /*SwitchType*/ 10, MVT::v4i32,// ->11773
/* 11763*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 11765*/   OPC_EmitMergeInputChains1_0,
/* 11766*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::v4i32, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v4i32] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v4i32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 11773*/  /*SwitchType*/ 10, MVT::v16i8,// ->11785
/* 11775*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 11777*/   OPC_EmitMergeInputChains1_0,
/* 11778*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::v16i8, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v16i8] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v16i8] } (tglobaladdr:{ *:[i32] }):$addr)
/* 11785*/  /*SwitchType*/ 10, MVT::v8i16,// ->11797
/* 11787*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 11789*/   OPC_EmitMergeInputChains1_0,
/* 11790*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::v8i16, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v8i16] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v8i16] } (tglobaladdr:{ *:[i32] }):$addr)
/* 11797*/  /*SwitchType*/ 10, MVT::v4f32,// ->11809
/* 11799*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 11801*/   OPC_EmitMergeInputChains1_0,
/* 11802*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::v4f32, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v4f32] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v4f32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 11809*/  /*SwitchType*/ 10, MVT::v2f64,// ->11821
/* 11811*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 11813*/   OPC_EmitMergeInputChains1_0,
/* 11814*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::v2f64, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v2f64] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v2f64] } (tglobaladdr:{ *:[i32] }):$addr)
/* 11821*/  0, // EndSwitchType
/* 11822*/ /*SwitchOpcode*/ 29|128,2/*285*/, TARGET_VAL(WebAssemblyISD::GLOBAL_SET),// ->12111
/* 11826*/  OPC_RecordMemRef,
/* 11827*/  OPC_RecordNode, // #0 = 'WebAssemblyglobal_set' chained node
/* 11828*/  OPC_RecordChild1, // #1 = $src
/* 11829*/  OPC_Scope, 21, /*->11852*/ // 12 children in Scope
/* 11831*/   OPC_CheckChild1Type, MVT::i32,
/* 11833*/   OPC_MoveChild2,
/* 11834*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 11837*/   OPC_RecordChild0, // #2 = $addr
/* 11838*/   OPC_MoveChild0,
/* 11839*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 11842*/   OPC_MoveParent,
/* 11843*/   OPC_MoveParent,
/* 11844*/   OPC_EmitMergeInputChains1_0,
/* 11845*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_I32), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set i32:{ *:[i32] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_I32 (tglobaladdr:{ *:[i32] }):$addr, i32:{ *:[i32] }:$src)
/* 11852*/  /*Scope*/ 21, /*->11874*/
/* 11853*/   OPC_CheckChild1Type, MVT::i64,
/* 11855*/   OPC_MoveChild2,
/* 11856*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 11859*/   OPC_RecordChild0, // #2 = $addr
/* 11860*/   OPC_MoveChild0,
/* 11861*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 11864*/   OPC_MoveParent,
/* 11865*/   OPC_MoveParent,
/* 11866*/   OPC_EmitMergeInputChains1_0,
/* 11867*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_I64), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set i64:{ *:[i64] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_I64 (tglobaladdr:{ *:[i64] }):$addr, i64:{ *:[i64] }:$src)
/* 11874*/  /*Scope*/ 21, /*->11896*/
/* 11875*/   OPC_CheckChild1Type, MVT::f32,
/* 11877*/   OPC_MoveChild2,
/* 11878*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 11881*/   OPC_RecordChild0, // #2 = $addr
/* 11882*/   OPC_MoveChild0,
/* 11883*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 11886*/   OPC_MoveParent,
/* 11887*/   OPC_MoveParent,
/* 11888*/   OPC_EmitMergeInputChains1_0,
/* 11889*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_F32), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set f32:{ *:[f32] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_F32 (tglobaladdr:{ *:[i32] }):$addr, f32:{ *:[f32] }:$src)
/* 11896*/  /*Scope*/ 21, /*->11918*/
/* 11897*/   OPC_CheckChild1Type, MVT::f64,
/* 11899*/   OPC_MoveChild2,
/* 11900*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 11903*/   OPC_RecordChild0, // #2 = $addr
/* 11904*/   OPC_MoveChild0,
/* 11905*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 11908*/   OPC_MoveParent,
/* 11909*/   OPC_MoveParent,
/* 11910*/   OPC_EmitMergeInputChains1_0,
/* 11911*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_F64), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set f64:{ *:[f64] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_F64 (tglobaladdr:{ *:[i32] }):$addr, f64:{ *:[f64] }:$src)
/* 11918*/  /*Scope*/ 23, /*->11942*/
/* 11919*/   OPC_CheckChild1Type, MVT::v4f32,
/* 11921*/   OPC_MoveChild2,
/* 11922*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 11925*/   OPC_RecordChild0, // #2 = $addr
/* 11926*/   OPC_MoveChild0,
/* 11927*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 11930*/   OPC_MoveParent,
/* 11931*/   OPC_MoveParent,
/* 11932*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 11934*/   OPC_EmitMergeInputChains1_0,
/* 11935*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v4f32:{ *:[v4f32] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v4f32:{ *:[v4f32] }:$src)
/* 11942*/  /*Scope*/ 23, /*->11966*/
/* 11943*/   OPC_CheckChild1Type, MVT::v2f64,
/* 11945*/   OPC_MoveChild2,
/* 11946*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 11949*/   OPC_RecordChild0, // #2 = $addr
/* 11950*/   OPC_MoveChild0,
/* 11951*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 11954*/   OPC_MoveParent,
/* 11955*/   OPC_MoveParent,
/* 11956*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 11958*/   OPC_EmitMergeInputChains1_0,
/* 11959*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v2f64:{ *:[v2f64] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v2f64:{ *:[v2f64] }:$src)
/* 11966*/  /*Scope*/ 23, /*->11990*/
/* 11967*/   OPC_CheckChild1Type, MVT::v2i64,
/* 11969*/   OPC_MoveChild2,
/* 11970*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 11973*/   OPC_RecordChild0, // #2 = $addr
/* 11974*/   OPC_MoveChild0,
/* 11975*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 11978*/   OPC_MoveParent,
/* 11979*/   OPC_MoveParent,
/* 11980*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 11982*/   OPC_EmitMergeInputChains1_0,
/* 11983*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v2i64:{ *:[v2i64] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v2i64:{ *:[v2i64] }:$src)
/* 11990*/  /*Scope*/ 23, /*->12014*/
/* 11991*/   OPC_CheckChild1Type, MVT::v4i32,
/* 11993*/   OPC_MoveChild2,
/* 11994*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 11997*/   OPC_RecordChild0, // #2 = $addr
/* 11998*/   OPC_MoveChild0,
/* 11999*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 12002*/   OPC_MoveParent,
/* 12003*/   OPC_MoveParent,
/* 12004*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 12006*/   OPC_EmitMergeInputChains1_0,
/* 12007*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v4i32:{ *:[v4i32] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v4i32:{ *:[v4i32] }:$src)
/* 12014*/  /*Scope*/ 23, /*->12038*/
/* 12015*/   OPC_CheckChild1Type, MVT::v16i8,
/* 12017*/   OPC_MoveChild2,
/* 12018*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 12021*/   OPC_RecordChild0, // #2 = $addr
/* 12022*/   OPC_MoveChild0,
/* 12023*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 12026*/   OPC_MoveParent,
/* 12027*/   OPC_MoveParent,
/* 12028*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 12030*/   OPC_EmitMergeInputChains1_0,
/* 12031*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v16i8:{ *:[v16i8] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v16i8:{ *:[v16i8] }:$src)
/* 12038*/  /*Scope*/ 23, /*->12062*/
/* 12039*/   OPC_CheckChild1Type, MVT::v8i16,
/* 12041*/   OPC_MoveChild2,
/* 12042*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 12045*/   OPC_RecordChild0, // #2 = $addr
/* 12046*/   OPC_MoveChild0,
/* 12047*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 12050*/   OPC_MoveParent,
/* 12051*/   OPC_MoveParent,
/* 12052*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 12054*/   OPC_EmitMergeInputChains1_0,
/* 12055*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v8i16:{ *:[v8i16] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v8i16:{ *:[v8i16] }:$src)
/* 12062*/  /*Scope*/ 23, /*->12086*/
/* 12063*/   OPC_CheckChild1Type, MVT::funcref,
/* 12065*/   OPC_MoveChild2,
/* 12066*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 12069*/   OPC_RecordChild0, // #2 = $addr
/* 12070*/   OPC_MoveChild0,
/* 12071*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 12074*/   OPC_MoveParent,
/* 12075*/   OPC_MoveParent,
/* 12076*/   OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/* 12078*/   OPC_EmitMergeInputChains1_0,
/* 12079*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_FUNCREF), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set funcref:{ *:[funcref] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_FUNCREF (tglobaladdr:{ *:[i32] }):$addr, funcref:{ *:[funcref] }:$src)
/* 12086*/  /*Scope*/ 23, /*->12110*/
/* 12087*/   OPC_CheckChild1Type, MVT::externref,
/* 12089*/   OPC_MoveChild2,
/* 12090*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 12093*/   OPC_RecordChild0, // #2 = $addr
/* 12094*/   OPC_MoveChild0,
/* 12095*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 12098*/   OPC_MoveParent,
/* 12099*/   OPC_MoveParent,
/* 12100*/   OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/* 12102*/   OPC_EmitMergeInputChains1_0,
/* 12103*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_EXTERNREF), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set externref:{ *:[externref] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_EXTERNREF (tglobaladdr:{ *:[i32] }):$addr, externref:{ *:[externref] }:$src)
/* 12110*/  0, /*End of Scope*/
/* 12111*/ /*SwitchOpcode*/ 22, TARGET_VAL(ISD::CALLSEQ_START),// ->12136
/* 12114*/  OPC_RecordNode, // #0 = 'WebAssemblycallseq_start' chained node
/* 12115*/  OPC_RecordChild1, // #1 = $amt
/* 12116*/  OPC_MoveChild1,
/* 12117*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 12120*/  OPC_MoveParent,
/* 12121*/  OPC_RecordChild2, // #2 = $amt2
/* 12122*/  OPC_MoveChild2,
/* 12123*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 12126*/  OPC_MoveParent,
/* 12127*/  OPC_EmitMergeInputChains1_0,
/* 12128*/  OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADJCALLSTACKDOWN), 0|OPFL_Chain|OPFL_GlueOutput,
                MVT::i32, 2/*#Ops*/, 1, 2, 
            // Src: (WebAssemblycallseq_start (timm:{ *:[iPTR] }):$amt, (timm:{ *:[iPTR] }):$amt2) - Complexity = 9
            // Dst: (ADJCALLSTACKDOWN:{ *:[i32] } (timm:{ *:[i32] }):$amt, (timm:{ *:[i32] }):$amt2)
/* 12136*/ /*SwitchOpcode*/ 23, TARGET_VAL(ISD::CALLSEQ_END),// ->12162
/* 12139*/  OPC_RecordNode, // #0 = 'WebAssemblycallseq_end' chained node
/* 12140*/  OPC_CaptureGlueInput,
/* 12141*/  OPC_RecordChild1, // #1 = $amt
/* 12142*/  OPC_MoveChild1,
/* 12143*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 12146*/  OPC_MoveParent,
/* 12147*/  OPC_RecordChild2, // #2 = $amt2
/* 12148*/  OPC_MoveChild2,
/* 12149*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 12152*/  OPC_MoveParent,
/* 12153*/  OPC_EmitMergeInputChains1_0,
/* 12154*/  OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADJCALLSTACKUP), 0|OPFL_Chain|OPFL_GlueInput|OPFL_GlueOutput,
                MVT::i32, 2/*#Ops*/, 1, 2, 
            // Src: (WebAssemblycallseq_end (timm:{ *:[iPTR] }):$amt, (timm:{ *:[iPTR] }):$amt2) - Complexity = 9
            // Dst: (ADJCALLSTACKUP:{ *:[i32] } (timm:{ *:[i32] }):$amt, (timm:{ *:[i32] }):$amt2)
/* 12162*/ /*SwitchOpcode*/ 72, TARGET_VAL(WebAssemblyISD::MEMORY_COPY),// ->12237
/* 12165*/  OPC_RecordNode, // #0 = 'wasm_memcpy' chained node
/* 12166*/  OPC_RecordChild1, // #1 = $src_idx
/* 12167*/  OPC_MoveChild1,
/* 12168*/  OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 12171*/  OPC_CheckType, MVT::i32,
/* 12173*/  OPC_MoveParent,
/* 12174*/  OPC_RecordChild2, // #2 = $dst_idx
/* 12175*/  OPC_MoveChild2,
/* 12176*/  OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 12179*/  OPC_CheckType, MVT::i32,
/* 12181*/  OPC_MoveParent,
/* 12182*/  OPC_RecordChild3, // #3 = $dst
/* 12183*/  OPC_Scope, 25, /*->12210*/ // 2 children in Scope
/* 12185*/   OPC_CheckChild3Type, MVT::i32,
/* 12187*/   OPC_RecordChild4, // #4 = $src
/* 12188*/   OPC_CheckChild4Type, MVT::i32,
/* 12190*/   OPC_RecordChild5, // #5 = $len
/* 12191*/   OPC_CheckChild5Type, MVT::i32,
/* 12193*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasBulkMemory())
/* 12195*/   OPC_EmitMergeInputChains1_0,
/* 12196*/   OPC_EmitConvertToTarget, 1,
/* 12198*/   OPC_EmitConvertToTarget, 2,
/* 12200*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::anonymous_7819MEMORY_COPY_A32), 0|OPFL_Chain,
                 5/*#Ops*/, 6, 7, 3, 4, 5, 
             // Src: (wasm_memcpy (imm:{ *:[i32] }):$src_idx, (imm:{ *:[i32] }):$dst_idx, I32:{ *:[i32] }:$dst, I32:{ *:[i32] }:$src, I32:{ *:[i32] }:$len) - Complexity = 9
             // Dst: (anonymous_7819MEMORY_COPY_A32 (imm:{ *:[i32] }):$src_idx, (imm:{ *:[i32] }):$dst_idx, I32:{ *:[i32] }:$dst, I32:{ *:[i32] }:$src, I32:{ *:[i32] }:$len)
/* 12210*/  /*Scope*/ 25, /*->12236*/
/* 12211*/   OPC_CheckChild3Type, MVT::i64,
/* 12213*/   OPC_RecordChild4, // #4 = $src
/* 12214*/   OPC_CheckChild4Type, MVT::i64,
/* 12216*/   OPC_RecordChild5, // #5 = $len
/* 12217*/   OPC_CheckChild5Type, MVT::i64,
/* 12219*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasBulkMemory())
/* 12221*/   OPC_EmitMergeInputChains1_0,
/* 12222*/   OPC_EmitConvertToTarget, 1,
/* 12224*/   OPC_EmitConvertToTarget, 2,
/* 12226*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::anonymous_7820MEMORY_COPY_A64), 0|OPFL_Chain,
                 5/*#Ops*/, 6, 7, 3, 4, 5, 
             // Src: (wasm_memcpy (imm:{ *:[i32] }):$src_idx, (imm:{ *:[i32] }):$dst_idx, I64:{ *:[i64] }:$dst, I64:{ *:[i64] }:$src, I64:{ *:[i64] }:$len) - Complexity = 9
             // Dst: (anonymous_7820MEMORY_COPY_A64 (imm:{ *:[i32] }):$src_idx, (imm:{ *:[i32] }):$dst_idx, I64:{ *:[i64] }:$dst, I64:{ *:[i64] }:$src, I64:{ *:[i64] }:$len)
/* 12236*/  0, /*End of Scope*/
/* 12237*/ /*SwitchOpcode*/ 44, TARGET_VAL(WebAssemblyISD::TABLE_GET),// ->12284
/* 12240*/  OPC_RecordMemRef,
/* 12241*/  OPC_RecordNode, // #0 = 'WebAssemblyTableGet' chained node
/* 12242*/  OPC_MoveChild1,
/* 12243*/  OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 12246*/  OPC_RecordChild0, // #1 = $table
/* 12247*/  OPC_MoveChild0,
/* 12248*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 12251*/  OPC_MoveParent,
/* 12252*/  OPC_MoveParent,
/* 12253*/  OPC_RecordChild2, // #2 = $idx
/* 12254*/  OPC_CheckChild2Type, MVT::i32,
/* 12256*/  OPC_SwitchType /*2 cases */, 11, MVT::funcref,// ->12270
/* 12259*/   OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/* 12261*/   OPC_EmitMergeInputChains1_0,
/* 12262*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::TABLE_GET_FUNCREF), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::funcref, 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblyTableGet:{ *:[funcref] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), i32:{ *:[i32] }:$idx) - Complexity = 9
             // Dst: (TABLE_GET_FUNCREF:{ *:[funcref] } (tglobaladdr:{ *:[i32] }):$table, i32:{ *:[i32] }:$idx)
/* 12270*/  /*SwitchType*/ 11, MVT::externref,// ->12283
/* 12272*/   OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/* 12274*/   OPC_EmitMergeInputChains1_0,
/* 12275*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::TABLE_GET_EXTERNREF), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::externref, 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblyTableGet:{ *:[externref] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), i32:{ *:[i32] }:$idx) - Complexity = 9
             // Dst: (TABLE_GET_EXTERNREF:{ *:[externref] } (tglobaladdr:{ *:[i32] }):$table, i32:{ *:[i32] }:$idx)
/* 12283*/  0, // EndSwitchType
/* 12284*/ /*SwitchOpcode*/ 74, TARGET_VAL(WebAssemblyISD::TABLE_SET),// ->12361
/* 12287*/  OPC_RecordMemRef,
/* 12288*/  OPC_RecordNode, // #0 = 'WebAssemblyTableSet' chained node
/* 12289*/  OPC_Scope, 45, /*->12336*/ // 2 children in Scope
/* 12291*/   OPC_MoveChild1,
/* 12292*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 12295*/   OPC_RecordChild0, // #1 = $table
/* 12296*/   OPC_MoveChild0,
/* 12297*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 12300*/   OPC_MoveParent,
/* 12301*/   OPC_MoveParent,
/* 12302*/   OPC_RecordChild2, // #2 = $idx
/* 12303*/   OPC_CheckChild2Type, MVT::i32,
/* 12305*/   OPC_RecordChild3, // #3 = $src
/* 12306*/   OPC_Scope, 13, /*->12321*/ // 2 children in Scope
/* 12308*/    OPC_CheckChild3Type, MVT::funcref,
/* 12310*/    OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/* 12312*/    OPC_EmitMergeInputChains1_0,
/* 12313*/    OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::TABLE_SET_FUNCREF), 0|OPFL_Chain|OPFL_MemRefs,
                  3/*#Ops*/, 1, 2, 3, 
              // Src: (WebAssemblyTableSet (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), i32:{ *:[i32] }:$idx, funcref:{ *:[funcref] }:$src) - Complexity = 9
              // Dst: (TABLE_SET_FUNCREF (tglobaladdr:{ *:[i32] }):$table, i32:{ *:[i32] }:$idx, funcref:{ *:[funcref] }:$src)
/* 12321*/   /*Scope*/ 13, /*->12335*/
/* 12322*/    OPC_CheckChild3Type, MVT::externref,
/* 12324*/    OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/* 12326*/    OPC_EmitMergeInputChains1_0,
/* 12327*/    OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::TABLE_SET_EXTERNREF), 0|OPFL_Chain|OPFL_MemRefs,
                  3/*#Ops*/, 1, 2, 3, 
              // Src: (WebAssemblyTableSet (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), i32:{ *:[i32] }:$idx, externref:{ *:[externref] }:$src) - Complexity = 9
              // Dst: (TABLE_SET_EXTERNREF (tglobaladdr:{ *:[i32] }):$table, i32:{ *:[i32] }:$idx, externref:{ *:[externref] }:$src)
/* 12335*/   0, /*End of Scope*/
/* 12336*/  /*Scope*/ 23, /*->12360*/
/* 12337*/   OPC_RecordChild1, // #1 = $table
/* 12338*/   OPC_MoveChild1,
/* 12339*/   OPC_CheckOpcode, TARGET_VAL(ISD::MCSymbol),
/* 12342*/   OPC_MoveParent,
/* 12343*/   OPC_RecordChild2, // #2 = $idx
/* 12344*/   OPC_CheckChild2Type, MVT::i32,
/* 12346*/   OPC_RecordChild3, // #3 = $r
/* 12347*/   OPC_CheckChild3Type, MVT::funcref,
/* 12349*/   OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/* 12351*/   OPC_EmitMergeInputChains1_0,
/* 12352*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::TABLE_SET_FUNCREF), 0|OPFL_Chain|OPFL_MemRefs,
                 3/*#Ops*/, 1, 2, 3, 
             // Src: (WebAssemblyTableSet (mcsym:{ *:[iPTR] }):$table, i32:{ *:[i32] }:$idx, funcref:{ *:[funcref] }:$r) - Complexity = 6
             // Dst: (TABLE_SET_FUNCREF (mcsym:{ *:[i32] }):$table, i32:{ *:[i32] }:$idx, funcref:{ *:[funcref] }:$r)
/* 12360*/  0, /*End of Scope*/
/* 12361*/ /*SwitchOpcode*/ 124|128,9/*1276*/, TARGET_VAL(ISD::INTRINSIC_WO_CHAIN),// ->13641
/* 12365*/  OPC_Scope, 53, /*->12420*/ // 36 children in Scope
/* 12367*/   OPC_CheckChild0Integer, 78|128,57|128,1/*23758*/, 
/* 12371*/   OPC_RecordChild1, // #0 = $src
/* 12372*/   OPC_Scope, 22, /*->12396*/ // 2 children in Scope
/* 12374*/    OPC_CheckChild1Type, MVT::f32,
/* 12376*/    OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->12386
/* 12379*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I32_TRUNC_S_F32), 0,
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i32] } 11879:{ *:[iPTR] }, F32:{ *:[f32] }:$src) - Complexity = 8
               // Dst: (I32_TRUNC_S_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 12386*/    /*SwitchType*/ 7, MVT::i64,// ->12395
/* 12388*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I64_TRUNC_S_F32), 0,
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i64] } 11879:{ *:[iPTR] }, F32:{ *:[f32] }:$src) - Complexity = 8
               // Dst: (I64_TRUNC_S_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 12395*/    0, // EndSwitchType
/* 12396*/   /*Scope*/ 22, /*->12419*/
/* 12397*/    OPC_CheckChild1Type, MVT::f64,
/* 12399*/    OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->12409
/* 12402*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I32_TRUNC_S_F64), 0,
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i32] } 11879:{ *:[iPTR] }, F64:{ *:[f64] }:$src) - Complexity = 8
               // Dst: (I32_TRUNC_S_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 12409*/    /*SwitchType*/ 7, MVT::i64,// ->12418
/* 12411*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I64_TRUNC_S_F64), 0,
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i64] } 11879:{ *:[iPTR] }, F64:{ *:[f64] }:$src) - Complexity = 8
               // Dst: (I64_TRUNC_S_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 12418*/    0, // EndSwitchType
/* 12419*/   0, /*End of Scope*/
/* 12420*/  /*Scope*/ 53, /*->12474*/
/* 12421*/   OPC_CheckChild0Integer, 80|128,57|128,1/*23760*/, 
/* 12425*/   OPC_RecordChild1, // #0 = $src
/* 12426*/   OPC_Scope, 22, /*->12450*/ // 2 children in Scope
/* 12428*/    OPC_CheckChild1Type, MVT::f32,
/* 12430*/    OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->12440
/* 12433*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I32_TRUNC_U_F32), 0,
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i32] } 11880:{ *:[iPTR] }, F32:{ *:[f32] }:$src) - Complexity = 8
               // Dst: (I32_TRUNC_U_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 12440*/    /*SwitchType*/ 7, MVT::i64,// ->12449
/* 12442*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I64_TRUNC_U_F32), 0,
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i64] } 11880:{ *:[iPTR] }, F32:{ *:[f32] }:$src) - Complexity = 8
               // Dst: (I64_TRUNC_U_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 12449*/    0, // EndSwitchType
/* 12450*/   /*Scope*/ 22, /*->12473*/
/* 12451*/    OPC_CheckChild1Type, MVT::f64,
/* 12453*/    OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->12463
/* 12456*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I32_TRUNC_U_F64), 0,
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i32] } 11880:{ *:[iPTR] }, F64:{ *:[f64] }:$src) - Complexity = 8
               // Dst: (I32_TRUNC_U_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 12463*/    /*SwitchType*/ 7, MVT::i64,// ->12472
/* 12465*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I64_TRUNC_U_F64), 0,
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i64] } 11880:{ *:[iPTR] }, F64:{ *:[f64] }:$src) - Complexity = 8
               // Dst: (I64_TRUNC_U_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 12472*/    0, // EndSwitchType
/* 12473*/   0, /*End of Scope*/
/* 12474*/  /*Scope*/ 47, /*->12522*/
/* 12475*/   OPC_CheckChild0Integer, 84|128,56|128,1/*23636*/, 
/* 12479*/   OPC_RecordChild1, // #0 = $vec
/* 12480*/   OPC_Scope, 9, /*->12491*/ // 4 children in Scope
/* 12482*/    OPC_CheckChild1Type, MVT::v16i8,
/* 12484*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ANYTRUE), 0,
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 11818:{ *:[iPTR] }, V128:{ *:[v16i8] }:$vec) - Complexity = 8
              // Dst: (ANYTRUE:{ *:[i32] } V128:{ *:[v16i8] }:$vec)
/* 12491*/   /*Scope*/ 9, /*->12501*/
/* 12492*/    OPC_CheckChild1Type, MVT::v8i16,
/* 12494*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ANYTRUE), 0,
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 11818:{ *:[iPTR] }, V128:{ *:[v8i16] }:$vec) - Complexity = 8
              // Dst: (ANYTRUE:{ *:[i32] } V128:{ *:[v8i16] }:$vec)
/* 12501*/   /*Scope*/ 9, /*->12511*/
/* 12502*/    OPC_CheckChild1Type, MVT::v4i32,
/* 12504*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ANYTRUE), 0,
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 11818:{ *:[iPTR] }, V128:{ *:[v4i32] }:$vec) - Complexity = 8
              // Dst: (ANYTRUE:{ *:[i32] } V128:{ *:[v4i32] }:$vec)
/* 12511*/   /*Scope*/ 9, /*->12521*/
/* 12512*/    OPC_CheckChild1Type, MVT::v2i64,
/* 12514*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ANYTRUE), 0,
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 11818:{ *:[iPTR] }, V128:{ *:[v2i64] }:$vec) - Complexity = 8
              // Dst: (ANYTRUE:{ *:[i32] } V128:{ *:[v2i64] }:$vec)
/* 12521*/   0, /*End of Scope*/
/* 12522*/  /*Scope*/ 55, /*->12578*/
/* 12523*/   OPC_CheckChild0Integer, 82|128,56|128,1/*23634*/, 
/* 12527*/   OPC_RecordChild1, // #0 = $vec
/* 12528*/   OPC_Scope, 11, /*->12541*/ // 4 children in Scope
/* 12530*/    OPC_CheckChild1Type, MVT::v16i8,
/* 12532*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 12534*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ALLTRUE_I8x16), 0,
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 11817:{ *:[iPTR] }, V128:{ *:[v16i8] }:$vec) - Complexity = 8
              // Dst: (ALLTRUE_I8x16:{ *:[i32] } V128:{ *:[v16i8] }:$vec)
/* 12541*/   /*Scope*/ 11, /*->12553*/
/* 12542*/    OPC_CheckChild1Type, MVT::v8i16,
/* 12544*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 12546*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ALLTRUE_I16x8), 0,
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 11817:{ *:[iPTR] }, V128:{ *:[v8i16] }:$vec) - Complexity = 8
              // Dst: (ALLTRUE_I16x8:{ *:[i32] } V128:{ *:[v8i16] }:$vec)
/* 12553*/   /*Scope*/ 11, /*->12565*/
/* 12554*/    OPC_CheckChild1Type, MVT::v4i32,
/* 12556*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 12558*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ALLTRUE_I32x4), 0,
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 11817:{ *:[iPTR] }, V128:{ *:[v4i32] }:$vec) - Complexity = 8
              // Dst: (ALLTRUE_I32x4:{ *:[i32] } V128:{ *:[v4i32] }:$vec)
/* 12565*/   /*Scope*/ 11, /*->12577*/
/* 12566*/    OPC_CheckChild1Type, MVT::v2i64,
/* 12568*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 12570*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ALLTRUE_I64x2), 0,
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 11817:{ *:[iPTR] }, V128:{ *:[v2i64] }:$vec) - Complexity = 8
              // Dst: (ALLTRUE_I64x2:{ *:[i32] } V128:{ *:[v2i64] }:$vec)
/* 12577*/   0, /*End of Scope*/
/* 12578*/  /*Scope*/ 55, /*->12634*/
/* 12579*/   OPC_CheckChild0Integer, 88|128,56|128,1/*23640*/, 
/* 12583*/   OPC_RecordChild1, // #0 = $vec
/* 12584*/   OPC_Scope, 11, /*->12597*/ // 4 children in Scope
/* 12586*/    OPC_CheckChild1Type, MVT::v16i8,
/* 12588*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 12590*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITMASK_I8x16), 0,
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 11820:{ *:[iPTR] }, V128:{ *:[v16i8] }:$vec) - Complexity = 8
              // Dst: (BITMASK_I8x16:{ *:[i32] } V128:{ *:[v16i8] }:$vec)
/* 12597*/   /*Scope*/ 11, /*->12609*/
/* 12598*/    OPC_CheckChild1Type, MVT::v8i16,
/* 12600*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 12602*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITMASK_I16x8), 0,
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 11820:{ *:[iPTR] }, V128:{ *:[v8i16] }:$vec) - Complexity = 8
              // Dst: (BITMASK_I16x8:{ *:[i32] } V128:{ *:[v8i16] }:$vec)
/* 12609*/   /*Scope*/ 11, /*->12621*/
/* 12610*/    OPC_CheckChild1Type, MVT::v4i32,
/* 12612*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 12614*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITMASK_I32x4), 0,
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 11820:{ *:[iPTR] }, V128:{ *:[v4i32] }:$vec) - Complexity = 8
              // Dst: (BITMASK_I32x4:{ *:[i32] } V128:{ *:[v4i32] }:$vec)
/* 12621*/   /*Scope*/ 11, /*->12633*/
/* 12622*/    OPC_CheckChild1Type, MVT::v2i64,
/* 12624*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 12626*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITMASK_I64x2), 0,
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 11820:{ *:[iPTR] }, V128:{ *:[v2i64] }:$vec) - Complexity = 8
              // Dst: (BITMASK_I64x2:{ *:[i32] } V128:{ *:[v2i64] }:$vec)
/* 12633*/   0, /*End of Scope*/
/* 12634*/  /*Scope*/ 12, /*->12647*/
/* 12635*/   OPC_CheckChild0Integer, 6|128,57|128,1/*23686*/, 
/* 12639*/   OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/* 12641*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::REF_NULL_FUNCREF), 0,
                 MVT::funcref, 0/*#Ops*/, 
             // Src: (intrinsic_wo_chain:{ *:[funcref] } 11843:{ *:[iPTR] }) - Complexity = 8
             // Dst: (REF_NULL_FUNCREF:{ *:[funcref] })
/* 12647*/  /*Scope*/ 14, /*->12662*/
/* 12648*/   OPC_CheckChild0Integer, 2|128,57|128,1/*23682*/, 
/* 12652*/   OPC_RecordChild1, // #0 = $ref
/* 12653*/   OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/* 12655*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::REF_IS_NULL_FUNCREF), 0,
                 MVT::i32, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[i32] } 11841:{ *:[iPTR] }, FUNCREF:{ *:[funcref] }:$ref) - Complexity = 8
             // Dst: (REF_IS_NULL_FUNCREF:{ *:[i32] } FUNCREF:{ *:[funcref] }:$ref)
/* 12662*/  /*Scope*/ 12, /*->12675*/
/* 12663*/   OPC_CheckChild0Integer, 4|128,57|128,1/*23684*/, 
/* 12667*/   OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/* 12669*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::REF_NULL_EXTERNREF), 0,
                 MVT::externref, 0/*#Ops*/, 
             // Src: (intrinsic_wo_chain:{ *:[externref] } 11842:{ *:[iPTR] }) - Complexity = 8
             // Dst: (REF_NULL_EXTERNREF:{ *:[externref] })
/* 12675*/  /*Scope*/ 14, /*->12690*/
/* 12676*/   OPC_CheckChild0Integer, 0|128,57|128,1/*23680*/, 
/* 12680*/   OPC_RecordChild1, // #0 = $ref
/* 12681*/   OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/* 12683*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::REF_IS_NULL_EXTERNREF), 0,
                 MVT::i32, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[i32] } 11840:{ *:[iPTR] }, EXTERNREF:{ *:[externref] }:$ref) - Complexity = 8
             // Dst: (REF_IS_NULL_EXTERNREF:{ *:[i32] } EXTERNREF:{ *:[externref] }:$ref)
/* 12690*/  /*Scope*/ 14, /*->12705*/
/* 12691*/   OPC_CheckChild0Integer, 44|128,57|128,1/*23724*/, 
/* 12695*/   OPC_RecordChild1, // #0 = $src
/* 12696*/   OPC_RecordChild2, // #1 = $mask
/* 12697*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SWIZZLE), 0,
                 MVT::v16i8, 2/*#Ops*/, 0, 1, 
             // Src: (intrinsic_wo_chain:{ *:[v16i8] } 11862:{ *:[iPTR] }, V128:{ *:[v16i8] }:$src, V128:{ *:[v16i8] }:$mask) - Complexity = 8
             // Dst: (SWIZZLE:{ *:[v16i8] } ?:{ *:[v16i8] }:$src, ?:{ *:[v16i8] }:$mask)
/* 12705*/  /*Scope*/ 121, /*->12827*/
/* 12706*/   OPC_CheckChild0Integer, 90|128,56|128,1/*23642*/, 
/* 12710*/   OPC_RecordChild1, // #0 = $v1
/* 12711*/   OPC_SwitchType /*6 cases */, 17, MVT::v16i8,// ->12731
/* 12714*/    OPC_CheckChild1Type, MVT::v16i8,
/* 12716*/    OPC_RecordChild2, // #1 = $v2
/* 12717*/    OPC_CheckChild2Type, MVT::v16i8,
/* 12719*/    OPC_RecordChild3, // #2 = $c
/* 12720*/    OPC_CheckChild3Type, MVT::v16i8,
/* 12722*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                  MVT::v16i8, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v16i8] } 11821:{ *:[iPTR] }, V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$c) - Complexity = 8
              // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 12731*/   /*SwitchType*/ 17, MVT::v8i16,// ->12750
/* 12733*/    OPC_CheckChild1Type, MVT::v8i16,
/* 12735*/    OPC_RecordChild2, // #1 = $v2
/* 12736*/    OPC_CheckChild2Type, MVT::v8i16,
/* 12738*/    OPC_RecordChild3, // #2 = $c
/* 12739*/    OPC_CheckChild3Type, MVT::v8i16,
/* 12741*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                  MVT::v8i16, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 11821:{ *:[iPTR] }, V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$c) - Complexity = 8
              // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 12750*/   /*SwitchType*/ 17, MVT::v4i32,// ->12769
/* 12752*/    OPC_CheckChild1Type, MVT::v4i32,
/* 12754*/    OPC_RecordChild2, // #1 = $v2
/* 12755*/    OPC_CheckChild2Type, MVT::v4i32,
/* 12757*/    OPC_RecordChild3, // #2 = $c
/* 12758*/    OPC_CheckChild3Type, MVT::v4i32,
/* 12760*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                  MVT::v4i32, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v4i32] } 11821:{ *:[iPTR] }, V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$c) - Complexity = 8
              // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 12769*/   /*SwitchType*/ 17, MVT::v2i64,// ->12788
/* 12771*/    OPC_CheckChild1Type, MVT::v2i64,
/* 12773*/    OPC_RecordChild2, // #1 = $v2
/* 12774*/    OPC_CheckChild2Type, MVT::v2i64,
/* 12776*/    OPC_RecordChild3, // #2 = $c
/* 12777*/    OPC_CheckChild3Type, MVT::v2i64,
/* 12779*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                  MVT::v2i64, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v2i64] } 11821:{ *:[iPTR] }, V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$c) - Complexity = 8
              // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 12788*/   /*SwitchType*/ 17, MVT::v4f32,// ->12807
/* 12790*/    OPC_CheckChild1Type, MVT::v4f32,
/* 12792*/    OPC_RecordChild2, // #1 = $v2
/* 12793*/    OPC_CheckChild2Type, MVT::v4f32,
/* 12795*/    OPC_RecordChild3, // #2 = $c
/* 12796*/    OPC_CheckChild3Type, MVT::v4f32,
/* 12798*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                  MVT::v4f32, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v4f32] } 11821:{ *:[iPTR] }, V128:{ *:[v4f32] }:$v1, V128:{ *:[v4f32] }:$v2, V128:{ *:[v4f32] }:$c) - Complexity = 8
              // Dst: (BITSELECT:{ *:[v4f32] } ?:{ *:[v4f32] }:$v1, ?:{ *:[v4f32] }:$v2, ?:{ *:[v4f32] }:$c)
/* 12807*/   /*SwitchType*/ 17, MVT::v2f64,// ->12826
/* 12809*/    OPC_CheckChild1Type, MVT::v2f64,
/* 12811*/    OPC_RecordChild2, // #1 = $v2
/* 12812*/    OPC_CheckChild2Type, MVT::v2f64,
/* 12814*/    OPC_RecordChild3, // #2 = $c
/* 12815*/    OPC_CheckChild3Type, MVT::v2f64,
/* 12817*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                  MVT::v2f64, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v2f64] } 11821:{ *:[iPTR] }, V128:{ *:[v2f64] }:$v1, V128:{ *:[v2f64] }:$v2, V128:{ *:[v2f64] }:$c) - Complexity = 8
              // Dst: (BITSELECT:{ *:[v2f64] } ?:{ *:[v2f64] }:$v1, ?:{ *:[v2f64] }:$v2, ?:{ *:[v2f64] }:$c)
/* 12826*/   0, // EndSwitchType
/* 12827*/  /*Scope*/ 41, /*->12869*/
/* 12828*/   OPC_CheckChild0Integer, 40|128,57|128,1/*23720*/, 
/* 12832*/   OPC_RecordChild1, // #0 = $lhs
/* 12833*/   OPC_SwitchType /*2 cases */, 15, MVT::v16i8,// ->12851
/* 12836*/    OPC_CheckChild1Type, MVT::v16i8,
/* 12838*/    OPC_RecordChild2, // #1 = $rhs
/* 12839*/    OPC_CheckChild2Type, MVT::v16i8,
/* 12841*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 12843*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SUB_SAT_S_I8x16), 0,
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v16i8] } 11860:{ *:[iPTR] }, V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 8
              // Dst: (SUB_SAT_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 12851*/   /*SwitchType*/ 15, MVT::v8i16,// ->12868
/* 12853*/    OPC_CheckChild1Type, MVT::v8i16,
/* 12855*/    OPC_RecordChild2, // #1 = $rhs
/* 12856*/    OPC_CheckChild2Type, MVT::v8i16,
/* 12858*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 12860*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SUB_SAT_S_I16x8), 0,
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 11860:{ *:[iPTR] }, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 8
              // Dst: (SUB_SAT_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 12868*/   0, // EndSwitchType
/* 12869*/  /*Scope*/ 41, /*->12911*/
/* 12870*/   OPC_CheckChild0Integer, 42|128,57|128,1/*23722*/, 
/* 12874*/   OPC_RecordChild1, // #0 = $lhs
/* 12875*/   OPC_SwitchType /*2 cases */, 15, MVT::v16i8,// ->12893
/* 12878*/    OPC_CheckChild1Type, MVT::v16i8,
/* 12880*/    OPC_RecordChild2, // #1 = $rhs
/* 12881*/    OPC_CheckChild2Type, MVT::v16i8,
/* 12883*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 12885*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SUB_SAT_U_I8x16), 0,
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v16i8] } 11861:{ *:[iPTR] }, V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 8
              // Dst: (SUB_SAT_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 12893*/   /*SwitchType*/ 15, MVT::v8i16,// ->12910
/* 12895*/    OPC_CheckChild1Type, MVT::v8i16,
/* 12897*/    OPC_RecordChild2, // #1 = $rhs
/* 12898*/    OPC_CheckChild2Type, MVT::v8i16,
/* 12900*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 12902*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SUB_SAT_U_I16x8), 0,
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 11861:{ *:[iPTR] }, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 8
              // Dst: (SUB_SAT_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 12910*/   0, // EndSwitchType
/* 12911*/  /*Scope*/ 41, /*->12953*/
/* 12912*/   OPC_CheckChild0Integer, 86|128,56|128,1/*23638*/, 
/* 12916*/   OPC_RecordChild1, // #0 = $lhs
/* 12917*/   OPC_SwitchType /*2 cases */, 15, MVT::v16i8,// ->12935
/* 12920*/    OPC_CheckChild1Type, MVT::v16i8,
/* 12922*/    OPC_RecordChild2, // #1 = $rhs
/* 12923*/    OPC_CheckChild2Type, MVT::v16i8,
/* 12925*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 12927*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::AVGR_U_I8x16), 0,
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v16i8] } 11819:{ *:[iPTR] }, V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 8
              // Dst: (AVGR_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 12935*/   /*SwitchType*/ 15, MVT::v8i16,// ->12952
/* 12937*/    OPC_CheckChild1Type, MVT::v8i16,
/* 12939*/    OPC_RecordChild2, // #1 = $rhs
/* 12940*/    OPC_CheckChild2Type, MVT::v8i16,
/* 12942*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 12944*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::AVGR_U_I16x8), 0,
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 11819:{ *:[iPTR] }, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 8
              // Dst: (AVGR_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 12952*/   0, // EndSwitchType
/* 12953*/  /*Scope*/ 16, /*->12970*/
/* 12954*/   OPC_CheckChild0Integer, 94|128,56|128,1/*23646*/, 
/* 12958*/   OPC_RecordChild1, // #0 = $lhs
/* 12959*/   OPC_RecordChild2, // #1 = $rhs
/* 12960*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 12962*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::DOT), 0,
                 MVT::v4i32, 2/*#Ops*/, 0, 1, 
             // Src: (intrinsic_wo_chain:{ *:[v4i32] } 11823:{ *:[iPTR] }, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 8
             // Dst: (DOT:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 12970*/  /*Scope*/ 41, /*->13012*/
/* 12971*/   OPC_CheckChild0Integer, 118|128,56|128,1/*23670*/, 
/* 12975*/   OPC_RecordChild1, // #0 = $low
/* 12976*/   OPC_SwitchType /*2 cases */, 15, MVT::v16i8,// ->12994
/* 12979*/    OPC_CheckChild1Type, MVT::v8i16,
/* 12981*/    OPC_RecordChild2, // #1 = $high
/* 12982*/    OPC_CheckChild2Type, MVT::v8i16,
/* 12984*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 12986*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NARROW_S_I8x16), 0,
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v16i8] } 11835:{ *:[iPTR] }, V128:{ *:[v8i16] }:$low, V128:{ *:[v8i16] }:$high) - Complexity = 8
              // Dst: (NARROW_S_I8x16:{ *:[v16i8] } V128:{ *:[v8i16] }:$low, V128:{ *:[v8i16] }:$high)
/* 12994*/   /*SwitchType*/ 15, MVT::v8i16,// ->13011
/* 12996*/    OPC_CheckChild1Type, MVT::v4i32,
/* 12998*/    OPC_RecordChild2, // #1 = $high
/* 12999*/    OPC_CheckChild2Type, MVT::v4i32,
/* 13001*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 13003*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NARROW_S_I16x8), 0,
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 11835:{ *:[iPTR] }, V128:{ *:[v4i32] }:$low, V128:{ *:[v4i32] }:$high) - Complexity = 8
              // Dst: (NARROW_S_I16x8:{ *:[v8i16] } V128:{ *:[v4i32] }:$low, V128:{ *:[v4i32] }:$high)
/* 13011*/   0, // EndSwitchType
/* 13012*/  /*Scope*/ 41, /*->13054*/
/* 13013*/   OPC_CheckChild0Integer, 120|128,56|128,1/*23672*/, 
/* 13017*/   OPC_RecordChild1, // #0 = $low
/* 13018*/   OPC_SwitchType /*2 cases */, 15, MVT::v16i8,// ->13036
/* 13021*/    OPC_CheckChild1Type, MVT::v8i16,
/* 13023*/    OPC_RecordChild2, // #1 = $high
/* 13024*/    OPC_CheckChild2Type, MVT::v8i16,
/* 13026*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 13028*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NARROW_U_I8x16), 0,
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v16i8] } 11836:{ *:[iPTR] }, V128:{ *:[v8i16] }:$low, V128:{ *:[v8i16] }:$high) - Complexity = 8
              // Dst: (NARROW_U_I8x16:{ *:[v16i8] } V128:{ *:[v8i16] }:$low, V128:{ *:[v8i16] }:$high)
/* 13036*/   /*SwitchType*/ 15, MVT::v8i16,// ->13053
/* 13038*/    OPC_CheckChild1Type, MVT::v4i32,
/* 13040*/    OPC_RecordChild2, // #1 = $high
/* 13041*/    OPC_CheckChild2Type, MVT::v4i32,
/* 13043*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 13045*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NARROW_U_I16x8), 0,
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 11836:{ *:[iPTR] }, V128:{ *:[v4i32] }:$low, V128:{ *:[v4i32] }:$high) - Complexity = 8
              // Dst: (NARROW_U_I16x8:{ *:[v8i16] } V128:{ *:[v4i32] }:$low, V128:{ *:[v4i32] }:$high)
/* 13053*/   0, // EndSwitchType
/* 13054*/  /*Scope*/ 33, /*->13088*/
/* 13055*/   OPC_CheckChild0Integer, 96|128,56|128,1/*23648*/, 
/* 13059*/   OPC_RecordChild1, // #0 = $vec
/* 13060*/   OPC_SwitchType /*2 cases */, 11, MVT::v8i16,// ->13074
/* 13063*/    OPC_CheckChild1Type, MVT::v16i8,
/* 13065*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 13067*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::int_wasm_extadd_pairwise_signed_I16x8), 0,
                  MVT::v8i16, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 11824:{ *:[iPTR] }, V128:{ *:[v16i8] }:$vec) - Complexity = 8
              // Dst: (int_wasm_extadd_pairwise_signed_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec)
/* 13074*/   /*SwitchType*/ 11, MVT::v4i32,// ->13087
/* 13076*/    OPC_CheckChild1Type, MVT::v8i16,
/* 13078*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 13080*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::int_wasm_extadd_pairwise_signed_I32x4), 0,
                  MVT::v4i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[v4i32] } 11824:{ *:[iPTR] }, V128:{ *:[v8i16] }:$vec) - Complexity = 8
              // Dst: (int_wasm_extadd_pairwise_signed_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec)
/* 13087*/   0, // EndSwitchType
/* 13088*/  /*Scope*/ 33, /*->13122*/
/* 13089*/   OPC_CheckChild0Integer, 98|128,56|128,1/*23650*/, 
/* 13093*/   OPC_RecordChild1, // #0 = $vec
/* 13094*/   OPC_SwitchType /*2 cases */, 11, MVT::v8i16,// ->13108
/* 13097*/    OPC_CheckChild1Type, MVT::v16i8,
/* 13099*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 13101*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::int_wasm_extadd_pairwise_unsigned_I16x8), 0,
                  MVT::v8i16, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 11825:{ *:[iPTR] }, V128:{ *:[v16i8] }:$vec) - Complexity = 8
              // Dst: (int_wasm_extadd_pairwise_unsigned_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec)
/* 13108*/   /*SwitchType*/ 11, MVT::v4i32,// ->13121
/* 13110*/    OPC_CheckChild1Type, MVT::v8i16,
/* 13112*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 13114*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::int_wasm_extadd_pairwise_unsigned_I32x4), 0,
                  MVT::v4i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[v4i32] } 11825:{ *:[iPTR] }, V128:{ *:[v8i16] }:$vec) - Complexity = 8
              // Dst: (int_wasm_extadd_pairwise_unsigned_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec)
/* 13121*/   0, // EndSwitchType
/* 13122*/  /*Scope*/ 16, /*->13139*/
/* 13123*/   OPC_CheckChild0Integer, 126|128,56|128,1/*23678*/, 
/* 13127*/   OPC_RecordChild1, // #0 = $lhs
/* 13128*/   OPC_RecordChild2, // #1 = $rhs
/* 13129*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 13131*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::Q15MULR_SAT_S_I16x8), 0,
                 MVT::v8i16, 2/*#Ops*/, 0, 1, 
             // Src: (intrinsic_wo_chain:{ *:[v8i16] } 11839:{ *:[iPTR] }, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 8
             // Dst: (Q15MULR_SAT_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 13139*/  /*Scope*/ 16, /*->13156*/
/* 13140*/   OPC_CheckChild0Integer, 26|128,57|128,1/*23706*/, 
/* 13144*/   OPC_RecordChild1, // #0 = $src
/* 13145*/   OPC_RecordChild2, // #1 = $mask
/* 13146*/   OPC_CheckPatternPredicate, 9, // (Subtarget->hasRelaxedSIMD())
/* 13148*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::RELAXED_SWIZZLE), 0,
                 MVT::v16i8, 2/*#Ops*/, 0, 1, 
             // Src: (intrinsic_wo_chain:{ *:[v16i8] } 11853:{ *:[iPTR] }, V128:{ *:[v16i8] }:$src, V128:{ *:[v16i8] }:$mask) - Complexity = 8
             // Dst: (RELAXED_SWIZZLE:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, V128:{ *:[v16i8] }:$mask)
/* 13156*/  /*Scope*/ 14, /*->13171*/
/* 13157*/   OPC_CheckChild0Integer, 28|128,57|128,1/*23708*/, 
/* 13161*/   OPC_RecordChild1, // #0 = $vec
/* 13162*/   OPC_CheckPatternPredicate, 9, // (Subtarget->hasRelaxedSIMD())
/* 13164*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::int_wasm_relaxed_trunc_signed_I32x4), 0,
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[v4i32] } 11854:{ *:[iPTR] }, V128:{ *:[v4f32] }:$vec) - Complexity = 8
             // Dst: (int_wasm_relaxed_trunc_signed_I32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$vec)
/* 13171*/  /*Scope*/ 14, /*->13186*/
/* 13172*/   OPC_CheckChild0Integer, 32|128,57|128,1/*23712*/, 
/* 13176*/   OPC_RecordChild1, // #0 = $vec
/* 13177*/   OPC_CheckPatternPredicate, 9, // (Subtarget->hasRelaxedSIMD())
/* 13179*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::int_wasm_relaxed_trunc_unsigned_I32x4), 0,
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[v4i32] } 11856:{ *:[iPTR] }, V128:{ *:[v4f32] }:$vec) - Complexity = 8
             // Dst: (int_wasm_relaxed_trunc_unsigned_I32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$vec)
/* 13186*/  /*Scope*/ 14, /*->13201*/
/* 13187*/   OPC_CheckChild0Integer, 30|128,57|128,1/*23710*/, 
/* 13191*/   OPC_RecordChild1, // #0 = $vec
/* 13192*/   OPC_CheckPatternPredicate, 9, // (Subtarget->hasRelaxedSIMD())
/* 13194*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::int_wasm_relaxed_trunc_signed_zero_I32x4), 0,
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[v4i32] } 11855:{ *:[iPTR] }, V128:{ *:[v2f64] }:$vec) - Complexity = 8
             // Dst: (int_wasm_relaxed_trunc_signed_zero_I32x4:{ *:[v4i32] } V128:{ *:[v2f64] }:$vec)
/* 13201*/  /*Scope*/ 14, /*->13216*/
/* 13202*/   OPC_CheckChild0Integer, 34|128,57|128,1/*23714*/, 
/* 13206*/   OPC_RecordChild1, // #0 = $vec
/* 13207*/   OPC_CheckPatternPredicate, 9, // (Subtarget->hasRelaxedSIMD())
/* 13209*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::int_wasm_relaxed_trunc_unsigned_zero_I32x4), 0,
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[v4i32] } 11857:{ *:[iPTR] }, V128:{ *:[v2f64] }:$vec) - Complexity = 8
             // Dst: (int_wasm_relaxed_trunc_unsigned_zero_I32x4:{ *:[v4i32] } V128:{ *:[v2f64] }:$vec)
/* 13216*/  /*Scope*/ 91, /*->13308*/
/* 13217*/   OPC_CheckChild0Integer, 14|128,57|128,1/*23694*/, 
/* 13221*/   OPC_RecordChild1, // #0 = $a
/* 13222*/   OPC_SwitchType /*4 cases */, 19, MVT::v16i8,// ->13244
/* 13225*/    OPC_CheckChild1Type, MVT::v16i8,
/* 13227*/    OPC_RecordChild2, // #1 = $b
/* 13228*/    OPC_CheckChild2Type, MVT::v16i8,
/* 13230*/    OPC_RecordChild3, // #2 = $c
/* 13231*/    OPC_CheckChild3Type, MVT::v16i8,
/* 13233*/    OPC_CheckPatternPredicate, 9, // (Subtarget->hasRelaxedSIMD())
/* 13235*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LANESELECT_I8x16), 0,
                  MVT::v16i8, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v16i8] } 11847:{ *:[iPTR] }, V128:{ *:[v16i8] }:$a, V128:{ *:[v16i8] }:$b, V128:{ *:[v16i8] }:$c) - Complexity = 8
              // Dst: (LANESELECT_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$a, V128:{ *:[v16i8] }:$b, V128:{ *:[v16i8] }:$c)
/* 13244*/   /*SwitchType*/ 19, MVT::v8i16,// ->13265
/* 13246*/    OPC_CheckChild1Type, MVT::v8i16,
/* 13248*/    OPC_RecordChild2, // #1 = $b
/* 13249*/    OPC_CheckChild2Type, MVT::v8i16,
/* 13251*/    OPC_RecordChild3, // #2 = $c
/* 13252*/    OPC_CheckChild3Type, MVT::v8i16,
/* 13254*/    OPC_CheckPatternPredicate, 9, // (Subtarget->hasRelaxedSIMD())
/* 13256*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LANESELECT_I16x8), 0,
                  MVT::v8i16, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 11847:{ *:[iPTR] }, V128:{ *:[v8i16] }:$a, V128:{ *:[v8i16] }:$b, V128:{ *:[v8i16] }:$c) - Complexity = 8
              // Dst: (LANESELECT_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$a, V128:{ *:[v8i16] }:$b, V128:{ *:[v8i16] }:$c)
/* 13265*/   /*SwitchType*/ 19, MVT::v4i32,// ->13286
/* 13267*/    OPC_CheckChild1Type, MVT::v4i32,
/* 13269*/    OPC_RecordChild2, // #1 = $b
/* 13270*/    OPC_CheckChild2Type, MVT::v4i32,
/* 13272*/    OPC_RecordChild3, // #2 = $c
/* 13273*/    OPC_CheckChild3Type, MVT::v4i32,
/* 13275*/    OPC_CheckPatternPredicate, 9, // (Subtarget->hasRelaxedSIMD())
/* 13277*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LANESELECT_I32x4), 0,
                  MVT::v4i32, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v4i32] } 11847:{ *:[iPTR] }, V128:{ *:[v4i32] }:$a, V128:{ *:[v4i32] }:$b, V128:{ *:[v4i32] }:$c) - Complexity = 8
              // Dst: (LANESELECT_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$a, V128:{ *:[v4i32] }:$b, V128:{ *:[v4i32] }:$c)
/* 13286*/   /*SwitchType*/ 19, MVT::v2i64,// ->13307
/* 13288*/    OPC_CheckChild1Type, MVT::v2i64,
/* 13290*/    OPC_RecordChild2, // #1 = $b
/* 13291*/    OPC_CheckChild2Type, MVT::v2i64,
/* 13293*/    OPC_RecordChild3, // #2 = $c
/* 13294*/    OPC_CheckChild3Type, MVT::v2i64,
/* 13296*/    OPC_CheckPatternPredicate, 9, // (Subtarget->hasRelaxedSIMD())
/* 13298*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LANESELECT_I64x2), 0,
                  MVT::v2i64, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v2i64] } 11847:{ *:[iPTR] }, V128:{ *:[v2i64] }:$a, V128:{ *:[v2i64] }:$b, V128:{ *:[v2i64] }:$c) - Complexity = 8
              // Dst: (LANESELECT_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$a, V128:{ *:[v2i64] }:$b, V128:{ *:[v2i64] }:$c)
/* 13307*/   0, // EndSwitchType
/* 13308*/  /*Scope*/ 16, /*->13325*/
/* 13309*/   OPC_CheckChild0Integer, 24|128,57|128,1/*23704*/, 
/* 13313*/   OPC_RecordChild1, // #0 = $lhs
/* 13314*/   OPC_RecordChild2, // #1 = $rhs
/* 13315*/   OPC_CheckPatternPredicate, 9, // (Subtarget->hasRelaxedSIMD())
/* 13317*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::RELAXED_Q15MULR_S_I16x8), 0,
                 MVT::v8i16, 2/*#Ops*/, 0, 1, 
             // Src: (intrinsic_wo_chain:{ *:[v8i16] } 11852:{ *:[iPTR] }, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 8
             // Dst: (RELAXED_Q15MULR_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 13325*/  /*Scope*/ 16, /*->13342*/
/* 13326*/   OPC_CheckChild0Integer, 12|128,57|128,1/*23692*/, 
/* 13330*/   OPC_RecordChild1, // #0 = $lhs
/* 13331*/   OPC_RecordChild2, // #1 = $rhs
/* 13332*/   OPC_CheckPatternPredicate, 9, // (Subtarget->hasRelaxedSIMD())
/* 13334*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::RELAXED_DOT), 0,
                 MVT::v8i16, 2/*#Ops*/, 0, 1, 
             // Src: (intrinsic_wo_chain:{ *:[v8i16] } 11846:{ *:[iPTR] }, V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 8
             // Dst: (RELAXED_DOT:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 13342*/  /*Scope*/ 18, /*->13361*/
/* 13343*/   OPC_CheckChild0Integer, 10|128,57|128,1/*23690*/, 
/* 13347*/   OPC_RecordChild1, // #0 = $lhs
/* 13348*/   OPC_RecordChild2, // #1 = $rhs
/* 13349*/   OPC_RecordChild3, // #2 = $acc
/* 13350*/   OPC_CheckPatternPredicate, 9, // (Subtarget->hasRelaxedSIMD())
/* 13352*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::RELAXED_DOT_ADD), 0,
                 MVT::v4i32, 3/*#Ops*/, 0, 1, 2, 
             // Src: (intrinsic_wo_chain:{ *:[v4i32] } 11845:{ *:[iPTR] }, V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, V128:{ *:[v4i32] }:$acc) - Complexity = 8
             // Dst: (RELAXED_DOT_ADD:{ *:[v4i32] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, V128:{ *:[v4i32] }:$acc)
/* 13361*/  /*Scope*/ 37, /*->13399*/
/* 13362*/   OPC_CheckChild0Integer, 124|128,56|128,1/*23676*/, 
/* 13366*/   OPC_RecordChild1, // #0 = $lhs
/* 13367*/   OPC_SwitchType /*2 cases */, 13, MVT::v4f32,// ->13383
/* 13370*/    OPC_CheckChild1Type, MVT::v4f32,
/* 13372*/    OPC_RecordChild2, // #1 = $rhs
/* 13373*/    OPC_CheckChild2Type, MVT::v4f32,
/* 13375*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::PMIN_F32x4), 0,
                  MVT::v4f32, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v4f32] } 11838:{ *:[iPTR] }, V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 8
              // Dst: (PMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 13383*/   /*SwitchType*/ 13, MVT::v2f64,// ->13398
/* 13385*/    OPC_CheckChild1Type, MVT::v2f64,
/* 13387*/    OPC_RecordChild2, // #1 = $rhs
/* 13388*/    OPC_CheckChild2Type, MVT::v2f64,
/* 13390*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::PMIN_F64x2), 0,
                  MVT::v2f64, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v2f64] } 11838:{ *:[iPTR] }, V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 8
              // Dst: (PMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 13398*/   0, // EndSwitchType
/* 13399*/  /*Scope*/ 37, /*->13437*/
/* 13400*/   OPC_CheckChild0Integer, 122|128,56|128,1/*23674*/, 
/* 13404*/   OPC_RecordChild1, // #0 = $lhs
/* 13405*/   OPC_SwitchType /*2 cases */, 13, MVT::v4f32,// ->13421
/* 13408*/    OPC_CheckChild1Type, MVT::v4f32,
/* 13410*/    OPC_RecordChild2, // #1 = $rhs
/* 13411*/    OPC_CheckChild2Type, MVT::v4f32,
/* 13413*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::PMAX_F32x4), 0,
                  MVT::v4f32, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v4f32] } 11837:{ *:[iPTR] }, V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 8
              // Dst: (PMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 13421*/   /*SwitchType*/ 13, MVT::v2f64,// ->13436
/* 13423*/    OPC_CheckChild1Type, MVT::v2f64,
/* 13425*/    OPC_RecordChild2, // #1 = $rhs
/* 13426*/    OPC_CheckChild2Type, MVT::v2f64,
/* 13428*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::PMAX_F64x2), 0,
                  MVT::v2f64, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v2f64] } 11837:{ *:[iPTR] }, V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 8
              // Dst: (PMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 13436*/   0, // EndSwitchType
/* 13437*/  /*Scope*/ 49, /*->13487*/
/* 13438*/   OPC_CheckChild0Integer, 16|128,57|128,1/*23696*/, 
/* 13442*/   OPC_RecordChild1, // #0 = $a
/* 13443*/   OPC_SwitchType /*2 cases */, 19, MVT::v4f32,// ->13465
/* 13446*/    OPC_CheckChild1Type, MVT::v4f32,
/* 13448*/    OPC_RecordChild2, // #1 = $b
/* 13449*/    OPC_CheckChild2Type, MVT::v4f32,
/* 13451*/    OPC_RecordChild3, // #2 = $c
/* 13452*/    OPC_CheckChild3Type, MVT::v4f32,
/* 13454*/    OPC_CheckPatternPredicate, 9, // (Subtarget->hasRelaxedSIMD())
/* 13456*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MADD_F32x4), 0,
                  MVT::v4f32, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v4f32] } 11848:{ *:[iPTR] }, V128:{ *:[v4f32] }:$a, V128:{ *:[v4f32] }:$b, V128:{ *:[v4f32] }:$c) - Complexity = 8
              // Dst: (MADD_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$a, V128:{ *:[v4f32] }:$b, V128:{ *:[v4f32] }:$c)
/* 13465*/   /*SwitchType*/ 19, MVT::v2f64,// ->13486
/* 13467*/    OPC_CheckChild1Type, MVT::v2f64,
/* 13469*/    OPC_RecordChild2, // #1 = $b
/* 13470*/    OPC_CheckChild2Type, MVT::v2f64,
/* 13472*/    OPC_RecordChild3, // #2 = $c
/* 13473*/    OPC_CheckChild3Type, MVT::v2f64,
/* 13475*/    OPC_CheckPatternPredicate, 9, // (Subtarget->hasRelaxedSIMD())
/* 13477*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MADD_F64x2), 0,
                  MVT::v2f64, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v2f64] } 11848:{ *:[iPTR] }, V128:{ *:[v2f64] }:$a, V128:{ *:[v2f64] }:$b, V128:{ *:[v2f64] }:$c) - Complexity = 8
              // Dst: (MADD_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$a, V128:{ *:[v2f64] }:$b, V128:{ *:[v2f64] }:$c)
/* 13486*/   0, // EndSwitchType
/* 13487*/  /*Scope*/ 49, /*->13537*/
/* 13488*/   OPC_CheckChild0Integer, 22|128,57|128,1/*23702*/, 
/* 13492*/   OPC_RecordChild1, // #0 = $a
/* 13493*/   OPC_SwitchType /*2 cases */, 19, MVT::v4f32,// ->13515
/* 13496*/    OPC_CheckChild1Type, MVT::v4f32,
/* 13498*/    OPC_RecordChild2, // #1 = $b
/* 13499*/    OPC_CheckChild2Type, MVT::v4f32,
/* 13501*/    OPC_RecordChild3, // #2 = $c
/* 13502*/    OPC_CheckChild3Type, MVT::v4f32,
/* 13504*/    OPC_CheckPatternPredicate, 9, // (Subtarget->hasRelaxedSIMD())
/* 13506*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NMADD_F32x4), 0,
                  MVT::v4f32, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v4f32] } 11851:{ *:[iPTR] }, V128:{ *:[v4f32] }:$a, V128:{ *:[v4f32] }:$b, V128:{ *:[v4f32] }:$c) - Complexity = 8
              // Dst: (NMADD_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$a, V128:{ *:[v4f32] }:$b, V128:{ *:[v4f32] }:$c)
/* 13515*/   /*SwitchType*/ 19, MVT::v2f64,// ->13536
/* 13517*/    OPC_CheckChild1Type, MVT::v2f64,
/* 13519*/    OPC_RecordChild2, // #1 = $b
/* 13520*/    OPC_CheckChild2Type, MVT::v2f64,
/* 13522*/    OPC_RecordChild3, // #2 = $c
/* 13523*/    OPC_CheckChild3Type, MVT::v2f64,
/* 13525*/    OPC_CheckPatternPredicate, 9, // (Subtarget->hasRelaxedSIMD())
/* 13527*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NMADD_F64x2), 0,
                  MVT::v2f64, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v2f64] } 11851:{ *:[iPTR] }, V128:{ *:[v2f64] }:$a, V128:{ *:[v2f64] }:$b, V128:{ *:[v2f64] }:$c) - Complexity = 8
              // Dst: (NMADD_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$a, V128:{ *:[v2f64] }:$b, V128:{ *:[v2f64] }:$c)
/* 13536*/   0, // EndSwitchType
/* 13537*/  /*Scope*/ 41, /*->13579*/
/* 13538*/   OPC_CheckChild0Integer, 20|128,57|128,1/*23700*/, 
/* 13542*/   OPC_RecordChild1, // #0 = $lhs
/* 13543*/   OPC_SwitchType /*2 cases */, 15, MVT::v4f32,// ->13561
/* 13546*/    OPC_CheckChild1Type, MVT::v4f32,
/* 13548*/    OPC_RecordChild2, // #1 = $rhs
/* 13549*/    OPC_CheckChild2Type, MVT::v4f32,
/* 13551*/    OPC_CheckPatternPredicate, 9, // (Subtarget->hasRelaxedSIMD())
/* 13553*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SIMD_RELAXED_FMIN_F32x4), 0,
                  MVT::v4f32, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v4f32] } 11850:{ *:[iPTR] }, V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 8
              // Dst: (SIMD_RELAXED_FMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 13561*/   /*SwitchType*/ 15, MVT::v2f64,// ->13578
/* 13563*/    OPC_CheckChild1Type, MVT::v2f64,
/* 13565*/    OPC_RecordChild2, // #1 = $rhs
/* 13566*/    OPC_CheckChild2Type, MVT::v2f64,
/* 13568*/    OPC_CheckPatternPredicate, 9, // (Subtarget->hasRelaxedSIMD())
/* 13570*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SIMD_RELAXED_FMIN_F64x2), 0,
                  MVT::v2f64, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v2f64] } 11850:{ *:[iPTR] }, V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 8
              // Dst: (SIMD_RELAXED_FMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 13578*/   0, // EndSwitchType
/* 13579*/  /*Scope*/ 41, /*->13621*/
/* 13580*/   OPC_CheckChild0Integer, 18|128,57|128,1/*23698*/, 
/* 13584*/   OPC_RecordChild1, // #0 = $lhs
/* 13585*/   OPC_SwitchType /*2 cases */, 15, MVT::v4f32,// ->13603
/* 13588*/    OPC_CheckChild1Type, MVT::v4f32,
/* 13590*/    OPC_RecordChild2, // #1 = $rhs
/* 13591*/    OPC_CheckChild2Type, MVT::v4f32,
/* 13593*/    OPC_CheckPatternPredicate, 9, // (Subtarget->hasRelaxedSIMD())
/* 13595*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SIMD_RELAXED_FMAX_F32x4), 0,
                  MVT::v4f32, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v4f32] } 11849:{ *:[iPTR] }, V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 8
              // Dst: (SIMD_RELAXED_FMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 13603*/   /*SwitchType*/ 15, MVT::v2f64,// ->13620
/* 13605*/    OPC_CheckChild1Type, MVT::v2f64,
/* 13607*/    OPC_RecordChild2, // #1 = $rhs
/* 13608*/    OPC_CheckChild2Type, MVT::v2f64,
/* 13610*/    OPC_CheckPatternPredicate, 9, // (Subtarget->hasRelaxedSIMD())
/* 13612*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SIMD_RELAXED_FMAX_F64x2), 0,
                  MVT::v2f64, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v2f64] } 11849:{ *:[iPTR] }, V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 8
              // Dst: (SIMD_RELAXED_FMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 13620*/   0, // EndSwitchType
/* 13621*/  /*Scope*/ 18, /*->13640*/
/* 13622*/   OPC_CheckChild0Integer, 8|128,57|128,1/*23688*/, 
/* 13626*/   OPC_RecordChild1, // #0 = $lhs
/* 13627*/   OPC_RecordChild2, // #1 = $rhs
/* 13628*/   OPC_RecordChild3, // #2 = $acc
/* 13629*/   OPC_CheckPatternPredicate, 9, // (Subtarget->hasRelaxedSIMD())
/* 13631*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::RELAXED_DOT_BFLOAT), 0,
                 MVT::v4f32, 3/*#Ops*/, 0, 1, 2, 
             // Src: (intrinsic_wo_chain:{ *:[v4f32] } 11844:{ *:[iPTR] }, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, V128:{ *:[v4f32] }:$acc) - Complexity = 8
             // Dst: (RELAXED_DOT_BFLOAT:{ *:[v4f32] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, V128:{ *:[v4f32] }:$acc)
/* 13640*/  0, /*End of Scope*/
/* 13641*/ /*SwitchOpcode*/ 25|128,1/*153*/, TARGET_VAL(ISD::EXTRACT_VECTOR_ELT),// ->13798
/* 13645*/  OPC_RecordChild0, // #0 = $vec
/* 13646*/  OPC_Scope, 24, /*->13672*/ // 6 children in Scope
/* 13648*/   OPC_CheckChild0Type, MVT::v16i8,
/* 13650*/   OPC_RecordChild1, // #1 = $idx
/* 13651*/   OPC_MoveChild1,
/* 13652*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 13655*/   OPC_CheckPredicate, 3, // Predicate_LaneIdx16
/* 13657*/   OPC_CheckType, MVT::i32,
/* 13659*/   OPC_MoveParent,
/* 13660*/   OPC_CheckType, MVT::i32,
/* 13662*/   OPC_EmitConvertToTarget, 1,
/* 13664*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTRACT_LANE_I8x16_u), 0,
                 MVT::i32, 2/*#Ops*/, 0, 2, 
             // Src: (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx) - Complexity = 7
             // Dst: (EXTRACT_LANE_I8x16_u:{ *:[i32] } ?:{ *:[v16i8] }:$vec, (imm:{ *:[i32] }):$idx)
/* 13672*/  /*Scope*/ 24, /*->13697*/
/* 13673*/   OPC_CheckChild0Type, MVT::v8i16,
/* 13675*/   OPC_RecordChild1, // #1 = $idx
/* 13676*/   OPC_MoveChild1,
/* 13677*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 13680*/   OPC_CheckPredicate, 7, // Predicate_LaneIdx8
/* 13682*/   OPC_CheckType, MVT::i32,
/* 13684*/   OPC_MoveParent,
/* 13685*/   OPC_CheckType, MVT::i32,
/* 13687*/   OPC_EmitConvertToTarget, 1,
/* 13689*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTRACT_LANE_I16x8_u), 0,
                 MVT::i32, 2/*#Ops*/, 0, 2, 
             // Src: (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx) - Complexity = 7
             // Dst: (EXTRACT_LANE_I16x8_u:{ *:[i32] } ?:{ *:[v8i16] }:$vec, (imm:{ *:[i32] }):$idx)
/* 13697*/  /*Scope*/ 24, /*->13722*/
/* 13698*/   OPC_CheckChild0Type, MVT::v4i32,
/* 13700*/   OPC_RecordChild1, // #1 = $idx
/* 13701*/   OPC_MoveChild1,
/* 13702*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 13705*/   OPC_CheckPredicate, 9, // Predicate_LaneIdx4
/* 13707*/   OPC_CheckType, MVT::i32,
/* 13709*/   OPC_MoveParent,
/* 13710*/   OPC_CheckType, MVT::i32,
/* 13712*/   OPC_EmitConvertToTarget, 1,
/* 13714*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTRACT_LANE_I32x4), 0,
                 MVT::i32, 2/*#Ops*/, 0, 2, 
             // Src: (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 7
             // Dst: (EXTRACT_LANE_I32x4:{ *:[i32] } ?:{ *:[v4i32] }:$vec, (imm:{ *:[i32] }):$idx)
/* 13722*/  /*Scope*/ 24, /*->13747*/
/* 13723*/   OPC_CheckChild0Type, MVT::v2i64,
/* 13725*/   OPC_RecordChild1, // #1 = $idx
/* 13726*/   OPC_MoveChild1,
/* 13727*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 13730*/   OPC_CheckPredicate, 11, // Predicate_LaneIdx2
/* 13732*/   OPC_CheckType, MVT::i32,
/* 13734*/   OPC_MoveParent,
/* 13735*/   OPC_CheckType, MVT::i64,
/* 13737*/   OPC_EmitConvertToTarget, 1,
/* 13739*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTRACT_LANE_I64x2), 0,
                 MVT::i64, 2/*#Ops*/, 0, 2, 
             // Src: (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 7
             // Dst: (EXTRACT_LANE_I64x2:{ *:[i64] } ?:{ *:[v2i64] }:$vec, (imm:{ *:[i32] }):$idx)
/* 13747*/  /*Scope*/ 24, /*->13772*/
/* 13748*/   OPC_CheckChild0Type, MVT::v4f32,
/* 13750*/   OPC_RecordChild1, // #1 = $idx
/* 13751*/   OPC_MoveChild1,
/* 13752*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 13755*/   OPC_CheckPredicate, 9, // Predicate_LaneIdx4
/* 13757*/   OPC_CheckType, MVT::i32,
/* 13759*/   OPC_MoveParent,
/* 13760*/   OPC_CheckType, MVT::f32,
/* 13762*/   OPC_EmitConvertToTarget, 1,
/* 13764*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTRACT_LANE_F32x4), 0,
                 MVT::f32, 2/*#Ops*/, 0, 2, 
             // Src: (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 7
             // Dst: (EXTRACT_LANE_F32x4:{ *:[f32] } ?:{ *:[v4f32] }:$vec, (imm:{ *:[i32] }):$idx)
/* 13772*/  /*Scope*/ 24, /*->13797*/
/* 13773*/   OPC_CheckChild0Type, MVT::v2f64,
/* 13775*/   OPC_RecordChild1, // #1 = $idx
/* 13776*/   OPC_MoveChild1,
/* 13777*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 13780*/   OPC_CheckPredicate, 11, // Predicate_LaneIdx2
/* 13782*/   OPC_CheckType, MVT::i32,
/* 13784*/   OPC_MoveParent,
/* 13785*/   OPC_CheckType, MVT::f64,
/* 13787*/   OPC_EmitConvertToTarget, 1,
/* 13789*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTRACT_LANE_F64x2), 0,
                 MVT::f64, 2/*#Ops*/, 0, 2, 
             // Src: (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 7
             // Dst: (EXTRACT_LANE_F64x2:{ *:[f64] } ?:{ *:[v2f64] }:$vec, (imm:{ *:[i32] }):$idx)
/* 13797*/  0, /*End of Scope*/
/* 13798*/ /*SwitchOpcode*/ 116, TARGET_VAL(WebAssemblyISD::ARGUMENT),// ->13917
/* 13801*/  OPC_RecordChild0, // #0 = $argno
/* 13802*/  OPC_MoveChild0,
/* 13803*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 13806*/  OPC_MoveParent,
/* 13807*/  OPC_SwitchType /*12 cases */, 7, MVT::i32,// ->13817
/* 13810*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ARGUMENT_i32), 0,
                 MVT::i32, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[i32] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_i32:{ *:[i32] } (timm:{ *:[i32] }):$argno)
/* 13817*/  /*SwitchType*/ 7, MVT::i64,// ->13826
/* 13819*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ARGUMENT_i64), 0,
                 MVT::i64, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[i64] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_i64:{ *:[i64] } (timm:{ *:[i32] }):$argno)
/* 13826*/  /*SwitchType*/ 7, MVT::funcref,// ->13835
/* 13828*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ARGUMENT_funcref), 0,
                 MVT::funcref, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[funcref] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_funcref:{ *:[funcref] } (timm:{ *:[i32] }):$argno)
/* 13835*/  /*SwitchType*/ 7, MVT::externref,// ->13844
/* 13837*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ARGUMENT_externref), 0,
                 MVT::externref, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[externref] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_externref:{ *:[externref] } (timm:{ *:[i32] }):$argno)
/* 13844*/  /*SwitchType*/ 7, MVT::f32,// ->13853
/* 13846*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ARGUMENT_f32), 0,
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[f32] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_f32:{ *:[f32] } (timm:{ *:[i32] }):$argno)
/* 13853*/  /*SwitchType*/ 7, MVT::f64,// ->13862
/* 13855*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ARGUMENT_f64), 0,
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[f64] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_f64:{ *:[f64] } (timm:{ *:[i32] }):$argno)
/* 13862*/  /*SwitchType*/ 7, MVT::v16i8,// ->13871
/* 13864*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ARGUMENT_v16i8), 0,
                 MVT::v16i8, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v16i8] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v16i8:{ *:[v16i8] } (timm:{ *:[i32] }):$argno)
/* 13871*/  /*SwitchType*/ 7, MVT::v8i16,// ->13880
/* 13873*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ARGUMENT_v8i16), 0,
                 MVT::v8i16, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v8i16] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v8i16:{ *:[v8i16] } (timm:{ *:[i32] }):$argno)
/* 13880*/  /*SwitchType*/ 7, MVT::v4i32,// ->13889
/* 13882*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ARGUMENT_v4i32), 0,
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v4i32] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v4i32:{ *:[v4i32] } (timm:{ *:[i32] }):$argno)
/* 13889*/  /*SwitchType*/ 7, MVT::v2i64,// ->13898
/* 13891*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ARGUMENT_v2i64), 0,
                 MVT::v2i64, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v2i64] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v2i64:{ *:[v2i64] } (timm:{ *:[i32] }):$argno)
/* 13898*/  /*SwitchType*/ 7, MVT::v4f32,// ->13907
/* 13900*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ARGUMENT_v4f32), 0,
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v4f32] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v4f32:{ *:[v4f32] } (timm:{ *:[i32] }):$argno)
/* 13907*/  /*SwitchType*/ 7, MVT::v2f64,// ->13916
/* 13909*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ARGUMENT_v2f64), 0,
                 MVT::v2f64, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v2f64] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v2f64:{ *:[v2f64] } (timm:{ *:[i32] }):$argno)
/* 13916*/  0, // EndSwitchType
/* 13917*/ /*SwitchOpcode*/ 17|128,1/*145*/, TARGET_VAL(WebAssemblyISD::LOCAL_GET),// ->14066
/* 13921*/  OPC_RecordNode, // #0 = 'WebAssemblylocal_get' chained node
/* 13922*/  OPC_RecordChild1, // #1 = $local
/* 13923*/  OPC_MoveChild1,
/* 13924*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 13927*/  OPC_MoveParent,
/* 13928*/  OPC_SwitchType /*12 cases */, 8, MVT::i32,// ->13939
/* 13931*/   OPC_EmitMergeInputChains1_0,
/* 13932*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOCAL_GET_I32), 0|OPFL_Chain,
                 MVT::i32, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[i32] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_I32:{ *:[i32] } (timm:{ *:[i32] }):$local)
/* 13939*/  /*SwitchType*/ 8, MVT::i64,// ->13949
/* 13941*/   OPC_EmitMergeInputChains1_0,
/* 13942*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOCAL_GET_I64), 0|OPFL_Chain,
                 MVT::i64, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[i64] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_I64:{ *:[i64] } (timm:{ *:[i32] }):$local)
/* 13949*/  /*SwitchType*/ 10, MVT::funcref,// ->13961
/* 13951*/   OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/* 13953*/   OPC_EmitMergeInputChains1_0,
/* 13954*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOCAL_GET_FUNCREF), 0|OPFL_Chain,
                 MVT::funcref, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[funcref] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_FUNCREF:{ *:[funcref] } (timm:{ *:[i32] }):$local)
/* 13961*/  /*SwitchType*/ 10, MVT::externref,// ->13973
/* 13963*/   OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/* 13965*/   OPC_EmitMergeInputChains1_0,
/* 13966*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOCAL_GET_EXTERNREF), 0|OPFL_Chain,
                 MVT::externref, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[externref] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_EXTERNREF:{ *:[externref] } (timm:{ *:[i32] }):$local)
/* 13973*/  /*SwitchType*/ 8, MVT::f32,// ->13983
/* 13975*/   OPC_EmitMergeInputChains1_0,
/* 13976*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOCAL_GET_F32), 0|OPFL_Chain,
                 MVT::f32, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[f32] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_F32:{ *:[f32] } (timm:{ *:[i32] }):$local)
/* 13983*/  /*SwitchType*/ 8, MVT::f64,// ->13993
/* 13985*/   OPC_EmitMergeInputChains1_0,
/* 13986*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOCAL_GET_F64), 0|OPFL_Chain,
                 MVT::f64, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[f64] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_F64:{ *:[f64] } (timm:{ *:[i32] }):$local)
/* 13993*/  /*SwitchType*/ 10, MVT::v2i64,// ->14005
/* 13995*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 13997*/   OPC_EmitMergeInputChains1_0,
/* 13998*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOCAL_GET_V128), 0|OPFL_Chain,
                 MVT::v2i64, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v2i64] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v2i64] } (timm:{ *:[i32] }):$local)
/* 14005*/  /*SwitchType*/ 10, MVT::v4i32,// ->14017
/* 14007*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 14009*/   OPC_EmitMergeInputChains1_0,
/* 14010*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOCAL_GET_V128), 0|OPFL_Chain,
                 MVT::v4i32, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v4i32] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v4i32] } (timm:{ *:[i32] }):$local)
/* 14017*/  /*SwitchType*/ 10, MVT::v16i8,// ->14029
/* 14019*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 14021*/   OPC_EmitMergeInputChains1_0,
/* 14022*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOCAL_GET_V128), 0|OPFL_Chain,
                 MVT::v16i8, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v16i8] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v16i8] } (timm:{ *:[i32] }):$local)
/* 14029*/  /*SwitchType*/ 10, MVT::v8i16,// ->14041
/* 14031*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 14033*/   OPC_EmitMergeInputChains1_0,
/* 14034*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOCAL_GET_V128), 0|OPFL_Chain,
                 MVT::v8i16, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v8i16] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v8i16] } (timm:{ *:[i32] }):$local)
/* 14041*/  /*SwitchType*/ 10, MVT::v4f32,// ->14053
/* 14043*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 14045*/   OPC_EmitMergeInputChains1_0,
/* 14046*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOCAL_GET_V128), 0|OPFL_Chain,
                 MVT::v4f32, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v4f32] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v4f32] } (timm:{ *:[i32] }):$local)
/* 14053*/  /*SwitchType*/ 10, MVT::v2f64,// ->14065
/* 14055*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 14057*/   OPC_EmitMergeInputChains1_0,
/* 14058*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOCAL_GET_V128), 0|OPFL_Chain,
                 MVT::v2f64, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v2f64] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v2f64] } (timm:{ *:[i32] }):$local)
/* 14065*/  0, // EndSwitchType
/* 14066*/ /*SwitchOpcode*/ 30|128,1/*158*/, TARGET_VAL(WebAssemblyISD::LOCAL_SET),// ->14228
/* 14070*/  OPC_RecordNode, // #0 = 'WebAssemblylocal_set' chained node
/* 14071*/  OPC_RecordChild1, // #1 = $local
/* 14072*/  OPC_MoveChild1,
/* 14073*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 14076*/  OPC_MoveParent,
/* 14077*/  OPC_RecordChild2, // #2 = $src
/* 14078*/  OPC_Scope, 10, /*->14090*/ // 12 children in Scope
/* 14080*/   OPC_CheckChild2Type, MVT::i32,
/* 14082*/   OPC_EmitMergeInputChains1_0,
/* 14083*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::LOCAL_SET_I32), 0|OPFL_Chain,
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, i32:{ *:[i32] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_I32 (timm:{ *:[i32] }):$local, i32:{ *:[i32] }:$src)
/* 14090*/  /*Scope*/ 10, /*->14101*/
/* 14091*/   OPC_CheckChild2Type, MVT::i64,
/* 14093*/   OPC_EmitMergeInputChains1_0,
/* 14094*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::LOCAL_SET_I64), 0|OPFL_Chain,
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, i64:{ *:[i64] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_I64 (timm:{ *:[i32] }):$local, i64:{ *:[i64] }:$src)
/* 14101*/  /*Scope*/ 10, /*->14112*/
/* 14102*/   OPC_CheckChild2Type, MVT::f32,
/* 14104*/   OPC_EmitMergeInputChains1_0,
/* 14105*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::LOCAL_SET_F32), 0|OPFL_Chain,
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, f32:{ *:[f32] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_F32 (timm:{ *:[i32] }):$local, f32:{ *:[f32] }:$src)
/* 14112*/  /*Scope*/ 10, /*->14123*/
/* 14113*/   OPC_CheckChild2Type, MVT::f64,
/* 14115*/   OPC_EmitMergeInputChains1_0,
/* 14116*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::LOCAL_SET_F64), 0|OPFL_Chain,
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, f64:{ *:[f64] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_F64 (timm:{ *:[i32] }):$local, f64:{ *:[f64] }:$src)
/* 14123*/  /*Scope*/ 12, /*->14136*/
/* 14124*/   OPC_CheckChild2Type, MVT::v4f32,
/* 14126*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 14128*/   OPC_EmitMergeInputChains1_0,
/* 14129*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::LOCAL_SET_V128), 0|OPFL_Chain,
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v4f32:{ *:[v4f32] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v4f32:{ *:[v4f32] }:$src)
/* 14136*/  /*Scope*/ 12, /*->14149*/
/* 14137*/   OPC_CheckChild2Type, MVT::v2f64,
/* 14139*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 14141*/   OPC_EmitMergeInputChains1_0,
/* 14142*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::LOCAL_SET_V128), 0|OPFL_Chain,
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v2f64:{ *:[v2f64] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v2f64:{ *:[v2f64] }:$src)
/* 14149*/  /*Scope*/ 12, /*->14162*/
/* 14150*/   OPC_CheckChild2Type, MVT::v2i64,
/* 14152*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 14154*/   OPC_EmitMergeInputChains1_0,
/* 14155*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::LOCAL_SET_V128), 0|OPFL_Chain,
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v2i64:{ *:[v2i64] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v2i64:{ *:[v2i64] }:$src)
/* 14162*/  /*Scope*/ 12, /*->14175*/
/* 14163*/   OPC_CheckChild2Type, MVT::v4i32,
/* 14165*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 14167*/   OPC_EmitMergeInputChains1_0,
/* 14168*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::LOCAL_SET_V128), 0|OPFL_Chain,
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v4i32:{ *:[v4i32] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v4i32:{ *:[v4i32] }:$src)
/* 14175*/  /*Scope*/ 12, /*->14188*/
/* 14176*/   OPC_CheckChild2Type, MVT::v16i8,
/* 14178*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 14180*/   OPC_EmitMergeInputChains1_0,
/* 14181*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::LOCAL_SET_V128), 0|OPFL_Chain,
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v16i8:{ *:[v16i8] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v16i8:{ *:[v16i8] }:$src)
/* 14188*/  /*Scope*/ 12, /*->14201*/
/* 14189*/   OPC_CheckChild2Type, MVT::v8i16,
/* 14191*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 14193*/   OPC_EmitMergeInputChains1_0,
/* 14194*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::LOCAL_SET_V128), 0|OPFL_Chain,
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v8i16:{ *:[v8i16] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v8i16:{ *:[v8i16] }:$src)
/* 14201*/  /*Scope*/ 12, /*->14214*/
/* 14202*/   OPC_CheckChild2Type, MVT::funcref,
/* 14204*/   OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/* 14206*/   OPC_EmitMergeInputChains1_0,
/* 14207*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::LOCAL_SET_FUNCREF), 0|OPFL_Chain,
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, funcref:{ *:[funcref] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_FUNCREF (timm:{ *:[i32] }):$local, funcref:{ *:[funcref] }:$src)
/* 14214*/  /*Scope*/ 12, /*->14227*/
/* 14215*/   OPC_CheckChild2Type, MVT::externref,
/* 14217*/   OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/* 14219*/   OPC_EmitMergeInputChains1_0,
/* 14220*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::LOCAL_SET_EXTERNREF), 0|OPFL_Chain,
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, externref:{ *:[externref] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_EXTERNREF (timm:{ *:[i32] }):$local, externref:{ *:[externref] }:$src)
/* 14227*/  0, /*End of Scope*/
/* 14228*/ /*SwitchOpcode*/ 12|128,1/*140*/, TARGET_VAL(WebAssemblyISD::Wrapper),// ->14372
/* 14232*/  OPC_RecordChild0, // #0 = $addr
/* 14233*/  OPC_MoveChild0,
/* 14234*/  OPC_SwitchOpcode /*3 cases */, 51, TARGET_VAL(ISD::TargetGlobalAddress),// ->14289
/* 14238*/   OPC_MoveParent,
/* 14239*/   OPC_SwitchType /*2 cases */, 22, MVT::i32,// ->14264
/* 14242*/    OPC_Scope, 9, /*->14253*/ // 2 children in Scope
/* 14244*/     OPC_CheckPatternPredicate, 10, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 14246*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr) - Complexity = 6
               // Dst: (CONST_I32:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 14253*/    /*Scope*/ 9, /*->14263*/
/* 14254*/     OPC_CheckPatternPredicate, 11, // (!Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 14256*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_I32), 0,
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr) - Complexity = 6
               // Dst: (GLOBAL_GET_I32:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 14263*/    0, /*End of Scope*/
/* 14264*/   /*SwitchType*/ 22, MVT::i64,// ->14288
/* 14266*/    OPC_Scope, 9, /*->14277*/ // 2 children in Scope
/* 14268*/     OPC_CheckPatternPredicate, 12, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 14270*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr) - Complexity = 6
               // Dst: (CONST_I64:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr)
/* 14277*/    /*Scope*/ 9, /*->14287*/
/* 14278*/     OPC_CheckPatternPredicate, 13, // (Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 14280*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_I64), 0,
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr) - Complexity = 6
               // Dst: (GLOBAL_GET_I64:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr)
/* 14287*/    0, /*End of Scope*/
/* 14288*/   0, // EndSwitchType
/* 14289*/  /*SwitchOpcode*/ 25, TARGET_VAL(ISD::TargetGlobalTLSAddress),// ->14317
/* 14292*/   OPC_MoveParent,
/* 14293*/   OPC_SwitchType /*2 cases */, 9, MVT::i32,// ->14305
/* 14296*/    OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/* 14298*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_I32), 0,
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapper:{ *:[i32] } (tglobaltlsaddr:{ *:[i32] }):$addr) - Complexity = 6
              // Dst: (GLOBAL_GET_I32:{ *:[i32] } (tglobaltlsaddr:{ *:[i32] }):$addr)
/* 14305*/   /*SwitchType*/ 9, MVT::i64,// ->14316
/* 14307*/    OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/* 14309*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_I64), 0,
                  MVT::i64, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapper:{ *:[i64] } (tglobaltlsaddr:{ *:[i64] }):$addr) - Complexity = 6
              // Dst: (GLOBAL_GET_I64:{ *:[i64] } (tglobaltlsaddr:{ *:[i64] }):$addr)
/* 14316*/   0, // EndSwitchType
/* 14317*/  /*SwitchOpcode*/ 51, TARGET_VAL(ISD::TargetExternalSymbol),// ->14371
/* 14320*/   OPC_MoveParent,
/* 14321*/   OPC_SwitchType /*2 cases */, 22, MVT::i32,// ->14346
/* 14324*/    OPC_Scope, 9, /*->14335*/ // 2 children in Scope
/* 14326*/     OPC_CheckPatternPredicate, 11, // (!Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 14328*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_I32), 0,
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$addr) - Complexity = 6
               // Dst: (GLOBAL_GET_I32:{ *:[i32] } (texternalsym:{ *:[i32] }):$addr)
/* 14335*/    /*Scope*/ 9, /*->14345*/
/* 14336*/     OPC_CheckPatternPredicate, 10, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 14338*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$addr) - Complexity = 6
               // Dst: (CONST_I32:{ *:[i32] } (texternalsym:{ *:[i32] }):$addr)
/* 14345*/    0, /*End of Scope*/
/* 14346*/   /*SwitchType*/ 22, MVT::i64,// ->14370
/* 14348*/    OPC_Scope, 9, /*->14359*/ // 2 children in Scope
/* 14350*/     OPC_CheckPatternPredicate, 13, // (Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 14352*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_I64), 0,
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i64] } (texternalsym:{ *:[i64] }):$addr) - Complexity = 6
               // Dst: (GLOBAL_GET_I64:{ *:[i64] } (texternalsym:{ *:[i64] }):$addr)
/* 14359*/    /*Scope*/ 9, /*->14369*/
/* 14360*/     OPC_CheckPatternPredicate, 12, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 14362*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i64] } (texternalsym:{ *:[i64] }):$addr) - Complexity = 6
               // Dst: (CONST_I64:{ *:[i64] } (texternalsym:{ *:[i64] }):$addr)
/* 14369*/    0, /*End of Scope*/
/* 14370*/   0, // EndSwitchType
/* 14371*/  0, // EndSwitchOpcode
/* 14372*/ /*SwitchOpcode*/ 88, TARGET_VAL(WebAssemblyISD::WrapperREL),// ->14463
/* 14375*/  OPC_RecordChild0, // #0 = $addr
/* 14376*/  OPC_MoveChild0,
/* 14377*/  OPC_SwitchOpcode /*3 cases */, 25, TARGET_VAL(ISD::TargetGlobalAddress),// ->14406
/* 14381*/   OPC_MoveParent,
/* 14382*/   OPC_SwitchType /*2 cases */, 9, MVT::i32,// ->14394
/* 14385*/    OPC_CheckPatternPredicate, 11, // (!Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 14387*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapperREL:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr) - Complexity = 6
              // Dst: (CONST_I32:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 14394*/   /*SwitchType*/ 9, MVT::i64,// ->14405
/* 14396*/    OPC_CheckPatternPredicate, 13, // (Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 14398*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                  MVT::i64, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapperREL:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr) - Complexity = 6
              // Dst: (CONST_I64:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr)
/* 14405*/   0, // EndSwitchType
/* 14406*/  /*SwitchOpcode*/ 25, TARGET_VAL(ISD::TargetGlobalTLSAddress),// ->14434
/* 14409*/   OPC_MoveParent,
/* 14410*/   OPC_SwitchType /*2 cases */, 9, MVT::i32,// ->14422
/* 14413*/    OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/* 14415*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapperREL:{ *:[i32] } (tglobaltlsaddr:{ *:[i32] }):$addr) - Complexity = 6
              // Dst: (CONST_I32:{ *:[i32] } (tglobaltlsaddr:{ *:[i32] }):$addr)
/* 14422*/   /*SwitchType*/ 9, MVT::i64,// ->14433
/* 14424*/    OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/* 14426*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                  MVT::i64, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapperREL:{ *:[i64] } (tglobaltlsaddr:{ *:[i64] }):$addr) - Complexity = 6
              // Dst: (CONST_I64:{ *:[i64] } (tglobaltlsaddr:{ *:[i64] }):$addr)
/* 14433*/   0, // EndSwitchType
/* 14434*/  /*SwitchOpcode*/ 25, TARGET_VAL(ISD::TargetExternalSymbol),// ->14462
/* 14437*/   OPC_MoveParent,
/* 14438*/   OPC_SwitchType /*2 cases */, 9, MVT::i32,// ->14450
/* 14441*/    OPC_CheckPatternPredicate, 11, // (!Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 14443*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapperREL:{ *:[i32] } (texternalsym:{ *:[i32] }):$addr) - Complexity = 6
              // Dst: (CONST_I32:{ *:[i32] } (texternalsym:{ *:[i32] }):$addr)
/* 14450*/   /*SwitchType*/ 9, MVT::i64,// ->14461
/* 14452*/    OPC_CheckPatternPredicate, 13, // (Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 14454*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                  MVT::i64, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapperREL:{ *:[i64] } (texternalsym:{ *:[i64] }):$addr) - Complexity = 6
              // Dst: (CONST_I64:{ *:[i64] } (texternalsym:{ *:[i64] }):$addr)
/* 14461*/   0, // EndSwitchType
/* 14462*/  0, // EndSwitchOpcode
/* 14463*/ /*SwitchOpcode*/ 58, TARGET_VAL(WebAssemblyISD::MEMORY_FILL),// ->14524
/* 14466*/  OPC_RecordNode, // #0 = 'wasm_memset' chained node
/* 14467*/  OPC_RecordChild1, // #1 = $idx
/* 14468*/  OPC_MoveChild1,
/* 14469*/  OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 14472*/  OPC_CheckType, MVT::i32,
/* 14474*/  OPC_MoveParent,
/* 14475*/  OPC_RecordChild2, // #2 = $dst
/* 14476*/  OPC_Scope, 22, /*->14500*/ // 2 children in Scope
/* 14478*/   OPC_CheckChild2Type, MVT::i32,
/* 14480*/   OPC_RecordChild3, // #3 = $value
/* 14481*/   OPC_CheckChild3Type, MVT::i32,
/* 14483*/   OPC_RecordChild4, // #4 = $size
/* 14484*/   OPC_CheckChild4Type, MVT::i32,
/* 14486*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasBulkMemory())
/* 14488*/   OPC_EmitMergeInputChains1_0,
/* 14489*/   OPC_EmitConvertToTarget, 1,
/* 14491*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::anonymous_7819MEMORY_FILL_A32), 0|OPFL_Chain,
                 4/*#Ops*/, 5, 2, 3, 4, 
             // Src: (wasm_memset (imm:{ *:[i32] }):$idx, I32:{ *:[i32] }:$dst, I32:{ *:[i32] }:$value, I32:{ *:[i32] }:$size) - Complexity = 6
             // Dst: (anonymous_7819MEMORY_FILL_A32 (imm:{ *:[i32] }):$idx, I32:{ *:[i32] }:$dst, I32:{ *:[i32] }:$value, I32:{ *:[i32] }:$size)
/* 14500*/  /*Scope*/ 22, /*->14523*/
/* 14501*/   OPC_CheckChild2Type, MVT::i64,
/* 14503*/   OPC_RecordChild3, // #3 = $value
/* 14504*/   OPC_CheckChild3Type, MVT::i32,
/* 14506*/   OPC_RecordChild4, // #4 = $size
/* 14507*/   OPC_CheckChild4Type, MVT::i64,
/* 14509*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasBulkMemory())
/* 14511*/   OPC_EmitMergeInputChains1_0,
/* 14512*/   OPC_EmitConvertToTarget, 1,
/* 14514*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::anonymous_7820MEMORY_FILL_A64), 0|OPFL_Chain,
                 4/*#Ops*/, 5, 2, 3, 4, 
             // Src: (wasm_memset (imm:{ *:[i32] }):$idx, I64:{ *:[i64] }:$dst, I32:{ *:[i32] }:$value, I64:{ *:[i64] }:$size) - Complexity = 6
             // Dst: (anonymous_7820MEMORY_FILL_A64 (imm:{ *:[i32] }):$idx, I64:{ *:[i64] }:$dst, I32:{ *:[i32] }:$value, I64:{ *:[i64] }:$size)
/* 14523*/  0, /*End of Scope*/
/* 14524*/ /*SwitchOpcode*/ 25, TARGET_VAL(ISD::Constant),// ->14552
/* 14527*/  OPC_RecordNode, // #0 = $imm
/* 14528*/  OPC_SwitchType /*2 cases */, 9, MVT::i32,// ->14540
/* 14531*/   OPC_EmitConvertToTarget, 0,
/* 14533*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                 MVT::i32, 1/*#Ops*/, 1, 
             // Src: (imm:{ *:[i32] }):$imm - Complexity = 3
             // Dst: (CONST_I32:{ *:[i32] } (imm:{ *:[i32] }):$imm)
/* 14540*/  /*SwitchType*/ 9, MVT::i64,// ->14551
/* 14542*/   OPC_EmitConvertToTarget, 0,
/* 14544*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                 MVT::i64, 1/*#Ops*/, 1, 
             // Src: (imm:{ *:[i64] }):$imm - Complexity = 3
             // Dst: (CONST_I64:{ *:[i64] } (imm:{ *:[i64] }):$imm)
/* 14551*/  0, // EndSwitchType
/* 14552*/ /*SwitchOpcode*/ 14, TARGET_VAL(ISD::BR),// ->14569
/* 14555*/  OPC_RecordNode, // #0 = 'br' chained node
/* 14556*/  OPC_RecordChild1, // #1 = $dst
/* 14557*/  OPC_MoveChild1,
/* 14558*/  OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/* 14561*/  OPC_MoveParent,
/* 14562*/  OPC_EmitMergeInputChains1_0,
/* 14563*/  OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::BR), 0|OPFL_Chain,
                1/*#Ops*/, 1, 
            // Src: (br (bb:{ *:[Other] }):$dst) - Complexity = 3
            // Dst: (BR (bb:{ *:[Other] }):$dst)
/* 14569*/ /*SwitchOpcode*/ 24, TARGET_VAL(WebAssemblyISD::BR_TABLE),// ->14596
/* 14572*/  OPC_RecordNode, // #0 = 'WebAssemblybr_table' chained node
/* 14573*/  OPC_RecordChild1, // #1 = $index
/* 14574*/  OPC_Scope, 9, /*->14585*/ // 2 children in Scope
/* 14576*/   OPC_CheckChild1Type, MVT::i32,
/* 14578*/   OPC_EmitMergeInputChains1_0,
/* 14579*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::BR_TABLE_I32), 0|OPFL_Chain|OPFL_Variadic1,
                 1/*#Ops*/, 1, 
             // Src: (WebAssemblybr_table I32:{ *:[i32] }:$index) - Complexity = 3
             // Dst: (BR_TABLE_I32 I32:{ *:[i32] }:$index)
/* 14585*/  /*Scope*/ 9, /*->14595*/
/* 14586*/   OPC_CheckChild1Type, MVT::i64,
/* 14588*/   OPC_EmitMergeInputChains1_0,
/* 14589*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::BR_TABLE_I64), 0|OPFL_Chain|OPFL_Variadic1,
                 1/*#Ops*/, 1, 
             // Src: (WebAssemblybr_table I64:{ *:[i64] }:$index) - Complexity = 3
             // Dst: (BR_TABLE_I64 I64:{ *:[i64] }:$index)
/* 14595*/  0, /*End of Scope*/
/* 14596*/ /*SwitchOpcode*/ 7, TARGET_VAL(WebAssemblyISD::RETURN),// ->14606
/* 14599*/  OPC_RecordNode, // #0 = 'WebAssemblyreturn' chained node
/* 14600*/  OPC_EmitMergeInputChains1_0,
/* 14601*/  OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::RETURN), 0|OPFL_Chain|OPFL_Variadic0,
                0/*#Ops*/, 
            // Src: (WebAssemblyreturn) - Complexity = 3
            // Dst: (RETURN)
/* 14606*/ /*SwitchOpcode*/ 7, TARGET_VAL(ISD::TRAP),// ->14616
/* 14609*/  OPC_RecordNode, // #0 = 'trap' chained node
/* 14610*/  OPC_EmitMergeInputChains1_0,
/* 14611*/  OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::UNREACHABLE), 0|OPFL_Chain,
                0/*#Ops*/, 
            // Src: (trap) - Complexity = 3
            // Dst: (UNREACHABLE)
/* 14616*/ /*SwitchOpcode*/ 7, TARGET_VAL(ISD::DEBUGTRAP),// ->14626
/* 14619*/  OPC_RecordNode, // #0 = 'debugtrap' chained node
/* 14620*/  OPC_EmitMergeInputChains1_0,
/* 14621*/  OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::DEBUG_UNREACHABLE), 0|OPFL_Chain,
                0/*#Ops*/, 
            // Src: (debugtrap) - Complexity = 3
            // Dst: (DEBUG_UNREACHABLE)
/* 14626*/ /*SwitchOpcode*/ 9, TARGET_VAL(ISD::CLEANUPRET),// ->14638
/* 14629*/  OPC_RecordNode, // #0 = 'cleanupret' chained node
/* 14630*/  OPC_CheckPatternPredicate, 5, // (Subtarget->hasExceptionHandling())
/* 14632*/  OPC_EmitMergeInputChains1_0,
/* 14633*/  OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::CLEANUPRET), 0|OPFL_Chain,
                0/*#Ops*/, 
            // Src: (cleanupret) - Complexity = 3
            // Dst: (CLEANUPRET)
/* 14638*/ /*SwitchOpcode*/ 23, TARGET_VAL(ISD::CATCHRET),// ->14664
/* 14641*/  OPC_RecordNode, // #0 = 'catchret' chained node
/* 14642*/  OPC_RecordChild1, // #1 = $dst
/* 14643*/  OPC_MoveChild1,
/* 14644*/  OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/* 14647*/  OPC_MoveParent,
/* 14648*/  OPC_RecordChild2, // #2 = $from
/* 14649*/  OPC_MoveChild2,
/* 14650*/  OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/* 14653*/  OPC_MoveParent,
/* 14654*/  OPC_CheckPatternPredicate, 5, // (Subtarget->hasExceptionHandling())
/* 14656*/  OPC_EmitMergeInputChains1_0,
/* 14657*/  OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::CATCHRET), 0|OPFL_Chain,
                2/*#Ops*/, 1, 2, 
            // Src: (catchret (bb:{ *:[Other] }):$dst, (bb:{ *:[Other] }):$from) - Complexity = 3
            // Dst: (CATCHRET (bb:{ *:[Other] }):$dst, (bb:{ *:[Other] }):$from)
/* 14664*/ /*SwitchOpcode*/ 72, TARGET_VAL(ISD::ADD),// ->14739
/* 14667*/  OPC_RecordChild0, // #0 = $lhs
/* 14668*/  OPC_RecordChild1, // #1 = $rhs
/* 14669*/  OPC_SwitchType /*6 cases */, 8, MVT::i32,// ->14680
/* 14672*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADD_I32), 0,
                 MVT::i32, 2/*#Ops*/, 0, 1, 
             // Src: (add:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
             // Dst: (ADD_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 14680*/  /*SwitchType*/ 8, MVT::i64,// ->14690
/* 14682*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADD_I64), 0,
                 MVT::i64, 2/*#Ops*/, 0, 1, 
             // Src: (add:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
             // Dst: (ADD_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 14690*/  /*SwitchType*/ 10, MVT::v16i8,// ->14702
/* 14692*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 14694*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADD_I8x16), 0,
                 MVT::v16i8, 2/*#Ops*/, 0, 1, 
             // Src: (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (ADD_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 14702*/  /*SwitchType*/ 10, MVT::v8i16,// ->14714
/* 14704*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 14706*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADD_I16x8), 0,
                 MVT::v8i16, 2/*#Ops*/, 0, 1, 
             // Src: (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (ADD_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 14714*/  /*SwitchType*/ 10, MVT::v4i32,// ->14726
/* 14716*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 14718*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADD_I32x4), 0,
                 MVT::v4i32, 2/*#Ops*/, 0, 1, 
             // Src: (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
             // Dst: (ADD_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 14726*/  /*SwitchType*/ 10, MVT::v2i64,// ->14738
/* 14728*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 14730*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADD_I64x2), 0,
                 MVT::v2i64, 2/*#Ops*/, 0, 1, 
             // Src: (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
             // Dst: (ADD_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/* 14738*/  0, // EndSwitchType
/* 14739*/ /*SwitchOpcode*/ 3|128,1/*131*/, TARGET_VAL(ISD::SUB),// ->14874
/* 14743*/  OPC_Scope, 24, /*->14769*/ // 3 children in Scope
/* 14745*/   OPC_RecordChild0, // #0 = $lhs
/* 14746*/   OPC_RecordChild1, // #1 = $rhs
/* 14747*/   OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->14758
/* 14750*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SUB_I32), 0,
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (sub:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (SUB_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 14758*/   /*SwitchType*/ 8, MVT::i64,// ->14768
/* 14760*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SUB_I64), 0,
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (sub:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (SUB_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 14768*/   0, // EndSwitchType
/* 14769*/  /*Scope*/ 50, /*->14820*/
/* 14770*/   OPC_MoveChild0,
/* 14771*/   OPC_CheckImmAllZerosV,
/* 14772*/   OPC_MoveParent,
/* 14773*/   OPC_RecordChild1, // #0 = $v
/* 14774*/   OPC_SwitchType /*4 cases */, 9, MVT::v16i8,// ->14786
/* 14777*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 14779*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NEG_I8x16), 0,
                  MVT::v16i8, 1/*#Ops*/, 0, 
              // Src: (sub:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$v) - Complexity = 7
              // Dst: (NEG_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$v)
/* 14786*/   /*SwitchType*/ 9, MVT::v8i16,// ->14797
/* 14788*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 14790*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NEG_I16x8), 0,
                  MVT::v8i16, 1/*#Ops*/, 0, 
              // Src: (sub:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$v) - Complexity = 7
              // Dst: (NEG_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$v)
/* 14797*/   /*SwitchType*/ 9, MVT::v4i32,// ->14808
/* 14799*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 14801*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NEG_I32x4), 0,
                  MVT::v4i32, 1/*#Ops*/, 0, 
              // Src: (sub:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$v) - Complexity = 7
              // Dst: (NEG_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$v)
/* 14808*/   /*SwitchType*/ 9, MVT::v2i64,// ->14819
/* 14810*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 14812*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NEG_I64x2), 0,
                  MVT::v2i64, 1/*#Ops*/, 0, 
              // Src: (sub:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$v) - Complexity = 7
              // Dst: (NEG_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$v)
/* 14819*/   0, // EndSwitchType
/* 14820*/  /*Scope*/ 52, /*->14873*/
/* 14821*/   OPC_RecordChild0, // #0 = $lhs
/* 14822*/   OPC_RecordChild1, // #1 = $rhs
/* 14823*/   OPC_SwitchType /*4 cases */, 10, MVT::v16i8,// ->14836
/* 14826*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 14828*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SUB_I8x16), 0,
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (sub:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
              // Dst: (SUB_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 14836*/   /*SwitchType*/ 10, MVT::v8i16,// ->14848
/* 14838*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 14840*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SUB_I16x8), 0,
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
              // Dst: (SUB_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 14848*/   /*SwitchType*/ 10, MVT::v4i32,// ->14860
/* 14850*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 14852*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SUB_I32x4), 0,
                  MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
              // Dst: (SUB_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 14860*/   /*SwitchType*/ 10, MVT::v2i64,// ->14872
/* 14862*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 14864*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SUB_I64x2), 0,
                  MVT::v2i64, 2/*#Ops*/, 0, 1, 
              // Src: (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
              // Dst: (SUB_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/* 14872*/   0, // EndSwitchType
/* 14873*/  0, /*End of Scope*/
/* 14874*/ /*SwitchOpcode*/ 1|128,3/*385*/, TARGET_VAL(ISD::MUL),// ->15263
/* 14878*/  OPC_Scope, 24, /*->14904*/ // 3 children in Scope
/* 14880*/   OPC_RecordChild0, // #0 = $lhs
/* 14881*/   OPC_RecordChild1, // #1 = $rhs
/* 14882*/   OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->14893
/* 14885*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MUL_I32), 0,
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (mul:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (MUL_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 14893*/   /*SwitchType*/ 8, MVT::i64,// ->14903
/* 14895*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MUL_I64), 0,
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (mul:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (MUL_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 14903*/   0, // EndSwitchType
/* 14904*/  /*Scope*/ 59|128,2/*315*/, /*->15221*/
/* 14906*/   OPC_MoveChild0,
/* 14907*/   OPC_SwitchOpcode /*4 cases */, 75, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_S),// ->14986
/* 14911*/    OPC_RecordChild0, // #0 = $lhs
/* 14912*/    OPC_Scope, 23, /*->14937*/ // 3 children in Scope
/* 14914*/     OPC_CheckChild0Type, MVT::v16i8,
/* 14916*/     OPC_MoveParent,
/* 14917*/     OPC_MoveChild1,
/* 14918*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_S),
/* 14921*/     OPC_RecordChild0, // #1 = $rhs
/* 14922*/     OPC_CheckChild0Type, MVT::v16i8,
/* 14924*/     OPC_MoveParent,
/* 14925*/     OPC_CheckType, MVT::v8i16,
/* 14927*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 14929*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTMUL_LOW_S_I16x8), 0,
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v8i16] } (extend_low_s:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs), (extend_low_s:{ *:[v8i16] } V128:{ *:[v16i8] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_LOW_S_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 14937*/    /*Scope*/ 23, /*->14961*/
/* 14938*/     OPC_CheckChild0Type, MVT::v8i16,
/* 14940*/     OPC_MoveParent,
/* 14941*/     OPC_MoveChild1,
/* 14942*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_S),
/* 14945*/     OPC_RecordChild0, // #1 = $rhs
/* 14946*/     OPC_CheckChild0Type, MVT::v8i16,
/* 14948*/     OPC_MoveParent,
/* 14949*/     OPC_CheckType, MVT::v4i32,
/* 14951*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 14953*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTMUL_LOW_S_I32x4), 0,
                   MVT::v4i32, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v4i32] } (extend_low_s:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs), (extend_low_s:{ *:[v4i32] } V128:{ *:[v8i16] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_LOW_S_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 14961*/    /*Scope*/ 23, /*->14985*/
/* 14962*/     OPC_CheckChild0Type, MVT::v4i32,
/* 14964*/     OPC_MoveParent,
/* 14965*/     OPC_MoveChild1,
/* 14966*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_S),
/* 14969*/     OPC_RecordChild0, // #1 = $rhs
/* 14970*/     OPC_CheckChild0Type, MVT::v4i32,
/* 14972*/     OPC_MoveParent,
/* 14973*/     OPC_CheckType, MVT::v2i64,
/* 14975*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 14977*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTMUL_LOW_S_I64x2), 0,
                   MVT::v2i64, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v2i64] } (extend_low_s:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs), (extend_low_s:{ *:[v2i64] } V128:{ *:[v4i32] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_LOW_S_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 14985*/    0, /*End of Scope*/
/* 14986*/   /*SwitchOpcode*/ 75, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_S),// ->15064
/* 14989*/    OPC_RecordChild0, // #0 = $lhs
/* 14990*/    OPC_Scope, 23, /*->15015*/ // 3 children in Scope
/* 14992*/     OPC_CheckChild0Type, MVT::v16i8,
/* 14994*/     OPC_MoveParent,
/* 14995*/     OPC_MoveChild1,
/* 14996*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_S),
/* 14999*/     OPC_RecordChild0, // #1 = $rhs
/* 15000*/     OPC_CheckChild0Type, MVT::v16i8,
/* 15002*/     OPC_MoveParent,
/* 15003*/     OPC_CheckType, MVT::v8i16,
/* 15005*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 15007*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTMUL_HIGH_S_I16x8), 0,
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v8i16] } (extend_high_s:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs), (extend_high_s:{ *:[v8i16] } V128:{ *:[v16i8] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_HIGH_S_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 15015*/    /*Scope*/ 23, /*->15039*/
/* 15016*/     OPC_CheckChild0Type, MVT::v8i16,
/* 15018*/     OPC_MoveParent,
/* 15019*/     OPC_MoveChild1,
/* 15020*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_S),
/* 15023*/     OPC_RecordChild0, // #1 = $rhs
/* 15024*/     OPC_CheckChild0Type, MVT::v8i16,
/* 15026*/     OPC_MoveParent,
/* 15027*/     OPC_CheckType, MVT::v4i32,
/* 15029*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 15031*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTMUL_HIGH_S_I32x4), 0,
                   MVT::v4i32, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v4i32] } (extend_high_s:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs), (extend_high_s:{ *:[v4i32] } V128:{ *:[v8i16] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_HIGH_S_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 15039*/    /*Scope*/ 23, /*->15063*/
/* 15040*/     OPC_CheckChild0Type, MVT::v4i32,
/* 15042*/     OPC_MoveParent,
/* 15043*/     OPC_MoveChild1,
/* 15044*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_S),
/* 15047*/     OPC_RecordChild0, // #1 = $rhs
/* 15048*/     OPC_CheckChild0Type, MVT::v4i32,
/* 15050*/     OPC_MoveParent,
/* 15051*/     OPC_CheckType, MVT::v2i64,
/* 15053*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 15055*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTMUL_HIGH_S_I64x2), 0,
                   MVT::v2i64, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v2i64] } (extend_high_s:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs), (extend_high_s:{ *:[v2i64] } V128:{ *:[v4i32] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_HIGH_S_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 15063*/    0, /*End of Scope*/
/* 15064*/   /*SwitchOpcode*/ 75, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_U),// ->15142
/* 15067*/    OPC_RecordChild0, // #0 = $lhs
/* 15068*/    OPC_Scope, 23, /*->15093*/ // 3 children in Scope
/* 15070*/     OPC_CheckChild0Type, MVT::v16i8,
/* 15072*/     OPC_MoveParent,
/* 15073*/     OPC_MoveChild1,
/* 15074*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_U),
/* 15077*/     OPC_RecordChild0, // #1 = $rhs
/* 15078*/     OPC_CheckChild0Type, MVT::v16i8,
/* 15080*/     OPC_MoveParent,
/* 15081*/     OPC_CheckType, MVT::v8i16,
/* 15083*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 15085*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTMUL_LOW_U_I16x8), 0,
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v8i16] } (extend_low_u:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs), (extend_low_u:{ *:[v8i16] } V128:{ *:[v16i8] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_LOW_U_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 15093*/    /*Scope*/ 23, /*->15117*/
/* 15094*/     OPC_CheckChild0Type, MVT::v8i16,
/* 15096*/     OPC_MoveParent,
/* 15097*/     OPC_MoveChild1,
/* 15098*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_U),
/* 15101*/     OPC_RecordChild0, // #1 = $rhs
/* 15102*/     OPC_CheckChild0Type, MVT::v8i16,
/* 15104*/     OPC_MoveParent,
/* 15105*/     OPC_CheckType, MVT::v4i32,
/* 15107*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 15109*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTMUL_LOW_U_I32x4), 0,
                   MVT::v4i32, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v4i32] } (extend_low_u:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs), (extend_low_u:{ *:[v4i32] } V128:{ *:[v8i16] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_LOW_U_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 15117*/    /*Scope*/ 23, /*->15141*/
/* 15118*/     OPC_CheckChild0Type, MVT::v4i32,
/* 15120*/     OPC_MoveParent,
/* 15121*/     OPC_MoveChild1,
/* 15122*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_U),
/* 15125*/     OPC_RecordChild0, // #1 = $rhs
/* 15126*/     OPC_CheckChild0Type, MVT::v4i32,
/* 15128*/     OPC_MoveParent,
/* 15129*/     OPC_CheckType, MVT::v2i64,
/* 15131*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 15133*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTMUL_LOW_U_I64x2), 0,
                   MVT::v2i64, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v2i64] } (extend_low_u:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs), (extend_low_u:{ *:[v2i64] } V128:{ *:[v4i32] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_LOW_U_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 15141*/    0, /*End of Scope*/
/* 15142*/   /*SwitchOpcode*/ 75, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_U),// ->15220
/* 15145*/    OPC_RecordChild0, // #0 = $lhs
/* 15146*/    OPC_Scope, 23, /*->15171*/ // 3 children in Scope
/* 15148*/     OPC_CheckChild0Type, MVT::v16i8,
/* 15150*/     OPC_MoveParent,
/* 15151*/     OPC_MoveChild1,
/* 15152*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_U),
/* 15155*/     OPC_RecordChild0, // #1 = $rhs
/* 15156*/     OPC_CheckChild0Type, MVT::v16i8,
/* 15158*/     OPC_MoveParent,
/* 15159*/     OPC_CheckType, MVT::v8i16,
/* 15161*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 15163*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTMUL_HIGH_U_I16x8), 0,
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v8i16] } (extend_high_u:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs), (extend_high_u:{ *:[v8i16] } V128:{ *:[v16i8] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_HIGH_U_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 15171*/    /*Scope*/ 23, /*->15195*/
/* 15172*/     OPC_CheckChild0Type, MVT::v8i16,
/* 15174*/     OPC_MoveParent,
/* 15175*/     OPC_MoveChild1,
/* 15176*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_U),
/* 15179*/     OPC_RecordChild0, // #1 = $rhs
/* 15180*/     OPC_CheckChild0Type, MVT::v8i16,
/* 15182*/     OPC_MoveParent,
/* 15183*/     OPC_CheckType, MVT::v4i32,
/* 15185*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 15187*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTMUL_HIGH_U_I32x4), 0,
                   MVT::v4i32, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v4i32] } (extend_high_u:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs), (extend_high_u:{ *:[v4i32] } V128:{ *:[v8i16] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_HIGH_U_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 15195*/    /*Scope*/ 23, /*->15219*/
/* 15196*/     OPC_CheckChild0Type, MVT::v4i32,
/* 15198*/     OPC_MoveParent,
/* 15199*/     OPC_MoveChild1,
/* 15200*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_U),
/* 15203*/     OPC_RecordChild0, // #1 = $rhs
/* 15204*/     OPC_CheckChild0Type, MVT::v4i32,
/* 15206*/     OPC_MoveParent,
/* 15207*/     OPC_CheckType, MVT::v2i64,
/* 15209*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 15211*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTMUL_HIGH_U_I64x2), 0,
                   MVT::v2i64, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v2i64] } (extend_high_u:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs), (extend_high_u:{ *:[v2i64] } V128:{ *:[v4i32] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_HIGH_U_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 15219*/    0, /*End of Scope*/
/* 15220*/   0, // EndSwitchOpcode
/* 15221*/  /*Scope*/ 40, /*->15262*/
/* 15222*/   OPC_RecordChild0, // #0 = $lhs
/* 15223*/   OPC_RecordChild1, // #1 = $rhs
/* 15224*/   OPC_SwitchType /*3 cases */, 10, MVT::v8i16,// ->15237
/* 15227*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 15229*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MUL_I16x8), 0,
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (mul:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
              // Dst: (MUL_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 15237*/   /*SwitchType*/ 10, MVT::v4i32,// ->15249
/* 15239*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 15241*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MUL_I32x4), 0,
                  MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (mul:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
              // Dst: (MUL_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 15249*/   /*SwitchType*/ 10, MVT::v2i64,// ->15261
/* 15251*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 15253*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MUL_I64x2), 0,
                  MVT::v2i64, 2/*#Ops*/, 0, 1, 
              // Src: (mul:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
              // Dst: (MUL_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/* 15261*/   0, // EndSwitchType
/* 15262*/  0, /*End of Scope*/
/* 15263*/ /*SwitchOpcode*/ 24, TARGET_VAL(ISD::SDIV),// ->15290
/* 15266*/  OPC_RecordChild0, // #0 = $lhs
/* 15267*/  OPC_RecordChild1, // #1 = $rhs
/* 15268*/  OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->15279
/* 15271*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::DIV_S_I32), 0,
                 MVT::i32, 2/*#Ops*/, 0, 1, 
             // Src: (sdiv:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
             // Dst: (DIV_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 15279*/  /*SwitchType*/ 8, MVT::i64,// ->15289
/* 15281*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::DIV_S_I64), 0,
                 MVT::i64, 2/*#Ops*/, 0, 1, 
             // Src: (sdiv:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
             // Dst: (DIV_S_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 15289*/  0, // EndSwitchType
/* 15290*/ /*SwitchOpcode*/ 24, TARGET_VAL(ISD::UDIV),// ->15317
/* 15293*/  OPC_RecordChild0, // #0 = $lhs
/* 15294*/  OPC_RecordChild1, // #1 = $rhs
/* 15295*/  OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->15306
/* 15298*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::DIV_U_I32), 0,
                 MVT::i32, 2/*#Ops*/, 0, 1, 
             // Src: (udiv:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
             // Dst: (DIV_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 15306*/  /*SwitchType*/ 8, MVT::i64,// ->15316
/* 15308*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::DIV_U_I64), 0,
                 MVT::i64, 2/*#Ops*/, 0, 1, 
             // Src: (udiv:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
             // Dst: (DIV_U_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 15316*/  0, // EndSwitchType
/* 15317*/ /*SwitchOpcode*/ 24, TARGET_VAL(ISD::SREM),// ->15344
/* 15320*/  OPC_RecordChild0, // #0 = $lhs
/* 15321*/  OPC_RecordChild1, // #1 = $rhs
/* 15322*/  OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->15333
/* 15325*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::REM_S_I32), 0,
                 MVT::i32, 2/*#Ops*/, 0, 1, 
             // Src: (srem:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
             // Dst: (REM_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 15333*/  /*SwitchType*/ 8, MVT::i64,// ->15343
/* 15335*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::REM_S_I64), 0,
                 MVT::i64, 2/*#Ops*/, 0, 1, 
             // Src: (srem:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
             // Dst: (REM_S_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 15343*/  0, // EndSwitchType
/* 15344*/ /*SwitchOpcode*/ 24, TARGET_VAL(ISD::UREM),// ->15371
/* 15347*/  OPC_RecordChild0, // #0 = $lhs
/* 15348*/  OPC_RecordChild1, // #1 = $rhs
/* 15349*/  OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->15360
/* 15352*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::REM_U_I32), 0,
                 MVT::i32, 2/*#Ops*/, 0, 1, 
             // Src: (urem:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
             // Dst: (REM_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 15360*/  /*SwitchType*/ 8, MVT::i64,// ->15370
/* 15362*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::REM_U_I64), 0,
                 MVT::i64, 2/*#Ops*/, 0, 1, 
             // Src: (urem:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
             // Dst: (REM_U_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 15370*/  0, // EndSwitchType
/* 15371*/ /*SwitchOpcode*/ 109|128,6/*877*/, TARGET_VAL(ISD::OR),// ->16252
/* 15375*/  OPC_Scope, 24, /*->15401*/ // 3 children in Scope
/* 15377*/   OPC_RecordChild0, // #0 = $lhs
/* 15378*/   OPC_RecordChild1, // #1 = $rhs
/* 15379*/   OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->15390
/* 15382*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::OR_I32), 0,
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (or:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (OR_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 15390*/   /*SwitchType*/ 8, MVT::i64,// ->15400
/* 15392*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::OR_I64), 0,
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (or:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (OR_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 15400*/   0, // EndSwitchType
/* 15401*/  /*Scope*/ 35|128,6/*803*/, /*->16206*/
/* 15403*/   OPC_MoveChild0,
/* 15404*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15407*/   OPC_Scope, 12|128,1/*140*/, /*->15550*/ // 9 children in Scope
/* 15410*/    OPC_RecordChild0, // #0 = $c
/* 15411*/    OPC_RecordChild1, // #1 = $v1
/* 15412*/    OPC_MoveParent,
/* 15413*/    OPC_MoveChild1,
/* 15414*/    OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15417*/    OPC_Scope, 58, /*->15477*/ // 4 children in Scope
/* 15419*/     OPC_MoveChild0,
/* 15420*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15423*/     OPC_CheckChild0Same, 0,
/* 15425*/     OPC_MoveChild1,
/* 15426*/     OPC_CheckImmAllOnesV,
/* 15427*/     OPC_MoveParent,
/* 15428*/     OPC_MoveParent,
/* 15429*/     OPC_RecordChild1, // #2 = $v2
/* 15430*/     OPC_MoveParent,
/* 15431*/     OPC_SwitchType /*4 cases */, 9, MVT::v16i8,// ->15443
/* 15434*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                    MVT::v16i8, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, V128:{ *:[v16i8] }:$v1), (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 15443*/     /*SwitchType*/ 9, MVT::v8i16,// ->15454
/* 15445*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                    MVT::v8i16, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, V128:{ *:[v8i16] }:$v1), (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 15454*/     /*SwitchType*/ 9, MVT::v4i32,// ->15465
/* 15456*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                    MVT::v4i32, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4i32] }:$v1), (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 15465*/     /*SwitchType*/ 9, MVT::v2i64,// ->15476
/* 15467*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                    MVT::v2i64, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2i64] }:$v1), (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 15476*/     0, // EndSwitchType
/* 15477*/    /*Scope*/ 23, /*->15501*/
/* 15478*/     OPC_RecordChild0, // #2 = $v2
/* 15479*/     OPC_MoveChild1,
/* 15480*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15483*/     OPC_CheckChild0Same, 0,
/* 15485*/     OPC_MoveChild1,
/* 15486*/     OPC_CheckImmAllOnesV,
/* 15487*/     OPC_MoveParent,
/* 15488*/     OPC_MoveParent,
/* 15489*/     OPC_MoveParent,
/* 15490*/     OPC_CheckType, MVT::v16i8,
/* 15492*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v16i8, 3/*#Ops*/, 1, 2, 0, 
               // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, V128:{ *:[v16i8] }:$v1), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 15501*/    /*Scope*/ 23, /*->15525*/
/* 15502*/     OPC_MoveChild0,
/* 15503*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15506*/     OPC_CheckChild0Same, 1,
/* 15508*/     OPC_MoveChild1,
/* 15509*/     OPC_CheckImmAllOnesV,
/* 15510*/     OPC_MoveParent,
/* 15511*/     OPC_MoveParent,
/* 15512*/     OPC_RecordChild1, // #2 = $v2
/* 15513*/     OPC_MoveParent,
/* 15514*/     OPC_CheckType, MVT::v16i8,
/* 15516*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v16i8, 3/*#Ops*/, 0, 2, 1, 
               // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$c), (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$v2)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 15525*/    /*Scope*/ 23, /*->15549*/
/* 15526*/     OPC_RecordChild0, // #2 = $v2
/* 15527*/     OPC_MoveChild1,
/* 15528*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15531*/     OPC_CheckChild0Same, 1,
/* 15533*/     OPC_MoveChild1,
/* 15534*/     OPC_CheckImmAllOnesV,
/* 15535*/     OPC_MoveParent,
/* 15536*/     OPC_MoveParent,
/* 15537*/     OPC_MoveParent,
/* 15538*/     OPC_CheckType, MVT::v16i8,
/* 15540*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v16i8, 3/*#Ops*/, 0, 2, 1, 
               // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$c), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 15549*/    0, /*End of Scope*/
/* 15550*/   /*Scope*/ 49, /*->15600*/
/* 15551*/    OPC_MoveChild0,
/* 15552*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15555*/    OPC_RecordChild0, // #0 = $c
/* 15556*/    OPC_MoveChild1,
/* 15557*/    OPC_CheckImmAllOnesV,
/* 15558*/    OPC_MoveParent,
/* 15559*/    OPC_MoveParent,
/* 15560*/    OPC_RecordChild1, // #1 = $v2
/* 15561*/    OPC_MoveParent,
/* 15562*/    OPC_MoveChild1,
/* 15563*/    OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15566*/    OPC_Scope, 15, /*->15583*/ // 2 children in Scope
/* 15568*/     OPC_CheckChild0Same, 0,
/* 15570*/     OPC_RecordChild1, // #2 = $v1
/* 15571*/     OPC_MoveParent,
/* 15572*/     OPC_CheckType, MVT::v16i8,
/* 15574*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v16i8, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$v2), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, V128:{ *:[v16i8] }:$v1)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 15583*/    /*Scope*/ 15, /*->15599*/
/* 15584*/     OPC_RecordChild0, // #2 = $v1
/* 15585*/     OPC_CheckChild1Same, 0,
/* 15587*/     OPC_MoveParent,
/* 15588*/     OPC_CheckType, MVT::v16i8,
/* 15590*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v16i8, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$v2), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$c)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 15599*/    0, /*End of Scope*/
/* 15600*/   /*Scope*/ 5|128,1/*133*/, /*->15735*/
/* 15602*/    OPC_RecordChild0, // #0 = $v2
/* 15603*/    OPC_Scope, 48, /*->15653*/ // 2 children in Scope
/* 15605*/     OPC_MoveChild1,
/* 15606*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15609*/     OPC_RecordChild0, // #1 = $c
/* 15610*/     OPC_MoveChild1,
/* 15611*/     OPC_CheckImmAllOnesV,
/* 15612*/     OPC_MoveParent,
/* 15613*/     OPC_MoveParent,
/* 15614*/     OPC_MoveParent,
/* 15615*/     OPC_MoveChild1,
/* 15616*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15619*/     OPC_Scope, 15, /*->15636*/ // 2 children in Scope
/* 15621*/      OPC_CheckChild0Same, 1,
/* 15623*/      OPC_RecordChild1, // #2 = $v1
/* 15624*/      OPC_MoveParent,
/* 15625*/      OPC_CheckType, MVT::v16i8,
/* 15627*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                    MVT::v16i8, 3/*#Ops*/, 2, 0, 1, 
                // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] })), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, V128:{ *:[v16i8] }:$v1)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 15636*/     /*Scope*/ 15, /*->15652*/
/* 15637*/      OPC_RecordChild0, // #2 = $v1
/* 15638*/      OPC_CheckChild1Same, 1,
/* 15640*/      OPC_MoveParent,
/* 15641*/      OPC_CheckType, MVT::v16i8,
/* 15643*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                    MVT::v16i8, 3/*#Ops*/, 2, 0, 1, 
                // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] })), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$c)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 15652*/     0, /*End of Scope*/
/* 15653*/    /*Scope*/ 80, /*->15734*/
/* 15654*/     OPC_RecordChild1, // #1 = $v1
/* 15655*/     OPC_MoveParent,
/* 15656*/     OPC_MoveChild1,
/* 15657*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15660*/     OPC_Scope, 23, /*->15685*/ // 3 children in Scope
/* 15662*/      OPC_RecordChild0, // #2 = $v2
/* 15663*/      OPC_MoveChild1,
/* 15664*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15667*/      OPC_CheckChild0Same, 0,
/* 15669*/      OPC_MoveChild1,
/* 15670*/      OPC_CheckImmAllOnesV,
/* 15671*/      OPC_MoveParent,
/* 15672*/      OPC_MoveParent,
/* 15673*/      OPC_MoveParent,
/* 15674*/      OPC_CheckType, MVT::v8i16,
/* 15676*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                    MVT::v8i16, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, V128:{ *:[v8i16] }:$v1), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }))) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 15685*/     /*Scope*/ 23, /*->15709*/
/* 15686*/      OPC_MoveChild0,
/* 15687*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15690*/      OPC_CheckChild0Same, 1,
/* 15692*/      OPC_MoveChild1,
/* 15693*/      OPC_CheckImmAllOnesV,
/* 15694*/      OPC_MoveParent,
/* 15695*/      OPC_MoveParent,
/* 15696*/      OPC_RecordChild1, // #2 = $v2
/* 15697*/      OPC_MoveParent,
/* 15698*/      OPC_CheckType, MVT::v8i16,
/* 15700*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                    MVT::v8i16, 3/*#Ops*/, 0, 2, 1, 
                // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$c), (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 15709*/     /*Scope*/ 23, /*->15733*/
/* 15710*/      OPC_RecordChild0, // #2 = $v2
/* 15711*/      OPC_MoveChild1,
/* 15712*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15715*/      OPC_CheckChild0Same, 1,
/* 15717*/      OPC_MoveChild1,
/* 15718*/      OPC_CheckImmAllOnesV,
/* 15719*/      OPC_MoveParent,
/* 15720*/      OPC_MoveParent,
/* 15721*/      OPC_MoveParent,
/* 15722*/      OPC_CheckType, MVT::v8i16,
/* 15724*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                    MVT::v8i16, 3/*#Ops*/, 0, 2, 1, 
                // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$c), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }))) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 15733*/     0, /*End of Scope*/
/* 15734*/    0, /*End of Scope*/
/* 15735*/   /*Scope*/ 49, /*->15785*/
/* 15736*/    OPC_MoveChild0,
/* 15737*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15740*/    OPC_RecordChild0, // #0 = $c
/* 15741*/    OPC_MoveChild1,
/* 15742*/    OPC_CheckImmAllOnesV,
/* 15743*/    OPC_MoveParent,
/* 15744*/    OPC_MoveParent,
/* 15745*/    OPC_RecordChild1, // #1 = $v2
/* 15746*/    OPC_MoveParent,
/* 15747*/    OPC_MoveChild1,
/* 15748*/    OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15751*/    OPC_Scope, 15, /*->15768*/ // 2 children in Scope
/* 15753*/     OPC_CheckChild0Same, 0,
/* 15755*/     OPC_RecordChild1, // #2 = $v1
/* 15756*/     OPC_MoveParent,
/* 15757*/     OPC_CheckType, MVT::v8i16,
/* 15759*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v8i16, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$v2), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, V128:{ *:[v8i16] }:$v1)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 15768*/    /*Scope*/ 15, /*->15784*/
/* 15769*/     OPC_RecordChild0, // #2 = $v1
/* 15770*/     OPC_CheckChild1Same, 0,
/* 15772*/     OPC_MoveParent,
/* 15773*/     OPC_CheckType, MVT::v8i16,
/* 15775*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v8i16, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$v2), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$c)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 15784*/    0, /*End of Scope*/
/* 15785*/   /*Scope*/ 5|128,1/*133*/, /*->15920*/
/* 15787*/    OPC_RecordChild0, // #0 = $v2
/* 15788*/    OPC_Scope, 48, /*->15838*/ // 2 children in Scope
/* 15790*/     OPC_MoveChild1,
/* 15791*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15794*/     OPC_RecordChild0, // #1 = $c
/* 15795*/     OPC_MoveChild1,
/* 15796*/     OPC_CheckImmAllOnesV,
/* 15797*/     OPC_MoveParent,
/* 15798*/     OPC_MoveParent,
/* 15799*/     OPC_MoveParent,
/* 15800*/     OPC_MoveChild1,
/* 15801*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15804*/     OPC_Scope, 15, /*->15821*/ // 2 children in Scope
/* 15806*/      OPC_CheckChild0Same, 1,
/* 15808*/      OPC_RecordChild1, // #2 = $v1
/* 15809*/      OPC_MoveParent,
/* 15810*/      OPC_CheckType, MVT::v8i16,
/* 15812*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                    MVT::v8i16, 3/*#Ops*/, 2, 0, 1, 
                // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] })), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, V128:{ *:[v8i16] }:$v1)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 15821*/     /*Scope*/ 15, /*->15837*/
/* 15822*/      OPC_RecordChild0, // #2 = $v1
/* 15823*/      OPC_CheckChild1Same, 1,
/* 15825*/      OPC_MoveParent,
/* 15826*/      OPC_CheckType, MVT::v8i16,
/* 15828*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                    MVT::v8i16, 3/*#Ops*/, 2, 0, 1, 
                // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] })), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$c)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 15837*/     0, /*End of Scope*/
/* 15838*/    /*Scope*/ 80, /*->15919*/
/* 15839*/     OPC_RecordChild1, // #1 = $v1
/* 15840*/     OPC_MoveParent,
/* 15841*/     OPC_MoveChild1,
/* 15842*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15845*/     OPC_Scope, 23, /*->15870*/ // 3 children in Scope
/* 15847*/      OPC_RecordChild0, // #2 = $v2
/* 15848*/      OPC_MoveChild1,
/* 15849*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15852*/      OPC_CheckChild0Same, 0,
/* 15854*/      OPC_MoveChild1,
/* 15855*/      OPC_CheckImmAllOnesV,
/* 15856*/      OPC_MoveParent,
/* 15857*/      OPC_MoveParent,
/* 15858*/      OPC_MoveParent,
/* 15859*/      OPC_CheckType, MVT::v4i32,
/* 15861*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                    MVT::v4i32, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4i32] }:$v1), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }))) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 15870*/     /*Scope*/ 23, /*->15894*/
/* 15871*/      OPC_MoveChild0,
/* 15872*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15875*/      OPC_CheckChild0Same, 1,
/* 15877*/      OPC_MoveChild1,
/* 15878*/      OPC_CheckImmAllOnesV,
/* 15879*/      OPC_MoveParent,
/* 15880*/      OPC_MoveParent,
/* 15881*/      OPC_RecordChild1, // #2 = $v2
/* 15882*/      OPC_MoveParent,
/* 15883*/      OPC_CheckType, MVT::v4i32,
/* 15885*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                    MVT::v4i32, 3/*#Ops*/, 0, 2, 1, 
                // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$c), (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 15894*/     /*Scope*/ 23, /*->15918*/
/* 15895*/      OPC_RecordChild0, // #2 = $v2
/* 15896*/      OPC_MoveChild1,
/* 15897*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15900*/      OPC_CheckChild0Same, 1,
/* 15902*/      OPC_MoveChild1,
/* 15903*/      OPC_CheckImmAllOnesV,
/* 15904*/      OPC_MoveParent,
/* 15905*/      OPC_MoveParent,
/* 15906*/      OPC_MoveParent,
/* 15907*/      OPC_CheckType, MVT::v4i32,
/* 15909*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                    MVT::v4i32, 3/*#Ops*/, 0, 2, 1, 
                // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$c), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }))) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 15918*/     0, /*End of Scope*/
/* 15919*/    0, /*End of Scope*/
/* 15920*/   /*Scope*/ 49, /*->15970*/
/* 15921*/    OPC_MoveChild0,
/* 15922*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15925*/    OPC_RecordChild0, // #0 = $c
/* 15926*/    OPC_MoveChild1,
/* 15927*/    OPC_CheckImmAllOnesV,
/* 15928*/    OPC_MoveParent,
/* 15929*/    OPC_MoveParent,
/* 15930*/    OPC_RecordChild1, // #1 = $v2
/* 15931*/    OPC_MoveParent,
/* 15932*/    OPC_MoveChild1,
/* 15933*/    OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15936*/    OPC_Scope, 15, /*->15953*/ // 2 children in Scope
/* 15938*/     OPC_CheckChild0Same, 0,
/* 15940*/     OPC_RecordChild1, // #2 = $v1
/* 15941*/     OPC_MoveParent,
/* 15942*/     OPC_CheckType, MVT::v4i32,
/* 15944*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v4i32, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$v2), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4i32] }:$v1)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 15953*/    /*Scope*/ 15, /*->15969*/
/* 15954*/     OPC_RecordChild0, // #2 = $v1
/* 15955*/     OPC_CheckChild1Same, 0,
/* 15957*/     OPC_MoveParent,
/* 15958*/     OPC_CheckType, MVT::v4i32,
/* 15960*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v4i32, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$v2), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$c)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 15969*/    0, /*End of Scope*/
/* 15970*/   /*Scope*/ 5|128,1/*133*/, /*->16105*/
/* 15972*/    OPC_RecordChild0, // #0 = $v2
/* 15973*/    OPC_Scope, 48, /*->16023*/ // 2 children in Scope
/* 15975*/     OPC_MoveChild1,
/* 15976*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15979*/     OPC_RecordChild0, // #1 = $c
/* 15980*/     OPC_MoveChild1,
/* 15981*/     OPC_CheckImmAllOnesV,
/* 15982*/     OPC_MoveParent,
/* 15983*/     OPC_MoveParent,
/* 15984*/     OPC_MoveParent,
/* 15985*/     OPC_MoveChild1,
/* 15986*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15989*/     OPC_Scope, 15, /*->16006*/ // 2 children in Scope
/* 15991*/      OPC_CheckChild0Same, 1,
/* 15993*/      OPC_RecordChild1, // #2 = $v1
/* 15994*/      OPC_MoveParent,
/* 15995*/      OPC_CheckType, MVT::v4i32,
/* 15997*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                    MVT::v4i32, 3/*#Ops*/, 2, 0, 1, 
                // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] })), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4i32] }:$v1)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 16006*/     /*Scope*/ 15, /*->16022*/
/* 16007*/      OPC_RecordChild0, // #2 = $v1
/* 16008*/      OPC_CheckChild1Same, 1,
/* 16010*/      OPC_MoveParent,
/* 16011*/      OPC_CheckType, MVT::v4i32,
/* 16013*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                    MVT::v4i32, 3/*#Ops*/, 2, 0, 1, 
                // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] })), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$c)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 16022*/     0, /*End of Scope*/
/* 16023*/    /*Scope*/ 80, /*->16104*/
/* 16024*/     OPC_RecordChild1, // #1 = $v1
/* 16025*/     OPC_MoveParent,
/* 16026*/     OPC_MoveChild1,
/* 16027*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 16030*/     OPC_Scope, 23, /*->16055*/ // 3 children in Scope
/* 16032*/      OPC_RecordChild0, // #2 = $v2
/* 16033*/      OPC_MoveChild1,
/* 16034*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16037*/      OPC_CheckChild0Same, 0,
/* 16039*/      OPC_MoveChild1,
/* 16040*/      OPC_CheckImmAllOnesV,
/* 16041*/      OPC_MoveParent,
/* 16042*/      OPC_MoveParent,
/* 16043*/      OPC_MoveParent,
/* 16044*/      OPC_CheckType, MVT::v2i64,
/* 16046*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                    MVT::v2i64, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2i64] }:$v1), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }))) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 16055*/     /*Scope*/ 23, /*->16079*/
/* 16056*/      OPC_MoveChild0,
/* 16057*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16060*/      OPC_CheckChild0Same, 1,
/* 16062*/      OPC_MoveChild1,
/* 16063*/      OPC_CheckImmAllOnesV,
/* 16064*/      OPC_MoveParent,
/* 16065*/      OPC_MoveParent,
/* 16066*/      OPC_RecordChild1, // #2 = $v2
/* 16067*/      OPC_MoveParent,
/* 16068*/      OPC_CheckType, MVT::v2i64,
/* 16070*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                    MVT::v2i64, 3/*#Ops*/, 0, 2, 1, 
                // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$c), (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 16079*/     /*Scope*/ 23, /*->16103*/
/* 16080*/      OPC_RecordChild0, // #2 = $v2
/* 16081*/      OPC_MoveChild1,
/* 16082*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16085*/      OPC_CheckChild0Same, 1,
/* 16087*/      OPC_MoveChild1,
/* 16088*/      OPC_CheckImmAllOnesV,
/* 16089*/      OPC_MoveParent,
/* 16090*/      OPC_MoveParent,
/* 16091*/      OPC_MoveParent,
/* 16092*/      OPC_CheckType, MVT::v2i64,
/* 16094*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                    MVT::v2i64, 3/*#Ops*/, 0, 2, 1, 
                // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$c), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }))) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 16103*/     0, /*End of Scope*/
/* 16104*/    0, /*End of Scope*/
/* 16105*/   /*Scope*/ 49, /*->16155*/
/* 16106*/    OPC_MoveChild0,
/* 16107*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16110*/    OPC_RecordChild0, // #0 = $c
/* 16111*/    OPC_MoveChild1,
/* 16112*/    OPC_CheckImmAllOnesV,
/* 16113*/    OPC_MoveParent,
/* 16114*/    OPC_MoveParent,
/* 16115*/    OPC_RecordChild1, // #1 = $v2
/* 16116*/    OPC_MoveParent,
/* 16117*/    OPC_MoveChild1,
/* 16118*/    OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 16121*/    OPC_Scope, 15, /*->16138*/ // 2 children in Scope
/* 16123*/     OPC_CheckChild0Same, 0,
/* 16125*/     OPC_RecordChild1, // #2 = $v1
/* 16126*/     OPC_MoveParent,
/* 16127*/     OPC_CheckType, MVT::v2i64,
/* 16129*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v2i64, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$v2), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2i64] }:$v1)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 16138*/    /*Scope*/ 15, /*->16154*/
/* 16139*/     OPC_RecordChild0, // #2 = $v1
/* 16140*/     OPC_CheckChild1Same, 0,
/* 16142*/     OPC_MoveParent,
/* 16143*/     OPC_CheckType, MVT::v2i64,
/* 16145*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v2i64, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$v2), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$c)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 16154*/    0, /*End of Scope*/
/* 16155*/   /*Scope*/ 49, /*->16205*/
/* 16156*/    OPC_RecordChild0, // #0 = $v2
/* 16157*/    OPC_MoveChild1,
/* 16158*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16161*/    OPC_RecordChild0, // #1 = $c
/* 16162*/    OPC_MoveChild1,
/* 16163*/    OPC_CheckImmAllOnesV,
/* 16164*/    OPC_MoveParent,
/* 16165*/    OPC_MoveParent,
/* 16166*/    OPC_MoveParent,
/* 16167*/    OPC_MoveChild1,
/* 16168*/    OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 16171*/    OPC_Scope, 15, /*->16188*/ // 2 children in Scope
/* 16173*/     OPC_CheckChild0Same, 1,
/* 16175*/     OPC_RecordChild1, // #2 = $v1
/* 16176*/     OPC_MoveParent,
/* 16177*/     OPC_CheckType, MVT::v2i64,
/* 16179*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v2i64, 3/*#Ops*/, 2, 0, 1, 
               // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] })), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2i64] }:$v1)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 16188*/    /*Scope*/ 15, /*->16204*/
/* 16189*/     OPC_RecordChild0, // #2 = $v1
/* 16190*/     OPC_CheckChild1Same, 1,
/* 16192*/     OPC_MoveParent,
/* 16193*/     OPC_CheckType, MVT::v2i64,
/* 16195*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v2i64, 3/*#Ops*/, 2, 0, 1, 
               // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] })), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$c)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 16204*/    0, /*End of Scope*/
/* 16205*/   0, /*End of Scope*/
/* 16206*/  /*Scope*/ 44, /*->16251*/
/* 16207*/   OPC_RecordChild0, // #0 = $lhs
/* 16208*/   OPC_RecordChild1, // #1 = $rhs
/* 16209*/   OPC_SwitchType /*4 cases */, 8, MVT::v16i8,// ->16220
/* 16212*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::OR), 0,
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
              // Dst: (OR:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/* 16220*/   /*SwitchType*/ 8, MVT::v8i16,// ->16230
/* 16222*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::OR), 0,
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
              // Dst: (OR:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/* 16230*/   /*SwitchType*/ 8, MVT::v4i32,// ->16240
/* 16232*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::OR), 0,
                  MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
              // Dst: (OR:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/* 16240*/   /*SwitchType*/ 8, MVT::v2i64,// ->16250
/* 16242*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::OR), 0,
                  MVT::v2i64, 2/*#Ops*/, 0, 1, 
              // Src: (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
              // Dst: (OR:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/* 16250*/   0, // EndSwitchType
/* 16251*/  0, /*End of Scope*/
/* 16252*/ /*SwitchOpcode*/ 89|128,12/*1625*/, TARGET_VAL(ISD::XOR),// ->17881
/* 16256*/  OPC_Scope, 24, /*->16282*/ // 17 children in Scope
/* 16258*/   OPC_RecordChild0, // #0 = $lhs
/* 16259*/   OPC_RecordChild1, // #1 = $rhs
/* 16260*/   OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->16271
/* 16263*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::XOR_I32), 0,
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (xor:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (XOR_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 16271*/   /*SwitchType*/ 8, MVT::i64,// ->16281
/* 16273*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::XOR_I64), 0,
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (xor:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (XOR_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 16281*/   0, // EndSwitchType
/* 16282*/  /*Scope*/ 2|128,1/*130*/, /*->16414*/
/* 16284*/   OPC_MoveChild0,
/* 16285*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 16288*/   OPC_MoveChild0,
/* 16289*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16292*/   OPC_RecordChild0, // #0 = $v1
/* 16293*/   OPC_Scope, 77, /*->16372*/ // 2 children in Scope
/* 16295*/    OPC_RecordChild1, // #1 = $v2
/* 16296*/    OPC_MoveParent,
/* 16297*/    OPC_MoveChild1,
/* 16298*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16301*/    OPC_RecordChild0, // #2 = $c
/* 16302*/    OPC_MoveChild1,
/* 16303*/    OPC_CheckImmAllOnesV,
/* 16304*/    OPC_MoveParent,
/* 16305*/    OPC_MoveParent,
/* 16306*/    OPC_MoveParent,
/* 16307*/    OPC_Scope, 48, /*->16357*/ // 2 children in Scope
/* 16309*/     OPC_CheckChild1Same, 1,
/* 16311*/     OPC_SwitchType /*4 cases */, 9, MVT::v16i8,// ->16323
/* 16314*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                    MVT::v16i8, 3/*#Ops*/, 1, 0, 2, 
                // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] })), V128:{ *:[v16i8] }:$v2) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 16323*/     /*SwitchType*/ 9, MVT::v8i16,// ->16334
/* 16325*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                    MVT::v8i16, 3/*#Ops*/, 1, 0, 2, 
                // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] })), V128:{ *:[v8i16] }:$v2) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 16334*/     /*SwitchType*/ 9, MVT::v4i32,// ->16345
/* 16336*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                    MVT::v4i32, 3/*#Ops*/, 1, 0, 2, 
                // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] })), V128:{ *:[v4i32] }:$v2) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 16345*/     /*SwitchType*/ 9, MVT::v2i64,// ->16356
/* 16347*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                    MVT::v2i64, 3/*#Ops*/, 1, 0, 2, 
                // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] })), V128:{ *:[v2i64] }:$v2) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 16356*/     0, // EndSwitchType
/* 16357*/    /*Scope*/ 13, /*->16371*/
/* 16358*/     OPC_CheckChild1Same, 0,
/* 16360*/     OPC_CheckType, MVT::v16i8,
/* 16362*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v16i8, 3/*#Ops*/, 0, 1, 2, 
               // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] })), V128:{ *:[v16i8] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 16371*/    0, /*End of Scope*/
/* 16372*/   /*Scope*/ 40, /*->16413*/
/* 16373*/    OPC_MoveChild1,
/* 16374*/    OPC_CheckImmAllOnesV,
/* 16375*/    OPC_MoveParent,
/* 16376*/    OPC_MoveParent,
/* 16377*/    OPC_MoveChild1,
/* 16378*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16381*/    OPC_RecordChild0, // #1 = $v1
/* 16382*/    OPC_RecordChild1, // #2 = $v2
/* 16383*/    OPC_MoveParent,
/* 16384*/    OPC_MoveParent,
/* 16385*/    OPC_CheckType, MVT::v16i8,
/* 16387*/    OPC_Scope, 11, /*->16400*/ // 2 children in Scope
/* 16389*/     OPC_CheckChild1Same, 2,
/* 16391*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v16i8, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2)), V128:{ *:[v16i8] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 16400*/    /*Scope*/ 11, /*->16412*/
/* 16401*/     OPC_CheckChild1Same, 1,
/* 16403*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v16i8, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1)), V128:{ *:[v16i8] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 16412*/    0, /*End of Scope*/
/* 16413*/   0, /*End of Scope*/
/* 16414*/  /*Scope*/ 109, /*->16524*/
/* 16415*/   OPC_RecordChild0, // #0 = $v2
/* 16416*/   OPC_MoveChild1,
/* 16417*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 16420*/   OPC_MoveChild0,
/* 16421*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16424*/   OPC_Scope, 25, /*->16451*/ // 3 children in Scope
/* 16426*/    OPC_RecordChild0, // #1 = $v1
/* 16427*/    OPC_CheckChild1Same, 0,
/* 16429*/    OPC_MoveParent,
/* 16430*/    OPC_MoveChild1,
/* 16431*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16434*/    OPC_RecordChild0, // #2 = $c
/* 16435*/    OPC_MoveChild1,
/* 16436*/    OPC_CheckImmAllOnesV,
/* 16437*/    OPC_MoveParent,
/* 16438*/    OPC_MoveParent,
/* 16439*/    OPC_MoveParent,
/* 16440*/    OPC_CheckType, MVT::v16i8,
/* 16442*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                  MVT::v16i8, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 16451*/   /*Scope*/ 25, /*->16477*/
/* 16452*/    OPC_CheckChild0Same, 0,
/* 16454*/    OPC_RecordChild1, // #1 = $v1
/* 16455*/    OPC_MoveParent,
/* 16456*/    OPC_MoveChild1,
/* 16457*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16460*/    OPC_RecordChild0, // #2 = $c
/* 16461*/    OPC_MoveChild1,
/* 16462*/    OPC_CheckImmAllOnesV,
/* 16463*/    OPC_MoveParent,
/* 16464*/    OPC_MoveParent,
/* 16465*/    OPC_MoveParent,
/* 16466*/    OPC_CheckType, MVT::v16i8,
/* 16468*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                  MVT::v16i8, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 16477*/   /*Scope*/ 45, /*->16523*/
/* 16478*/    OPC_RecordChild0, // #1 = $c
/* 16479*/    OPC_MoveChild1,
/* 16480*/    OPC_CheckImmAllOnesV,
/* 16481*/    OPC_MoveParent,
/* 16482*/    OPC_MoveParent,
/* 16483*/    OPC_MoveChild1,
/* 16484*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16487*/    OPC_Scope, 16, /*->16505*/ // 2 children in Scope
/* 16489*/     OPC_RecordChild0, // #2 = $v1
/* 16490*/     OPC_CheckChild1Same, 0,
/* 16492*/     OPC_MoveParent,
/* 16493*/     OPC_MoveParent,
/* 16494*/     OPC_CheckType, MVT::v16i8,
/* 16496*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v16i8, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 16505*/    /*Scope*/ 16, /*->16522*/
/* 16506*/     OPC_CheckChild0Same, 0,
/* 16508*/     OPC_RecordChild1, // #2 = $v1
/* 16509*/     OPC_MoveParent,
/* 16510*/     OPC_MoveParent,
/* 16511*/     OPC_CheckType, MVT::v16i8,
/* 16513*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v16i8, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 16522*/    0, /*End of Scope*/
/* 16523*/   0, /*End of Scope*/
/* 16524*/  /*Scope*/ 78, /*->16603*/
/* 16525*/   OPC_MoveChild0,
/* 16526*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 16529*/   OPC_MoveChild0,
/* 16530*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16533*/   OPC_RecordChild0, // #0 = $v2
/* 16534*/   OPC_Scope, 25, /*->16561*/ // 2 children in Scope
/* 16536*/    OPC_RecordChild1, // #1 = $v1
/* 16537*/    OPC_MoveParent,
/* 16538*/    OPC_MoveChild1,
/* 16539*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16542*/    OPC_RecordChild0, // #2 = $c
/* 16543*/    OPC_MoveChild1,
/* 16544*/    OPC_CheckImmAllOnesV,
/* 16545*/    OPC_MoveParent,
/* 16546*/    OPC_MoveParent,
/* 16547*/    OPC_MoveParent,
/* 16548*/    OPC_CheckChild1Same, 0,
/* 16550*/    OPC_CheckType, MVT::v8i16,
/* 16552*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                  MVT::v8i16, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] })), V128:{ *:[v8i16] }:$v2) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 16561*/   /*Scope*/ 40, /*->16602*/
/* 16562*/    OPC_MoveChild1,
/* 16563*/    OPC_CheckImmAllOnesV,
/* 16564*/    OPC_MoveParent,
/* 16565*/    OPC_MoveParent,
/* 16566*/    OPC_MoveChild1,
/* 16567*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16570*/    OPC_RecordChild0, // #1 = $v1
/* 16571*/    OPC_RecordChild1, // #2 = $v2
/* 16572*/    OPC_MoveParent,
/* 16573*/    OPC_MoveParent,
/* 16574*/    OPC_CheckType, MVT::v8i16,
/* 16576*/    OPC_Scope, 11, /*->16589*/ // 2 children in Scope
/* 16578*/     OPC_CheckChild1Same, 2,
/* 16580*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v8i16, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2)), V128:{ *:[v8i16] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 16589*/    /*Scope*/ 11, /*->16601*/
/* 16590*/     OPC_CheckChild1Same, 1,
/* 16592*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v8i16, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1)), V128:{ *:[v8i16] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 16601*/    0, /*End of Scope*/
/* 16602*/   0, /*End of Scope*/
/* 16603*/  /*Scope*/ 109, /*->16713*/
/* 16604*/   OPC_RecordChild0, // #0 = $v2
/* 16605*/   OPC_MoveChild1,
/* 16606*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 16609*/   OPC_MoveChild0,
/* 16610*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16613*/   OPC_Scope, 25, /*->16640*/ // 3 children in Scope
/* 16615*/    OPC_RecordChild0, // #1 = $v1
/* 16616*/    OPC_CheckChild1Same, 0,
/* 16618*/    OPC_MoveParent,
/* 16619*/    OPC_MoveChild1,
/* 16620*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16623*/    OPC_RecordChild0, // #2 = $c
/* 16624*/    OPC_MoveChild1,
/* 16625*/    OPC_CheckImmAllOnesV,
/* 16626*/    OPC_MoveParent,
/* 16627*/    OPC_MoveParent,
/* 16628*/    OPC_MoveParent,
/* 16629*/    OPC_CheckType, MVT::v8i16,
/* 16631*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                  MVT::v8i16, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 16640*/   /*Scope*/ 25, /*->16666*/
/* 16641*/    OPC_CheckChild0Same, 0,
/* 16643*/    OPC_RecordChild1, // #1 = $v1
/* 16644*/    OPC_MoveParent,
/* 16645*/    OPC_MoveChild1,
/* 16646*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16649*/    OPC_RecordChild0, // #2 = $c
/* 16650*/    OPC_MoveChild1,
/* 16651*/    OPC_CheckImmAllOnesV,
/* 16652*/    OPC_MoveParent,
/* 16653*/    OPC_MoveParent,
/* 16654*/    OPC_MoveParent,
/* 16655*/    OPC_CheckType, MVT::v8i16,
/* 16657*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                  MVT::v8i16, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 16666*/   /*Scope*/ 45, /*->16712*/
/* 16667*/    OPC_RecordChild0, // #1 = $c
/* 16668*/    OPC_MoveChild1,
/* 16669*/    OPC_CheckImmAllOnesV,
/* 16670*/    OPC_MoveParent,
/* 16671*/    OPC_MoveParent,
/* 16672*/    OPC_MoveChild1,
/* 16673*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16676*/    OPC_Scope, 16, /*->16694*/ // 2 children in Scope
/* 16678*/     OPC_RecordChild0, // #2 = $v1
/* 16679*/     OPC_CheckChild1Same, 0,
/* 16681*/     OPC_MoveParent,
/* 16682*/     OPC_MoveParent,
/* 16683*/     OPC_CheckType, MVT::v8i16,
/* 16685*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v8i16, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 16694*/    /*Scope*/ 16, /*->16711*/
/* 16695*/     OPC_CheckChild0Same, 0,
/* 16697*/     OPC_RecordChild1, // #2 = $v1
/* 16698*/     OPC_MoveParent,
/* 16699*/     OPC_MoveParent,
/* 16700*/     OPC_CheckType, MVT::v8i16,
/* 16702*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v8i16, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 16711*/    0, /*End of Scope*/
/* 16712*/   0, /*End of Scope*/
/* 16713*/  /*Scope*/ 78, /*->16792*/
/* 16714*/   OPC_MoveChild0,
/* 16715*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 16718*/   OPC_MoveChild0,
/* 16719*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16722*/   OPC_RecordChild0, // #0 = $v2
/* 16723*/   OPC_Scope, 25, /*->16750*/ // 2 children in Scope
/* 16725*/    OPC_RecordChild1, // #1 = $v1
/* 16726*/    OPC_MoveParent,
/* 16727*/    OPC_MoveChild1,
/* 16728*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16731*/    OPC_RecordChild0, // #2 = $c
/* 16732*/    OPC_MoveChild1,
/* 16733*/    OPC_CheckImmAllOnesV,
/* 16734*/    OPC_MoveParent,
/* 16735*/    OPC_MoveParent,
/* 16736*/    OPC_MoveParent,
/* 16737*/    OPC_CheckChild1Same, 0,
/* 16739*/    OPC_CheckType, MVT::v4i32,
/* 16741*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                  MVT::v4i32, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] })), V128:{ *:[v4i32] }:$v2) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 16750*/   /*Scope*/ 40, /*->16791*/
/* 16751*/    OPC_MoveChild1,
/* 16752*/    OPC_CheckImmAllOnesV,
/* 16753*/    OPC_MoveParent,
/* 16754*/    OPC_MoveParent,
/* 16755*/    OPC_MoveChild1,
/* 16756*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16759*/    OPC_RecordChild0, // #1 = $v1
/* 16760*/    OPC_RecordChild1, // #2 = $v2
/* 16761*/    OPC_MoveParent,
/* 16762*/    OPC_MoveParent,
/* 16763*/    OPC_CheckType, MVT::v4i32,
/* 16765*/    OPC_Scope, 11, /*->16778*/ // 2 children in Scope
/* 16767*/     OPC_CheckChild1Same, 2,
/* 16769*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v4i32, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2)), V128:{ *:[v4i32] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 16778*/    /*Scope*/ 11, /*->16790*/
/* 16779*/     OPC_CheckChild1Same, 1,
/* 16781*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v4i32, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1)), V128:{ *:[v4i32] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 16790*/    0, /*End of Scope*/
/* 16791*/   0, /*End of Scope*/
/* 16792*/  /*Scope*/ 109, /*->16902*/
/* 16793*/   OPC_RecordChild0, // #0 = $v2
/* 16794*/   OPC_MoveChild1,
/* 16795*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 16798*/   OPC_MoveChild0,
/* 16799*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16802*/   OPC_Scope, 25, /*->16829*/ // 3 children in Scope
/* 16804*/    OPC_RecordChild0, // #1 = $v1
/* 16805*/    OPC_CheckChild1Same, 0,
/* 16807*/    OPC_MoveParent,
/* 16808*/    OPC_MoveChild1,
/* 16809*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16812*/    OPC_RecordChild0, // #2 = $c
/* 16813*/    OPC_MoveChild1,
/* 16814*/    OPC_CheckImmAllOnesV,
/* 16815*/    OPC_MoveParent,
/* 16816*/    OPC_MoveParent,
/* 16817*/    OPC_MoveParent,
/* 16818*/    OPC_CheckType, MVT::v4i32,
/* 16820*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                  MVT::v4i32, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 16829*/   /*Scope*/ 25, /*->16855*/
/* 16830*/    OPC_CheckChild0Same, 0,
/* 16832*/    OPC_RecordChild1, // #1 = $v1
/* 16833*/    OPC_MoveParent,
/* 16834*/    OPC_MoveChild1,
/* 16835*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16838*/    OPC_RecordChild0, // #2 = $c
/* 16839*/    OPC_MoveChild1,
/* 16840*/    OPC_CheckImmAllOnesV,
/* 16841*/    OPC_MoveParent,
/* 16842*/    OPC_MoveParent,
/* 16843*/    OPC_MoveParent,
/* 16844*/    OPC_CheckType, MVT::v4i32,
/* 16846*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                  MVT::v4i32, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 16855*/   /*Scope*/ 45, /*->16901*/
/* 16856*/    OPC_RecordChild0, // #1 = $c
/* 16857*/    OPC_MoveChild1,
/* 16858*/    OPC_CheckImmAllOnesV,
/* 16859*/    OPC_MoveParent,
/* 16860*/    OPC_MoveParent,
/* 16861*/    OPC_MoveChild1,
/* 16862*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16865*/    OPC_Scope, 16, /*->16883*/ // 2 children in Scope
/* 16867*/     OPC_RecordChild0, // #2 = $v1
/* 16868*/     OPC_CheckChild1Same, 0,
/* 16870*/     OPC_MoveParent,
/* 16871*/     OPC_MoveParent,
/* 16872*/     OPC_CheckType, MVT::v4i32,
/* 16874*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v4i32, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 16883*/    /*Scope*/ 16, /*->16900*/
/* 16884*/     OPC_CheckChild0Same, 0,
/* 16886*/     OPC_RecordChild1, // #2 = $v1
/* 16887*/     OPC_MoveParent,
/* 16888*/     OPC_MoveParent,
/* 16889*/     OPC_CheckType, MVT::v4i32,
/* 16891*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v4i32, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 16900*/    0, /*End of Scope*/
/* 16901*/   0, /*End of Scope*/
/* 16902*/  /*Scope*/ 78, /*->16981*/
/* 16903*/   OPC_MoveChild0,
/* 16904*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 16907*/   OPC_MoveChild0,
/* 16908*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16911*/   OPC_RecordChild0, // #0 = $v2
/* 16912*/   OPC_Scope, 25, /*->16939*/ // 2 children in Scope
/* 16914*/    OPC_RecordChild1, // #1 = $v1
/* 16915*/    OPC_MoveParent,
/* 16916*/    OPC_MoveChild1,
/* 16917*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16920*/    OPC_RecordChild0, // #2 = $c
/* 16921*/    OPC_MoveChild1,
/* 16922*/    OPC_CheckImmAllOnesV,
/* 16923*/    OPC_MoveParent,
/* 16924*/    OPC_MoveParent,
/* 16925*/    OPC_MoveParent,
/* 16926*/    OPC_CheckChild1Same, 0,
/* 16928*/    OPC_CheckType, MVT::v2i64,
/* 16930*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                  MVT::v2i64, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] })), V128:{ *:[v2i64] }:$v2) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 16939*/   /*Scope*/ 40, /*->16980*/
/* 16940*/    OPC_MoveChild1,
/* 16941*/    OPC_CheckImmAllOnesV,
/* 16942*/    OPC_MoveParent,
/* 16943*/    OPC_MoveParent,
/* 16944*/    OPC_MoveChild1,
/* 16945*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16948*/    OPC_RecordChild0, // #1 = $v1
/* 16949*/    OPC_RecordChild1, // #2 = $v2
/* 16950*/    OPC_MoveParent,
/* 16951*/    OPC_MoveParent,
/* 16952*/    OPC_CheckType, MVT::v2i64,
/* 16954*/    OPC_Scope, 11, /*->16967*/ // 2 children in Scope
/* 16956*/     OPC_CheckChild1Same, 2,
/* 16958*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v2i64, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2)), V128:{ *:[v2i64] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 16967*/    /*Scope*/ 11, /*->16979*/
/* 16968*/     OPC_CheckChild1Same, 1,
/* 16970*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v2i64, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1)), V128:{ *:[v2i64] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 16979*/    0, /*End of Scope*/
/* 16980*/   0, /*End of Scope*/
/* 16981*/  /*Scope*/ 109, /*->17091*/
/* 16982*/   OPC_RecordChild0, // #0 = $v2
/* 16983*/   OPC_MoveChild1,
/* 16984*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 16987*/   OPC_MoveChild0,
/* 16988*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16991*/   OPC_Scope, 25, /*->17018*/ // 3 children in Scope
/* 16993*/    OPC_RecordChild0, // #1 = $v1
/* 16994*/    OPC_CheckChild1Same, 0,
/* 16996*/    OPC_MoveParent,
/* 16997*/    OPC_MoveChild1,
/* 16998*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 17001*/    OPC_RecordChild0, // #2 = $c
/* 17002*/    OPC_MoveChild1,
/* 17003*/    OPC_CheckImmAllOnesV,
/* 17004*/    OPC_MoveParent,
/* 17005*/    OPC_MoveParent,
/* 17006*/    OPC_MoveParent,
/* 17007*/    OPC_CheckType, MVT::v2i64,
/* 17009*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                  MVT::v2i64, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 17018*/   /*Scope*/ 25, /*->17044*/
/* 17019*/    OPC_CheckChild0Same, 0,
/* 17021*/    OPC_RecordChild1, // #1 = $v1
/* 17022*/    OPC_MoveParent,
/* 17023*/    OPC_MoveChild1,
/* 17024*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 17027*/    OPC_RecordChild0, // #2 = $c
/* 17028*/    OPC_MoveChild1,
/* 17029*/    OPC_CheckImmAllOnesV,
/* 17030*/    OPC_MoveParent,
/* 17031*/    OPC_MoveParent,
/* 17032*/    OPC_MoveParent,
/* 17033*/    OPC_CheckType, MVT::v2i64,
/* 17035*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                  MVT::v2i64, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 17044*/   /*Scope*/ 45, /*->17090*/
/* 17045*/    OPC_RecordChild0, // #1 = $c
/* 17046*/    OPC_MoveChild1,
/* 17047*/    OPC_CheckImmAllOnesV,
/* 17048*/    OPC_MoveParent,
/* 17049*/    OPC_MoveParent,
/* 17050*/    OPC_MoveChild1,
/* 17051*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 17054*/    OPC_Scope, 16, /*->17072*/ // 2 children in Scope
/* 17056*/     OPC_RecordChild0, // #2 = $v1
/* 17057*/     OPC_CheckChild1Same, 0,
/* 17059*/     OPC_MoveParent,
/* 17060*/     OPC_MoveParent,
/* 17061*/     OPC_CheckType, MVT::v2i64,
/* 17063*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v2i64, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 17072*/    /*Scope*/ 16, /*->17089*/
/* 17073*/     OPC_CheckChild0Same, 0,
/* 17075*/     OPC_RecordChild1, // #2 = $v1
/* 17076*/     OPC_MoveParent,
/* 17077*/     OPC_MoveParent,
/* 17078*/     OPC_CheckType, MVT::v2i64,
/* 17080*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v2i64, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 17089*/    0, /*End of Scope*/
/* 17090*/   0, /*End of Scope*/
/* 17091*/  /*Scope*/ 119, /*->17211*/
/* 17092*/   OPC_MoveChild0,
/* 17093*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 17096*/   OPC_Scope, 74, /*->17172*/ // 2 children in Scope
/* 17098*/    OPC_MoveChild0,
/* 17099*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 17102*/    OPC_RecordChild0, // #0 = $v1
/* 17103*/    OPC_RecordChild1, // #1 = $v2
/* 17104*/    OPC_MoveParent,
/* 17105*/    OPC_RecordChild1, // #2 = $c
/* 17106*/    OPC_MoveParent,
/* 17107*/    OPC_Scope, 48, /*->17157*/ // 2 children in Scope
/* 17109*/     OPC_CheckChild1Same, 1,
/* 17111*/     OPC_SwitchType /*4 cases */, 9, MVT::v16i8,// ->17123
/* 17114*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                    MVT::v16i8, 3/*#Ops*/, 0, 1, 2, 
                // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2), V128:{ *:[v16i8] }:$c), V128:{ *:[v16i8] }:$v2) - Complexity = 9
                // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 17123*/     /*SwitchType*/ 9, MVT::v8i16,// ->17134
/* 17125*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                    MVT::v8i16, 3/*#Ops*/, 0, 1, 2, 
                // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2), V128:{ *:[v8i16] }:$c), V128:{ *:[v8i16] }:$v2) - Complexity = 9
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 17134*/     /*SwitchType*/ 9, MVT::v4i32,// ->17145
/* 17136*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                    MVT::v4i32, 3/*#Ops*/, 0, 1, 2, 
                // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2), V128:{ *:[v4i32] }:$c), V128:{ *:[v4i32] }:$v2) - Complexity = 9
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 17145*/     /*SwitchType*/ 9, MVT::v2i64,// ->17156
/* 17147*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                    MVT::v2i64, 3/*#Ops*/, 0, 1, 2, 
                // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2), V128:{ *:[v2i64] }:$c), V128:{ *:[v2i64] }:$v2) - Complexity = 9
                // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 17156*/     0, // EndSwitchType
/* 17157*/    /*Scope*/ 13, /*->17171*/
/* 17158*/     OPC_CheckChild1Same, 0,
/* 17160*/     OPC_CheckType, MVT::v16i8,
/* 17162*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v16i8, 3/*#Ops*/, 1, 0, 2, 
               // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1), V128:{ *:[v16i8] }:$c), V128:{ *:[v16i8] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 17171*/    0, /*End of Scope*/
/* 17172*/   /*Scope*/ 37, /*->17210*/
/* 17173*/    OPC_RecordChild0, // #0 = $c
/* 17174*/    OPC_MoveChild1,
/* 17175*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 17178*/    OPC_RecordChild0, // #1 = $v1
/* 17179*/    OPC_RecordChild1, // #2 = $v2
/* 17180*/    OPC_MoveParent,
/* 17181*/    OPC_MoveParent,
/* 17182*/    OPC_CheckType, MVT::v16i8,
/* 17184*/    OPC_Scope, 11, /*->17197*/ // 2 children in Scope
/* 17186*/     OPC_CheckChild1Same, 2,
/* 17188*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v16i8, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2)), V128:{ *:[v16i8] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 17197*/    /*Scope*/ 11, /*->17209*/
/* 17198*/     OPC_CheckChild1Same, 1,
/* 17200*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v16i8, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1)), V128:{ *:[v16i8] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 17209*/    0, /*End of Scope*/
/* 17210*/   0, /*End of Scope*/
/* 17211*/  /*Scope*/ 92, /*->17304*/
/* 17212*/   OPC_RecordChild0, // #0 = $v2
/* 17213*/   OPC_MoveChild1,
/* 17214*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 17217*/   OPC_Scope, 42, /*->17261*/ // 2 children in Scope
/* 17219*/    OPC_MoveChild0,
/* 17220*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 17223*/    OPC_Scope, 17, /*->17242*/ // 2 children in Scope
/* 17225*/     OPC_RecordChild0, // #1 = $v1
/* 17226*/     OPC_CheckChild1Same, 0,
/* 17228*/     OPC_MoveParent,
/* 17229*/     OPC_RecordChild1, // #2 = $c
/* 17230*/     OPC_MoveParent,
/* 17231*/     OPC_CheckType, MVT::v16i8,
/* 17233*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v16i8, 3/*#Ops*/, 1, 0, 2, 
               // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2), V128:{ *:[v16i8] }:$c)) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 17242*/    /*Scope*/ 17, /*->17260*/
/* 17243*/     OPC_CheckChild0Same, 0,
/* 17245*/     OPC_RecordChild1, // #1 = $v1
/* 17246*/     OPC_MoveParent,
/* 17247*/     OPC_RecordChild1, // #2 = $c
/* 17248*/     OPC_MoveParent,
/* 17249*/     OPC_CheckType, MVT::v16i8,
/* 17251*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v16i8, 3/*#Ops*/, 1, 0, 2, 
               // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1), V128:{ *:[v16i8] }:$c)) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 17260*/    0, /*End of Scope*/
/* 17261*/   /*Scope*/ 41, /*->17303*/
/* 17262*/    OPC_RecordChild0, // #1 = $c
/* 17263*/    OPC_MoveChild1,
/* 17264*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 17267*/    OPC_Scope, 16, /*->17285*/ // 2 children in Scope
/* 17269*/     OPC_RecordChild0, // #2 = $v1
/* 17270*/     OPC_CheckChild1Same, 0,
/* 17272*/     OPC_MoveParent,
/* 17273*/     OPC_MoveParent,
/* 17274*/     OPC_CheckType, MVT::v16i8,
/* 17276*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v16i8, 3/*#Ops*/, 2, 0, 1, 
               // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2))) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 17285*/    /*Scope*/ 16, /*->17302*/
/* 17286*/     OPC_CheckChild0Same, 0,
/* 17288*/     OPC_RecordChild1, // #2 = $v1
/* 17289*/     OPC_MoveParent,
/* 17290*/     OPC_MoveParent,
/* 17291*/     OPC_CheckType, MVT::v16i8,
/* 17293*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v16i8, 3/*#Ops*/, 2, 0, 1, 
               // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1))) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 17302*/    0, /*End of Scope*/
/* 17303*/   0, /*End of Scope*/
/* 17304*/  /*Scope*/ 67, /*->17372*/
/* 17305*/   OPC_MoveChild0,
/* 17306*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 17309*/   OPC_Scope, 22, /*->17333*/ // 2 children in Scope
/* 17311*/    OPC_MoveChild0,
/* 17312*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 17315*/    OPC_RecordChild0, // #0 = $v2
/* 17316*/    OPC_RecordChild1, // #1 = $v1
/* 17317*/    OPC_MoveParent,
/* 17318*/    OPC_RecordChild1, // #2 = $c
/* 17319*/    OPC_MoveParent,
/* 17320*/    OPC_CheckChild1Same, 0,
/* 17322*/    OPC_CheckType, MVT::v8i16,
/* 17324*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                  MVT::v8i16, 3/*#Ops*/, 1, 0, 2, 
              // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1), V128:{ *:[v8i16] }:$c), V128:{ *:[v8i16] }:$v2) - Complexity = 9
              // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 17333*/   /*Scope*/ 37, /*->17371*/
/* 17334*/    OPC_RecordChild0, // #0 = $c
/* 17335*/    OPC_MoveChild1,
/* 17336*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 17339*/    OPC_RecordChild0, // #1 = $v1
/* 17340*/    OPC_RecordChild1, // #2 = $v2
/* 17341*/    OPC_MoveParent,
/* 17342*/    OPC_MoveParent,
/* 17343*/    OPC_CheckType, MVT::v8i16,
/* 17345*/    OPC_Scope, 11, /*->17358*/ // 2 children in Scope
/* 17347*/     OPC_CheckChild1Same, 2,
/* 17349*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v8i16, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2)), V128:{ *:[v8i16] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 17358*/    /*Scope*/ 11, /*->17370*/
/* 17359*/     OPC_CheckChild1Same, 1,
/* 17361*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v8i16, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1)), V128:{ *:[v8i16] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 17370*/    0, /*End of Scope*/
/* 17371*/   0, /*End of Scope*/
/* 17372*/  /*Scope*/ 92, /*->17465*/
/* 17373*/   OPC_RecordChild0, // #0 = $v2
/* 17374*/   OPC_MoveChild1,
/* 17375*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 17378*/   OPC_Scope, 42, /*->17422*/ // 2 children in Scope
/* 17380*/    OPC_MoveChild0,
/* 17381*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 17384*/    OPC_Scope, 17, /*->17403*/ // 2 children in Scope
/* 17386*/     OPC_RecordChild0, // #1 = $v1
/* 17387*/     OPC_CheckChild1Same, 0,
/* 17389*/     OPC_MoveParent,
/* 17390*/     OPC_RecordChild1, // #2 = $c
/* 17391*/     OPC_MoveParent,
/* 17392*/     OPC_CheckType, MVT::v8i16,
/* 17394*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v8i16, 3/*#Ops*/, 1, 0, 2, 
               // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2), V128:{ *:[v8i16] }:$c)) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 17403*/    /*Scope*/ 17, /*->17421*/
/* 17404*/     OPC_CheckChild0Same, 0,
/* 17406*/     OPC_RecordChild1, // #1 = $v1
/* 17407*/     OPC_MoveParent,
/* 17408*/     OPC_RecordChild1, // #2 = $c
/* 17409*/     OPC_MoveParent,
/* 17410*/     OPC_CheckType, MVT::v8i16,
/* 17412*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v8i16, 3/*#Ops*/, 1, 0, 2, 
               // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1), V128:{ *:[v8i16] }:$c)) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 17421*/    0, /*End of Scope*/
/* 17422*/   /*Scope*/ 41, /*->17464*/
/* 17423*/    OPC_RecordChild0, // #1 = $c
/* 17424*/    OPC_MoveChild1,
/* 17425*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 17428*/    OPC_Scope, 16, /*->17446*/ // 2 children in Scope
/* 17430*/     OPC_RecordChild0, // #2 = $v1
/* 17431*/     OPC_CheckChild1Same, 0,
/* 17433*/     OPC_MoveParent,
/* 17434*/     OPC_MoveParent,
/* 17435*/     OPC_CheckType, MVT::v8i16,
/* 17437*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v8i16, 3/*#Ops*/, 2, 0, 1, 
               // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2))) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 17446*/    /*Scope*/ 16, /*->17463*/
/* 17447*/     OPC_CheckChild0Same, 0,
/* 17449*/     OPC_RecordChild1, // #2 = $v1
/* 17450*/     OPC_MoveParent,
/* 17451*/     OPC_MoveParent,
/* 17452*/     OPC_CheckType, MVT::v8i16,
/* 17454*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v8i16, 3/*#Ops*/, 2, 0, 1, 
               // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1))) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 17463*/    0, /*End of Scope*/
/* 17464*/   0, /*End of Scope*/
/* 17465*/  /*Scope*/ 67, /*->17533*/
/* 17466*/   OPC_MoveChild0,
/* 17467*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 17470*/   OPC_Scope, 22, /*->17494*/ // 2 children in Scope
/* 17472*/    OPC_MoveChild0,
/* 17473*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 17476*/    OPC_RecordChild0, // #0 = $v2
/* 17477*/    OPC_RecordChild1, // #1 = $v1
/* 17478*/    OPC_MoveParent,
/* 17479*/    OPC_RecordChild1, // #2 = $c
/* 17480*/    OPC_MoveParent,
/* 17481*/    OPC_CheckChild1Same, 0,
/* 17483*/    OPC_CheckType, MVT::v4i32,
/* 17485*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                  MVT::v4i32, 3/*#Ops*/, 1, 0, 2, 
              // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1), V128:{ *:[v4i32] }:$c), V128:{ *:[v4i32] }:$v2) - Complexity = 9
              // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 17494*/   /*Scope*/ 37, /*->17532*/
/* 17495*/    OPC_RecordChild0, // #0 = $c
/* 17496*/    OPC_MoveChild1,
/* 17497*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 17500*/    OPC_RecordChild0, // #1 = $v1
/* 17501*/    OPC_RecordChild1, // #2 = $v2
/* 17502*/    OPC_MoveParent,
/* 17503*/    OPC_MoveParent,
/* 17504*/    OPC_CheckType, MVT::v4i32,
/* 17506*/    OPC_Scope, 11, /*->17519*/ // 2 children in Scope
/* 17508*/     OPC_CheckChild1Same, 2,
/* 17510*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v4i32, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2)), V128:{ *:[v4i32] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 17519*/    /*Scope*/ 11, /*->17531*/
/* 17520*/     OPC_CheckChild1Same, 1,
/* 17522*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v4i32, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1)), V128:{ *:[v4i32] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 17531*/    0, /*End of Scope*/
/* 17532*/   0, /*End of Scope*/
/* 17533*/  /*Scope*/ 92, /*->17626*/
/* 17534*/   OPC_RecordChild0, // #0 = $v2
/* 17535*/   OPC_MoveChild1,
/* 17536*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 17539*/   OPC_Scope, 42, /*->17583*/ // 2 children in Scope
/* 17541*/    OPC_MoveChild0,
/* 17542*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 17545*/    OPC_Scope, 17, /*->17564*/ // 2 children in Scope
/* 17547*/     OPC_RecordChild0, // #1 = $v1
/* 17548*/     OPC_CheckChild1Same, 0,
/* 17550*/     OPC_MoveParent,
/* 17551*/     OPC_RecordChild1, // #2 = $c
/* 17552*/     OPC_MoveParent,
/* 17553*/     OPC_CheckType, MVT::v4i32,
/* 17555*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v4i32, 3/*#Ops*/, 1, 0, 2, 
               // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2), V128:{ *:[v4i32] }:$c)) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 17564*/    /*Scope*/ 17, /*->17582*/
/* 17565*/     OPC_CheckChild0Same, 0,
/* 17567*/     OPC_RecordChild1, // #1 = $v1
/* 17568*/     OPC_MoveParent,
/* 17569*/     OPC_RecordChild1, // #2 = $c
/* 17570*/     OPC_MoveParent,
/* 17571*/     OPC_CheckType, MVT::v4i32,
/* 17573*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v4i32, 3/*#Ops*/, 1, 0, 2, 
               // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1), V128:{ *:[v4i32] }:$c)) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 17582*/    0, /*End of Scope*/
/* 17583*/   /*Scope*/ 41, /*->17625*/
/* 17584*/    OPC_RecordChild0, // #1 = $c
/* 17585*/    OPC_MoveChild1,
/* 17586*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 17589*/    OPC_Scope, 16, /*->17607*/ // 2 children in Scope
/* 17591*/     OPC_RecordChild0, // #2 = $v1
/* 17592*/     OPC_CheckChild1Same, 0,
/* 17594*/     OPC_MoveParent,
/* 17595*/     OPC_MoveParent,
/* 17596*/     OPC_CheckType, MVT::v4i32,
/* 17598*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v4i32, 3/*#Ops*/, 2, 0, 1, 
               // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2))) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 17607*/    /*Scope*/ 16, /*->17624*/
/* 17608*/     OPC_CheckChild0Same, 0,
/* 17610*/     OPC_RecordChild1, // #2 = $v1
/* 17611*/     OPC_MoveParent,
/* 17612*/     OPC_MoveParent,
/* 17613*/     OPC_CheckType, MVT::v4i32,
/* 17615*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v4i32, 3/*#Ops*/, 2, 0, 1, 
               // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1))) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 17624*/    0, /*End of Scope*/
/* 17625*/   0, /*End of Scope*/
/* 17626*/  /*Scope*/ 67, /*->17694*/
/* 17627*/   OPC_MoveChild0,
/* 17628*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 17631*/   OPC_Scope, 22, /*->17655*/ // 2 children in Scope
/* 17633*/    OPC_MoveChild0,
/* 17634*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 17637*/    OPC_RecordChild0, // #0 = $v2
/* 17638*/    OPC_RecordChild1, // #1 = $v1
/* 17639*/    OPC_MoveParent,
/* 17640*/    OPC_RecordChild1, // #2 = $c
/* 17641*/    OPC_MoveParent,
/* 17642*/    OPC_CheckChild1Same, 0,
/* 17644*/    OPC_CheckType, MVT::v2i64,
/* 17646*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                  MVT::v2i64, 3/*#Ops*/, 1, 0, 2, 
              // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1), V128:{ *:[v2i64] }:$c), V128:{ *:[v2i64] }:$v2) - Complexity = 9
              // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 17655*/   /*Scope*/ 37, /*->17693*/
/* 17656*/    OPC_RecordChild0, // #0 = $c
/* 17657*/    OPC_MoveChild1,
/* 17658*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 17661*/    OPC_RecordChild0, // #1 = $v1
/* 17662*/    OPC_RecordChild1, // #2 = $v2
/* 17663*/    OPC_MoveParent,
/* 17664*/    OPC_MoveParent,
/* 17665*/    OPC_CheckType, MVT::v2i64,
/* 17667*/    OPC_Scope, 11, /*->17680*/ // 2 children in Scope
/* 17669*/     OPC_CheckChild1Same, 2,
/* 17671*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v2i64, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2)), V128:{ *:[v2i64] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 17680*/    /*Scope*/ 11, /*->17692*/
/* 17681*/     OPC_CheckChild1Same, 1,
/* 17683*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v2i64, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1)), V128:{ *:[v2i64] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 17692*/    0, /*End of Scope*/
/* 17693*/   0, /*End of Scope*/
/* 17694*/  /*Scope*/ 56|128,1/*184*/, /*->17880*/
/* 17696*/   OPC_RecordChild0, // #0 = $v2
/* 17697*/   OPC_Scope, 7|128,1/*135*/, /*->17835*/ // 2 children in Scope
/* 17700*/    OPC_MoveChild1,
/* 17701*/    OPC_Scope, 90, /*->17793*/ // 2 children in Scope
/* 17703*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 17706*/     OPC_Scope, 42, /*->17750*/ // 2 children in Scope
/* 17708*/      OPC_MoveChild0,
/* 17709*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 17712*/      OPC_Scope, 17, /*->17731*/ // 2 children in Scope
/* 17714*/       OPC_RecordChild0, // #1 = $v1
/* 17715*/       OPC_CheckChild1Same, 0,
/* 17717*/       OPC_MoveParent,
/* 17718*/       OPC_RecordChild1, // #2 = $c
/* 17719*/       OPC_MoveParent,
/* 17720*/       OPC_CheckType, MVT::v2i64,
/* 17722*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                     MVT::v2i64, 3/*#Ops*/, 1, 0, 2, 
                 // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2), V128:{ *:[v2i64] }:$c)) - Complexity = 9
                 // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 17731*/      /*Scope*/ 17, /*->17749*/
/* 17732*/       OPC_CheckChild0Same, 0,
/* 17734*/       OPC_RecordChild1, // #1 = $v1
/* 17735*/       OPC_MoveParent,
/* 17736*/       OPC_RecordChild1, // #2 = $c
/* 17737*/       OPC_MoveParent,
/* 17738*/       OPC_CheckType, MVT::v2i64,
/* 17740*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                     MVT::v2i64, 3/*#Ops*/, 1, 0, 2, 
                 // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1), V128:{ *:[v2i64] }:$c)) - Complexity = 9
                 // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 17749*/      0, /*End of Scope*/
/* 17750*/     /*Scope*/ 41, /*->17792*/
/* 17751*/      OPC_RecordChild0, // #1 = $c
/* 17752*/      OPC_MoveChild1,
/* 17753*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 17756*/      OPC_Scope, 16, /*->17774*/ // 2 children in Scope
/* 17758*/       OPC_RecordChild0, // #2 = $v1
/* 17759*/       OPC_CheckChild1Same, 0,
/* 17761*/       OPC_MoveParent,
/* 17762*/       OPC_MoveParent,
/* 17763*/       OPC_CheckType, MVT::v2i64,
/* 17765*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                     MVT::v2i64, 3/*#Ops*/, 2, 0, 1, 
                 // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2))) - Complexity = 9
                 // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 17774*/      /*Scope*/ 16, /*->17791*/
/* 17775*/       OPC_CheckChild0Same, 0,
/* 17777*/       OPC_RecordChild1, // #2 = $v1
/* 17778*/       OPC_MoveParent,
/* 17779*/       OPC_MoveParent,
/* 17780*/       OPC_CheckType, MVT::v2i64,
/* 17782*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                     MVT::v2i64, 3/*#Ops*/, 2, 0, 1, 
                 // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1))) - Complexity = 9
                 // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 17791*/      0, /*End of Scope*/
/* 17792*/     0, /*End of Scope*/
/* 17793*/    /*Scope*/ 40, /*->17834*/
/* 17794*/     OPC_CheckImmAllOnesV,
/* 17795*/     OPC_MoveParent,
/* 17796*/     OPC_SwitchType /*4 cases */, 7, MVT::v16i8,// ->17806
/* 17799*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NOT), 0,
                    MVT::v16i8, 1/*#Ops*/, 0, 
                // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v, immAllOnesV:{ *:[v16i8] }) - Complexity = 7
                // Dst: (NOT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v)
/* 17806*/     /*SwitchType*/ 7, MVT::v8i16,// ->17815
/* 17808*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NOT), 0,
                    MVT::v8i16, 1/*#Ops*/, 0, 
                // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v, immAllOnesV:{ *:[v8i16] }) - Complexity = 7
                // Dst: (NOT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v)
/* 17815*/     /*SwitchType*/ 7, MVT::v4i32,// ->17824
/* 17817*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NOT), 0,
                    MVT::v4i32, 1/*#Ops*/, 0, 
                // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v, immAllOnesV:{ *:[v4i32] }) - Complexity = 7
                // Dst: (NOT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v)
/* 17824*/     /*SwitchType*/ 7, MVT::v2i64,// ->17833
/* 17826*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NOT), 0,
                    MVT::v2i64, 1/*#Ops*/, 0, 
                // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v, immAllOnesV:{ *:[v2i64] }) - Complexity = 7
                // Dst: (NOT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v)
/* 17833*/     0, // EndSwitchType
/* 17834*/    0, /*End of Scope*/
/* 17835*/   /*Scope*/ 43, /*->17879*/
/* 17836*/    OPC_RecordChild1, // #1 = $rhs
/* 17837*/    OPC_SwitchType /*4 cases */, 8, MVT::v16i8,// ->17848
/* 17840*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::XOR), 0,
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
               // Dst: (XOR:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/* 17848*/    /*SwitchType*/ 8, MVT::v8i16,// ->17858
/* 17850*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::XOR), 0,
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
               // Dst: (XOR:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/* 17858*/    /*SwitchType*/ 8, MVT::v4i32,// ->17868
/* 17860*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::XOR), 0,
                   MVT::v4i32, 2/*#Ops*/, 0, 1, 
               // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
               // Dst: (XOR:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/* 17868*/    /*SwitchType*/ 8, MVT::v2i64,// ->17878
/* 17870*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::XOR), 0,
                   MVT::v2i64, 2/*#Ops*/, 0, 1, 
               // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
               // Dst: (XOR:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/* 17878*/    0, // EndSwitchType
/* 17879*/   0, /*End of Scope*/
/* 17880*/  0, /*End of Scope*/
/* 17881*/ /*SwitchOpcode*/ 25, TARGET_VAL(ISD::CTLZ),// ->17909
/* 17884*/  OPC_RecordChild0, // #0 = $src
/* 17885*/  OPC_SwitchType /*2 cases */, 9, MVT::i32,// ->17897
/* 17888*/   OPC_CheckChild0Type, MVT::i32,
/* 17890*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CLZ_I32), 0,
                 MVT::i32, 1/*#Ops*/, 0, 
             // Src: (ctlz:{ *:[i32] } I32:{ *:[i32] }:$src) - Complexity = 3
             // Dst: (CLZ_I32:{ *:[i32] } I32:{ *:[i32] }:$src)
/* 17897*/  /*SwitchType*/ 9, MVT::i64,// ->17908
/* 17899*/   OPC_CheckChild0Type, MVT::i64,
/* 17901*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CLZ_I64), 0,
                 MVT::i64, 1/*#Ops*/, 0, 
             // Src: (ctlz:{ *:[i64] } I64:{ *:[i64] }:$src) - Complexity = 3
             // Dst: (CLZ_I64:{ *:[i64] } I64:{ *:[i64] }:$src)
/* 17908*/  0, // EndSwitchType
/* 17909*/ /*SwitchOpcode*/ 25, TARGET_VAL(ISD::CTTZ),// ->17937
/* 17912*/  OPC_RecordChild0, // #0 = $src
/* 17913*/  OPC_SwitchType /*2 cases */, 9, MVT::i32,// ->17925
/* 17916*/   OPC_CheckChild0Type, MVT::i32,
/* 17918*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CTZ_I32), 0,
                 MVT::i32, 1/*#Ops*/, 0, 
             // Src: (cttz:{ *:[i32] } I32:{ *:[i32] }:$src) - Complexity = 3
             // Dst: (CTZ_I32:{ *:[i32] } I32:{ *:[i32] }:$src)
/* 17925*/  /*SwitchType*/ 9, MVT::i64,// ->17936
/* 17927*/   OPC_CheckChild0Type, MVT::i64,
/* 17929*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CTZ_I64), 0,
                 MVT::i64, 1/*#Ops*/, 0, 
             // Src: (cttz:{ *:[i64] } I64:{ *:[i64] }:$src) - Complexity = 3
             // Dst: (CTZ_I64:{ *:[i64] } I64:{ *:[i64] }:$src)
/* 17936*/  0, // EndSwitchType
/* 17937*/ /*SwitchOpcode*/ 38, TARGET_VAL(ISD::CTPOP),// ->17978
/* 17940*/  OPC_RecordChild0, // #0 = $src
/* 17941*/  OPC_SwitchType /*3 cases */, 9, MVT::i32,// ->17953
/* 17944*/   OPC_CheckChild0Type, MVT::i32,
/* 17946*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::POPCNT_I32), 0,
                 MVT::i32, 1/*#Ops*/, 0, 
             // Src: (ctpop:{ *:[i32] } I32:{ *:[i32] }:$src) - Complexity = 3
             // Dst: (POPCNT_I32:{ *:[i32] } I32:{ *:[i32] }:$src)
/* 17953*/  /*SwitchType*/ 9, MVT::i64,// ->17964
/* 17955*/   OPC_CheckChild0Type, MVT::i64,
/* 17957*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::POPCNT_I64), 0,
                 MVT::i64, 1/*#Ops*/, 0, 
             // Src: (ctpop:{ *:[i64] } I64:{ *:[i64] }:$src) - Complexity = 3
             // Dst: (POPCNT_I64:{ *:[i64] } I64:{ *:[i64] }:$src)
/* 17964*/  /*SwitchType*/ 11, MVT::v16i8,// ->17977
/* 17966*/   OPC_CheckChild0Type, MVT::v16i8,
/* 17968*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 17970*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::POPCNT_I8x16), 0,
                 MVT::v16i8, 1/*#Ops*/, 0, 
             // Src: (ctpop:{ *:[v16i8] } V128:{ *:[v16i8] }:$v) - Complexity = 3
             // Dst: (POPCNT_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$v)
/* 17977*/  0, // EndSwitchType
/* 17978*/ /*SwitchOpcode*/ 8, TARGET_VAL(ISD::TRUNCATE),// ->17989
/* 17981*/  OPC_RecordChild0, // #0 = $src
/* 17982*/  OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I32_WRAP_I64), 0,
                MVT::i32, 1/*#Ops*/, 0, 
            // Src: (trunc:{ *:[i32] } I64:{ *:[i64] }:$src) - Complexity = 3
            // Dst: (I32_WRAP_I64:{ *:[i32] } I64:{ *:[i64] }:$src)
/* 17989*/ /*SwitchOpcode*/ 8, TARGET_VAL(ISD::SIGN_EXTEND),// ->18000
/* 17992*/  OPC_RecordChild0, // #0 = $src
/* 17993*/  OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I64_EXTEND_S_I32), 0,
                MVT::i64, 1/*#Ops*/, 0, 
            // Src: (sext:{ *:[i64] } I32:{ *:[i32] }:$src) - Complexity = 3
            // Dst: (I64_EXTEND_S_I32:{ *:[i64] } I32:{ *:[i32] }:$src)
/* 18000*/ /*SwitchOpcode*/ 121, TARGET_VAL(ISD::FP_TO_SINT),// ->18124
/* 18003*/  OPC_RecordChild0, // #0 = $src
/* 18004*/  OPC_Scope, 52, /*->18058*/ // 3 children in Scope
/* 18006*/   OPC_CheckChild0Type, MVT::f32,
/* 18008*/   OPC_SwitchType /*2 cases */, 22, MVT::i32,// ->18033
/* 18011*/    OPC_Scope, 9, /*->18022*/ // 2 children in Scope
/* 18013*/     OPC_CheckPatternPredicate, 14, // (Subtarget->hasNontrappingFPToInt())
/* 18015*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I32_TRUNC_S_SAT_F32), 0,
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i32] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (I32_TRUNC_S_SAT_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 18022*/    /*Scope*/ 9, /*->18032*/
/* 18023*/     OPC_CheckPatternPredicate, 15, // (!Subtarget->hasNontrappingFPToInt())
/* 18025*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::FP_TO_SINT_I32_F32), 0,
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i32] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (FP_TO_SINT_I32_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 18032*/    0, /*End of Scope*/
/* 18033*/   /*SwitchType*/ 22, MVT::i64,// ->18057
/* 18035*/    OPC_Scope, 9, /*->18046*/ // 2 children in Scope
/* 18037*/     OPC_CheckPatternPredicate, 14, // (Subtarget->hasNontrappingFPToInt())
/* 18039*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I64_TRUNC_S_SAT_F32), 0,
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i64] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (I64_TRUNC_S_SAT_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 18046*/    /*Scope*/ 9, /*->18056*/
/* 18047*/     OPC_CheckPatternPredicate, 15, // (!Subtarget->hasNontrappingFPToInt())
/* 18049*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::FP_TO_SINT_I64_F32), 0,
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i64] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (FP_TO_SINT_I64_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 18056*/    0, /*End of Scope*/
/* 18057*/   0, // EndSwitchType
/* 18058*/  /*Scope*/ 52, /*->18111*/
/* 18059*/   OPC_CheckChild0Type, MVT::f64,
/* 18061*/   OPC_SwitchType /*2 cases */, 22, MVT::i32,// ->18086
/* 18064*/    OPC_Scope, 9, /*->18075*/ // 2 children in Scope
/* 18066*/     OPC_CheckPatternPredicate, 14, // (Subtarget->hasNontrappingFPToInt())
/* 18068*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I32_TRUNC_S_SAT_F64), 0,
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i32] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (I32_TRUNC_S_SAT_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 18075*/    /*Scope*/ 9, /*->18085*/
/* 18076*/     OPC_CheckPatternPredicate, 15, // (!Subtarget->hasNontrappingFPToInt())
/* 18078*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::FP_TO_SINT_I32_F64), 0,
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i32] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (FP_TO_SINT_I32_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 18085*/    0, /*End of Scope*/
/* 18086*/   /*SwitchType*/ 22, MVT::i64,// ->18110
/* 18088*/    OPC_Scope, 9, /*->18099*/ // 2 children in Scope
/* 18090*/     OPC_CheckPatternPredicate, 14, // (Subtarget->hasNontrappingFPToInt())
/* 18092*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I64_TRUNC_S_SAT_F64), 0,
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i64] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (I64_TRUNC_S_SAT_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 18099*/    /*Scope*/ 9, /*->18109*/
/* 18100*/     OPC_CheckPatternPredicate, 15, // (!Subtarget->hasNontrappingFPToInt())
/* 18102*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::FP_TO_SINT_I64_F64), 0,
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i64] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (FP_TO_SINT_I64_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 18109*/    0, /*End of Scope*/
/* 18110*/   0, // EndSwitchType
/* 18111*/  /*Scope*/ 11, /*->18123*/
/* 18112*/   OPC_CheckType, MVT::v4i32,
/* 18114*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 18116*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::fp_to_sint_I32x4), 0,
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (fp_to_sint:{ *:[v4i32] } V128:{ *:[v4f32] }:$vec) - Complexity = 3
             // Dst: (fp_to_sint_I32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$vec)
/* 18123*/  0, /*End of Scope*/
/* 18124*/ /*SwitchOpcode*/ 121, TARGET_VAL(ISD::FP_TO_UINT),// ->18248
/* 18127*/  OPC_RecordChild0, // #0 = $src
/* 18128*/  OPC_Scope, 52, /*->18182*/ // 3 children in Scope
/* 18130*/   OPC_CheckChild0Type, MVT::f32,
/* 18132*/   OPC_SwitchType /*2 cases */, 22, MVT::i32,// ->18157
/* 18135*/    OPC_Scope, 9, /*->18146*/ // 2 children in Scope
/* 18137*/     OPC_CheckPatternPredicate, 14, // (Subtarget->hasNontrappingFPToInt())
/* 18139*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I32_TRUNC_U_SAT_F32), 0,
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i32] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (I32_TRUNC_U_SAT_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 18146*/    /*Scope*/ 9, /*->18156*/
/* 18147*/     OPC_CheckPatternPredicate, 15, // (!Subtarget->hasNontrappingFPToInt())
/* 18149*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::FP_TO_UINT_I32_F32), 0,
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i32] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (FP_TO_UINT_I32_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 18156*/    0, /*End of Scope*/
/* 18157*/   /*SwitchType*/ 22, MVT::i64,// ->18181
/* 18159*/    OPC_Scope, 9, /*->18170*/ // 2 children in Scope
/* 18161*/     OPC_CheckPatternPredicate, 14, // (Subtarget->hasNontrappingFPToInt())
/* 18163*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I64_TRUNC_U_SAT_F32), 0,
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i64] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (I64_TRUNC_U_SAT_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 18170*/    /*Scope*/ 9, /*->18180*/
/* 18171*/     OPC_CheckPatternPredicate, 15, // (!Subtarget->hasNontrappingFPToInt())
/* 18173*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::FP_TO_UINT_I64_F32), 0,
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i64] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (FP_TO_UINT_I64_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 18180*/    0, /*End of Scope*/
/* 18181*/   0, // EndSwitchType
/* 18182*/  /*Scope*/ 52, /*->18235*/
/* 18183*/   OPC_CheckChild0Type, MVT::f64,
/* 18185*/   OPC_SwitchType /*2 cases */, 22, MVT::i32,// ->18210
/* 18188*/    OPC_Scope, 9, /*->18199*/ // 2 children in Scope
/* 18190*/     OPC_CheckPatternPredicate, 14, // (Subtarget->hasNontrappingFPToInt())
/* 18192*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I32_TRUNC_U_SAT_F64), 0,
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i32] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (I32_TRUNC_U_SAT_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 18199*/    /*Scope*/ 9, /*->18209*/
/* 18200*/     OPC_CheckPatternPredicate, 15, // (!Subtarget->hasNontrappingFPToInt())
/* 18202*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::FP_TO_UINT_I32_F64), 0,
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i32] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (FP_TO_UINT_I32_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 18209*/    0, /*End of Scope*/
/* 18210*/   /*SwitchType*/ 22, MVT::i64,// ->18234
/* 18212*/    OPC_Scope, 9, /*->18223*/ // 2 children in Scope
/* 18214*/     OPC_CheckPatternPredicate, 14, // (Subtarget->hasNontrappingFPToInt())
/* 18216*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I64_TRUNC_U_SAT_F64), 0,
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i64] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (I64_TRUNC_U_SAT_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 18223*/    /*Scope*/ 9, /*->18233*/
/* 18224*/     OPC_CheckPatternPredicate, 15, // (!Subtarget->hasNontrappingFPToInt())
/* 18226*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::FP_TO_UINT_I64_F64), 0,
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i64] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (FP_TO_UINT_I64_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 18233*/    0, /*End of Scope*/
/* 18234*/   0, // EndSwitchType
/* 18235*/  /*Scope*/ 11, /*->18247*/
/* 18236*/   OPC_CheckType, MVT::v4i32,
/* 18238*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 18240*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::fp_to_uint_I32x4), 0,
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (fp_to_uint:{ *:[v4i32] } V128:{ *:[v4f32] }:$vec) - Complexity = 3
             // Dst: (fp_to_uint_I32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$vec)
/* 18247*/  0, /*End of Scope*/
/* 18248*/ /*SwitchOpcode*/ 81, TARGET_VAL(ISD::FP_TO_SINT_SAT),// ->18332
/* 18251*/  OPC_RecordChild0, // #0 = $src
/* 18252*/  OPC_Scope, 31, /*->18285*/ // 3 children in Scope
/* 18254*/   OPC_CheckChild0Type, MVT::f32,
/* 18256*/   OPC_MoveChild1,
/* 18257*/   OPC_Scope, 12, /*->18271*/ // 2 children in Scope
/* 18259*/    OPC_CheckValueType, MVT::i32,
/* 18261*/    OPC_MoveParent,
/* 18262*/    OPC_CheckType, MVT::i32,
/* 18264*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I32_TRUNC_S_SAT_F32), 0,
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (fp_to_sint_sat:{ *:[i32] } F32:{ *:[f32] }:$src, i32:{ *:[Other] }) - Complexity = 3
              // Dst: (I32_TRUNC_S_SAT_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 18271*/   /*Scope*/ 12, /*->18284*/
/* 18272*/    OPC_CheckValueType, MVT::i64,
/* 18274*/    OPC_MoveParent,
/* 18275*/    OPC_CheckType, MVT::i64,
/* 18277*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I64_TRUNC_S_SAT_F32), 0,
                  MVT::i64, 1/*#Ops*/, 0, 
              // Src: (fp_to_sint_sat:{ *:[i64] } F32:{ *:[f32] }:$src, i64:{ *:[Other] }) - Complexity = 3
              // Dst: (I64_TRUNC_S_SAT_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 18284*/   0, /*End of Scope*/
/* 18285*/  /*Scope*/ 31, /*->18317*/
/* 18286*/   OPC_CheckChild0Type, MVT::f64,
/* 18288*/   OPC_MoveChild1,
/* 18289*/   OPC_Scope, 12, /*->18303*/ // 2 children in Scope
/* 18291*/    OPC_CheckValueType, MVT::i32,
/* 18293*/    OPC_MoveParent,
/* 18294*/    OPC_CheckType, MVT::i32,
/* 18296*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I32_TRUNC_S_SAT_F64), 0,
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (fp_to_sint_sat:{ *:[i32] } F64:{ *:[f64] }:$src, i32:{ *:[Other] }) - Complexity = 3
              // Dst: (I32_TRUNC_S_SAT_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 18303*/   /*Scope*/ 12, /*->18316*/
/* 18304*/    OPC_CheckValueType, MVT::i64,
/* 18306*/    OPC_MoveParent,
/* 18307*/    OPC_CheckType, MVT::i64,
/* 18309*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I64_TRUNC_S_SAT_F64), 0,
                  MVT::i64, 1/*#Ops*/, 0, 
              // Src: (fp_to_sint_sat:{ *:[i64] } F64:{ *:[f64] }:$src, i64:{ *:[Other] }) - Complexity = 3
              // Dst: (I64_TRUNC_S_SAT_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 18316*/   0, /*End of Scope*/
/* 18317*/  /*Scope*/ 13, /*->18331*/
/* 18318*/   OPC_MoveChild1,
/* 18319*/   OPC_CheckValueType, MVT::i32,
/* 18321*/   OPC_MoveParent,
/* 18322*/   OPC_CheckType, MVT::v4i32,
/* 18324*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::fp_to_sint_I32x4), 0,
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (fp_to_sint_sat:{ *:[v4i32] } V128:{ *:[v4f32] }:$src, i32:{ *:[Other] }) - Complexity = 3
             // Dst: (fp_to_sint_I32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$src)
/* 18331*/  0, /*End of Scope*/
/* 18332*/ /*SwitchOpcode*/ 81, TARGET_VAL(ISD::FP_TO_UINT_SAT),// ->18416
/* 18335*/  OPC_RecordChild0, // #0 = $src
/* 18336*/  OPC_Scope, 31, /*->18369*/ // 3 children in Scope
/* 18338*/   OPC_CheckChild0Type, MVT::f32,
/* 18340*/   OPC_MoveChild1,
/* 18341*/   OPC_Scope, 12, /*->18355*/ // 2 children in Scope
/* 18343*/    OPC_CheckValueType, MVT::i32,
/* 18345*/    OPC_MoveParent,
/* 18346*/    OPC_CheckType, MVT::i32,
/* 18348*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I32_TRUNC_U_SAT_F32), 0,
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (fp_to_uint_sat:{ *:[i32] } F32:{ *:[f32] }:$src, i32:{ *:[Other] }) - Complexity = 3
              // Dst: (I32_TRUNC_U_SAT_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 18355*/   /*Scope*/ 12, /*->18368*/
/* 18356*/    OPC_CheckValueType, MVT::i64,
/* 18358*/    OPC_MoveParent,
/* 18359*/    OPC_CheckType, MVT::i64,
/* 18361*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I64_TRUNC_U_SAT_F32), 0,
                  MVT::i64, 1/*#Ops*/, 0, 
              // Src: (fp_to_uint_sat:{ *:[i64] } F32:{ *:[f32] }:$src, i64:{ *:[Other] }) - Complexity = 3
              // Dst: (I64_TRUNC_U_SAT_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 18368*/   0, /*End of Scope*/
/* 18369*/  /*Scope*/ 31, /*->18401*/
/* 18370*/   OPC_CheckChild0Type, MVT::f64,
/* 18372*/   OPC_MoveChild1,
/* 18373*/   OPC_Scope, 12, /*->18387*/ // 2 children in Scope
/* 18375*/    OPC_CheckValueType, MVT::i32,
/* 18377*/    OPC_MoveParent,
/* 18378*/    OPC_CheckType, MVT::i32,
/* 18380*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I32_TRUNC_U_SAT_F64), 0,
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (fp_to_uint_sat:{ *:[i32] } F64:{ *:[f64] }:$src, i32:{ *:[Other] }) - Complexity = 3
              // Dst: (I32_TRUNC_U_SAT_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 18387*/   /*Scope*/ 12, /*->18400*/
/* 18388*/    OPC_CheckValueType, MVT::i64,
/* 18390*/    OPC_MoveParent,
/* 18391*/    OPC_CheckType, MVT::i64,
/* 18393*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I64_TRUNC_U_SAT_F64), 0,
                  MVT::i64, 1/*#Ops*/, 0, 
              // Src: (fp_to_uint_sat:{ *:[i64] } F64:{ *:[f64] }:$src, i64:{ *:[Other] }) - Complexity = 3
              // Dst: (I64_TRUNC_U_SAT_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 18400*/   0, /*End of Scope*/
/* 18401*/  /*Scope*/ 13, /*->18415*/
/* 18402*/   OPC_MoveChild1,
/* 18403*/   OPC_CheckValueType, MVT::i32,
/* 18405*/   OPC_MoveParent,
/* 18406*/   OPC_CheckType, MVT::v4i32,
/* 18408*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::fp_to_uint_I32x4), 0,
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (fp_to_uint_sat:{ *:[v4i32] } V128:{ *:[v4f32] }:$src, i32:{ *:[Other] }) - Complexity = 3
             // Dst: (fp_to_uint_I32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$src)
/* 18415*/  0, /*End of Scope*/
/* 18416*/ /*SwitchOpcode*/ 103|128,1/*231*/, TARGET_VAL(ISD::BITCAST),// ->18651
/* 18420*/  OPC_RecordChild0, // #0 = $src
/* 18421*/  OPC_Scope, 11, /*->18434*/ // 10 children in Scope
/* 18423*/   OPC_CheckChild0Type, MVT::f32,
/* 18425*/   OPC_CheckType, MVT::i32,
/* 18427*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I32_REINTERPRET_F32), 0,
                 MVT::i32, 1/*#Ops*/, 0, 
             // Src: (bitconvert:{ *:[i32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (I32_REINTERPRET_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 18434*/  /*Scope*/ 11, /*->18446*/
/* 18435*/   OPC_CheckChild0Type, MVT::f64,
/* 18437*/   OPC_CheckType, MVT::i64,
/* 18439*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I64_REINTERPRET_F64), 0,
                 MVT::i64, 1/*#Ops*/, 0, 
             // Src: (bitconvert:{ *:[i64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (I64_REINTERPRET_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 18446*/  /*Scope*/ 11, /*->18458*/
/* 18447*/   OPC_CheckChild0Type, MVT::i32,
/* 18449*/   OPC_CheckType, MVT::f32,
/* 18451*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::F32_REINTERPRET_I32), 0,
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (bitconvert:{ *:[f32] } I32:{ *:[i32] }:$src) - Complexity = 3
             // Dst: (F32_REINTERPRET_I32:{ *:[f32] } I32:{ *:[i32] }:$src)
/* 18458*/  /*Scope*/ 11, /*->18470*/
/* 18459*/   OPC_CheckChild0Type, MVT::i64,
/* 18461*/   OPC_CheckType, MVT::f64,
/* 18463*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::F64_REINTERPRET_I64), 0,
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (bitconvert:{ *:[f64] } I64:{ *:[i64] }:$src) - Complexity = 3
             // Dst: (F64_REINTERPRET_I64:{ *:[f64] } I64:{ *:[i64] }:$src)
/* 18470*/  /*Scope*/ 29, /*->18500*/
/* 18471*/   OPC_CheckChild0Type, MVT::v8i16,
/* 18473*/   OPC_SwitchType /*5 cases */, 3, MVT::v16i8,// ->18479
/* 18476*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v16i8] } V128:{ *:[v8i16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v16i8] }:$v
/* 18479*/   /*SwitchType*/ 3, MVT::v4i32,// ->18484
/* 18481*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4i32] } V128:{ *:[v8i16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4i32] }:$v
/* 18484*/   /*SwitchType*/ 3, MVT::v2i64,// ->18489
/* 18486*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2i64] } V128:{ *:[v8i16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2i64] }:$v
/* 18489*/   /*SwitchType*/ 3, MVT::v4f32,// ->18494
/* 18491*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4f32] } V128:{ *:[v8i16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4f32] }:$v
/* 18494*/   /*SwitchType*/ 3, MVT::v2f64,// ->18499
/* 18496*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2f64] } V128:{ *:[v8i16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2f64] }:$v
/* 18499*/   0, // EndSwitchType
/* 18500*/  /*Scope*/ 29, /*->18530*/
/* 18501*/   OPC_CheckChild0Type, MVT::v4i32,
/* 18503*/   OPC_SwitchType /*5 cases */, 3, MVT::v16i8,// ->18509
/* 18506*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v16i8] } V128:{ *:[v4i32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v16i8] }:$v
/* 18509*/   /*SwitchType*/ 3, MVT::v8i16,// ->18514
/* 18511*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8i16] } V128:{ *:[v4i32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8i16] }:$v
/* 18514*/   /*SwitchType*/ 3, MVT::v2i64,// ->18519
/* 18516*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2i64] } V128:{ *:[v4i32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2i64] }:$v
/* 18519*/   /*SwitchType*/ 3, MVT::v4f32,// ->18524
/* 18521*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4f32] } V128:{ *:[v4i32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4f32] }:$v
/* 18524*/   /*SwitchType*/ 3, MVT::v2f64,// ->18529
/* 18526*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2f64] } V128:{ *:[v4i32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2f64] }:$v
/* 18529*/   0, // EndSwitchType
/* 18530*/  /*Scope*/ 29, /*->18560*/
/* 18531*/   OPC_CheckChild0Type, MVT::v2i64,
/* 18533*/   OPC_SwitchType /*5 cases */, 3, MVT::v16i8,// ->18539
/* 18536*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v16i8] } V128:{ *:[v2i64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v16i8] }:$v
/* 18539*/   /*SwitchType*/ 3, MVT::v8i16,// ->18544
/* 18541*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8i16] } V128:{ *:[v2i64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8i16] }:$v
/* 18544*/   /*SwitchType*/ 3, MVT::v4i32,// ->18549
/* 18546*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4i32] } V128:{ *:[v2i64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4i32] }:$v
/* 18549*/   /*SwitchType*/ 3, MVT::v4f32,// ->18554
/* 18551*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4f32] } V128:{ *:[v2i64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4f32] }:$v
/* 18554*/   /*SwitchType*/ 3, MVT::v2f64,// ->18559
/* 18556*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2f64] } V128:{ *:[v2i64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2f64] }:$v
/* 18559*/   0, // EndSwitchType
/* 18560*/  /*Scope*/ 29, /*->18590*/
/* 18561*/   OPC_CheckChild0Type, MVT::v4f32,
/* 18563*/   OPC_SwitchType /*5 cases */, 3, MVT::v16i8,// ->18569
/* 18566*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v16i8] } V128:{ *:[v4f32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v16i8] }:$v
/* 18569*/   /*SwitchType*/ 3, MVT::v8i16,// ->18574
/* 18571*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8i16] } V128:{ *:[v4f32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8i16] }:$v
/* 18574*/   /*SwitchType*/ 3, MVT::v4i32,// ->18579
/* 18576*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4i32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4i32] }:$v
/* 18579*/   /*SwitchType*/ 3, MVT::v2i64,// ->18584
/* 18581*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2i64] } V128:{ *:[v4f32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2i64] }:$v
/* 18584*/   /*SwitchType*/ 3, MVT::v2f64,// ->18589
/* 18586*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2f64] } V128:{ *:[v4f32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2f64] }:$v
/* 18589*/   0, // EndSwitchType
/* 18590*/  /*Scope*/ 29, /*->18620*/
/* 18591*/   OPC_CheckChild0Type, MVT::v2f64,
/* 18593*/   OPC_SwitchType /*5 cases */, 3, MVT::v16i8,// ->18599
/* 18596*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v16i8] } V128:{ *:[v2f64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v16i8] }:$v
/* 18599*/   /*SwitchType*/ 3, MVT::v8i16,// ->18604
/* 18601*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8i16] } V128:{ *:[v2f64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8i16] }:$v
/* 18604*/   /*SwitchType*/ 3, MVT::v4i32,// ->18609
/* 18606*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4i32] } V128:{ *:[v2f64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4i32] }:$v
/* 18609*/   /*SwitchType*/ 3, MVT::v2i64,// ->18614
/* 18611*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2i64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2i64] }:$v
/* 18614*/   /*SwitchType*/ 3, MVT::v4f32,// ->18619
/* 18616*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4f32] } V128:{ *:[v2f64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4f32] }:$v
/* 18619*/   0, // EndSwitchType
/* 18620*/  /*Scope*/ 29, /*->18650*/
/* 18621*/   OPC_CheckChild0Type, MVT::v16i8,
/* 18623*/   OPC_SwitchType /*5 cases */, 3, MVT::v8i16,// ->18629
/* 18626*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8i16] } V128:{ *:[v16i8] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8i16] }:$v
/* 18629*/   /*SwitchType*/ 3, MVT::v4i32,// ->18634
/* 18631*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4i32] } V128:{ *:[v16i8] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4i32] }:$v
/* 18634*/   /*SwitchType*/ 3, MVT::v2i64,// ->18639
/* 18636*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2i64] } V128:{ *:[v16i8] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2i64] }:$v
/* 18639*/   /*SwitchType*/ 3, MVT::v4f32,// ->18644
/* 18641*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4f32] } V128:{ *:[v16i8] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4f32] }:$v
/* 18644*/   /*SwitchType*/ 3, MVT::v2f64,// ->18649
/* 18646*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2f64] } V128:{ *:[v16i8] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2f64] }:$v
/* 18649*/   0, // EndSwitchType
/* 18650*/  0, /*End of Scope*/
/* 18651*/ /*SwitchOpcode*/ 25, TARGET_VAL(ISD::ConstantFP),// ->18679
/* 18654*/  OPC_RecordNode, // #0 = $imm
/* 18655*/  OPC_SwitchType /*2 cases */, 9, MVT::f32,// ->18667
/* 18658*/   OPC_EmitConvertToTarget, 0,
/* 18660*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_F32), 0,
                 MVT::f32, 1/*#Ops*/, 1, 
             // Src: (fpimm:{ *:[f32] }):$imm - Complexity = 3
             // Dst: (CONST_F32:{ *:[f32] } (fpimm:{ *:[f32] }):$imm)
/* 18667*/  /*SwitchType*/ 9, MVT::f64,// ->18678
/* 18669*/   OPC_EmitConvertToTarget, 0,
/* 18671*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_F64), 0,
                 MVT::f64, 1/*#Ops*/, 1, 
             // Src: (fpimm:{ *:[f64] }):$imm - Complexity = 3
             // Dst: (CONST_F64:{ *:[f64] } (fpimm:{ *:[f64] }):$imm)
/* 18678*/  0, // EndSwitchType
/* 18679*/ /*SwitchOpcode*/ 61, TARGET_VAL(ISD::SINT_TO_FP),// ->18743
/* 18682*/  OPC_RecordChild0, // #0 = $src
/* 18683*/  OPC_Scope, 22, /*->18707*/ // 3 children in Scope
/* 18685*/   OPC_CheckChild0Type, MVT::i32,
/* 18687*/   OPC_SwitchType /*2 cases */, 7, MVT::f32,// ->18697
/* 18690*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::F32_CONVERT_S_I32), 0,
                  MVT::f32, 1/*#Ops*/, 0, 
              // Src: (sint_to_fp:{ *:[f32] } I32:{ *:[i32] }:$src) - Complexity = 3
              // Dst: (F32_CONVERT_S_I32:{ *:[f32] } I32:{ *:[i32] }:$src)
/* 18697*/   /*SwitchType*/ 7, MVT::f64,// ->18706
/* 18699*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::F64_CONVERT_S_I32), 0,
                  MVT::f64, 1/*#Ops*/, 0, 
              // Src: (sint_to_fp:{ *:[f64] } I32:{ *:[i32] }:$src) - Complexity = 3
              // Dst: (F64_CONVERT_S_I32:{ *:[f64] } I32:{ *:[i32] }:$src)
/* 18706*/   0, // EndSwitchType
/* 18707*/  /*Scope*/ 22, /*->18730*/
/* 18708*/   OPC_CheckChild0Type, MVT::i64,
/* 18710*/   OPC_SwitchType /*2 cases */, 7, MVT::f32,// ->18720
/* 18713*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::F32_CONVERT_S_I64), 0,
                  MVT::f32, 1/*#Ops*/, 0, 
              // Src: (sint_to_fp:{ *:[f32] } I64:{ *:[i64] }:$src) - Complexity = 3
              // Dst: (F32_CONVERT_S_I64:{ *:[f32] } I64:{ *:[i64] }:$src)
/* 18720*/   /*SwitchType*/ 7, MVT::f64,// ->18729
/* 18722*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::F64_CONVERT_S_I64), 0,
                  MVT::f64, 1/*#Ops*/, 0, 
              // Src: (sint_to_fp:{ *:[f64] } I64:{ *:[i64] }:$src) - Complexity = 3
              // Dst: (F64_CONVERT_S_I64:{ *:[f64] } I64:{ *:[i64] }:$src)
/* 18729*/   0, // EndSwitchType
/* 18730*/  /*Scope*/ 11, /*->18742*/
/* 18731*/   OPC_CheckType, MVT::v4f32,
/* 18733*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 18735*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::sint_to_fp_F32x4), 0,
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (sint_to_fp:{ *:[v4f32] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
             // Dst: (sint_to_fp_F32x4:{ *:[v4f32] } V128:{ *:[v4i32] }:$vec)
/* 18742*/  0, /*End of Scope*/
/* 18743*/ /*SwitchOpcode*/ 61, TARGET_VAL(ISD::UINT_TO_FP),// ->18807
/* 18746*/  OPC_RecordChild0, // #0 = $src
/* 18747*/  OPC_Scope, 22, /*->18771*/ // 3 children in Scope
/* 18749*/   OPC_CheckChild0Type, MVT::i32,
/* 18751*/   OPC_SwitchType /*2 cases */, 7, MVT::f32,// ->18761
/* 18754*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::F32_CONVERT_U_I32), 0,
                  MVT::f32, 1/*#Ops*/, 0, 
              // Src: (uint_to_fp:{ *:[f32] } I32:{ *:[i32] }:$src) - Complexity = 3
              // Dst: (F32_CONVERT_U_I32:{ *:[f32] } I32:{ *:[i32] }:$src)
/* 18761*/   /*SwitchType*/ 7, MVT::f64,// ->18770
/* 18763*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::F64_CONVERT_U_I32), 0,
                  MVT::f64, 1/*#Ops*/, 0, 
              // Src: (uint_to_fp:{ *:[f64] } I32:{ *:[i32] }:$src) - Complexity = 3
              // Dst: (F64_CONVERT_U_I32:{ *:[f64] } I32:{ *:[i32] }:$src)
/* 18770*/   0, // EndSwitchType
/* 18771*/  /*Scope*/ 22, /*->18794*/
/* 18772*/   OPC_CheckChild0Type, MVT::i64,
/* 18774*/   OPC_SwitchType /*2 cases */, 7, MVT::f32,// ->18784
/* 18777*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::F32_CONVERT_U_I64), 0,
                  MVT::f32, 1/*#Ops*/, 0, 
              // Src: (uint_to_fp:{ *:[f32] } I64:{ *:[i64] }:$src) - Complexity = 3
              // Dst: (F32_CONVERT_U_I64:{ *:[f32] } I64:{ *:[i64] }:$src)
/* 18784*/   /*SwitchType*/ 7, MVT::f64,// ->18793
/* 18786*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::F64_CONVERT_U_I64), 0,
                  MVT::f64, 1/*#Ops*/, 0, 
              // Src: (uint_to_fp:{ *:[f64] } I64:{ *:[i64] }:$src) - Complexity = 3
              // Dst: (F64_CONVERT_U_I64:{ *:[f64] } I64:{ *:[i64] }:$src)
/* 18793*/   0, // EndSwitchType
/* 18794*/  /*Scope*/ 11, /*->18806*/
/* 18795*/   OPC_CheckType, MVT::v4f32,
/* 18797*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 18799*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::uint_to_fp_F32x4), 0,
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (uint_to_fp:{ *:[v4f32] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
             // Dst: (uint_to_fp_F32x4:{ *:[v4f32] } V128:{ *:[v4i32] }:$vec)
/* 18806*/  0, /*End of Scope*/
/* 18807*/ /*SwitchOpcode*/ 8, TARGET_VAL(ISD::FP_EXTEND),// ->18818
/* 18810*/  OPC_RecordChild0, // #0 = $src
/* 18811*/  OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::F64_PROMOTE_F32), 0,
                MVT::f64, 1/*#Ops*/, 0, 
            // Src: (fpextend:{ *:[f64] } F32:{ *:[f32] }:$src) - Complexity = 3
            // Dst: (F64_PROMOTE_F32:{ *:[f64] } F32:{ *:[f32] }:$src)
/* 18818*/ /*SwitchOpcode*/ 8, TARGET_VAL(ISD::FP_ROUND),// ->18829
/* 18821*/  OPC_RecordChild0, // #0 = $src
/* 18822*/  OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::F32_DEMOTE_F64), 0,
                MVT::f32, 1/*#Ops*/, 0, 
            // Src: (fpround:{ *:[f32] } F64:{ *:[f64] }:$src) - Complexity = 3
            // Dst: (F32_DEMOTE_F64:{ *:[f32] } F64:{ *:[f64] }:$src)
/* 18829*/ /*SwitchOpcode*/ 48, TARGET_VAL(ISD::FADD),// ->18880
/* 18832*/  OPC_RecordChild0, // #0 = $lhs
/* 18833*/  OPC_RecordChild1, // #1 = $rhs
/* 18834*/  OPC_SwitchType /*4 cases */, 8, MVT::f32,// ->18845
/* 18837*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADD_F32), 0,
                 MVT::f32, 2/*#Ops*/, 0, 1, 
             // Src: (fadd:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
             // Dst: (ADD_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 18845*/  /*SwitchType*/ 8, MVT::f64,// ->18855
/* 18847*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADD_F64), 0,
                 MVT::f64, 2/*#Ops*/, 0, 1, 
             // Src: (fadd:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
             // Dst: (ADD_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 18855*/  /*SwitchType*/ 10, MVT::v4f32,// ->18867
/* 18857*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 18859*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADD_F32x4), 0,
                 MVT::v4f32, 2/*#Ops*/, 0, 1, 
             // Src: (fadd:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
             // Dst: (ADD_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 18867*/  /*SwitchType*/ 10, MVT::v2f64,// ->18879
/* 18869*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 18871*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADD_F64x2), 0,
                 MVT::v2f64, 2/*#Ops*/, 0, 1, 
             // Src: (fadd:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
             // Dst: (ADD_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 18879*/  0, // EndSwitchType
/* 18880*/ /*SwitchOpcode*/ 48, TARGET_VAL(ISD::FSUB),// ->18931
/* 18883*/  OPC_RecordChild0, // #0 = $lhs
/* 18884*/  OPC_RecordChild1, // #1 = $rhs
/* 18885*/  OPC_SwitchType /*4 cases */, 8, MVT::f32,// ->18896
/* 18888*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SUB_F32), 0,
                 MVT::f32, 2/*#Ops*/, 0, 1, 
             // Src: (fsub:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
             // Dst: (SUB_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 18896*/  /*SwitchType*/ 8, MVT::f64,// ->18906
/* 18898*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SUB_F64), 0,
                 MVT::f64, 2/*#Ops*/, 0, 1, 
             // Src: (fsub:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
             // Dst: (SUB_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 18906*/  /*SwitchType*/ 10, MVT::v4f32,// ->18918
/* 18908*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 18910*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SUB_F32x4), 0,
                 MVT::v4f32, 2/*#Ops*/, 0, 1, 
             // Src: (fsub:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
             // Dst: (SUB_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 18918*/  /*SwitchType*/ 10, MVT::v2f64,// ->18930
/* 18920*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 18922*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SUB_F64x2), 0,
                 MVT::v2f64, 2/*#Ops*/, 0, 1, 
             // Src: (fsub:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
             // Dst: (SUB_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 18930*/  0, // EndSwitchType
/* 18931*/ /*SwitchOpcode*/ 48, TARGET_VAL(ISD::FMUL),// ->18982
/* 18934*/  OPC_RecordChild0, // #0 = $lhs
/* 18935*/  OPC_RecordChild1, // #1 = $rhs
/* 18936*/  OPC_SwitchType /*4 cases */, 8, MVT::f32,// ->18947
/* 18939*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MUL_F32), 0,
                 MVT::f32, 2/*#Ops*/, 0, 1, 
             // Src: (fmul:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
             // Dst: (MUL_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 18947*/  /*SwitchType*/ 8, MVT::f64,// ->18957
/* 18949*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MUL_F64), 0,
                 MVT::f64, 2/*#Ops*/, 0, 1, 
             // Src: (fmul:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
             // Dst: (MUL_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 18957*/  /*SwitchType*/ 10, MVT::v4f32,// ->18969
/* 18959*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 18961*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MUL_F32x4), 0,
                 MVT::v4f32, 2/*#Ops*/, 0, 1, 
             // Src: (fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
             // Dst: (MUL_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 18969*/  /*SwitchType*/ 10, MVT::v2f64,// ->18981
/* 18971*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 18973*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MUL_F64x2), 0,
                 MVT::v2f64, 2/*#Ops*/, 0, 1, 
             // Src: (fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
             // Dst: (MUL_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 18981*/  0, // EndSwitchType
/* 18982*/ /*SwitchOpcode*/ 48, TARGET_VAL(ISD::FDIV),// ->19033
/* 18985*/  OPC_RecordChild0, // #0 = $lhs
/* 18986*/  OPC_RecordChild1, // #1 = $rhs
/* 18987*/  OPC_SwitchType /*4 cases */, 8, MVT::f32,// ->18998
/* 18990*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::DIV_F32), 0,
                 MVT::f32, 2/*#Ops*/, 0, 1, 
             // Src: (fdiv:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
             // Dst: (DIV_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 18998*/  /*SwitchType*/ 8, MVT::f64,// ->19008
/* 19000*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::DIV_F64), 0,
                 MVT::f64, 2/*#Ops*/, 0, 1, 
             // Src: (fdiv:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
             // Dst: (DIV_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 19008*/  /*SwitchType*/ 10, MVT::v4f32,// ->19020
/* 19010*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 19012*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::DIV_F32x4), 0,
                 MVT::v4f32, 2/*#Ops*/, 0, 1, 
             // Src: (fdiv:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
             // Dst: (DIV_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 19020*/  /*SwitchType*/ 10, MVT::v2f64,// ->19032
/* 19022*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 19024*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::DIV_F64x2), 0,
                 MVT::v2f64, 2/*#Ops*/, 0, 1, 
             // Src: (fdiv:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
             // Dst: (DIV_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 19032*/  0, // EndSwitchType
/* 19033*/ /*SwitchOpcode*/ 43, TARGET_VAL(ISD::FSQRT),// ->19079
/* 19036*/  OPC_RecordChild0, // #0 = $src
/* 19037*/  OPC_SwitchType /*4 cases */, 7, MVT::f32,// ->19047
/* 19040*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SQRT_F32), 0,
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (fsqrt:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (SQRT_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 19047*/  /*SwitchType*/ 7, MVT::f64,// ->19056
/* 19049*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SQRT_F64), 0,
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (fsqrt:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (SQRT_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 19056*/  /*SwitchType*/ 9, MVT::v4f32,// ->19067
/* 19058*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 19060*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SQRT_F32x4), 0,
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (fsqrt:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (SQRT_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 19067*/  /*SwitchType*/ 9, MVT::v2f64,// ->19078
/* 19069*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 19071*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SQRT_F64x2), 0,
                 MVT::v2f64, 1/*#Ops*/, 0, 
             // Src: (fsqrt:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (SQRT_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 19078*/  0, // EndSwitchType
/* 19079*/ /*SwitchOpcode*/ 43, TARGET_VAL(ISD::FABS),// ->19125
/* 19082*/  OPC_RecordChild0, // #0 = $src
/* 19083*/  OPC_SwitchType /*4 cases */, 7, MVT::f32,// ->19093
/* 19086*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ABS_F32), 0,
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (fabs:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (ABS_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 19093*/  /*SwitchType*/ 7, MVT::f64,// ->19102
/* 19095*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ABS_F64), 0,
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (fabs:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (ABS_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 19102*/  /*SwitchType*/ 9, MVT::v4f32,// ->19113
/* 19104*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 19106*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ABS_F32x4), 0,
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (ABS_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 19113*/  /*SwitchType*/ 9, MVT::v2f64,// ->19124
/* 19115*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 19117*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ABS_F64x2), 0,
                 MVT::v2f64, 1/*#Ops*/, 0, 
             // Src: (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (ABS_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 19124*/  0, // EndSwitchType
/* 19125*/ /*SwitchOpcode*/ 43, TARGET_VAL(ISD::FNEG),// ->19171
/* 19128*/  OPC_RecordChild0, // #0 = $src
/* 19129*/  OPC_SwitchType /*4 cases */, 7, MVT::f32,// ->19139
/* 19132*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NEG_F32), 0,
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (fneg:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (NEG_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 19139*/  /*SwitchType*/ 7, MVT::f64,// ->19148
/* 19141*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NEG_F64), 0,
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (fneg:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (NEG_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 19148*/  /*SwitchType*/ 9, MVT::v4f32,// ->19159
/* 19150*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 19152*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NEG_F32x4), 0,
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (NEG_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 19159*/  /*SwitchType*/ 9, MVT::v2f64,// ->19170
/* 19161*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 19163*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NEG_F64x2), 0,
                 MVT::v2f64, 1/*#Ops*/, 0, 
             // Src: (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (NEG_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 19170*/  0, // EndSwitchType
/* 19171*/ /*SwitchOpcode*/ 68, TARGET_VAL(ISD::FCOPYSIGN),// ->19242
/* 19174*/  OPC_RecordChild0, // #0 = $lhs
/* 19175*/  OPC_RecordChild1, // #1 = $rhs
/* 19176*/  OPC_Scope, 31, /*->19209*/ // 2 children in Scope
/* 19178*/   OPC_CheckChild1Type, MVT::f32,
/* 19180*/   OPC_SwitchType /*2 cases */, 8, MVT::f32,// ->19191
/* 19183*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::COPYSIGN_F32), 0,
                  MVT::f32, 2/*#Ops*/, 0, 1, 
              // Src: (fcopysign:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
              // Dst: (COPYSIGN_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 19191*/   /*SwitchType*/ 15, MVT::f64,// ->19208
/* 19193*/    OPC_EmitNode1, TARGET_VAL(WebAssembly::F64_PROMOTE_F32), 0,
                  MVT::f64, 1/*#Ops*/, 1,  // Results = #2
/* 19200*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::COPYSIGN_F64), 0,
                  MVT::f64, 2/*#Ops*/, 0, 2, 
              // Src: (fcopysign:{ *:[f64] } F64:{ *:[f64] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
              // Dst: (COPYSIGN_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, (F64_PROMOTE_F32:{ *:[f64] } F32:{ *:[f32] }:$rhs))
/* 19208*/   0, // EndSwitchType
/* 19209*/  /*Scope*/ 31, /*->19241*/
/* 19210*/   OPC_CheckChild1Type, MVT::f64,
/* 19212*/   OPC_SwitchType /*2 cases */, 8, MVT::f64,// ->19223
/* 19215*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::COPYSIGN_F64), 0,
                  MVT::f64, 2/*#Ops*/, 0, 1, 
              // Src: (fcopysign:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
              // Dst: (COPYSIGN_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 19223*/   /*SwitchType*/ 15, MVT::f32,// ->19240
/* 19225*/    OPC_EmitNode1, TARGET_VAL(WebAssembly::F32_DEMOTE_F64), 0,
                  MVT::f32, 1/*#Ops*/, 1,  // Results = #2
/* 19232*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::COPYSIGN_F32), 0,
                  MVT::f32, 2/*#Ops*/, 0, 2, 
              // Src: (fcopysign:{ *:[f32] } F32:{ *:[f32] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
              // Dst: (COPYSIGN_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, (F32_DEMOTE_F64:{ *:[f32] } F64:{ *:[f64] }:$rhs))
/* 19240*/   0, // EndSwitchType
/* 19241*/  0, /*End of Scope*/
/* 19242*/ /*SwitchOpcode*/ 48, TARGET_VAL(ISD::FMINIMUM),// ->19293
/* 19245*/  OPC_RecordChild0, // #0 = $lhs
/* 19246*/  OPC_RecordChild1, // #1 = $rhs
/* 19247*/  OPC_SwitchType /*4 cases */, 8, MVT::f32,// ->19258
/* 19250*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MIN_F32), 0,
                 MVT::f32, 2/*#Ops*/, 0, 1, 
             // Src: (fminimum:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
             // Dst: (MIN_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 19258*/  /*SwitchType*/ 8, MVT::f64,// ->19268
/* 19260*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MIN_F64), 0,
                 MVT::f64, 2/*#Ops*/, 0, 1, 
             // Src: (fminimum:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
             // Dst: (MIN_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 19268*/  /*SwitchType*/ 10, MVT::v4f32,// ->19280
/* 19270*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 19272*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MIN_F32x4), 0,
                 MVT::v4f32, 2/*#Ops*/, 0, 1, 
             // Src: (fminimum:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
             // Dst: (MIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 19280*/  /*SwitchType*/ 10, MVT::v2f64,// ->19292
/* 19282*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 19284*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MIN_F64x2), 0,
                 MVT::v2f64, 2/*#Ops*/, 0, 1, 
             // Src: (fminimum:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
             // Dst: (MIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 19292*/  0, // EndSwitchType
/* 19293*/ /*SwitchOpcode*/ 48, TARGET_VAL(ISD::FMAXIMUM),// ->19344
/* 19296*/  OPC_RecordChild0, // #0 = $lhs
/* 19297*/  OPC_RecordChild1, // #1 = $rhs
/* 19298*/  OPC_SwitchType /*4 cases */, 8, MVT::f32,// ->19309
/* 19301*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MAX_F32), 0,
                 MVT::f32, 2/*#Ops*/, 0, 1, 
             // Src: (fmaximum:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
             // Dst: (MAX_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 19309*/  /*SwitchType*/ 8, MVT::f64,// ->19319
/* 19311*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MAX_F64), 0,
                 MVT::f64, 2/*#Ops*/, 0, 1, 
             // Src: (fmaximum:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
             // Dst: (MAX_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 19319*/  /*SwitchType*/ 10, MVT::v4f32,// ->19331
/* 19321*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 19323*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MAX_F32x4), 0,
                 MVT::v4f32, 2/*#Ops*/, 0, 1, 
             // Src: (fmaximum:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
             // Dst: (MAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 19331*/  /*SwitchType*/ 10, MVT::v2f64,// ->19343
/* 19333*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 19335*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MAX_F64x2), 0,
                 MVT::v2f64, 2/*#Ops*/, 0, 1, 
             // Src: (fmaximum:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
             // Dst: (MAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 19343*/  0, // EndSwitchType
/* 19344*/ /*SwitchOpcode*/ 43, TARGET_VAL(ISD::FCEIL),// ->19390
/* 19347*/  OPC_RecordChild0, // #0 = $src
/* 19348*/  OPC_SwitchType /*4 cases */, 7, MVT::f32,// ->19358
/* 19351*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CEIL_F32), 0,
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (fceil:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (CEIL_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 19358*/  /*SwitchType*/ 7, MVT::f64,// ->19367
/* 19360*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CEIL_F64), 0,
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (fceil:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (CEIL_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 19367*/  /*SwitchType*/ 9, MVT::v4f32,// ->19378
/* 19369*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 19371*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CEIL_F32x4), 0,
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (fceil:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (CEIL_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 19378*/  /*SwitchType*/ 9, MVT::v2f64,// ->19389
/* 19380*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 19382*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CEIL_F64x2), 0,
                 MVT::v2f64, 1/*#Ops*/, 0, 
             // Src: (fceil:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (CEIL_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 19389*/  0, // EndSwitchType
/* 19390*/ /*SwitchOpcode*/ 43, TARGET_VAL(ISD::FFLOOR),// ->19436
/* 19393*/  OPC_RecordChild0, // #0 = $src
/* 19394*/  OPC_SwitchType /*4 cases */, 7, MVT::f32,// ->19404
/* 19397*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::FLOOR_F32), 0,
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (ffloor:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (FLOOR_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 19404*/  /*SwitchType*/ 7, MVT::f64,// ->19413
/* 19406*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::FLOOR_F64), 0,
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (ffloor:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (FLOOR_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 19413*/  /*SwitchType*/ 9, MVT::v4f32,// ->19424
/* 19415*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 19417*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::FLOOR_F32x4), 0,
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (ffloor:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (FLOOR_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 19424*/  /*SwitchType*/ 9, MVT::v2f64,// ->19435
/* 19426*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 19428*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::FLOOR_F64x2), 0,
                 MVT::v2f64, 1/*#Ops*/, 0, 
             // Src: (ffloor:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (FLOOR_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 19435*/  0, // EndSwitchType
/* 19436*/ /*SwitchOpcode*/ 43, TARGET_VAL(ISD::FTRUNC),// ->19482
/* 19439*/  OPC_RecordChild0, // #0 = $src
/* 19440*/  OPC_SwitchType /*4 cases */, 7, MVT::f32,// ->19450
/* 19443*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::TRUNC_F32), 0,
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (ftrunc:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (TRUNC_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 19450*/  /*SwitchType*/ 7, MVT::f64,// ->19459
/* 19452*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::TRUNC_F64), 0,
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (ftrunc:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (TRUNC_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 19459*/  /*SwitchType*/ 9, MVT::v4f32,// ->19470
/* 19461*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 19463*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::TRUNC_F32x4), 0,
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (ftrunc:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (TRUNC_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 19470*/  /*SwitchType*/ 9, MVT::v2f64,// ->19481
/* 19472*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 19474*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::TRUNC_F64x2), 0,
                 MVT::v2f64, 1/*#Ops*/, 0, 
             // Src: (ftrunc:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (TRUNC_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 19481*/  0, // EndSwitchType
/* 19482*/ /*SwitchOpcode*/ 43, TARGET_VAL(ISD::FNEARBYINT),// ->19528
/* 19485*/  OPC_RecordChild0, // #0 = $src
/* 19486*/  OPC_SwitchType /*4 cases */, 7, MVT::f32,// ->19496
/* 19489*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NEAREST_F32), 0,
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (fnearbyint:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (NEAREST_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 19496*/  /*SwitchType*/ 7, MVT::f64,// ->19505
/* 19498*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NEAREST_F64), 0,
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (fnearbyint:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (NEAREST_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 19505*/  /*SwitchType*/ 9, MVT::v4f32,// ->19516
/* 19507*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 19509*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NEAREST_F32x4), 0,
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (fnearbyint:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (NEAREST_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 19516*/  /*SwitchType*/ 9, MVT::v2f64,// ->19527
/* 19518*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 19520*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NEAREST_F64x2), 0,
                 MVT::v2f64, 1/*#Ops*/, 0, 
             // Src: (fnearbyint:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (NEAREST_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 19527*/  0, // EndSwitchType
/* 19528*/ /*SwitchOpcode*/ 39, TARGET_VAL(ISD::FRINT),// ->19570
/* 19531*/  OPC_RecordChild0, // #0 = $src
/* 19532*/  OPC_SwitchType /*4 cases */, 7, MVT::f32,// ->19542
/* 19535*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NEAREST_F32), 0,
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (frint:{ *:[f32] } f32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (NEAREST_F32:{ *:[f32] } f32:{ *:[f32] }:$src)
/* 19542*/  /*SwitchType*/ 7, MVT::f64,// ->19551
/* 19544*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NEAREST_F64), 0,
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (frint:{ *:[f64] } f64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (NEAREST_F64:{ *:[f64] } f64:{ *:[f64] }:$src)
/* 19551*/  /*SwitchType*/ 7, MVT::v4f32,// ->19560
/* 19553*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NEAREST_F32x4), 0,
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (frint:{ *:[v4f32] } V128:{ *:[v4f32] }:$src) - Complexity = 3
             // Dst: (NEAREST_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$src)
/* 19560*/  /*SwitchType*/ 7, MVT::v2f64,// ->19569
/* 19562*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NEAREST_F64x2), 0,
                 MVT::v2f64, 1/*#Ops*/, 0, 
             // Src: (frint:{ *:[v2f64] } V128:{ *:[v2f64] }:$src) - Complexity = 3
             // Dst: (NEAREST_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$src)
/* 19569*/  0, // EndSwitchType
/* 19570*/ /*SwitchOpcode*/ 39, TARGET_VAL(ISD::FROUNDEVEN),// ->19612
/* 19573*/  OPC_RecordChild0, // #0 = $src
/* 19574*/  OPC_SwitchType /*4 cases */, 7, MVT::f32,// ->19584
/* 19577*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NEAREST_F32), 0,
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (froundeven:{ *:[f32] } f32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (NEAREST_F32:{ *:[f32] } f32:{ *:[f32] }:$src)
/* 19584*/  /*SwitchType*/ 7, MVT::f64,// ->19593
/* 19586*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NEAREST_F64), 0,
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (froundeven:{ *:[f64] } f64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (NEAREST_F64:{ *:[f64] } f64:{ *:[f64] }:$src)
/* 19593*/  /*SwitchType*/ 7, MVT::v4f32,// ->19602
/* 19595*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NEAREST_F32x4), 0,
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (froundeven:{ *:[v4f32] } V128:{ *:[v4f32] }:$src) - Complexity = 3
             // Dst: (NEAREST_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$src)
/* 19602*/  /*SwitchType*/ 7, MVT::v2f64,// ->19611
/* 19604*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NEAREST_F64x2), 0,
                 MVT::v2f64, 1/*#Ops*/, 0, 
             // Src: (froundeven:{ *:[v2f64] } V128:{ *:[v2f64] }:$src) - Complexity = 3
             // Dst: (NEAREST_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$src)
/* 19611*/  0, // EndSwitchType
/* 19612*/ /*SwitchOpcode*/ 116|128,3/*500*/, TARGET_VAL(ISD::BUILD_VECTOR),// ->20116
/* 19616*/  OPC_RecordChild0, // #0 = $i0
/* 19617*/  OPC_MoveChild0,
/* 19618*/  OPC_SwitchOpcode /*2 cases */, 27|128,3/*411*/, TARGET_VAL(ISD::Constant),// ->20034
/* 19623*/   OPC_SwitchType /*2 cases */, 123|128,2/*379*/, MVT::i32,// ->20006
/* 19627*/    OPC_Scope, 91|128,1/*219*/, /*->19849*/ // 3 children in Scope
/* 19630*/     OPC_CheckPredicate, 23, // Predicate_ImmI8
/* 19632*/     OPC_MoveParent,
/* 19633*/     OPC_RecordChild1, // #1 = $i1
/* 19634*/     OPC_MoveChild1,
/* 19635*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19638*/     OPC_CheckPredicate, 23, // Predicate_ImmI8
/* 19640*/     OPC_CheckType, MVT::i32,
/* 19642*/     OPC_MoveParent,
/* 19643*/     OPC_RecordChild2, // #2 = $i2
/* 19644*/     OPC_MoveChild2,
/* 19645*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19648*/     OPC_CheckPredicate, 23, // Predicate_ImmI8
/* 19650*/     OPC_CheckType, MVT::i32,
/* 19652*/     OPC_MoveParent,
/* 19653*/     OPC_RecordChild3, // #3 = $i3
/* 19654*/     OPC_MoveChild3,
/* 19655*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19658*/     OPC_CheckPredicate, 23, // Predicate_ImmI8
/* 19660*/     OPC_CheckType, MVT::i32,
/* 19662*/     OPC_MoveParent,
/* 19663*/     OPC_RecordChild4, // #4 = $i4
/* 19664*/     OPC_MoveChild4,
/* 19665*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19668*/     OPC_CheckPredicate, 23, // Predicate_ImmI8
/* 19670*/     OPC_CheckType, MVT::i32,
/* 19672*/     OPC_MoveParent,
/* 19673*/     OPC_RecordChild5, // #5 = $i5
/* 19674*/     OPC_MoveChild5,
/* 19675*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19678*/     OPC_CheckPredicate, 23, // Predicate_ImmI8
/* 19680*/     OPC_CheckType, MVT::i32,
/* 19682*/     OPC_MoveParent,
/* 19683*/     OPC_RecordChild6, // #6 = $i6
/* 19684*/     OPC_MoveChild6,
/* 19685*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19688*/     OPC_CheckPredicate, 23, // Predicate_ImmI8
/* 19690*/     OPC_CheckType, MVT::i32,
/* 19692*/     OPC_MoveParent,
/* 19693*/     OPC_RecordChild7, // #7 = $i7
/* 19694*/     OPC_MoveChild7,
/* 19695*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19698*/     OPC_CheckPredicate, 23, // Predicate_ImmI8
/* 19700*/     OPC_CheckType, MVT::i32,
/* 19702*/     OPC_MoveParent,
/* 19703*/     OPC_MoveChild, 8,
/* 19705*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19708*/     OPC_RecordNode, // #8 = $i8
/* 19709*/     OPC_CheckPredicate, 23, // Predicate_ImmI8
/* 19711*/     OPC_CheckType, MVT::i32,
/* 19713*/     OPC_MoveParent,
/* 19714*/     OPC_MoveChild, 9,
/* 19716*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19719*/     OPC_RecordNode, // #9 = $i9
/* 19720*/     OPC_CheckPredicate, 23, // Predicate_ImmI8
/* 19722*/     OPC_CheckType, MVT::i32,
/* 19724*/     OPC_MoveParent,
/* 19725*/     OPC_MoveChild, 10,
/* 19727*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19730*/     OPC_RecordNode, // #10 = $iA
/* 19731*/     OPC_CheckPredicate, 23, // Predicate_ImmI8
/* 19733*/     OPC_CheckType, MVT::i32,
/* 19735*/     OPC_MoveParent,
/* 19736*/     OPC_MoveChild, 11,
/* 19738*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19741*/     OPC_RecordNode, // #11 = $iB
/* 19742*/     OPC_CheckPredicate, 23, // Predicate_ImmI8
/* 19744*/     OPC_CheckType, MVT::i32,
/* 19746*/     OPC_MoveParent,
/* 19747*/     OPC_MoveChild, 12,
/* 19749*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19752*/     OPC_RecordNode, // #12 = $iC
/* 19753*/     OPC_CheckPredicate, 23, // Predicate_ImmI8
/* 19755*/     OPC_CheckType, MVT::i32,
/* 19757*/     OPC_MoveParent,
/* 19758*/     OPC_MoveChild, 13,
/* 19760*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19763*/     OPC_RecordNode, // #13 = $iD
/* 19764*/     OPC_CheckPredicate, 23, // Predicate_ImmI8
/* 19766*/     OPC_CheckType, MVT::i32,
/* 19768*/     OPC_MoveParent,
/* 19769*/     OPC_MoveChild, 14,
/* 19771*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19774*/     OPC_RecordNode, // #14 = $iE
/* 19775*/     OPC_CheckPredicate, 23, // Predicate_ImmI8
/* 19777*/     OPC_CheckType, MVT::i32,
/* 19779*/     OPC_MoveParent,
/* 19780*/     OPC_MoveChild, 15,
/* 19782*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19785*/     OPC_RecordNode, // #15 = $iF
/* 19786*/     OPC_CheckPredicate, 23, // Predicate_ImmI8
/* 19788*/     OPC_CheckType, MVT::i32,
/* 19790*/     OPC_MoveParent,
/* 19791*/     OPC_CheckType, MVT::v16i8,
/* 19793*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 19795*/     OPC_EmitConvertToTarget, 0,
/* 19797*/     OPC_EmitConvertToTarget, 1,
/* 19799*/     OPC_EmitConvertToTarget, 2,
/* 19801*/     OPC_EmitConvertToTarget, 3,
/* 19803*/     OPC_EmitConvertToTarget, 4,
/* 19805*/     OPC_EmitConvertToTarget, 5,
/* 19807*/     OPC_EmitConvertToTarget, 6,
/* 19809*/     OPC_EmitConvertToTarget, 7,
/* 19811*/     OPC_EmitConvertToTarget, 8,
/* 19813*/     OPC_EmitConvertToTarget, 9,
/* 19815*/     OPC_EmitConvertToTarget, 10,
/* 19817*/     OPC_EmitConvertToTarget, 11,
/* 19819*/     OPC_EmitConvertToTarget, 12,
/* 19821*/     OPC_EmitConvertToTarget, 13,
/* 19823*/     OPC_EmitConvertToTarget, 14,
/* 19825*/     OPC_EmitConvertToTarget, 15,
/* 19827*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_V128_I8x16), 0,
                   MVT::v16i8, 16/*#Ops*/, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 
               // Src: (build_vector:{ *:[v16i8] } (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i0, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i1, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i2, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i3, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i4, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i5, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i6, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i7, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i8, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i9, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$iA, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$iB, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$iC, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$iD, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$iE, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$iF) - Complexity = 67
               // Dst: (CONST_V128_I8x16:{ *:[v16i8] } (imm:{ *:[i32] }):$i0, (imm:{ *:[i32] }):$i1, (imm:{ *:[i32] }):$i2, (imm:{ *:[i32] }):$i3, (imm:{ *:[i32] }):$i4, (imm:{ *:[i32] }):$i5, (imm:{ *:[i32] }):$i6, (imm:{ *:[i32] }):$i7, (imm:{ *:[i32] }):$i8, (imm:{ *:[i32] }):$i9, (imm:{ *:[i32] }):$iA, (imm:{ *:[i32] }):$iB, (imm:{ *:[i32] }):$iC, (imm:{ *:[i32] }):$iD, (imm:{ *:[i32] }):$iE, (imm:{ *:[i32] }):$iF)
/* 19849*/    /*Scope*/ 107, /*->19957*/
/* 19850*/     OPC_CheckPredicate, 24, // Predicate_ImmI16
/* 19852*/     OPC_MoveParent,
/* 19853*/     OPC_RecordChild1, // #1 = $i1
/* 19854*/     OPC_MoveChild1,
/* 19855*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19858*/     OPC_CheckPredicate, 24, // Predicate_ImmI16
/* 19860*/     OPC_CheckType, MVT::i32,
/* 19862*/     OPC_MoveParent,
/* 19863*/     OPC_RecordChild2, // #2 = $i2
/* 19864*/     OPC_MoveChild2,
/* 19865*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19868*/     OPC_CheckPredicate, 24, // Predicate_ImmI16
/* 19870*/     OPC_CheckType, MVT::i32,
/* 19872*/     OPC_MoveParent,
/* 19873*/     OPC_RecordChild3, // #3 = $i3
/* 19874*/     OPC_MoveChild3,
/* 19875*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19878*/     OPC_CheckPredicate, 24, // Predicate_ImmI16
/* 19880*/     OPC_CheckType, MVT::i32,
/* 19882*/     OPC_MoveParent,
/* 19883*/     OPC_RecordChild4, // #4 = $i4
/* 19884*/     OPC_MoveChild4,
/* 19885*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19888*/     OPC_CheckPredicate, 24, // Predicate_ImmI16
/* 19890*/     OPC_CheckType, MVT::i32,
/* 19892*/     OPC_MoveParent,
/* 19893*/     OPC_RecordChild5, // #5 = $i5
/* 19894*/     OPC_MoveChild5,
/* 19895*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19898*/     OPC_CheckPredicate, 24, // Predicate_ImmI16
/* 19900*/     OPC_CheckType, MVT::i32,
/* 19902*/     OPC_MoveParent,
/* 19903*/     OPC_RecordChild6, // #6 = $i6
/* 19904*/     OPC_MoveChild6,
/* 19905*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19908*/     OPC_CheckPredicate, 24, // Predicate_ImmI16
/* 19910*/     OPC_CheckType, MVT::i32,
/* 19912*/     OPC_MoveParent,
/* 19913*/     OPC_RecordChild7, // #7 = $i7
/* 19914*/     OPC_MoveChild7,
/* 19915*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19918*/     OPC_CheckPredicate, 24, // Predicate_ImmI16
/* 19920*/     OPC_CheckType, MVT::i32,
/* 19922*/     OPC_MoveParent,
/* 19923*/     OPC_CheckType, MVT::v8i16,
/* 19925*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 19927*/     OPC_EmitConvertToTarget, 0,
/* 19929*/     OPC_EmitConvertToTarget, 1,
/* 19931*/     OPC_EmitConvertToTarget, 2,
/* 19933*/     OPC_EmitConvertToTarget, 3,
/* 19935*/     OPC_EmitConvertToTarget, 4,
/* 19937*/     OPC_EmitConvertToTarget, 5,
/* 19939*/     OPC_EmitConvertToTarget, 6,
/* 19941*/     OPC_EmitConvertToTarget, 7,
/* 19943*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_V128_I16x8), 0,
                   MVT::v8i16, 8/*#Ops*/, 8, 9, 10, 11, 12, 13, 14, 15, 
               // Src: (build_vector:{ *:[v8i16] } (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i0, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i1, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i2, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i3, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i4, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i5, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i6, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i7) - Complexity = 35
               // Dst: (CONST_V128_I16x8:{ *:[v8i16] } (imm:{ *:[i32] }):$i0, (imm:{ *:[i32] }):$i1, (imm:{ *:[i32] }):$i2, (imm:{ *:[i32] }):$i3, (imm:{ *:[i32] }):$i4, (imm:{ *:[i32] }):$i5, (imm:{ *:[i32] }):$i6, (imm:{ *:[i32] }):$i7)
/* 19957*/    /*Scope*/ 47, /*->20005*/
/* 19958*/     OPC_MoveParent,
/* 19959*/     OPC_RecordChild1, // #1 = $i1
/* 19960*/     OPC_MoveChild1,
/* 19961*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19964*/     OPC_CheckType, MVT::i32,
/* 19966*/     OPC_MoveParent,
/* 19967*/     OPC_RecordChild2, // #2 = $i2
/* 19968*/     OPC_MoveChild2,
/* 19969*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19972*/     OPC_CheckType, MVT::i32,
/* 19974*/     OPC_MoveParent,
/* 19975*/     OPC_RecordChild3, // #3 = $i3
/* 19976*/     OPC_MoveChild3,
/* 19977*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19980*/     OPC_CheckType, MVT::i32,
/* 19982*/     OPC_MoveParent,
/* 19983*/     OPC_CheckType, MVT::v4i32,
/* 19985*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 19987*/     OPC_EmitConvertToTarget, 0,
/* 19989*/     OPC_EmitConvertToTarget, 1,
/* 19991*/     OPC_EmitConvertToTarget, 2,
/* 19993*/     OPC_EmitConvertToTarget, 3,
/* 19995*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_V128_I32x4), 0,
                   MVT::v4i32, 4/*#Ops*/, 4, 5, 6, 7, 
               // Src: (build_vector:{ *:[v4i32] } (imm:{ *:[i32] }):$i0, (imm:{ *:[i32] }):$i1, (imm:{ *:[i32] }):$i2, (imm:{ *:[i32] }):$i3) - Complexity = 15
               // Dst: (CONST_V128_I32x4:{ *:[v4i32] } (imm:{ *:[i32] }):$i0, (imm:{ *:[i32] }):$i1, (imm:{ *:[i32] }):$i2, (imm:{ *:[i32] }):$i3)
/* 20005*/    0, /*End of Scope*/
/* 20006*/   /*SwitchType*/ 25, MVT::i64,// ->20033
/* 20008*/    OPC_MoveParent,
/* 20009*/    OPC_RecordChild1, // #1 = $i1
/* 20010*/    OPC_MoveChild1,
/* 20011*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20014*/    OPC_CheckType, MVT::i64,
/* 20016*/    OPC_MoveParent,
/* 20017*/    OPC_CheckType, MVT::v2i64,
/* 20019*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 20021*/    OPC_EmitConvertToTarget, 0,
/* 20023*/    OPC_EmitConvertToTarget, 1,
/* 20025*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_V128_I64x2), 0,
                  MVT::v2i64, 2/*#Ops*/, 2, 3, 
              // Src: (build_vector:{ *:[v2i64] } (imm:{ *:[i64] }):$i0, (imm:{ *:[i64] }):$i1) - Complexity = 9
              // Dst: (CONST_V128_I64x2:{ *:[v2i64] } (imm:{ *:[i64] }):$i0, (imm:{ *:[i64] }):$i1)
/* 20033*/   0, // EndSwitchType
/* 20034*/  /*SwitchOpcode*/ 78, TARGET_VAL(ISD::ConstantFP),// ->20115
/* 20037*/   OPC_SwitchType /*2 cases */, 47, MVT::f32,// ->20087
/* 20040*/    OPC_MoveParent,
/* 20041*/    OPC_RecordChild1, // #1 = $i1
/* 20042*/    OPC_MoveChild1,
/* 20043*/    OPC_CheckOpcode, TARGET_VAL(ISD::ConstantFP),
/* 20046*/    OPC_CheckType, MVT::f32,
/* 20048*/    OPC_MoveParent,
/* 20049*/    OPC_RecordChild2, // #2 = $i2
/* 20050*/    OPC_MoveChild2,
/* 20051*/    OPC_CheckOpcode, TARGET_VAL(ISD::ConstantFP),
/* 20054*/    OPC_CheckType, MVT::f32,
/* 20056*/    OPC_MoveParent,
/* 20057*/    OPC_RecordChild3, // #3 = $i3
/* 20058*/    OPC_MoveChild3,
/* 20059*/    OPC_CheckOpcode, TARGET_VAL(ISD::ConstantFP),
/* 20062*/    OPC_CheckType, MVT::f32,
/* 20064*/    OPC_MoveParent,
/* 20065*/    OPC_CheckType, MVT::v4f32,
/* 20067*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 20069*/    OPC_EmitConvertToTarget, 0,
/* 20071*/    OPC_EmitConvertToTarget, 1,
/* 20073*/    OPC_EmitConvertToTarget, 2,
/* 20075*/    OPC_EmitConvertToTarget, 3,
/* 20077*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_V128_F32x4), 0,
                  MVT::v4f32, 4/*#Ops*/, 4, 5, 6, 7, 
              // Src: (build_vector:{ *:[v4f32] } (fpimm:{ *:[f32] }):$i0, (fpimm:{ *:[f32] }):$i1, (fpimm:{ *:[f32] }):$i2, (fpimm:{ *:[f32] }):$i3) - Complexity = 15
              // Dst: (CONST_V128_F32x4:{ *:[v4f32] } (fpimm:{ *:[f32] }):$i0, (fpimm:{ *:[f32] }):$i1, (fpimm:{ *:[f32] }):$i2, (fpimm:{ *:[f32] }):$i3)
/* 20087*/   /*SwitchType*/ 25, MVT::f64,// ->20114
/* 20089*/    OPC_MoveParent,
/* 20090*/    OPC_RecordChild1, // #1 = $i1
/* 20091*/    OPC_MoveChild1,
/* 20092*/    OPC_CheckOpcode, TARGET_VAL(ISD::ConstantFP),
/* 20095*/    OPC_CheckType, MVT::f64,
/* 20097*/    OPC_MoveParent,
/* 20098*/    OPC_CheckType, MVT::v2f64,
/* 20100*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 20102*/    OPC_EmitConvertToTarget, 0,
/* 20104*/    OPC_EmitConvertToTarget, 1,
/* 20106*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_V128_F64x2), 0,
                  MVT::v2f64, 2/*#Ops*/, 2, 3, 
              // Src: (build_vector:{ *:[v2f64] } (fpimm:{ *:[f64] }):$i0, (fpimm:{ *:[f64] }):$i1) - Complexity = 9
              // Dst: (CONST_V128_F64x2:{ *:[v2f64] } (fpimm:{ *:[f64] }):$i0, (fpimm:{ *:[f64] }):$i1)
/* 20114*/   0, // EndSwitchType
/* 20115*/  0, // EndSwitchOpcode
/* 20116*/ /*SwitchOpcode*/ 41|128,20/*2601*/, TARGET_VAL(WebAssemblyISD::SHUFFLE),// ->22721
/* 20120*/  OPC_RecordChild0, // #0 = $x
/* 20121*/  OPC_Scope, 47|128,3/*431*/, /*->20555*/ // 6 children in Scope
/* 20124*/   OPC_CheckChild0Type, MVT::v16i8,
/* 20126*/   OPC_RecordChild1, // #1 = $y
/* 20127*/   OPC_CheckChild1Type, MVT::v16i8,
/* 20129*/   OPC_RecordChild2, // #2 = $m0
/* 20130*/   OPC_MoveChild2,
/* 20131*/   OPC_SwitchOpcode /*2 cases */, 95|128,1/*223*/, TARGET_VAL(ISD::Constant),// ->20359
/* 20136*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20138*/    OPC_CheckType, MVT::i32,
/* 20140*/    OPC_MoveParent,
/* 20141*/    OPC_RecordChild3, // #3 = $m1
/* 20142*/    OPC_MoveChild3,
/* 20143*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20146*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20148*/    OPC_CheckType, MVT::i32,
/* 20150*/    OPC_MoveParent,
/* 20151*/    OPC_RecordChild4, // #4 = $m2
/* 20152*/    OPC_MoveChild4,
/* 20153*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20156*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20158*/    OPC_CheckType, MVT::i32,
/* 20160*/    OPC_MoveParent,
/* 20161*/    OPC_RecordChild5, // #5 = $m3
/* 20162*/    OPC_MoveChild5,
/* 20163*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20166*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20168*/    OPC_CheckType, MVT::i32,
/* 20170*/    OPC_MoveParent,
/* 20171*/    OPC_RecordChild6, // #6 = $m4
/* 20172*/    OPC_MoveChild6,
/* 20173*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20176*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20178*/    OPC_CheckType, MVT::i32,
/* 20180*/    OPC_MoveParent,
/* 20181*/    OPC_RecordChild7, // #7 = $m5
/* 20182*/    OPC_MoveChild7,
/* 20183*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20186*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20188*/    OPC_CheckType, MVT::i32,
/* 20190*/    OPC_MoveParent,
/* 20191*/    OPC_MoveChild, 8,
/* 20193*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20196*/    OPC_RecordNode, // #8 = $m6
/* 20197*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20199*/    OPC_CheckType, MVT::i32,
/* 20201*/    OPC_MoveParent,
/* 20202*/    OPC_MoveChild, 9,
/* 20204*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20207*/    OPC_RecordNode, // #9 = $m7
/* 20208*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20210*/    OPC_CheckType, MVT::i32,
/* 20212*/    OPC_MoveParent,
/* 20213*/    OPC_MoveChild, 10,
/* 20215*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20218*/    OPC_RecordNode, // #10 = $m8
/* 20219*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20221*/    OPC_CheckType, MVT::i32,
/* 20223*/    OPC_MoveParent,
/* 20224*/    OPC_MoveChild, 11,
/* 20226*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20229*/    OPC_RecordNode, // #11 = $m9
/* 20230*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20232*/    OPC_CheckType, MVT::i32,
/* 20234*/    OPC_MoveParent,
/* 20235*/    OPC_MoveChild, 12,
/* 20237*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20240*/    OPC_RecordNode, // #12 = $mA
/* 20241*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20243*/    OPC_CheckType, MVT::i32,
/* 20245*/    OPC_MoveParent,
/* 20246*/    OPC_MoveChild, 13,
/* 20248*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20251*/    OPC_RecordNode, // #13 = $mB
/* 20252*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20254*/    OPC_CheckType, MVT::i32,
/* 20256*/    OPC_MoveParent,
/* 20257*/    OPC_MoveChild, 14,
/* 20259*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20262*/    OPC_RecordNode, // #14 = $mC
/* 20263*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20265*/    OPC_CheckType, MVT::i32,
/* 20267*/    OPC_MoveParent,
/* 20268*/    OPC_MoveChild, 15,
/* 20270*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20273*/    OPC_RecordNode, // #15 = $mD
/* 20274*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20276*/    OPC_CheckType, MVT::i32,
/* 20278*/    OPC_MoveParent,
/* 20279*/    OPC_MoveChild, 16,
/* 20281*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20284*/    OPC_RecordNode, // #16 = $mE
/* 20285*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20287*/    OPC_CheckType, MVT::i32,
/* 20289*/    OPC_MoveParent,
/* 20290*/    OPC_MoveChild, 17,
/* 20292*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20295*/    OPC_RecordNode, // #17 = $mF
/* 20296*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20298*/    OPC_CheckType, MVT::i32,
/* 20300*/    OPC_MoveParent,
/* 20301*/    OPC_CheckType, MVT::v16i8,
/* 20303*/    OPC_EmitConvertToTarget, 2,
/* 20305*/    OPC_EmitConvertToTarget, 3,
/* 20307*/    OPC_EmitConvertToTarget, 4,
/* 20309*/    OPC_EmitConvertToTarget, 5,
/* 20311*/    OPC_EmitConvertToTarget, 6,
/* 20313*/    OPC_EmitConvertToTarget, 7,
/* 20315*/    OPC_EmitConvertToTarget, 8,
/* 20317*/    OPC_EmitConvertToTarget, 9,
/* 20319*/    OPC_EmitConvertToTarget, 10,
/* 20321*/    OPC_EmitConvertToTarget, 11,
/* 20323*/    OPC_EmitConvertToTarget, 12,
/* 20325*/    OPC_EmitConvertToTarget, 13,
/* 20327*/    OPC_EmitConvertToTarget, 14,
/* 20329*/    OPC_EmitConvertToTarget, 15,
/* 20331*/    OPC_EmitConvertToTarget, 16,
/* 20333*/    OPC_EmitConvertToTarget, 17,
/* 20335*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHUFFLE), 0,
                  MVT::v16i8, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v16i8] } V128:{ *:[v16i8] }:$x, V128:{ *:[v16i8] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
              // Dst: (SHUFFLE:{ *:[v16i8] } ?:{ *:[v16i8] }:$x, ?:{ *:[v16i8] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 20359*/   /*SwitchOpcode*/ 63|128,1/*191*/, TARGET_VAL(ISD::TargetConstant),// ->20554
/* 20363*/    OPC_CheckType, MVT::i32,
/* 20365*/    OPC_MoveParent,
/* 20366*/    OPC_RecordChild3, // #3 = $m1
/* 20367*/    OPC_MoveChild3,
/* 20368*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20371*/    OPC_CheckType, MVT::i32,
/* 20373*/    OPC_MoveParent,
/* 20374*/    OPC_RecordChild4, // #4 = $m2
/* 20375*/    OPC_MoveChild4,
/* 20376*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20379*/    OPC_CheckType, MVT::i32,
/* 20381*/    OPC_MoveParent,
/* 20382*/    OPC_RecordChild5, // #5 = $m3
/* 20383*/    OPC_MoveChild5,
/* 20384*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20387*/    OPC_CheckType, MVT::i32,
/* 20389*/    OPC_MoveParent,
/* 20390*/    OPC_RecordChild6, // #6 = $m4
/* 20391*/    OPC_MoveChild6,
/* 20392*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20395*/    OPC_CheckType, MVT::i32,
/* 20397*/    OPC_MoveParent,
/* 20398*/    OPC_RecordChild7, // #7 = $m5
/* 20399*/    OPC_MoveChild7,
/* 20400*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20403*/    OPC_CheckType, MVT::i32,
/* 20405*/    OPC_MoveParent,
/* 20406*/    OPC_MoveChild, 8,
/* 20408*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20411*/    OPC_RecordNode, // #8 = $m6
/* 20412*/    OPC_CheckType, MVT::i32,
/* 20414*/    OPC_MoveParent,
/* 20415*/    OPC_MoveChild, 9,
/* 20417*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20420*/    OPC_RecordNode, // #9 = $m7
/* 20421*/    OPC_CheckType, MVT::i32,
/* 20423*/    OPC_MoveParent,
/* 20424*/    OPC_MoveChild, 10,
/* 20426*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20429*/    OPC_RecordNode, // #10 = $m8
/* 20430*/    OPC_CheckType, MVT::i32,
/* 20432*/    OPC_MoveParent,
/* 20433*/    OPC_MoveChild, 11,
/* 20435*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20438*/    OPC_RecordNode, // #11 = $m9
/* 20439*/    OPC_CheckType, MVT::i32,
/* 20441*/    OPC_MoveParent,
/* 20442*/    OPC_MoveChild, 12,
/* 20444*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20447*/    OPC_RecordNode, // #12 = $mA
/* 20448*/    OPC_CheckType, MVT::i32,
/* 20450*/    OPC_MoveParent,
/* 20451*/    OPC_MoveChild, 13,
/* 20453*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20456*/    OPC_RecordNode, // #13 = $mB
/* 20457*/    OPC_CheckType, MVT::i32,
/* 20459*/    OPC_MoveParent,
/* 20460*/    OPC_MoveChild, 14,
/* 20462*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20465*/    OPC_RecordNode, // #14 = $mC
/* 20466*/    OPC_CheckType, MVT::i32,
/* 20468*/    OPC_MoveParent,
/* 20469*/    OPC_MoveChild, 15,
/* 20471*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20474*/    OPC_RecordNode, // #15 = $mD
/* 20475*/    OPC_CheckType, MVT::i32,
/* 20477*/    OPC_MoveParent,
/* 20478*/    OPC_MoveChild, 16,
/* 20480*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20483*/    OPC_RecordNode, // #16 = $mE
/* 20484*/    OPC_CheckType, MVT::i32,
/* 20486*/    OPC_MoveParent,
/* 20487*/    OPC_MoveChild, 17,
/* 20489*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20492*/    OPC_RecordNode, // #17 = $mF
/* 20493*/    OPC_CheckType, MVT::i32,
/* 20495*/    OPC_MoveParent,
/* 20496*/    OPC_CheckType, MVT::v16i8,
/* 20498*/    OPC_EmitConvertToTarget, 2,
/* 20500*/    OPC_EmitConvertToTarget, 3,
/* 20502*/    OPC_EmitConvertToTarget, 4,
/* 20504*/    OPC_EmitConvertToTarget, 5,
/* 20506*/    OPC_EmitConvertToTarget, 6,
/* 20508*/    OPC_EmitConvertToTarget, 7,
/* 20510*/    OPC_EmitConvertToTarget, 8,
/* 20512*/    OPC_EmitConvertToTarget, 9,
/* 20514*/    OPC_EmitConvertToTarget, 10,
/* 20516*/    OPC_EmitConvertToTarget, 11,
/* 20518*/    OPC_EmitConvertToTarget, 12,
/* 20520*/    OPC_EmitConvertToTarget, 13,
/* 20522*/    OPC_EmitConvertToTarget, 14,
/* 20524*/    OPC_EmitConvertToTarget, 15,
/* 20526*/    OPC_EmitConvertToTarget, 16,
/* 20528*/    OPC_EmitConvertToTarget, 17,
/* 20530*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHUFFLE), 0,
                  MVT::v16i8, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v16i8] } V128:{ *:[v16i8] }:$x, V128:{ *:[v16i8] }:$y, (timm:{ *:[i32] }):$m0, (timm:{ *:[i32] }):$m1, (timm:{ *:[i32] }):$m2, (timm:{ *:[i32] }):$m3, (timm:{ *:[i32] }):$m4, (timm:{ *:[i32] }):$m5, (timm:{ *:[i32] }):$m6, (timm:{ *:[i32] }):$m7, (timm:{ *:[i32] }):$m8, (timm:{ *:[i32] }):$m9, (timm:{ *:[i32] }):$mA, (timm:{ *:[i32] }):$mB, (timm:{ *:[i32] }):$mC, (timm:{ *:[i32] }):$mD, (timm:{ *:[i32] }):$mE, (timm:{ *:[i32] }):$mF) - Complexity = 51
              // Dst: (SHUFFLE:{ *:[v16i8] } ?:{ *:[v16i8] }:$x, ?:{ *:[v16i8] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 20554*/   0, // EndSwitchOpcode
/* 20555*/  /*Scope*/ 47|128,3/*431*/, /*->20988*/
/* 20557*/   OPC_CheckChild0Type, MVT::v8i16,
/* 20559*/   OPC_RecordChild1, // #1 = $y
/* 20560*/   OPC_CheckChild1Type, MVT::v8i16,
/* 20562*/   OPC_RecordChild2, // #2 = $m0
/* 20563*/   OPC_MoveChild2,
/* 20564*/   OPC_SwitchOpcode /*2 cases */, 95|128,1/*223*/, TARGET_VAL(ISD::Constant),// ->20792
/* 20569*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20571*/    OPC_CheckType, MVT::i32,
/* 20573*/    OPC_MoveParent,
/* 20574*/    OPC_RecordChild3, // #3 = $m1
/* 20575*/    OPC_MoveChild3,
/* 20576*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20579*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20581*/    OPC_CheckType, MVT::i32,
/* 20583*/    OPC_MoveParent,
/* 20584*/    OPC_RecordChild4, // #4 = $m2
/* 20585*/    OPC_MoveChild4,
/* 20586*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20589*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20591*/    OPC_CheckType, MVT::i32,
/* 20593*/    OPC_MoveParent,
/* 20594*/    OPC_RecordChild5, // #5 = $m3
/* 20595*/    OPC_MoveChild5,
/* 20596*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20599*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20601*/    OPC_CheckType, MVT::i32,
/* 20603*/    OPC_MoveParent,
/* 20604*/    OPC_RecordChild6, // #6 = $m4
/* 20605*/    OPC_MoveChild6,
/* 20606*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20609*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20611*/    OPC_CheckType, MVT::i32,
/* 20613*/    OPC_MoveParent,
/* 20614*/    OPC_RecordChild7, // #7 = $m5
/* 20615*/    OPC_MoveChild7,
/* 20616*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20619*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20621*/    OPC_CheckType, MVT::i32,
/* 20623*/    OPC_MoveParent,
/* 20624*/    OPC_MoveChild, 8,
/* 20626*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20629*/    OPC_RecordNode, // #8 = $m6
/* 20630*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20632*/    OPC_CheckType, MVT::i32,
/* 20634*/    OPC_MoveParent,
/* 20635*/    OPC_MoveChild, 9,
/* 20637*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20640*/    OPC_RecordNode, // #9 = $m7
/* 20641*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20643*/    OPC_CheckType, MVT::i32,
/* 20645*/    OPC_MoveParent,
/* 20646*/    OPC_MoveChild, 10,
/* 20648*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20651*/    OPC_RecordNode, // #10 = $m8
/* 20652*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20654*/    OPC_CheckType, MVT::i32,
/* 20656*/    OPC_MoveParent,
/* 20657*/    OPC_MoveChild, 11,
/* 20659*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20662*/    OPC_RecordNode, // #11 = $m9
/* 20663*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20665*/    OPC_CheckType, MVT::i32,
/* 20667*/    OPC_MoveParent,
/* 20668*/    OPC_MoveChild, 12,
/* 20670*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20673*/    OPC_RecordNode, // #12 = $mA
/* 20674*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20676*/    OPC_CheckType, MVT::i32,
/* 20678*/    OPC_MoveParent,
/* 20679*/    OPC_MoveChild, 13,
/* 20681*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20684*/    OPC_RecordNode, // #13 = $mB
/* 20685*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20687*/    OPC_CheckType, MVT::i32,
/* 20689*/    OPC_MoveParent,
/* 20690*/    OPC_MoveChild, 14,
/* 20692*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20695*/    OPC_RecordNode, // #14 = $mC
/* 20696*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20698*/    OPC_CheckType, MVT::i32,
/* 20700*/    OPC_MoveParent,
/* 20701*/    OPC_MoveChild, 15,
/* 20703*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20706*/    OPC_RecordNode, // #15 = $mD
/* 20707*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20709*/    OPC_CheckType, MVT::i32,
/* 20711*/    OPC_MoveParent,
/* 20712*/    OPC_MoveChild, 16,
/* 20714*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20717*/    OPC_RecordNode, // #16 = $mE
/* 20718*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20720*/    OPC_CheckType, MVT::i32,
/* 20722*/    OPC_MoveParent,
/* 20723*/    OPC_MoveChild, 17,
/* 20725*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20728*/    OPC_RecordNode, // #17 = $mF
/* 20729*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20731*/    OPC_CheckType, MVT::i32,
/* 20733*/    OPC_MoveParent,
/* 20734*/    OPC_CheckType, MVT::v8i16,
/* 20736*/    OPC_EmitConvertToTarget, 2,
/* 20738*/    OPC_EmitConvertToTarget, 3,
/* 20740*/    OPC_EmitConvertToTarget, 4,
/* 20742*/    OPC_EmitConvertToTarget, 5,
/* 20744*/    OPC_EmitConvertToTarget, 6,
/* 20746*/    OPC_EmitConvertToTarget, 7,
/* 20748*/    OPC_EmitConvertToTarget, 8,
/* 20750*/    OPC_EmitConvertToTarget, 9,
/* 20752*/    OPC_EmitConvertToTarget, 10,
/* 20754*/    OPC_EmitConvertToTarget, 11,
/* 20756*/    OPC_EmitConvertToTarget, 12,
/* 20758*/    OPC_EmitConvertToTarget, 13,
/* 20760*/    OPC_EmitConvertToTarget, 14,
/* 20762*/    OPC_EmitConvertToTarget, 15,
/* 20764*/    OPC_EmitConvertToTarget, 16,
/* 20766*/    OPC_EmitConvertToTarget, 17,
/* 20768*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHUFFLE), 0,
                  MVT::v8i16, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v8i16] } V128:{ *:[v8i16] }:$x, V128:{ *:[v8i16] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
              // Dst: (SHUFFLE:{ *:[v8i16] } ?:{ *:[v8i16] }:$x, ?:{ *:[v8i16] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 20792*/   /*SwitchOpcode*/ 63|128,1/*191*/, TARGET_VAL(ISD::TargetConstant),// ->20987
/* 20796*/    OPC_CheckType, MVT::i32,
/* 20798*/    OPC_MoveParent,
/* 20799*/    OPC_RecordChild3, // #3 = $m1
/* 20800*/    OPC_MoveChild3,
/* 20801*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20804*/    OPC_CheckType, MVT::i32,
/* 20806*/    OPC_MoveParent,
/* 20807*/    OPC_RecordChild4, // #4 = $m2
/* 20808*/    OPC_MoveChild4,
/* 20809*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20812*/    OPC_CheckType, MVT::i32,
/* 20814*/    OPC_MoveParent,
/* 20815*/    OPC_RecordChild5, // #5 = $m3
/* 20816*/    OPC_MoveChild5,
/* 20817*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20820*/    OPC_CheckType, MVT::i32,
/* 20822*/    OPC_MoveParent,
/* 20823*/    OPC_RecordChild6, // #6 = $m4
/* 20824*/    OPC_MoveChild6,
/* 20825*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20828*/    OPC_CheckType, MVT::i32,
/* 20830*/    OPC_MoveParent,
/* 20831*/    OPC_RecordChild7, // #7 = $m5
/* 20832*/    OPC_MoveChild7,
/* 20833*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20836*/    OPC_CheckType, MVT::i32,
/* 20838*/    OPC_MoveParent,
/* 20839*/    OPC_MoveChild, 8,
/* 20841*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20844*/    OPC_RecordNode, // #8 = $m6
/* 20845*/    OPC_CheckType, MVT::i32,
/* 20847*/    OPC_MoveParent,
/* 20848*/    OPC_MoveChild, 9,
/* 20850*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20853*/    OPC_RecordNode, // #9 = $m7
/* 20854*/    OPC_CheckType, MVT::i32,
/* 20856*/    OPC_MoveParent,
/* 20857*/    OPC_MoveChild, 10,
/* 20859*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20862*/    OPC_RecordNode, // #10 = $m8
/* 20863*/    OPC_CheckType, MVT::i32,
/* 20865*/    OPC_MoveParent,
/* 20866*/    OPC_MoveChild, 11,
/* 20868*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20871*/    OPC_RecordNode, // #11 = $m9
/* 20872*/    OPC_CheckType, MVT::i32,
/* 20874*/    OPC_MoveParent,
/* 20875*/    OPC_MoveChild, 12,
/* 20877*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20880*/    OPC_RecordNode, // #12 = $mA
/* 20881*/    OPC_CheckType, MVT::i32,
/* 20883*/    OPC_MoveParent,
/* 20884*/    OPC_MoveChild, 13,
/* 20886*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20889*/    OPC_RecordNode, // #13 = $mB
/* 20890*/    OPC_CheckType, MVT::i32,
/* 20892*/    OPC_MoveParent,
/* 20893*/    OPC_MoveChild, 14,
/* 20895*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20898*/    OPC_RecordNode, // #14 = $mC
/* 20899*/    OPC_CheckType, MVT::i32,
/* 20901*/    OPC_MoveParent,
/* 20902*/    OPC_MoveChild, 15,
/* 20904*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20907*/    OPC_RecordNode, // #15 = $mD
/* 20908*/    OPC_CheckType, MVT::i32,
/* 20910*/    OPC_MoveParent,
/* 20911*/    OPC_MoveChild, 16,
/* 20913*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20916*/    OPC_RecordNode, // #16 = $mE
/* 20917*/    OPC_CheckType, MVT::i32,
/* 20919*/    OPC_MoveParent,
/* 20920*/    OPC_MoveChild, 17,
/* 20922*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20925*/    OPC_RecordNode, // #17 = $mF
/* 20926*/    OPC_CheckType, MVT::i32,
/* 20928*/    OPC_MoveParent,
/* 20929*/    OPC_CheckType, MVT::v8i16,
/* 20931*/    OPC_EmitConvertToTarget, 2,
/* 20933*/    OPC_EmitConvertToTarget, 3,
/* 20935*/    OPC_EmitConvertToTarget, 4,
/* 20937*/    OPC_EmitConvertToTarget, 5,
/* 20939*/    OPC_EmitConvertToTarget, 6,
/* 20941*/    OPC_EmitConvertToTarget, 7,
/* 20943*/    OPC_EmitConvertToTarget, 8,
/* 20945*/    OPC_EmitConvertToTarget, 9,
/* 20947*/    OPC_EmitConvertToTarget, 10,
/* 20949*/    OPC_EmitConvertToTarget, 11,
/* 20951*/    OPC_EmitConvertToTarget, 12,
/* 20953*/    OPC_EmitConvertToTarget, 13,
/* 20955*/    OPC_EmitConvertToTarget, 14,
/* 20957*/    OPC_EmitConvertToTarget, 15,
/* 20959*/    OPC_EmitConvertToTarget, 16,
/* 20961*/    OPC_EmitConvertToTarget, 17,
/* 20963*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHUFFLE), 0,
                  MVT::v8i16, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v8i16] } V128:{ *:[v8i16] }:$x, V128:{ *:[v8i16] }:$y, (timm:{ *:[i32] }):$m0, (timm:{ *:[i32] }):$m1, (timm:{ *:[i32] }):$m2, (timm:{ *:[i32] }):$m3, (timm:{ *:[i32] }):$m4, (timm:{ *:[i32] }):$m5, (timm:{ *:[i32] }):$m6, (timm:{ *:[i32] }):$m7, (timm:{ *:[i32] }):$m8, (timm:{ *:[i32] }):$m9, (timm:{ *:[i32] }):$mA, (timm:{ *:[i32] }):$mB, (timm:{ *:[i32] }):$mC, (timm:{ *:[i32] }):$mD, (timm:{ *:[i32] }):$mE, (timm:{ *:[i32] }):$mF) - Complexity = 51
              // Dst: (SHUFFLE:{ *:[v8i16] } ?:{ *:[v8i16] }:$x, ?:{ *:[v8i16] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 20987*/   0, // EndSwitchOpcode
/* 20988*/  /*Scope*/ 47|128,3/*431*/, /*->21421*/
/* 20990*/   OPC_CheckChild0Type, MVT::v4i32,
/* 20992*/   OPC_RecordChild1, // #1 = $y
/* 20993*/   OPC_CheckChild1Type, MVT::v4i32,
/* 20995*/   OPC_RecordChild2, // #2 = $m0
/* 20996*/   OPC_MoveChild2,
/* 20997*/   OPC_SwitchOpcode /*2 cases */, 95|128,1/*223*/, TARGET_VAL(ISD::Constant),// ->21225
/* 21002*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 21004*/    OPC_CheckType, MVT::i32,
/* 21006*/    OPC_MoveParent,
/* 21007*/    OPC_RecordChild3, // #3 = $m1
/* 21008*/    OPC_MoveChild3,
/* 21009*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21012*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 21014*/    OPC_CheckType, MVT::i32,
/* 21016*/    OPC_MoveParent,
/* 21017*/    OPC_RecordChild4, // #4 = $m2
/* 21018*/    OPC_MoveChild4,
/* 21019*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21022*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 21024*/    OPC_CheckType, MVT::i32,
/* 21026*/    OPC_MoveParent,
/* 21027*/    OPC_RecordChild5, // #5 = $m3
/* 21028*/    OPC_MoveChild5,
/* 21029*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21032*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 21034*/    OPC_CheckType, MVT::i32,
/* 21036*/    OPC_MoveParent,
/* 21037*/    OPC_RecordChild6, // #6 = $m4
/* 21038*/    OPC_MoveChild6,
/* 21039*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21042*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 21044*/    OPC_CheckType, MVT::i32,
/* 21046*/    OPC_MoveParent,
/* 21047*/    OPC_RecordChild7, // #7 = $m5
/* 21048*/    OPC_MoveChild7,
/* 21049*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21052*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 21054*/    OPC_CheckType, MVT::i32,
/* 21056*/    OPC_MoveParent,
/* 21057*/    OPC_MoveChild, 8,
/* 21059*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21062*/    OPC_RecordNode, // #8 = $m6
/* 21063*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 21065*/    OPC_CheckType, MVT::i32,
/* 21067*/    OPC_MoveParent,
/* 21068*/    OPC_MoveChild, 9,
/* 21070*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21073*/    OPC_RecordNode, // #9 = $m7
/* 21074*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 21076*/    OPC_CheckType, MVT::i32,
/* 21078*/    OPC_MoveParent,
/* 21079*/    OPC_MoveChild, 10,
/* 21081*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21084*/    OPC_RecordNode, // #10 = $m8
/* 21085*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 21087*/    OPC_CheckType, MVT::i32,
/* 21089*/    OPC_MoveParent,
/* 21090*/    OPC_MoveChild, 11,
/* 21092*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21095*/    OPC_RecordNode, // #11 = $m9
/* 21096*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 21098*/    OPC_CheckType, MVT::i32,
/* 21100*/    OPC_MoveParent,
/* 21101*/    OPC_MoveChild, 12,
/* 21103*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21106*/    OPC_RecordNode, // #12 = $mA
/* 21107*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 21109*/    OPC_CheckType, MVT::i32,
/* 21111*/    OPC_MoveParent,
/* 21112*/    OPC_MoveChild, 13,
/* 21114*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21117*/    OPC_RecordNode, // #13 = $mB
/* 21118*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 21120*/    OPC_CheckType, MVT::i32,
/* 21122*/    OPC_MoveParent,
/* 21123*/    OPC_MoveChild, 14,
/* 21125*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21128*/    OPC_RecordNode, // #14 = $mC
/* 21129*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 21131*/    OPC_CheckType, MVT::i32,
/* 21133*/    OPC_MoveParent,
/* 21134*/    OPC_MoveChild, 15,
/* 21136*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21139*/    OPC_RecordNode, // #15 = $mD
/* 21140*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 21142*/    OPC_CheckType, MVT::i32,
/* 21144*/    OPC_MoveParent,
/* 21145*/    OPC_MoveChild, 16,
/* 21147*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21150*/    OPC_RecordNode, // #16 = $mE
/* 21151*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 21153*/    OPC_CheckType, MVT::i32,
/* 21155*/    OPC_MoveParent,
/* 21156*/    OPC_MoveChild, 17,
/* 21158*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21161*/    OPC_RecordNode, // #17 = $mF
/* 21162*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 21164*/    OPC_CheckType, MVT::i32,
/* 21166*/    OPC_MoveParent,
/* 21167*/    OPC_CheckType, MVT::v4i32,
/* 21169*/    OPC_EmitConvertToTarget, 2,
/* 21171*/    OPC_EmitConvertToTarget, 3,
/* 21173*/    OPC_EmitConvertToTarget, 4,
/* 21175*/    OPC_EmitConvertToTarget, 5,
/* 21177*/    OPC_EmitConvertToTarget, 6,
/* 21179*/    OPC_EmitConvertToTarget, 7,
/* 21181*/    OPC_EmitConvertToTarget, 8,
/* 21183*/    OPC_EmitConvertToTarget, 9,
/* 21185*/    OPC_EmitConvertToTarget, 10,
/* 21187*/    OPC_EmitConvertToTarget, 11,
/* 21189*/    OPC_EmitConvertToTarget, 12,
/* 21191*/    OPC_EmitConvertToTarget, 13,
/* 21193*/    OPC_EmitConvertToTarget, 14,
/* 21195*/    OPC_EmitConvertToTarget, 15,
/* 21197*/    OPC_EmitConvertToTarget, 16,
/* 21199*/    OPC_EmitConvertToTarget, 17,
/* 21201*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHUFFLE), 0,
                  MVT::v4i32, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v4i32] } V128:{ *:[v4i32] }:$x, V128:{ *:[v4i32] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
              // Dst: (SHUFFLE:{ *:[v4i32] } ?:{ *:[v4i32] }:$x, ?:{ *:[v4i32] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 21225*/   /*SwitchOpcode*/ 63|128,1/*191*/, TARGET_VAL(ISD::TargetConstant),// ->21420
/* 21229*/    OPC_CheckType, MVT::i32,
/* 21231*/    OPC_MoveParent,
/* 21232*/    OPC_RecordChild3, // #3 = $m1
/* 21233*/    OPC_MoveChild3,
/* 21234*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 21237*/    OPC_CheckType, MVT::i32,
/* 21239*/    OPC_MoveParent,
/* 21240*/    OPC_RecordChild4, // #4 = $m2
/* 21241*/    OPC_MoveChild4,
/* 21242*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 21245*/    OPC_CheckType, MVT::i32,
/* 21247*/    OPC_MoveParent,
/* 21248*/    OPC_RecordChild5, // #5 = $m3
/* 21249*/    OPC_MoveChild5,
/* 21250*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 21253*/    OPC_CheckType, MVT::i32,
/* 21255*/    OPC_MoveParent,
/* 21256*/    OPC_RecordChild6, // #6 = $m4
/* 21257*/    OPC_MoveChild6,
/* 21258*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 21261*/    OPC_CheckType, MVT::i32,
/* 21263*/    OPC_MoveParent,
/* 21264*/    OPC_RecordChild7, // #7 = $m5
/* 21265*/    OPC_MoveChild7,
/* 21266*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 21269*/    OPC_CheckType, MVT::i32,
/* 21271*/    OPC_MoveParent,
/* 21272*/    OPC_MoveChild, 8,
/* 21274*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 21277*/    OPC_RecordNode, // #8 = $m6
/* 21278*/    OPC_CheckType, MVT::i32,
/* 21280*/    OPC_MoveParent,
/* 21281*/    OPC_MoveChild, 9,
/* 21283*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 21286*/    OPC_RecordNode, // #9 = $m7
/* 21287*/    OPC_CheckType, MVT::i32,
/* 21289*/    OPC_MoveParent,
/* 21290*/    OPC_MoveChild, 10,
/* 21292*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 21295*/    OPC_RecordNode, // #10 = $m8
/* 21296*/    OPC_CheckType, MVT::i32,
/* 21298*/    OPC_MoveParent,
/* 21299*/    OPC_MoveChild, 11,
/* 21301*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 21304*/    OPC_RecordNode, // #11 = $m9
/* 21305*/    OPC_CheckType, MVT::i32,
/* 21307*/    OPC_MoveParent,
/* 21308*/    OPC_MoveChild, 12,
/* 21310*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 21313*/    OPC_RecordNode, // #12 = $mA
/* 21314*/    OPC_CheckType, MVT::i32,
/* 21316*/    OPC_MoveParent,
/* 21317*/    OPC_MoveChild, 13,
/* 21319*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 21322*/    OPC_RecordNode, // #13 = $mB
/* 21323*/    OPC_CheckType, MVT::i32,
/* 21325*/    OPC_MoveParent,
/* 21326*/    OPC_MoveChild, 14,
/* 21328*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 21331*/    OPC_RecordNode, // #14 = $mC
/* 21332*/    OPC_CheckType, MVT::i32,
/* 21334*/    OPC_MoveParent,
/* 21335*/    OPC_MoveChild, 15,
/* 21337*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 21340*/    OPC_RecordNode, // #15 = $mD
/* 21341*/    OPC_CheckType, MVT::i32,
/* 21343*/    OPC_MoveParent,
/* 21344*/    OPC_MoveChild, 16,
/* 21346*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 21349*/    OPC_RecordNode, // #16 = $mE
/* 21350*/    OPC_CheckType, MVT::i32,
/* 21352*/    OPC_MoveParent,
/* 21353*/    OPC_MoveChild, 17,
/* 21355*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 21358*/    OPC_RecordNode, // #17 = $mF
/* 21359*/    OPC_CheckType, MVT::i32,
/* 21361*/    OPC_MoveParent,
/* 21362*/    OPC_CheckType, MVT::v4i32,
/* 21364*/    OPC_EmitConvertToTarget, 2,
/* 21366*/    OPC_EmitConvertToTarget, 3,
/* 21368*/    OPC_EmitConvertToTarget, 4,
/* 21370*/    OPC_EmitConvertToTarget, 5,
/* 21372*/    OPC_EmitConvertToTarget, 6,
/* 21374*/    OPC_EmitConvertToTarget, 7,
/* 21376*/    OPC_EmitConvertToTarget, 8,
/* 21378*/    OPC_EmitConvertToTarget, 9,
/* 21380*/    OPC_EmitConvertToTarget, 10,
/* 21382*/    OPC_EmitConvertToTarget, 11,
/* 21384*/    OPC_EmitConvertToTarget, 12,
/* 21386*/    OPC_EmitConvertToTarget, 13,
/* 21388*/    OPC_EmitConvertToTarget, 14,
/* 21390*/    OPC_EmitConvertToTarget, 15,
/* 21392*/    OPC_EmitConvertToTarget, 16,
/* 21394*/    OPC_EmitConvertToTarget, 17,
/* 21396*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHUFFLE), 0,
                  MVT::v4i32, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v4i32] } V128:{ *:[v4i32] }:$x, V128:{ *:[v4i32] }:$y, (timm:{ *:[i32] }):$m0, (timm:{ *:[i32] }):$m1, (timm:{ *:[i32] }):$m2, (timm:{ *:[i32] }):$m3, (timm:{ *:[i32] }):$m4, (timm:{ *:[i32] }):$m5, (timm:{ *:[i32] }):$m6, (timm:{ *:[i32] }):$m7, (timm:{ *:[i32] }):$m8, (timm:{ *:[i32] }):$m9, (timm:{ *:[i32] }):$mA, (timm:{ *:[i32] }):$mB, (timm:{ *:[i32] }):$mC, (timm:{ *:[i32] }):$mD, (timm:{ *:[i32] }):$mE, (timm:{ *:[i32] }):$mF) - Complexity = 51
              // Dst: (SHUFFLE:{ *:[v4i32] } ?:{ *:[v4i32] }:$x, ?:{ *:[v4i32] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 21420*/   0, // EndSwitchOpcode
/* 21421*/  /*Scope*/ 47|128,3/*431*/, /*->21854*/
/* 21423*/   OPC_CheckChild0Type, MVT::v2i64,
/* 21425*/   OPC_RecordChild1, // #1 = $y
/* 21426*/   OPC_CheckChild1Type, MVT::v2i64,
/* 21428*/   OPC_RecordChild2, // #2 = $m0
/* 21429*/   OPC_MoveChild2,
/* 21430*/   OPC_SwitchOpcode /*2 cases */, 95|128,1/*223*/, TARGET_VAL(ISD::Constant),// ->21658
/* 21435*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 21437*/    OPC_CheckType, MVT::i32,
/* 21439*/    OPC_MoveParent,
/* 21440*/    OPC_RecordChild3, // #3 = $m1
/* 21441*/    OPC_MoveChild3,
/* 21442*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21445*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 21447*/    OPC_CheckType, MVT::i32,
/* 21449*/    OPC_MoveParent,
/* 21450*/    OPC_RecordChild4, // #4 = $m2
/* 21451*/    OPC_MoveChild4,
/* 21452*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21455*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 21457*/    OPC_CheckType, MVT::i32,
/* 21459*/    OPC_MoveParent,
/* 21460*/    OPC_RecordChild5, // #5 = $m3
/* 21461*/    OPC_MoveChild5,
/* 21462*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21465*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 21467*/    OPC_CheckType, MVT::i32,
/* 21469*/    OPC_MoveParent,
/* 21470*/    OPC_RecordChild6, // #6 = $m4
/* 21471*/    OPC_MoveChild6,
/* 21472*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21475*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 21477*/    OPC_CheckType, MVT::i32,
/* 21479*/    OPC_MoveParent,
/* 21480*/    OPC_RecordChild7, // #7 = $m5
/* 21481*/    OPC_MoveChild7,
/* 21482*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21485*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 21487*/    OPC_CheckType, MVT::i32,
/* 21489*/    OPC_MoveParent,
/* 21490*/    OPC_MoveChild, 8,
/* 21492*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21495*/    OPC_RecordNode, // #8 = $m6
/* 21496*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 21498*/    OPC_CheckType, MVT::i32,
/* 21500*/    OPC_MoveParent,
/* 21501*/    OPC_MoveChild, 9,
/* 21503*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21506*/    OPC_RecordNode, // #9 = $m7
/* 21507*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 21509*/    OPC_CheckType, MVT::i32,
/* 21511*/    OPC_MoveParent,
/* 21512*/    OPC_MoveChild, 10,
/* 21514*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21517*/    OPC_RecordNode, // #10 = $m8
/* 21518*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 21520*/    OPC_CheckType, MVT::i32,
/* 21522*/    OPC_MoveParent,
/* 21523*/    OPC_MoveChild, 11,
/* 21525*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21528*/    OPC_RecordNode, // #11 = $m9
/* 21529*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 21531*/    OPC_CheckType, MVT::i32,
/* 21533*/    OPC_MoveParent,
/* 21534*/    OPC_MoveChild, 12,
/* 21536*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21539*/    OPC_RecordNode, // #12 = $mA
/* 21540*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 21542*/    OPC_CheckType, MVT::i32,
/* 21544*/    OPC_MoveParent,
/* 21545*/    OPC_MoveChild, 13,
/* 21547*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21550*/    OPC_RecordNode, // #13 = $mB
/* 21551*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 21553*/    OPC_CheckType, MVT::i32,
/* 21555*/    OPC_MoveParent,
/* 21556*/    OPC_MoveChild, 14,
/* 21558*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21561*/    OPC_RecordNode, // #14 = $mC
/* 21562*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 21564*/    OPC_CheckType, MVT::i32,
/* 21566*/    OPC_MoveParent,
/* 21567*/    OPC_MoveChild, 15,
/* 21569*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21572*/    OPC_RecordNode, // #15 = $mD
/* 21573*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 21575*/    OPC_CheckType, MVT::i32,
/* 21577*/    OPC_MoveParent,
/* 21578*/    OPC_MoveChild, 16,
/* 21580*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21583*/    OPC_RecordNode, // #16 = $mE
/* 21584*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 21586*/    OPC_CheckType, MVT::i32,
/* 21588*/    OPC_MoveParent,
/* 21589*/    OPC_MoveChild, 17,
/* 21591*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21594*/    OPC_RecordNode, // #17 = $mF
/* 21595*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 21597*/    OPC_CheckType, MVT::i32,
/* 21599*/    OPC_MoveParent,
/* 21600*/    OPC_CheckType, MVT::v2i64,
/* 21602*/    OPC_EmitConvertToTarget, 2,
/* 21604*/    OPC_EmitConvertToTarget, 3,
/* 21606*/    OPC_EmitConvertToTarget, 4,
/* 21608*/    OPC_EmitConvertToTarget, 5,
/* 21610*/    OPC_EmitConvertToTarget, 6,
/* 21612*/    OPC_EmitConvertToTarget, 7,
/* 21614*/    OPC_EmitConvertToTarget, 8,
/* 21616*/    OPC_EmitConvertToTarget, 9,
/* 21618*/    OPC_EmitConvertToTarget, 10,
/* 21620*/    OPC_EmitConvertToTarget, 11,
/* 21622*/    OPC_EmitConvertToTarget, 12,
/* 21624*/    OPC_EmitConvertToTarget, 13,
/* 21626*/    OPC_EmitConvertToTarget, 14,
/* 21628*/    OPC_EmitConvertToTarget, 15,
/* 21630*/    OPC_EmitConvertToTarget, 16,
/* 21632*/    OPC_EmitConvertToTarget, 17,
/* 21634*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHUFFLE), 0,
                  MVT::v2i64, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v2i64] } V128:{ *:[v2i64] }:$x, V128:{ *:[v2i64] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
              // Dst: (SHUFFLE:{ *:[v2i64] } ?:{ *:[v2i64] }:$x, ?:{ *:[v2i64] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 21658*/   /*SwitchOpcode*/ 63|128,1/*191*/, TARGET_VAL(ISD::TargetConstant),// ->21853
/* 21662*/    OPC_CheckType, MVT::i32,
/* 21664*/    OPC_MoveParent,
/* 21665*/    OPC_RecordChild3, // #3 = $m1
/* 21666*/    OPC_MoveChild3,
/* 21667*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 21670*/    OPC_CheckType, MVT::i32,
/* 21672*/    OPC_MoveParent,
/* 21673*/    OPC_RecordChild4, // #4 = $m2
/* 21674*/    OPC_MoveChild4,
/* 21675*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 21678*/    OPC_CheckType, MVT::i32,
/* 21680*/    OPC_MoveParent,
/* 21681*/    OPC_RecordChild5, // #5 = $m3
/* 21682*/    OPC_MoveChild5,
/* 21683*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 21686*/    OPC_CheckType, MVT::i32,
/* 21688*/    OPC_MoveParent,
/* 21689*/    OPC_RecordChild6, // #6 = $m4
/* 21690*/    OPC_MoveChild6,
/* 21691*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 21694*/    OPC_CheckType, MVT::i32,
/* 21696*/    OPC_MoveParent,
/* 21697*/    OPC_RecordChild7, // #7 = $m5
/* 21698*/    OPC_MoveChild7,
/* 21699*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 21702*/    OPC_CheckType, MVT::i32,
/* 21704*/    OPC_MoveParent,
/* 21705*/    OPC_MoveChild, 8,
/* 21707*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 21710*/    OPC_RecordNode, // #8 = $m6
/* 21711*/    OPC_CheckType, MVT::i32,
/* 21713*/    OPC_MoveParent,
/* 21714*/    OPC_MoveChild, 9,
/* 21716*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 21719*/    OPC_RecordNode, // #9 = $m7
/* 21720*/    OPC_CheckType, MVT::i32,
/* 21722*/    OPC_MoveParent,
/* 21723*/    OPC_MoveChild, 10,
/* 21725*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 21728*/    OPC_RecordNode, // #10 = $m8
/* 21729*/    OPC_CheckType, MVT::i32,
/* 21731*/    OPC_MoveParent,
/* 21732*/    OPC_MoveChild, 11,
/* 21734*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 21737*/    OPC_RecordNode, // #11 = $m9
/* 21738*/    OPC_CheckType, MVT::i32,
/* 21740*/    OPC_MoveParent,
/* 21741*/    OPC_MoveChild, 12,
/* 21743*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 21746*/    OPC_RecordNode, // #12 = $mA
/* 21747*/    OPC_CheckType, MVT::i32,
/* 21749*/    OPC_MoveParent,
/* 21750*/    OPC_MoveChild, 13,
/* 21752*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 21755*/    OPC_RecordNode, // #13 = $mB
/* 21756*/    OPC_CheckType, MVT::i32,
/* 21758*/    OPC_MoveParent,
/* 21759*/    OPC_MoveChild, 14,
/* 21761*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 21764*/    OPC_RecordNode, // #14 = $mC
/* 21765*/    OPC_CheckType, MVT::i32,
/* 21767*/    OPC_MoveParent,
/* 21768*/    OPC_MoveChild, 15,
/* 21770*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 21773*/    OPC_RecordNode, // #15 = $mD
/* 21774*/    OPC_CheckType, MVT::i32,
/* 21776*/    OPC_MoveParent,
/* 21777*/    OPC_MoveChild, 16,
/* 21779*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 21782*/    OPC_RecordNode, // #16 = $mE
/* 21783*/    OPC_CheckType, MVT::i32,
/* 21785*/    OPC_MoveParent,
/* 21786*/    OPC_MoveChild, 17,
/* 21788*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 21791*/    OPC_RecordNode, // #17 = $mF
/* 21792*/    OPC_CheckType, MVT::i32,
/* 21794*/    OPC_MoveParent,
/* 21795*/    OPC_CheckType, MVT::v2i64,
/* 21797*/    OPC_EmitConvertToTarget, 2,
/* 21799*/    OPC_EmitConvertToTarget, 3,
/* 21801*/    OPC_EmitConvertToTarget, 4,
/* 21803*/    OPC_EmitConvertToTarget, 5,
/* 21805*/    OPC_EmitConvertToTarget, 6,
/* 21807*/    OPC_EmitConvertToTarget, 7,
/* 21809*/    OPC_EmitConvertToTarget, 8,
/* 21811*/    OPC_EmitConvertToTarget, 9,
/* 21813*/    OPC_EmitConvertToTarget, 10,
/* 21815*/    OPC_EmitConvertToTarget, 11,
/* 21817*/    OPC_EmitConvertToTarget, 12,
/* 21819*/    OPC_EmitConvertToTarget, 13,
/* 21821*/    OPC_EmitConvertToTarget, 14,
/* 21823*/    OPC_EmitConvertToTarget, 15,
/* 21825*/    OPC_EmitConvertToTarget, 16,
/* 21827*/    OPC_EmitConvertToTarget, 17,
/* 21829*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHUFFLE), 0,
                  MVT::v2i64, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v2i64] } V128:{ *:[v2i64] }:$x, V128:{ *:[v2i64] }:$y, (timm:{ *:[i32] }):$m0, (timm:{ *:[i32] }):$m1, (timm:{ *:[i32] }):$m2, (timm:{ *:[i32] }):$m3, (timm:{ *:[i32] }):$m4, (timm:{ *:[i32] }):$m5, (timm:{ *:[i32] }):$m6, (timm:{ *:[i32] }):$m7, (timm:{ *:[i32] }):$m8, (timm:{ *:[i32] }):$m9, (timm:{ *:[i32] }):$mA, (timm:{ *:[i32] }):$mB, (timm:{ *:[i32] }):$mC, (timm:{ *:[i32] }):$mD, (timm:{ *:[i32] }):$mE, (timm:{ *:[i32] }):$mF) - Complexity = 51
              // Dst: (SHUFFLE:{ *:[v2i64] } ?:{ *:[v2i64] }:$x, ?:{ *:[v2i64] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 21853*/   0, // EndSwitchOpcode
/* 21854*/  /*Scope*/ 47|128,3/*431*/, /*->22287*/
/* 21856*/   OPC_CheckChild0Type, MVT::v4f32,
/* 21858*/   OPC_RecordChild1, // #1 = $y
/* 21859*/   OPC_CheckChild1Type, MVT::v4f32,
/* 21861*/   OPC_RecordChild2, // #2 = $m0
/* 21862*/   OPC_MoveChild2,
/* 21863*/   OPC_SwitchOpcode /*2 cases */, 95|128,1/*223*/, TARGET_VAL(ISD::Constant),// ->22091
/* 21868*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 21870*/    OPC_CheckType, MVT::i32,
/* 21872*/    OPC_MoveParent,
/* 21873*/    OPC_RecordChild3, // #3 = $m1
/* 21874*/    OPC_MoveChild3,
/* 21875*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21878*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 21880*/    OPC_CheckType, MVT::i32,
/* 21882*/    OPC_MoveParent,
/* 21883*/    OPC_RecordChild4, // #4 = $m2
/* 21884*/    OPC_MoveChild4,
/* 21885*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21888*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 21890*/    OPC_CheckType, MVT::i32,
/* 21892*/    OPC_MoveParent,
/* 21893*/    OPC_RecordChild5, // #5 = $m3
/* 21894*/    OPC_MoveChild5,
/* 21895*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21898*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 21900*/    OPC_CheckType, MVT::i32,
/* 21902*/    OPC_MoveParent,
/* 21903*/    OPC_RecordChild6, // #6 = $m4
/* 21904*/    OPC_MoveChild6,
/* 21905*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21908*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 21910*/    OPC_CheckType, MVT::i32,
/* 21912*/    OPC_MoveParent,
/* 21913*/    OPC_RecordChild7, // #7 = $m5
/* 21914*/    OPC_MoveChild7,
/* 21915*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21918*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 21920*/    OPC_CheckType, MVT::i32,
/* 21922*/    OPC_MoveParent,
/* 21923*/    OPC_MoveChild, 8,
/* 21925*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21928*/    OPC_RecordNode, // #8 = $m6
/* 21929*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 21931*/    OPC_CheckType, MVT::i32,
/* 21933*/    OPC_MoveParent,
/* 21934*/    OPC_MoveChild, 9,
/* 21936*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21939*/    OPC_RecordNode, // #9 = $m7
/* 21940*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 21942*/    OPC_CheckType, MVT::i32,
/* 21944*/    OPC_MoveParent,
/* 21945*/    OPC_MoveChild, 10,
/* 21947*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21950*/    OPC_RecordNode, // #10 = $m8
/* 21951*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 21953*/    OPC_CheckType, MVT::i32,
/* 21955*/    OPC_MoveParent,
/* 21956*/    OPC_MoveChild, 11,
/* 21958*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21961*/    OPC_RecordNode, // #11 = $m9
/* 21962*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 21964*/    OPC_CheckType, MVT::i32,
/* 21966*/    OPC_MoveParent,
/* 21967*/    OPC_MoveChild, 12,
/* 21969*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21972*/    OPC_RecordNode, // #12 = $mA
/* 21973*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 21975*/    OPC_CheckType, MVT::i32,
/* 21977*/    OPC_MoveParent,
/* 21978*/    OPC_MoveChild, 13,
/* 21980*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21983*/    OPC_RecordNode, // #13 = $mB
/* 21984*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 21986*/    OPC_CheckType, MVT::i32,
/* 21988*/    OPC_MoveParent,
/* 21989*/    OPC_MoveChild, 14,
/* 21991*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21994*/    OPC_RecordNode, // #14 = $mC
/* 21995*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 21997*/    OPC_CheckType, MVT::i32,
/* 21999*/    OPC_MoveParent,
/* 22000*/    OPC_MoveChild, 15,
/* 22002*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 22005*/    OPC_RecordNode, // #15 = $mD
/* 22006*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 22008*/    OPC_CheckType, MVT::i32,
/* 22010*/    OPC_MoveParent,
/* 22011*/    OPC_MoveChild, 16,
/* 22013*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 22016*/    OPC_RecordNode, // #16 = $mE
/* 22017*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 22019*/    OPC_CheckType, MVT::i32,
/* 22021*/    OPC_MoveParent,
/* 22022*/    OPC_MoveChild, 17,
/* 22024*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 22027*/    OPC_RecordNode, // #17 = $mF
/* 22028*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 22030*/    OPC_CheckType, MVT::i32,
/* 22032*/    OPC_MoveParent,
/* 22033*/    OPC_CheckType, MVT::v4f32,
/* 22035*/    OPC_EmitConvertToTarget, 2,
/* 22037*/    OPC_EmitConvertToTarget, 3,
/* 22039*/    OPC_EmitConvertToTarget, 4,
/* 22041*/    OPC_EmitConvertToTarget, 5,
/* 22043*/    OPC_EmitConvertToTarget, 6,
/* 22045*/    OPC_EmitConvertToTarget, 7,
/* 22047*/    OPC_EmitConvertToTarget, 8,
/* 22049*/    OPC_EmitConvertToTarget, 9,
/* 22051*/    OPC_EmitConvertToTarget, 10,
/* 22053*/    OPC_EmitConvertToTarget, 11,
/* 22055*/    OPC_EmitConvertToTarget, 12,
/* 22057*/    OPC_EmitConvertToTarget, 13,
/* 22059*/    OPC_EmitConvertToTarget, 14,
/* 22061*/    OPC_EmitConvertToTarget, 15,
/* 22063*/    OPC_EmitConvertToTarget, 16,
/* 22065*/    OPC_EmitConvertToTarget, 17,
/* 22067*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHUFFLE), 0,
                  MVT::v4f32, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v4f32] } V128:{ *:[v4f32] }:$x, V128:{ *:[v4f32] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
              // Dst: (SHUFFLE:{ *:[v4f32] } ?:{ *:[v4f32] }:$x, ?:{ *:[v4f32] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 22091*/   /*SwitchOpcode*/ 63|128,1/*191*/, TARGET_VAL(ISD::TargetConstant),// ->22286
/* 22095*/    OPC_CheckType, MVT::i32,
/* 22097*/    OPC_MoveParent,
/* 22098*/    OPC_RecordChild3, // #3 = $m1
/* 22099*/    OPC_MoveChild3,
/* 22100*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 22103*/    OPC_CheckType, MVT::i32,
/* 22105*/    OPC_MoveParent,
/* 22106*/    OPC_RecordChild4, // #4 = $m2
/* 22107*/    OPC_MoveChild4,
/* 22108*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 22111*/    OPC_CheckType, MVT::i32,
/* 22113*/    OPC_MoveParent,
/* 22114*/    OPC_RecordChild5, // #5 = $m3
/* 22115*/    OPC_MoveChild5,
/* 22116*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 22119*/    OPC_CheckType, MVT::i32,
/* 22121*/    OPC_MoveParent,
/* 22122*/    OPC_RecordChild6, // #6 = $m4
/* 22123*/    OPC_MoveChild6,
/* 22124*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 22127*/    OPC_CheckType, MVT::i32,
/* 22129*/    OPC_MoveParent,
/* 22130*/    OPC_RecordChild7, // #7 = $m5
/* 22131*/    OPC_MoveChild7,
/* 22132*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 22135*/    OPC_CheckType, MVT::i32,
/* 22137*/    OPC_MoveParent,
/* 22138*/    OPC_MoveChild, 8,
/* 22140*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 22143*/    OPC_RecordNode, // #8 = $m6
/* 22144*/    OPC_CheckType, MVT::i32,
/* 22146*/    OPC_MoveParent,
/* 22147*/    OPC_MoveChild, 9,
/* 22149*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 22152*/    OPC_RecordNode, // #9 = $m7
/* 22153*/    OPC_CheckType, MVT::i32,
/* 22155*/    OPC_MoveParent,
/* 22156*/    OPC_MoveChild, 10,
/* 22158*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 22161*/    OPC_RecordNode, // #10 = $m8
/* 22162*/    OPC_CheckType, MVT::i32,
/* 22164*/    OPC_MoveParent,
/* 22165*/    OPC_MoveChild, 11,
/* 22167*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 22170*/    OPC_RecordNode, // #11 = $m9
/* 22171*/    OPC_CheckType, MVT::i32,
/* 22173*/    OPC_MoveParent,
/* 22174*/    OPC_MoveChild, 12,
/* 22176*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 22179*/    OPC_RecordNode, // #12 = $mA
/* 22180*/    OPC_CheckType, MVT::i32,
/* 22182*/    OPC_MoveParent,
/* 22183*/    OPC_MoveChild, 13,
/* 22185*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 22188*/    OPC_RecordNode, // #13 = $mB
/* 22189*/    OPC_CheckType, MVT::i32,
/* 22191*/    OPC_MoveParent,
/* 22192*/    OPC_MoveChild, 14,
/* 22194*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 22197*/    OPC_RecordNode, // #14 = $mC
/* 22198*/    OPC_CheckType, MVT::i32,
/* 22200*/    OPC_MoveParent,
/* 22201*/    OPC_MoveChild, 15,
/* 22203*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 22206*/    OPC_RecordNode, // #15 = $mD
/* 22207*/    OPC_CheckType, MVT::i32,
/* 22209*/    OPC_MoveParent,
/* 22210*/    OPC_MoveChild, 16,
/* 22212*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 22215*/    OPC_RecordNode, // #16 = $mE
/* 22216*/    OPC_CheckType, MVT::i32,
/* 22218*/    OPC_MoveParent,
/* 22219*/    OPC_MoveChild, 17,
/* 22221*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 22224*/    OPC_RecordNode, // #17 = $mF
/* 22225*/    OPC_CheckType, MVT::i32,
/* 22227*/    OPC_MoveParent,
/* 22228*/    OPC_CheckType, MVT::v4f32,
/* 22230*/    OPC_EmitConvertToTarget, 2,
/* 22232*/    OPC_EmitConvertToTarget, 3,
/* 22234*/    OPC_EmitConvertToTarget, 4,
/* 22236*/    OPC_EmitConvertToTarget, 5,
/* 22238*/    OPC_EmitConvertToTarget, 6,
/* 22240*/    OPC_EmitConvertToTarget, 7,
/* 22242*/    OPC_EmitConvertToTarget, 8,
/* 22244*/    OPC_EmitConvertToTarget, 9,
/* 22246*/    OPC_EmitConvertToTarget, 10,
/* 22248*/    OPC_EmitConvertToTarget, 11,
/* 22250*/    OPC_EmitConvertToTarget, 12,
/* 22252*/    OPC_EmitConvertToTarget, 13,
/* 22254*/    OPC_EmitConvertToTarget, 14,
/* 22256*/    OPC_EmitConvertToTarget, 15,
/* 22258*/    OPC_EmitConvertToTarget, 16,
/* 22260*/    OPC_EmitConvertToTarget, 17,
/* 22262*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHUFFLE), 0,
                  MVT::v4f32, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v4f32] } V128:{ *:[v4f32] }:$x, V128:{ *:[v4f32] }:$y, (timm:{ *:[i32] }):$m0, (timm:{ *:[i32] }):$m1, (timm:{ *:[i32] }):$m2, (timm:{ *:[i32] }):$m3, (timm:{ *:[i32] }):$m4, (timm:{ *:[i32] }):$m5, (timm:{ *:[i32] }):$m6, (timm:{ *:[i32] }):$m7, (timm:{ *:[i32] }):$m8, (timm:{ *:[i32] }):$m9, (timm:{ *:[i32] }):$mA, (timm:{ *:[i32] }):$mB, (timm:{ *:[i32] }):$mC, (timm:{ *:[i32] }):$mD, (timm:{ *:[i32] }):$mE, (timm:{ *:[i32] }):$mF) - Complexity = 51
              // Dst: (SHUFFLE:{ *:[v4f32] } ?:{ *:[v4f32] }:$x, ?:{ *:[v4f32] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 22286*/   0, // EndSwitchOpcode
/* 22287*/  /*Scope*/ 47|128,3/*431*/, /*->22720*/
/* 22289*/   OPC_CheckChild0Type, MVT::v2f64,
/* 22291*/   OPC_RecordChild1, // #1 = $y
/* 22292*/   OPC_CheckChild1Type, MVT::v2f64,
/* 22294*/   OPC_RecordChild2, // #2 = $m0
/* 22295*/   OPC_MoveChild2,
/* 22296*/   OPC_SwitchOpcode /*2 cases */, 95|128,1/*223*/, TARGET_VAL(ISD::Constant),// ->22524
/* 22301*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 22303*/    OPC_CheckType, MVT::i32,
/* 22305*/    OPC_MoveParent,
/* 22306*/    OPC_RecordChild3, // #3 = $m1
/* 22307*/    OPC_MoveChild3,
/* 22308*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 22311*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 22313*/    OPC_CheckType, MVT::i32,
/* 22315*/    OPC_MoveParent,
/* 22316*/    OPC_RecordChild4, // #4 = $m2
/* 22317*/    OPC_MoveChild4,
/* 22318*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 22321*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 22323*/    OPC_CheckType, MVT::i32,
/* 22325*/    OPC_MoveParent,
/* 22326*/    OPC_RecordChild5, // #5 = $m3
/* 22327*/    OPC_MoveChild5,
/* 22328*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 22331*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 22333*/    OPC_CheckType, MVT::i32,
/* 22335*/    OPC_MoveParent,
/* 22336*/    OPC_RecordChild6, // #6 = $m4
/* 22337*/    OPC_MoveChild6,
/* 22338*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 22341*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 22343*/    OPC_CheckType, MVT::i32,
/* 22345*/    OPC_MoveParent,
/* 22346*/    OPC_RecordChild7, // #7 = $m5
/* 22347*/    OPC_MoveChild7,
/* 22348*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 22351*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 22353*/    OPC_CheckType, MVT::i32,
/* 22355*/    OPC_MoveParent,
/* 22356*/    OPC_MoveChild, 8,
/* 22358*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 22361*/    OPC_RecordNode, // #8 = $m6
/* 22362*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 22364*/    OPC_CheckType, MVT::i32,
/* 22366*/    OPC_MoveParent,
/* 22367*/    OPC_MoveChild, 9,
/* 22369*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 22372*/    OPC_RecordNode, // #9 = $m7
/* 22373*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 22375*/    OPC_CheckType, MVT::i32,
/* 22377*/    OPC_MoveParent,
/* 22378*/    OPC_MoveChild, 10,
/* 22380*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 22383*/    OPC_RecordNode, // #10 = $m8
/* 22384*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 22386*/    OPC_CheckType, MVT::i32,
/* 22388*/    OPC_MoveParent,
/* 22389*/    OPC_MoveChild, 11,
/* 22391*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 22394*/    OPC_RecordNode, // #11 = $m9
/* 22395*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 22397*/    OPC_CheckType, MVT::i32,
/* 22399*/    OPC_MoveParent,
/* 22400*/    OPC_MoveChild, 12,
/* 22402*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 22405*/    OPC_RecordNode, // #12 = $mA
/* 22406*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 22408*/    OPC_CheckType, MVT::i32,
/* 22410*/    OPC_MoveParent,
/* 22411*/    OPC_MoveChild, 13,
/* 22413*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 22416*/    OPC_RecordNode, // #13 = $mB
/* 22417*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 22419*/    OPC_CheckType, MVT::i32,
/* 22421*/    OPC_MoveParent,
/* 22422*/    OPC_MoveChild, 14,
/* 22424*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 22427*/    OPC_RecordNode, // #14 = $mC
/* 22428*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 22430*/    OPC_CheckType, MVT::i32,
/* 22432*/    OPC_MoveParent,
/* 22433*/    OPC_MoveChild, 15,
/* 22435*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 22438*/    OPC_RecordNode, // #15 = $mD
/* 22439*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 22441*/    OPC_CheckType, MVT::i32,
/* 22443*/    OPC_MoveParent,
/* 22444*/    OPC_MoveChild, 16,
/* 22446*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 22449*/    OPC_RecordNode, // #16 = $mE
/* 22450*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 22452*/    OPC_CheckType, MVT::i32,
/* 22454*/    OPC_MoveParent,
/* 22455*/    OPC_MoveChild, 17,
/* 22457*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 22460*/    OPC_RecordNode, // #17 = $mF
/* 22461*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 22463*/    OPC_CheckType, MVT::i32,
/* 22465*/    OPC_MoveParent,
/* 22466*/    OPC_CheckType, MVT::v2f64,
/* 22468*/    OPC_EmitConvertToTarget, 2,
/* 22470*/    OPC_EmitConvertToTarget, 3,
/* 22472*/    OPC_EmitConvertToTarget, 4,
/* 22474*/    OPC_EmitConvertToTarget, 5,
/* 22476*/    OPC_EmitConvertToTarget, 6,
/* 22478*/    OPC_EmitConvertToTarget, 7,
/* 22480*/    OPC_EmitConvertToTarget, 8,
/* 22482*/    OPC_EmitConvertToTarget, 9,
/* 22484*/    OPC_EmitConvertToTarget, 10,
/* 22486*/    OPC_EmitConvertToTarget, 11,
/* 22488*/    OPC_EmitConvertToTarget, 12,
/* 22490*/    OPC_EmitConvertToTarget, 13,
/* 22492*/    OPC_EmitConvertToTarget, 14,
/* 22494*/    OPC_EmitConvertToTarget, 15,
/* 22496*/    OPC_EmitConvertToTarget, 16,
/* 22498*/    OPC_EmitConvertToTarget, 17,
/* 22500*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHUFFLE), 0,
                  MVT::v2f64, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v2f64] } V128:{ *:[v2f64] }:$x, V128:{ *:[v2f64] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
              // Dst: (SHUFFLE:{ *:[v2f64] } ?:{ *:[v2f64] }:$x, ?:{ *:[v2f64] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 22524*/   /*SwitchOpcode*/ 63|128,1/*191*/, TARGET_VAL(ISD::TargetConstant),// ->22719
/* 22528*/    OPC_CheckType, MVT::i32,
/* 22530*/    OPC_MoveParent,
/* 22531*/    OPC_RecordChild3, // #3 = $m1
/* 22532*/    OPC_MoveChild3,
/* 22533*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 22536*/    OPC_CheckType, MVT::i32,
/* 22538*/    OPC_MoveParent,
/* 22539*/    OPC_RecordChild4, // #4 = $m2
/* 22540*/    OPC_MoveChild4,
/* 22541*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 22544*/    OPC_CheckType, MVT::i32,
/* 22546*/    OPC_MoveParent,
/* 22547*/    OPC_RecordChild5, // #5 = $m3
/* 22548*/    OPC_MoveChild5,
/* 22549*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 22552*/    OPC_CheckType, MVT::i32,
/* 22554*/    OPC_MoveParent,
/* 22555*/    OPC_RecordChild6, // #6 = $m4
/* 22556*/    OPC_MoveChild6,
/* 22557*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 22560*/    OPC_CheckType, MVT::i32,
/* 22562*/    OPC_MoveParent,
/* 22563*/    OPC_RecordChild7, // #7 = $m5
/* 22564*/    OPC_MoveChild7,
/* 22565*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 22568*/    OPC_CheckType, MVT::i32,
/* 22570*/    OPC_MoveParent,
/* 22571*/    OPC_MoveChild, 8,
/* 22573*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 22576*/    OPC_RecordNode, // #8 = $m6
/* 22577*/    OPC_CheckType, MVT::i32,
/* 22579*/    OPC_MoveParent,
/* 22580*/    OPC_MoveChild, 9,
/* 22582*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 22585*/    OPC_RecordNode, // #9 = $m7
/* 22586*/    OPC_CheckType, MVT::i32,
/* 22588*/    OPC_MoveParent,
/* 22589*/    OPC_MoveChild, 10,
/* 22591*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 22594*/    OPC_RecordNode, // #10 = $m8
/* 22595*/    OPC_CheckType, MVT::i32,
/* 22597*/    OPC_MoveParent,
/* 22598*/    OPC_MoveChild, 11,
/* 22600*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 22603*/    OPC_RecordNode, // #11 = $m9
/* 22604*/    OPC_CheckType, MVT::i32,
/* 22606*/    OPC_MoveParent,
/* 22607*/    OPC_MoveChild, 12,
/* 22609*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 22612*/    OPC_RecordNode, // #12 = $mA
/* 22613*/    OPC_CheckType, MVT::i32,
/* 22615*/    OPC_MoveParent,
/* 22616*/    OPC_MoveChild, 13,
/* 22618*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 22621*/    OPC_RecordNode, // #13 = $mB
/* 22622*/    OPC_CheckType, MVT::i32,
/* 22624*/    OPC_MoveParent,
/* 22625*/    OPC_MoveChild, 14,
/* 22627*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 22630*/    OPC_RecordNode, // #14 = $mC
/* 22631*/    OPC_CheckType, MVT::i32,
/* 22633*/    OPC_MoveParent,
/* 22634*/    OPC_MoveChild, 15,
/* 22636*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 22639*/    OPC_RecordNode, // #15 = $mD
/* 22640*/    OPC_CheckType, MVT::i32,
/* 22642*/    OPC_MoveParent,
/* 22643*/    OPC_MoveChild, 16,
/* 22645*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 22648*/    OPC_RecordNode, // #16 = $mE
/* 22649*/    OPC_CheckType, MVT::i32,
/* 22651*/    OPC_MoveParent,
/* 22652*/    OPC_MoveChild, 17,
/* 22654*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 22657*/    OPC_RecordNode, // #17 = $mF
/* 22658*/    OPC_CheckType, MVT::i32,
/* 22660*/    OPC_MoveParent,
/* 22661*/    OPC_CheckType, MVT::v2f64,
/* 22663*/    OPC_EmitConvertToTarget, 2,
/* 22665*/    OPC_EmitConvertToTarget, 3,
/* 22667*/    OPC_EmitConvertToTarget, 4,
/* 22669*/    OPC_EmitConvertToTarget, 5,
/* 22671*/    OPC_EmitConvertToTarget, 6,
/* 22673*/    OPC_EmitConvertToTarget, 7,
/* 22675*/    OPC_EmitConvertToTarget, 8,
/* 22677*/    OPC_EmitConvertToTarget, 9,
/* 22679*/    OPC_EmitConvertToTarget, 10,
/* 22681*/    OPC_EmitConvertToTarget, 11,
/* 22683*/    OPC_EmitConvertToTarget, 12,
/* 22685*/    OPC_EmitConvertToTarget, 13,
/* 22687*/    OPC_EmitConvertToTarget, 14,
/* 22689*/    OPC_EmitConvertToTarget, 15,
/* 22691*/    OPC_EmitConvertToTarget, 16,
/* 22693*/    OPC_EmitConvertToTarget, 17,
/* 22695*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHUFFLE), 0,
                  MVT::v2f64, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v2f64] } V128:{ *:[v2f64] }:$x, V128:{ *:[v2f64] }:$y, (timm:{ *:[i32] }):$m0, (timm:{ *:[i32] }):$m1, (timm:{ *:[i32] }):$m2, (timm:{ *:[i32] }):$m3, (timm:{ *:[i32] }):$m4, (timm:{ *:[i32] }):$m5, (timm:{ *:[i32] }):$m6, (timm:{ *:[i32] }):$m7, (timm:{ *:[i32] }):$m8, (timm:{ *:[i32] }):$m9, (timm:{ *:[i32] }):$mA, (timm:{ *:[i32] }):$mB, (timm:{ *:[i32] }):$mC, (timm:{ *:[i32] }):$mD, (timm:{ *:[i32] }):$mE, (timm:{ *:[i32] }):$mF) - Complexity = 51
              // Dst: (SHUFFLE:{ *:[v2f64] } ?:{ *:[v2f64] }:$x, ?:{ *:[v2f64] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 22719*/   0, // EndSwitchOpcode
/* 22720*/  0, /*End of Scope*/
/* 22721*/ /*SwitchOpcode*/ 33|128,6/*801*/, TARGET_VAL(ISD::INSERT_VECTOR_ELT),// ->23526
/* 22725*/  OPC_Scope, 32|128,1/*160*/, /*->22888*/ // 2 children in Scope
/* 22728*/   OPC_MoveChild0,
/* 22729*/   OPC_CheckOpcode, TARGET_VAL(ISD::SPLAT_VECTOR),
/* 22732*/   OPC_CheckChild0Integer, 0, 
/* 22734*/   OPC_Scope, 75, /*->22811*/ // 2 children in Scope
/* 22736*/    OPC_CheckChild0Type, MVT::i32,
/* 22738*/    OPC_MoveParent,
/* 22739*/    OPC_MoveChild1,
/* 22740*/    OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
/* 22743*/    OPC_RecordMemRef,
/* 22744*/    OPC_RecordNode, // #0 = 'ld' chained node
/* 22745*/    OPC_CheckFoldableChainNode,
/* 22746*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/* 22747*/    OPC_CheckType, MVT::i32,
/* 22749*/    OPC_Scope, 29, /*->22780*/ // 2 children in Scope
/* 22751*/     OPC_CheckChild1Type, MVT::i32,
/* 22753*/     OPC_CheckPredicate, 14, // Predicate_unindexedload
/* 22755*/     OPC_CheckPredicate, 15, // Predicate_load
/* 22757*/     OPC_MoveParent,
/* 22758*/     OPC_CheckChild2Integer, 0, 
/* 22760*/     OPC_CheckType, MVT::v4i32,
/* 22762*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/* 22764*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 22767*/     OPC_EmitMergeInputChains1_0,
/* 22768*/     OPC_EmitInteger, MVT::i32, 0, 
/* 22771*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (vector_insert:{ *:[v4i32] } (splat_vector:{ *:[v4i32] } 0:{ *:[i32] }), (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[iPTR] }) - Complexity = 29
               // Dst: (LOAD_ZERO_I32x4_A32:{ *:[v4i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 22780*/    /*Scope*/ 29, /*->22810*/
/* 22781*/     OPC_CheckChild1Type, MVT::i64,
/* 22783*/     OPC_CheckPredicate, 14, // Predicate_unindexedload
/* 22785*/     OPC_CheckPredicate, 15, // Predicate_load
/* 22787*/     OPC_MoveParent,
/* 22788*/     OPC_CheckChild2Integer, 0, 
/* 22790*/     OPC_CheckType, MVT::v4i32,
/* 22792*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/* 22794*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 22797*/     OPC_EmitMergeInputChains1_0,
/* 22798*/     OPC_EmitInteger, MVT::i32, 0, 
/* 22801*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (vector_insert:{ *:[v4i32] } (splat_vector:{ *:[v4i32] } 0:{ *:[i32] }), (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[iPTR] }) - Complexity = 29
               // Dst: (LOAD_ZERO_I32x4_A64:{ *:[v4i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 22810*/    0, /*End of Scope*/
/* 22811*/   /*Scope*/ 75, /*->22887*/
/* 22812*/    OPC_CheckChild0Type, MVT::i64,
/* 22814*/    OPC_MoveParent,
/* 22815*/    OPC_MoveChild1,
/* 22816*/    OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
/* 22819*/    OPC_RecordMemRef,
/* 22820*/    OPC_RecordNode, // #0 = 'ld' chained node
/* 22821*/    OPC_CheckFoldableChainNode,
/* 22822*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/* 22823*/    OPC_CheckType, MVT::i64,
/* 22825*/    OPC_Scope, 29, /*->22856*/ // 2 children in Scope
/* 22827*/     OPC_CheckChild1Type, MVT::i32,
/* 22829*/     OPC_CheckPredicate, 14, // Predicate_unindexedload
/* 22831*/     OPC_CheckPredicate, 15, // Predicate_load
/* 22833*/     OPC_MoveParent,
/* 22834*/     OPC_CheckChild2Integer, 0, 
/* 22836*/     OPC_CheckType, MVT::v2i64,
/* 22838*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/* 22840*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 22843*/     OPC_EmitMergeInputChains1_0,
/* 22844*/     OPC_EmitInteger, MVT::i32, 0, 
/* 22847*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (vector_insert:{ *:[v2i64] } (splat_vector:{ *:[v2i64] } 0:{ *:[i64] }), (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[iPTR] }) - Complexity = 29
               // Dst: (LOAD_ZERO_I64x2_A32:{ *:[v2i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 22856*/    /*Scope*/ 29, /*->22886*/
/* 22857*/     OPC_CheckChild1Type, MVT::i64,
/* 22859*/     OPC_CheckPredicate, 14, // Predicate_unindexedload
/* 22861*/     OPC_CheckPredicate, 15, // Predicate_load
/* 22863*/     OPC_MoveParent,
/* 22864*/     OPC_CheckChild2Integer, 0, 
/* 22866*/     OPC_CheckType, MVT::v2i64,
/* 22868*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/* 22870*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 22873*/     OPC_EmitMergeInputChains1_0,
/* 22874*/     OPC_EmitInteger, MVT::i32, 0, 
/* 22877*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (vector_insert:{ *:[v2i64] } (splat_vector:{ *:[v2i64] } 0:{ *:[i64] }), (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[iPTR] }) - Complexity = 29
               // Dst: (LOAD_ZERO_I64x2_A64:{ *:[v2i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 22886*/    0, /*End of Scope*/
/* 22887*/   0, /*End of Scope*/
/* 22888*/  /*Scope*/ 123|128,4/*635*/, /*->23525*/
/* 22890*/   OPC_RecordChild0, // #0 = $vec
/* 22891*/   OPC_Scope, 94|128,2/*350*/, /*->23244*/ // 2 children in Scope
/* 22894*/    OPC_MoveChild1,
/* 22895*/    OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
/* 22898*/    OPC_RecordMemRef,
/* 22899*/    OPC_RecordNode, // #1 = 'ld' chained node
/* 22900*/    OPC_CheckFoldableChainNode,
/* 22901*/    OPC_RecordChild1, // #2 = $addr
/* 22902*/    OPC_Scope, 40|128,1/*168*/, /*->23073*/ // 2 children in Scope
/* 22905*/     OPC_CheckChild1Type, MVT::i32,
/* 22907*/     OPC_CheckPredicate, 14, // Predicate_unindexedload
/* 22909*/     OPC_Scope, 82, /*->22993*/ // 2 children in Scope
/* 22911*/      OPC_CheckPredicate, 18, // Predicate_extload
/* 22913*/      OPC_CheckType, MVT::i32,
/* 22915*/      OPC_Scope, 37, /*->22954*/ // 2 children in Scope
/* 22917*/       OPC_CheckPredicate, 0, // Predicate_extloadi8
/* 22919*/       OPC_MoveParent,
/* 22920*/       OPC_RecordChild2, // #3 = $idx
/* 22921*/       OPC_MoveChild2,
/* 22922*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 22925*/       OPC_CheckPredicate, 3, // Predicate_LaneIdx16
/* 22927*/       OPC_CheckType, MVT::i32,
/* 22929*/       OPC_MoveParent,
/* 22930*/       OPC_CheckType, MVT::v16i8,
/* 22932*/       OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/* 22934*/       OPC_EmitMergeInputChains1_1,
/* 22935*/       OPC_EmitInteger, MVT::i32, 0, 
/* 22938*/       OPC_EmitInteger, MVT::i32, 0, 
/* 22941*/       OPC_EmitConvertToTarget, 3,
/* 22943*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_I8x16_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v16i8, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, (ld:{ *:[i32] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_I8x16_A32:{ *:[v16i8] } 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v16i8] }:$vec)
/* 22954*/      /*Scope*/ 37, /*->22992*/
/* 22955*/       OPC_CheckPredicate, 1, // Predicate_extloadi16
/* 22957*/       OPC_MoveParent,
/* 22958*/       OPC_RecordChild2, // #3 = $idx
/* 22959*/       OPC_MoveChild2,
/* 22960*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 22963*/       OPC_CheckPredicate, 7, // Predicate_LaneIdx8
/* 22965*/       OPC_CheckType, MVT::i32,
/* 22967*/       OPC_MoveParent,
/* 22968*/       OPC_CheckType, MVT::v8i16,
/* 22970*/       OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/* 22972*/       OPC_EmitMergeInputChains1_1,
/* 22973*/       OPC_EmitInteger, MVT::i32, 0, 
/* 22976*/       OPC_EmitInteger, MVT::i32, 0, 
/* 22979*/       OPC_EmitConvertToTarget, 3,
/* 22981*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_I16x8_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v8i16, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, (ld:{ *:[i32] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_I16x8_A32:{ *:[v8i16] } 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v8i16] }:$vec)
/* 22992*/      0, /*End of Scope*/
/* 22993*/     /*Scope*/ 78, /*->23072*/
/* 22994*/      OPC_CheckPredicate, 15, // Predicate_load
/* 22996*/      OPC_SwitchType /*2 cases */, 35, MVT::i32,// ->23034
/* 22999*/       OPC_MoveParent,
/* 23000*/       OPC_RecordChild2, // #3 = $idx
/* 23001*/       OPC_MoveChild2,
/* 23002*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 23005*/       OPC_CheckPredicate, 9, // Predicate_LaneIdx4
/* 23007*/       OPC_CheckType, MVT::i32,
/* 23009*/       OPC_MoveParent,
/* 23010*/       OPC_CheckType, MVT::v4i32,
/* 23012*/       OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/* 23014*/       OPC_EmitMergeInputChains1_1,
/* 23015*/       OPC_EmitInteger, MVT::i32, 0, 
/* 23018*/       OPC_EmitInteger, MVT::i32, 0, 
/* 23021*/       OPC_EmitConvertToTarget, 3,
/* 23023*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v4i32, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, (ld:{ *:[i32] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_I32x4_A32:{ *:[v4i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v4i32] }:$vec)
/* 23034*/      /*SwitchType*/ 35, MVT::i64,// ->23071
/* 23036*/       OPC_MoveParent,
/* 23037*/       OPC_RecordChild2, // #3 = $idx
/* 23038*/       OPC_MoveChild2,
/* 23039*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 23042*/       OPC_CheckPredicate, 11, // Predicate_LaneIdx2
/* 23044*/       OPC_CheckType, MVT::i32,
/* 23046*/       OPC_MoveParent,
/* 23047*/       OPC_CheckType, MVT::v2i64,
/* 23049*/       OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/* 23051*/       OPC_EmitMergeInputChains1_1,
/* 23052*/       OPC_EmitInteger, MVT::i32, 0, 
/* 23055*/       OPC_EmitInteger, MVT::i32, 0, 
/* 23058*/       OPC_EmitConvertToTarget, 3,
/* 23060*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v2i64, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, (ld:{ *:[i64] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_I64x2_A32:{ *:[v2i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v2i64] }:$vec)
/* 23071*/      0, // EndSwitchType
/* 23072*/     0, /*End of Scope*/
/* 23073*/    /*Scope*/ 40|128,1/*168*/, /*->23243*/
/* 23075*/     OPC_CheckChild1Type, MVT::i64,
/* 23077*/     OPC_CheckPredicate, 14, // Predicate_unindexedload
/* 23079*/     OPC_Scope, 82, /*->23163*/ // 2 children in Scope
/* 23081*/      OPC_CheckPredicate, 18, // Predicate_extload
/* 23083*/      OPC_CheckType, MVT::i32,
/* 23085*/      OPC_Scope, 37, /*->23124*/ // 2 children in Scope
/* 23087*/       OPC_CheckPredicate, 0, // Predicate_extloadi8
/* 23089*/       OPC_MoveParent,
/* 23090*/       OPC_RecordChild2, // #3 = $idx
/* 23091*/       OPC_MoveChild2,
/* 23092*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 23095*/       OPC_CheckPredicate, 3, // Predicate_LaneIdx16
/* 23097*/       OPC_CheckType, MVT::i32,
/* 23099*/       OPC_MoveParent,
/* 23100*/       OPC_CheckType, MVT::v16i8,
/* 23102*/       OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/* 23104*/       OPC_EmitMergeInputChains1_1,
/* 23105*/       OPC_EmitInteger, MVT::i32, 0, 
/* 23108*/       OPC_EmitInteger, MVT::i64, 0, 
/* 23111*/       OPC_EmitConvertToTarget, 3,
/* 23113*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_I8x16_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v16i8, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, (ld:{ *:[i32] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_I8x16_A64:{ *:[v16i8] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v16i8] }:$vec)
/* 23124*/      /*Scope*/ 37, /*->23162*/
/* 23125*/       OPC_CheckPredicate, 1, // Predicate_extloadi16
/* 23127*/       OPC_MoveParent,
/* 23128*/       OPC_RecordChild2, // #3 = $idx
/* 23129*/       OPC_MoveChild2,
/* 23130*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 23133*/       OPC_CheckPredicate, 7, // Predicate_LaneIdx8
/* 23135*/       OPC_CheckType, MVT::i32,
/* 23137*/       OPC_MoveParent,
/* 23138*/       OPC_CheckType, MVT::v8i16,
/* 23140*/       OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/* 23142*/       OPC_EmitMergeInputChains1_1,
/* 23143*/       OPC_EmitInteger, MVT::i32, 0, 
/* 23146*/       OPC_EmitInteger, MVT::i64, 0, 
/* 23149*/       OPC_EmitConvertToTarget, 3,
/* 23151*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_I16x8_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v8i16, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, (ld:{ *:[i32] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_I16x8_A64:{ *:[v8i16] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v8i16] }:$vec)
/* 23162*/      0, /*End of Scope*/
/* 23163*/     /*Scope*/ 78, /*->23242*/
/* 23164*/      OPC_CheckPredicate, 15, // Predicate_load
/* 23166*/      OPC_SwitchType /*2 cases */, 35, MVT::i32,// ->23204
/* 23169*/       OPC_MoveParent,
/* 23170*/       OPC_RecordChild2, // #3 = $idx
/* 23171*/       OPC_MoveChild2,
/* 23172*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 23175*/       OPC_CheckPredicate, 9, // Predicate_LaneIdx4
/* 23177*/       OPC_CheckType, MVT::i32,
/* 23179*/       OPC_MoveParent,
/* 23180*/       OPC_CheckType, MVT::v4i32,
/* 23182*/       OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/* 23184*/       OPC_EmitMergeInputChains1_1,
/* 23185*/       OPC_EmitInteger, MVT::i32, 0, 
/* 23188*/       OPC_EmitInteger, MVT::i64, 0, 
/* 23191*/       OPC_EmitConvertToTarget, 3,
/* 23193*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v4i32, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, (ld:{ *:[i32] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_I32x4_A64:{ *:[v4i32] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v4i32] }:$vec)
/* 23204*/      /*SwitchType*/ 35, MVT::i64,// ->23241
/* 23206*/       OPC_MoveParent,
/* 23207*/       OPC_RecordChild2, // #3 = $idx
/* 23208*/       OPC_MoveChild2,
/* 23209*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 23212*/       OPC_CheckPredicate, 11, // Predicate_LaneIdx2
/* 23214*/       OPC_CheckType, MVT::i32,
/* 23216*/       OPC_MoveParent,
/* 23217*/       OPC_CheckType, MVT::v2i64,
/* 23219*/       OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/* 23221*/       OPC_EmitMergeInputChains1_1,
/* 23222*/       OPC_EmitInteger, MVT::i32, 0, 
/* 23225*/       OPC_EmitInteger, MVT::i64, 0, 
/* 23228*/       OPC_EmitConvertToTarget, 3,
/* 23230*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v2i64, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, (ld:{ *:[i64] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_I64x2_A64:{ *:[v2i64] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v2i64] }:$vec)
/* 23241*/      0, // EndSwitchType
/* 23242*/     0, /*End of Scope*/
/* 23243*/    0, /*End of Scope*/
/* 23244*/   /*Scope*/ 22|128,2/*278*/, /*->23524*/
/* 23246*/    OPC_RecordChild1, // #1 = $x
/* 23247*/    OPC_Scope, 121, /*->23370*/ // 4 children in Scope
/* 23249*/     OPC_CheckChild1Type, MVT::i32,
/* 23251*/     OPC_Scope, 66, /*->23319*/ // 2 children in Scope
/* 23253*/      OPC_RecordChild2, // #2 = $idx
/* 23254*/      OPC_MoveChild2,
/* 23255*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 23258*/      OPC_CheckType, MVT::i32,
/* 23260*/      OPC_Scope, 18, /*->23280*/ // 3 children in Scope
/* 23262*/       OPC_CheckPredicate, 3, // Predicate_LaneIdx16
/* 23264*/       OPC_MoveParent,
/* 23265*/       OPC_CheckType, MVT::v16i8,
/* 23267*/       OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23269*/       OPC_EmitConvertToTarget, 2,
/* 23271*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::REPLACE_LANE_I8x16), 0,
                     MVT::v16i8, 3/*#Ops*/, 0, 3, 1, 
                 // Src: (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx) - Complexity = 7
                 // Dst: (REPLACE_LANE_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, (imm:{ *:[i32] }):$idx, I32:{ *:[i32] }:$x)
/* 23280*/      /*Scope*/ 18, /*->23299*/
/* 23281*/       OPC_CheckPredicate, 7, // Predicate_LaneIdx8
/* 23283*/       OPC_MoveParent,
/* 23284*/       OPC_CheckType, MVT::v8i16,
/* 23286*/       OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23288*/       OPC_EmitConvertToTarget, 2,
/* 23290*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::REPLACE_LANE_I16x8), 0,
                     MVT::v8i16, 3/*#Ops*/, 0, 3, 1, 
                 // Src: (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx) - Complexity = 7
                 // Dst: (REPLACE_LANE_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, (imm:{ *:[i32] }):$idx, I32:{ *:[i32] }:$x)
/* 23299*/      /*Scope*/ 18, /*->23318*/
/* 23300*/       OPC_CheckPredicate, 9, // Predicate_LaneIdx4
/* 23302*/       OPC_MoveParent,
/* 23303*/       OPC_CheckType, MVT::v4i32,
/* 23305*/       OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23307*/       OPC_EmitConvertToTarget, 2,
/* 23309*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::REPLACE_LANE_I32x4), 0,
                     MVT::v4i32, 3/*#Ops*/, 0, 3, 1, 
                 // Src: (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 7
                 // Dst: (REPLACE_LANE_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, (imm:{ *:[i32] }):$idx, I32:{ *:[i32] }:$x)
/* 23318*/      0, /*End of Scope*/
/* 23319*/     /*Scope*/ 49, /*->23369*/
/* 23320*/      OPC_MoveChild2,
/* 23321*/      OPC_CheckOpcode, TARGET_VAL(ISD::UNDEF),
/* 23324*/      OPC_MoveParent,
/* 23325*/      OPC_SwitchType /*3 cases */, 12, MVT::v16i8,// ->23340
/* 23328*/       OPC_EmitInteger, MVT::i32, 0, 
/* 23331*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::REPLACE_LANE_I8x16), 0,
                     MVT::v16i8, 3/*#Ops*/, 0, 2, 1, 
                 // Src: (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x, (undef:{ *:[iPTR] })) - Complexity = 6
                 // Dst: (REPLACE_LANE_I8x16:{ *:[v16i8] } ?:{ *:[v16i8] }:$vec, 0:{ *:[i32] }, ?:{ *:[i32] }:$x)
/* 23340*/      /*SwitchType*/ 12, MVT::v8i16,// ->23354
/* 23342*/       OPC_EmitInteger, MVT::i32, 0, 
/* 23345*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::REPLACE_LANE_I16x8), 0,
                     MVT::v8i16, 3/*#Ops*/, 0, 2, 1, 
                 // Src: (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x, (undef:{ *:[iPTR] })) - Complexity = 6
                 // Dst: (REPLACE_LANE_I16x8:{ *:[v8i16] } ?:{ *:[v8i16] }:$vec, 0:{ *:[i32] }, ?:{ *:[i32] }:$x)
/* 23354*/      /*SwitchType*/ 12, MVT::v4i32,// ->23368
/* 23356*/       OPC_EmitInteger, MVT::i32, 0, 
/* 23359*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::REPLACE_LANE_I32x4), 0,
                     MVT::v4i32, 3/*#Ops*/, 0, 2, 1, 
                 // Src: (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x, (undef:{ *:[iPTR] })) - Complexity = 6
                 // Dst: (REPLACE_LANE_I32x4:{ *:[v4i32] } ?:{ *:[v4i32] }:$vec, 0:{ *:[i32] }, ?:{ *:[i32] }:$x)
/* 23368*/      0, // EndSwitchType
/* 23369*/     0, /*End of Scope*/
/* 23370*/    /*Scope*/ 50, /*->23421*/
/* 23371*/     OPC_CheckChild1Type, MVT::i64,
/* 23373*/     OPC_Scope, 25, /*->23400*/ // 2 children in Scope
/* 23375*/      OPC_RecordChild2, // #2 = $idx
/* 23376*/      OPC_MoveChild2,
/* 23377*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 23380*/      OPC_CheckPredicate, 11, // Predicate_LaneIdx2
/* 23382*/      OPC_CheckType, MVT::i32,
/* 23384*/      OPC_MoveParent,
/* 23385*/      OPC_CheckType, MVT::v2i64,
/* 23387*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23389*/      OPC_EmitConvertToTarget, 2,
/* 23391*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::REPLACE_LANE_I64x2), 0,
                    MVT::v2i64, 3/*#Ops*/, 0, 3, 1, 
                // Src: (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I64:{ *:[i64] }:$x, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 7
                // Dst: (REPLACE_LANE_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, (imm:{ *:[i32] }):$idx, I64:{ *:[i64] }:$x)
/* 23400*/     /*Scope*/ 19, /*->23420*/
/* 23401*/      OPC_MoveChild2,
/* 23402*/      OPC_CheckOpcode, TARGET_VAL(ISD::UNDEF),
/* 23405*/      OPC_MoveParent,
/* 23406*/      OPC_CheckType, MVT::v2i64,
/* 23408*/      OPC_EmitInteger, MVT::i32, 0, 
/* 23411*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::REPLACE_LANE_I64x2), 0,
                    MVT::v2i64, 3/*#Ops*/, 0, 2, 1, 
                // Src: (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I64:{ *:[i64] }:$x, (undef:{ *:[iPTR] })) - Complexity = 6
                // Dst: (REPLACE_LANE_I64x2:{ *:[v2i64] } ?:{ *:[v2i64] }:$vec, 0:{ *:[i32] }, ?:{ *:[i64] }:$x)
/* 23420*/     0, /*End of Scope*/
/* 23421*/    /*Scope*/ 50, /*->23472*/
/* 23422*/     OPC_CheckChild1Type, MVT::f32,
/* 23424*/     OPC_Scope, 25, /*->23451*/ // 2 children in Scope
/* 23426*/      OPC_RecordChild2, // #2 = $idx
/* 23427*/      OPC_MoveChild2,
/* 23428*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 23431*/      OPC_CheckPredicate, 9, // Predicate_LaneIdx4
/* 23433*/      OPC_CheckType, MVT::i32,
/* 23435*/      OPC_MoveParent,
/* 23436*/      OPC_CheckType, MVT::v4f32,
/* 23438*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23440*/      OPC_EmitConvertToTarget, 2,
/* 23442*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::REPLACE_LANE_F32x4), 0,
                    MVT::v4f32, 3/*#Ops*/, 0, 3, 1, 
                // Src: (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$vec, F32:{ *:[f32] }:$x, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 7
                // Dst: (REPLACE_LANE_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$vec, (imm:{ *:[i32] }):$idx, F32:{ *:[f32] }:$x)
/* 23451*/     /*Scope*/ 19, /*->23471*/
/* 23452*/      OPC_MoveChild2,
/* 23453*/      OPC_CheckOpcode, TARGET_VAL(ISD::UNDEF),
/* 23456*/      OPC_MoveParent,
/* 23457*/      OPC_CheckType, MVT::v4f32,
/* 23459*/      OPC_EmitInteger, MVT::i32, 0, 
/* 23462*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::REPLACE_LANE_F32x4), 0,
                    MVT::v4f32, 3/*#Ops*/, 0, 2, 1, 
                // Src: (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$vec, F32:{ *:[f32] }:$x, (undef:{ *:[iPTR] })) - Complexity = 6
                // Dst: (REPLACE_LANE_F32x4:{ *:[v4f32] } ?:{ *:[v4f32] }:$vec, 0:{ *:[i32] }, ?:{ *:[f32] }:$x)
/* 23471*/     0, /*End of Scope*/
/* 23472*/    /*Scope*/ 50, /*->23523*/
/* 23473*/     OPC_CheckChild1Type, MVT::f64,
/* 23475*/     OPC_Scope, 25, /*->23502*/ // 2 children in Scope
/* 23477*/      OPC_RecordChild2, // #2 = $idx
/* 23478*/      OPC_MoveChild2,
/* 23479*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 23482*/      OPC_CheckPredicate, 11, // Predicate_LaneIdx2
/* 23484*/      OPC_CheckType, MVT::i32,
/* 23486*/      OPC_MoveParent,
/* 23487*/      OPC_CheckType, MVT::v2f64,
/* 23489*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23491*/      OPC_EmitConvertToTarget, 2,
/* 23493*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::REPLACE_LANE_F64x2), 0,
                    MVT::v2f64, 3/*#Ops*/, 0, 3, 1, 
                // Src: (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$vec, F64:{ *:[f64] }:$x, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 7
                // Dst: (REPLACE_LANE_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$vec, (imm:{ *:[i32] }):$idx, F64:{ *:[f64] }:$x)
/* 23502*/     /*Scope*/ 19, /*->23522*/
/* 23503*/      OPC_MoveChild2,
/* 23504*/      OPC_CheckOpcode, TARGET_VAL(ISD::UNDEF),
/* 23507*/      OPC_MoveParent,
/* 23508*/      OPC_CheckType, MVT::v2f64,
/* 23510*/      OPC_EmitInteger, MVT::i32, 0, 
/* 23513*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::REPLACE_LANE_F64x2), 0,
                    MVT::v2f64, 3/*#Ops*/, 0, 2, 1, 
                // Src: (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$vec, F64:{ *:[f64] }:$x, (undef:{ *:[iPTR] })) - Complexity = 6
                // Dst: (REPLACE_LANE_F64x2:{ *:[v2f64] } ?:{ *:[v2f64] }:$vec, 0:{ *:[i32] }, ?:{ *:[f64] }:$x)
/* 23522*/     0, /*End of Scope*/
/* 23523*/    0, /*End of Scope*/
/* 23524*/   0, /*End of Scope*/
/* 23525*/  0, /*End of Scope*/
/* 23526*/ /*SwitchOpcode*/ 118|128,1/*246*/, TARGET_VAL(WebAssemblyISD::VEC_SHR_U),// ->23776
/* 23530*/  OPC_Scope, 95, /*->23627*/ // 2 children in Scope
/* 23532*/   OPC_MoveChild0,
/* 23533*/   OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/* 23536*/   OPC_MoveChild0,
/* 23537*/   OPC_SwitchOpcode /*2 cases */, 41, TARGET_VAL(ISD::ADD),// ->23582
/* 23541*/    OPC_RecordChild0, // #0 = $lhs
/* 23542*/    OPC_RecordChild1, // #1 = $rhs
/* 23543*/    OPC_CheckPredicate, 26, // Predicate_add_nuw
/* 23545*/    OPC_MoveParent,
/* 23546*/    OPC_MoveChild1,
/* 23547*/    OPC_CheckOpcode, TARGET_VAL(ISD::SPLAT_VECTOR),
/* 23550*/    OPC_CheckChild0Integer, 2, 
/* 23552*/    OPC_CheckChild0Type, MVT::i32,
/* 23554*/    OPC_MoveParent,
/* 23555*/    OPC_CheckPredicate, 26, // Predicate_add_nuw
/* 23557*/    OPC_MoveParent,
/* 23558*/    OPC_CheckChild1Integer, 2, 
/* 23560*/    OPC_SwitchType /*2 cases */, 8, MVT::v16i8,// ->23571
/* 23563*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::AVGR_U_I8x16), 0,
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v16i8] } (add:{ *:[v16i8] } (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)<<P:Predicate_add_nuw>>, (splat_vector:{ *:[v16i8] } 1:{ *:[i32] }))<<P:Predicate_add_nuw>>, 1:{ *:[i32] }) - Complexity = 24
               // Dst: (AVGR_U_I8x16:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/* 23571*/    /*SwitchType*/ 8, MVT::v8i16,// ->23581
/* 23573*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::AVGR_U_I16x8), 0,
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v8i16] } (add:{ *:[v8i16] } (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)<<P:Predicate_add_nuw>>, (splat_vector:{ *:[v8i16] } 1:{ *:[i32] }))<<P:Predicate_add_nuw>>, 1:{ *:[i32] }) - Complexity = 24
               // Dst: (AVGR_U_I16x8:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/* 23581*/    0, // EndSwitchType
/* 23582*/   /*SwitchOpcode*/ 41, TARGET_VAL(ISD::SPLAT_VECTOR),// ->23626
/* 23585*/    OPC_CheckChild0Integer, 2, 
/* 23587*/    OPC_CheckChild0Type, MVT::i32,
/* 23589*/    OPC_MoveParent,
/* 23590*/    OPC_MoveChild1,
/* 23591*/    OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/* 23594*/    OPC_RecordChild0, // #0 = $lhs
/* 23595*/    OPC_RecordChild1, // #1 = $rhs
/* 23596*/    OPC_CheckPredicate, 26, // Predicate_add_nuw
/* 23598*/    OPC_MoveParent,
/* 23599*/    OPC_CheckPredicate, 26, // Predicate_add_nuw
/* 23601*/    OPC_MoveParent,
/* 23602*/    OPC_CheckChild1Integer, 2, 
/* 23604*/    OPC_SwitchType /*2 cases */, 8, MVT::v16i8,// ->23615
/* 23607*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::AVGR_U_I8x16), 0,
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v16i8] } (add:{ *:[v16i8] } (splat_vector:{ *:[v16i8] } 1:{ *:[i32] }), (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)<<P:Predicate_add_nuw>>)<<P:Predicate_add_nuw>>, 1:{ *:[i32] }) - Complexity = 24
               // Dst: (AVGR_U_I8x16:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/* 23615*/    /*SwitchType*/ 8, MVT::v8i16,// ->23625
/* 23617*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::AVGR_U_I16x8), 0,
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v8i16] } (add:{ *:[v8i16] } (splat_vector:{ *:[v8i16] } 1:{ *:[i32] }), (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)<<P:Predicate_add_nuw>>)<<P:Predicate_add_nuw>>, 1:{ *:[i32] }) - Complexity = 24
               // Dst: (AVGR_U_I16x8:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/* 23625*/    0, // EndSwitchType
/* 23626*/   0, // EndSwitchOpcode
/* 23627*/  /*Scope*/ 18|128,1/*146*/, /*->23775*/
/* 23629*/   OPC_RecordChild0, // #0 = $lhs
/* 23630*/   OPC_Scope, 90, /*->23722*/ // 2 children in Scope
/* 23632*/    OPC_MoveChild1,
/* 23633*/    OPC_Scope, 26, /*->23661*/ // 5 children in Scope
/* 23635*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 23638*/     OPC_MoveChild0,
/* 23639*/     OPC_CheckAndImm, 63, 
/* 23641*/     OPC_RecordChild0, // #1 = $rhs
/* 23642*/     OPC_MoveParent,
/* 23643*/     OPC_MoveParent,
/* 23644*/     OPC_CheckType, MVT::v2i64,
/* 23646*/     OPC_EmitNode1, TARGET_VAL(WebAssembly::I32_WRAP_I64), 0,
                   MVT::i32, 1/*#Ops*/, 1,  // Results = #2
/* 23653*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_U_I64x2), 0,
                   MVT::v2i64, 2/*#Ops*/, 0, 2, 
               // Src: (wasm_shr_u:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (trunc:{ *:[i32] } (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] }))) - Complexity = 14
               // Dst: (SHR_U_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (I32_WRAP_I64:{ *:[i32] } I64:{ *:[i64] }:$rhs))
/* 23661*/    /*Scope*/ 14, /*->23676*/
/* 23662*/     OPC_CheckAndImm, 7, 
/* 23664*/     OPC_RecordChild0, // #1 = $rhs
/* 23665*/     OPC_MoveParent,
/* 23666*/     OPC_CheckType, MVT::v16i8,
/* 23668*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_U_I8x16), 0,
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 7:{ *:[i32] })) - Complexity = 11
               // Dst: (SHR_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 23676*/    /*Scope*/ 14, /*->23691*/
/* 23677*/     OPC_CheckAndImm, 15, 
/* 23679*/     OPC_RecordChild0, // #1 = $rhs
/* 23680*/     OPC_MoveParent,
/* 23681*/     OPC_CheckType, MVT::v8i16,
/* 23683*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_U_I16x8), 0,
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 15:{ *:[i32] })) - Complexity = 11
               // Dst: (SHR_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 23691*/    /*Scope*/ 14, /*->23706*/
/* 23692*/     OPC_CheckAndImm, 31, 
/* 23694*/     OPC_RecordChild0, // #1 = $rhs
/* 23695*/     OPC_MoveParent,
/* 23696*/     OPC_CheckType, MVT::v4i32,
/* 23698*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_U_I32x4), 0,
                   MVT::v4i32, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
               // Dst: (SHR_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 23706*/    /*Scope*/ 14, /*->23721*/
/* 23707*/     OPC_CheckAndImm, 63, 
/* 23709*/     OPC_RecordChild0, // #1 = $rhs
/* 23710*/     OPC_MoveParent,
/* 23711*/     OPC_CheckType, MVT::v2i64,
/* 23713*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_U_I64x2), 0,
                   MVT::v2i64, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 63:{ *:[i32] })) - Complexity = 11
               // Dst: (SHR_U_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 23721*/    0, /*End of Scope*/
/* 23722*/   /*Scope*/ 51, /*->23774*/
/* 23723*/    OPC_RecordChild1, // #1 = $x
/* 23724*/    OPC_SwitchType /*4 cases */, 10, MVT::v16i8,// ->23737
/* 23727*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23729*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_U_I8x16), 0,
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SHR_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x)
/* 23737*/    /*SwitchType*/ 10, MVT::v8i16,// ->23749
/* 23739*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23741*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_U_I16x8), 0,
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SHR_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x)
/* 23749*/    /*SwitchType*/ 10, MVT::v4i32,// ->23761
/* 23751*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23753*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_U_I32x4), 0,
                   MVT::v4i32, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SHR_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x)
/* 23761*/    /*SwitchType*/ 10, MVT::v2i64,// ->23773
/* 23763*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23765*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_U_I64x2), 0,
                   MVT::v2i64, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SHR_U_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x)
/* 23773*/    0, // EndSwitchType
/* 23774*/   0, /*End of Scope*/
/* 23775*/  0, /*End of Scope*/
/* 23776*/ /*SwitchOpcode*/ 121|128,4/*633*/, TARGET_VAL(ISD::SPLAT_VECTOR),// ->24413
/* 23780*/  OPC_Scope, 107|128,1/*235*/, /*->24018*/ // 4 children in Scope
/* 23783*/   OPC_MoveChild0,
/* 23784*/   OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
/* 23787*/   OPC_RecordMemRef,
/* 23788*/   OPC_RecordNode, // #0 = 'ld' chained node
/* 23789*/   OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/* 23790*/   OPC_Scope, 112, /*->23904*/ // 2 children in Scope
/* 23792*/    OPC_CheckChild1Type, MVT::i32,
/* 23794*/    OPC_CheckPredicate, 14, // Predicate_unindexedload
/* 23796*/    OPC_Scope, 54, /*->23852*/ // 2 children in Scope
/* 23798*/     OPC_CheckPredicate, 18, // Predicate_extload
/* 23800*/     OPC_CheckType, MVT::i32,
/* 23802*/     OPC_Scope, 23, /*->23827*/ // 2 children in Scope
/* 23804*/      OPC_CheckPredicate, 0, // Predicate_extloadi8
/* 23806*/      OPC_MoveParent,
/* 23807*/      OPC_CheckType, MVT::v16i8,
/* 23809*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/* 23811*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 23814*/      OPC_EmitMergeInputChains1_0,
/* 23815*/      OPC_EmitInteger, MVT::i32, 0, 
/* 23818*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v16i8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v16i8] } (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>) - Complexity = 16
                // Dst: (LOAD8_SPLAT_A32:{ *:[v16i8] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 23827*/     /*Scope*/ 23, /*->23851*/
/* 23828*/      OPC_CheckPredicate, 1, // Predicate_extloadi16
/* 23830*/      OPC_MoveParent,
/* 23831*/      OPC_CheckType, MVT::v8i16,
/* 23833*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/* 23835*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 23838*/      OPC_EmitMergeInputChains1_0,
/* 23839*/      OPC_EmitInteger, MVT::i32, 0, 
/* 23842*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v8i16, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v8i16] } (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>) - Complexity = 16
                // Dst: (LOAD16_SPLAT_A32:{ *:[v8i16] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 23851*/     0, /*End of Scope*/
/* 23852*/    /*Scope*/ 50, /*->23903*/
/* 23853*/     OPC_CheckPredicate, 15, // Predicate_load
/* 23855*/     OPC_SwitchType /*2 cases */, 21, MVT::i32,// ->23879
/* 23858*/      OPC_MoveParent,
/* 23859*/      OPC_CheckType, MVT::v4i32,
/* 23861*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/* 23863*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 23866*/      OPC_EmitMergeInputChains1_0,
/* 23867*/      OPC_EmitInteger, MVT::i32, 0, 
/* 23870*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v4i32] } (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
                // Dst: (LOAD32_SPLAT_A32:{ *:[v4i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 23879*/     /*SwitchType*/ 21, MVT::i64,// ->23902
/* 23881*/      OPC_MoveParent,
/* 23882*/      OPC_CheckType, MVT::v2i64,
/* 23884*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/* 23886*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 23889*/      OPC_EmitMergeInputChains1_0,
/* 23890*/      OPC_EmitInteger, MVT::i32, 0, 
/* 23893*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD64_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v2i64] } (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
                // Dst: (LOAD64_SPLAT_A32:{ *:[v2i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 23902*/     0, // EndSwitchType
/* 23903*/    0, /*End of Scope*/
/* 23904*/   /*Scope*/ 112, /*->24017*/
/* 23905*/    OPC_CheckChild1Type, MVT::i64,
/* 23907*/    OPC_CheckPredicate, 14, // Predicate_unindexedload
/* 23909*/    OPC_Scope, 54, /*->23965*/ // 2 children in Scope
/* 23911*/     OPC_CheckPredicate, 18, // Predicate_extload
/* 23913*/     OPC_CheckType, MVT::i32,
/* 23915*/     OPC_Scope, 23, /*->23940*/ // 2 children in Scope
/* 23917*/      OPC_CheckPredicate, 0, // Predicate_extloadi8
/* 23919*/      OPC_MoveParent,
/* 23920*/      OPC_CheckType, MVT::v16i8,
/* 23922*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/* 23924*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 23927*/      OPC_EmitMergeInputChains1_0,
/* 23928*/      OPC_EmitInteger, MVT::i32, 0, 
/* 23931*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v16i8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v16i8] } (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>) - Complexity = 16
                // Dst: (LOAD8_SPLAT_A64:{ *:[v16i8] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 23940*/     /*Scope*/ 23, /*->23964*/
/* 23941*/      OPC_CheckPredicate, 1, // Predicate_extloadi16
/* 23943*/      OPC_MoveParent,
/* 23944*/      OPC_CheckType, MVT::v8i16,
/* 23946*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/* 23948*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 23951*/      OPC_EmitMergeInputChains1_0,
/* 23952*/      OPC_EmitInteger, MVT::i32, 0, 
/* 23955*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v8i16, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v8i16] } (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>) - Complexity = 16
                // Dst: (LOAD16_SPLAT_A64:{ *:[v8i16] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 23964*/     0, /*End of Scope*/
/* 23965*/    /*Scope*/ 50, /*->24016*/
/* 23966*/     OPC_CheckPredicate, 15, // Predicate_load
/* 23968*/     OPC_SwitchType /*2 cases */, 21, MVT::i32,// ->23992
/* 23971*/      OPC_MoveParent,
/* 23972*/      OPC_CheckType, MVT::v4i32,
/* 23974*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/* 23976*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 23979*/      OPC_EmitMergeInputChains1_0,
/* 23980*/      OPC_EmitInteger, MVT::i32, 0, 
/* 23983*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v4i32] } (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
                // Dst: (LOAD32_SPLAT_A64:{ *:[v4i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 23992*/     /*SwitchType*/ 21, MVT::i64,// ->24015
/* 23994*/      OPC_MoveParent,
/* 23995*/      OPC_CheckType, MVT::v2i64,
/* 23997*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/* 23999*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 24002*/      OPC_EmitMergeInputChains1_0,
/* 24003*/      OPC_EmitInteger, MVT::i32, 0, 
/* 24006*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD64_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v2i64] } (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
                // Dst: (LOAD64_SPLAT_A64:{ *:[v2i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 24015*/     0, // EndSwitchType
/* 24016*/    0, /*End of Scope*/
/* 24017*/   0, /*End of Scope*/
/* 24018*/  /*Scope*/ 65|128,1/*193*/, /*->24213*/
/* 24020*/   OPC_RecordChild0, // #0 = $x
/* 24021*/   OPC_Scope, 8|128,1/*136*/, /*->24160*/ // 3 children in Scope
/* 24024*/    OPC_MoveChild0,
/* 24025*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 24028*/    OPC_SwitchType /*2 cases */, 111, MVT::i32,// ->24142
/* 24031*/     OPC_MoveParent,
/* 24032*/     OPC_SwitchType /*3 cases */, 54, MVT::v16i8,// ->24089
/* 24035*/      OPC_EmitConvertToTarget, 0,
/* 24037*/      OPC_EmitConvertToTarget, 0,
/* 24039*/      OPC_EmitConvertToTarget, 0,
/* 24041*/      OPC_EmitConvertToTarget, 0,
/* 24043*/      OPC_EmitConvertToTarget, 0,
/* 24045*/      OPC_EmitConvertToTarget, 0,
/* 24047*/      OPC_EmitConvertToTarget, 0,
/* 24049*/      OPC_EmitConvertToTarget, 0,
/* 24051*/      OPC_EmitConvertToTarget, 0,
/* 24053*/      OPC_EmitConvertToTarget, 0,
/* 24055*/      OPC_EmitConvertToTarget, 0,
/* 24057*/      OPC_EmitConvertToTarget, 0,
/* 24059*/      OPC_EmitConvertToTarget, 0,
/* 24061*/      OPC_EmitConvertToTarget, 0,
/* 24063*/      OPC_EmitConvertToTarget, 0,
/* 24065*/      OPC_EmitConvertToTarget, 0,
/* 24067*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_V128_I8x16), 0,
                    MVT::v16i8, 16/*#Ops*/, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 
                // Src: (splat_vector:{ *:[v16i8] } (imm:{ *:[i32] }):$x) - Complexity = 6
                // Dst: (CONST_V128_I8x16:{ *:[v16i8] } (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x)
/* 24089*/     /*SwitchType*/ 30, MVT::v8i16,// ->24121
/* 24091*/      OPC_EmitConvertToTarget, 0,
/* 24093*/      OPC_EmitConvertToTarget, 0,
/* 24095*/      OPC_EmitConvertToTarget, 0,
/* 24097*/      OPC_EmitConvertToTarget, 0,
/* 24099*/      OPC_EmitConvertToTarget, 0,
/* 24101*/      OPC_EmitConvertToTarget, 0,
/* 24103*/      OPC_EmitConvertToTarget, 0,
/* 24105*/      OPC_EmitConvertToTarget, 0,
/* 24107*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_V128_I16x8), 0,
                    MVT::v8i16, 8/*#Ops*/, 1, 2, 3, 4, 5, 6, 7, 8, 
                // Src: (splat_vector:{ *:[v8i16] } (imm:{ *:[i32] }):$x) - Complexity = 6
                // Dst: (CONST_V128_I16x8:{ *:[v8i16] } (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x)
/* 24121*/     /*SwitchType*/ 18, MVT::v4i32,// ->24141
/* 24123*/      OPC_EmitConvertToTarget, 0,
/* 24125*/      OPC_EmitConvertToTarget, 0,
/* 24127*/      OPC_EmitConvertToTarget, 0,
/* 24129*/      OPC_EmitConvertToTarget, 0,
/* 24131*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_V128_I32x4), 0,
                    MVT::v4i32, 4/*#Ops*/, 1, 2, 3, 4, 
                // Src: (splat_vector:{ *:[v4i32] } (imm:{ *:[i32] }):$x) - Complexity = 6
                // Dst: (CONST_V128_I32x4:{ *:[v4i32] } (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x)
/* 24141*/     0, // EndSwitchType
/* 24142*/    /*SwitchType*/ 15, MVT::i64,// ->24159
/* 24144*/     OPC_MoveParent,
/* 24145*/     OPC_CheckType, MVT::v2i64,
/* 24147*/     OPC_EmitConvertToTarget, 0,
/* 24149*/     OPC_EmitConvertToTarget, 0,
/* 24151*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_V128_I64x2), 0,
                   MVT::v2i64, 2/*#Ops*/, 1, 2, 
               // Src: (splat_vector:{ *:[v2i64] } (imm:{ *:[i64] }):$x) - Complexity = 6
               // Dst: (CONST_V128_I64x2:{ *:[v2i64] } (imm:{ *:[i64] }):$x, (imm:{ *:[i64] }):$x)
/* 24159*/    0, // EndSwitchType
/* 24160*/   /*Scope*/ 37, /*->24198*/
/* 24161*/    OPC_CheckChild0Type, MVT::i32,
/* 24163*/    OPC_SwitchType /*3 cases */, 9, MVT::v16i8,// ->24175
/* 24166*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 24168*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SPLAT_I8x16), 0,
                   MVT::v16i8, 1/*#Ops*/, 0, 
               // Src: (splat_vector:{ *:[v16i8] } I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SPLAT_I8x16:{ *:[v16i8] } I32:{ *:[i32] }:$x)
/* 24175*/    /*SwitchType*/ 9, MVT::v8i16,// ->24186
/* 24177*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 24179*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SPLAT_I16x8), 0,
                   MVT::v8i16, 1/*#Ops*/, 0, 
               // Src: (splat_vector:{ *:[v8i16] } I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SPLAT_I16x8:{ *:[v8i16] } I32:{ *:[i32] }:$x)
/* 24186*/    /*SwitchType*/ 9, MVT::v4i32,// ->24197
/* 24188*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 24190*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SPLAT_I32x4), 0,
                   MVT::v4i32, 1/*#Ops*/, 0, 
               // Src: (splat_vector:{ *:[v4i32] } I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SPLAT_I32x4:{ *:[v4i32] } I32:{ *:[i32] }:$x)
/* 24197*/    0, // EndSwitchType
/* 24198*/   /*Scope*/ 13, /*->24212*/
/* 24199*/    OPC_CheckChild0Type, MVT::i64,
/* 24201*/    OPC_CheckType, MVT::v2i64,
/* 24203*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 24205*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SPLAT_I64x2), 0,
                  MVT::v2i64, 1/*#Ops*/, 0, 
              // Src: (splat_vector:{ *:[v2i64] } I64:{ *:[i64] }:$x) - Complexity = 3
              // Dst: (SPLAT_I64x2:{ *:[v2i64] } I64:{ *:[i64] }:$x)
/* 24212*/   0, /*End of Scope*/
/* 24213*/  /*Scope*/ 119, /*->24333*/
/* 24214*/   OPC_MoveChild0,
/* 24215*/   OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
/* 24218*/   OPC_RecordMemRef,
/* 24219*/   OPC_RecordNode, // #0 = 'ld' chained node
/* 24220*/   OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/* 24221*/   OPC_Scope, 54, /*->24277*/ // 2 children in Scope
/* 24223*/    OPC_CheckChild1Type, MVT::i32,
/* 24225*/    OPC_CheckPredicate, 14, // Predicate_unindexedload
/* 24227*/    OPC_CheckPredicate, 15, // Predicate_load
/* 24229*/    OPC_SwitchType /*2 cases */, 21, MVT::f32,// ->24253
/* 24232*/     OPC_MoveParent,
/* 24233*/     OPC_CheckType, MVT::v4f32,
/* 24235*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/* 24237*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 24240*/     OPC_EmitMergeInputChains1_0,
/* 24241*/     OPC_EmitInteger, MVT::i32, 0, 
/* 24244*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v4f32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (splat_vector:{ *:[v4f32] } (ld:{ *:[f32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD32_SPLAT_A32:{ *:[v4f32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 24253*/    /*SwitchType*/ 21, MVT::f64,// ->24276
/* 24255*/     OPC_MoveParent,
/* 24256*/     OPC_CheckType, MVT::v2f64,
/* 24258*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/* 24260*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 24263*/     OPC_EmitMergeInputChains1_0,
/* 24264*/     OPC_EmitInteger, MVT::i32, 0, 
/* 24267*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD64_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v2f64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (splat_vector:{ *:[v2f64] } (ld:{ *:[f64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD64_SPLAT_A32:{ *:[v2f64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 24276*/    0, // EndSwitchType
/* 24277*/   /*Scope*/ 54, /*->24332*/
/* 24278*/    OPC_CheckChild1Type, MVT::i64,
/* 24280*/    OPC_CheckPredicate, 14, // Predicate_unindexedload
/* 24282*/    OPC_CheckPredicate, 15, // Predicate_load
/* 24284*/    OPC_SwitchType /*2 cases */, 21, MVT::f32,// ->24308
/* 24287*/     OPC_MoveParent,
/* 24288*/     OPC_CheckType, MVT::v4f32,
/* 24290*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/* 24292*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 24295*/     OPC_EmitMergeInputChains1_0,
/* 24296*/     OPC_EmitInteger, MVT::i32, 0, 
/* 24299*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v4f32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (splat_vector:{ *:[v4f32] } (ld:{ *:[f32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD32_SPLAT_A64:{ *:[v4f32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 24308*/    /*SwitchType*/ 21, MVT::f64,// ->24331
/* 24310*/     OPC_MoveParent,
/* 24311*/     OPC_CheckType, MVT::v2f64,
/* 24313*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/* 24315*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 24318*/     OPC_EmitMergeInputChains1_0,
/* 24319*/     OPC_EmitInteger, MVT::i32, 0, 
/* 24322*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD64_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v2f64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (splat_vector:{ *:[v2f64] } (ld:{ *:[f64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD64_SPLAT_A64:{ *:[v2f64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 24331*/    0, // EndSwitchType
/* 24332*/   0, /*End of Scope*/
/* 24333*/  /*Scope*/ 78, /*->24412*/
/* 24334*/   OPC_RecordChild0, // #0 = $x
/* 24335*/   OPC_Scope, 46, /*->24383*/ // 3 children in Scope
/* 24337*/    OPC_MoveChild0,
/* 24338*/    OPC_CheckOpcode, TARGET_VAL(ISD::ConstantFP),
/* 24341*/    OPC_SwitchType /*2 cases */, 21, MVT::f32,// ->24365
/* 24344*/     OPC_MoveParent,
/* 24345*/     OPC_CheckType, MVT::v4f32,
/* 24347*/     OPC_EmitConvertToTarget, 0,
/* 24349*/     OPC_EmitConvertToTarget, 0,
/* 24351*/     OPC_EmitConvertToTarget, 0,
/* 24353*/     OPC_EmitConvertToTarget, 0,
/* 24355*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_V128_F32x4), 0,
                   MVT::v4f32, 4/*#Ops*/, 1, 2, 3, 4, 
               // Src: (splat_vector:{ *:[v4f32] } (fpimm:{ *:[f32] }):$x) - Complexity = 6
               // Dst: (CONST_V128_F32x4:{ *:[v4f32] } (fpimm:{ *:[f32] }):$x, (fpimm:{ *:[f32] }):$x, (fpimm:{ *:[f32] }):$x, (fpimm:{ *:[f32] }):$x)
/* 24365*/    /*SwitchType*/ 15, MVT::f64,// ->24382
/* 24367*/     OPC_MoveParent,
/* 24368*/     OPC_CheckType, MVT::v2f64,
/* 24370*/     OPC_EmitConvertToTarget, 0,
/* 24372*/     OPC_EmitConvertToTarget, 0,
/* 24374*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_V128_F64x2), 0,
                   MVT::v2f64, 2/*#Ops*/, 1, 2, 
               // Src: (splat_vector:{ *:[v2f64] } (fpimm:{ *:[f64] }):$x) - Complexity = 6
               // Dst: (CONST_V128_F64x2:{ *:[v2f64] } (fpimm:{ *:[f64] }):$x, (fpimm:{ *:[f64] }):$x)
/* 24382*/    0, // EndSwitchType
/* 24383*/   /*Scope*/ 13, /*->24397*/
/* 24384*/    OPC_CheckChild0Type, MVT::f32,
/* 24386*/    OPC_CheckType, MVT::v4f32,
/* 24388*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 24390*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SPLAT_F32x4), 0,
                  MVT::v4f32, 1/*#Ops*/, 0, 
              // Src: (splat_vector:{ *:[v4f32] } F32:{ *:[f32] }:$x) - Complexity = 3
              // Dst: (SPLAT_F32x4:{ *:[v4f32] } F32:{ *:[f32] }:$x)
/* 24397*/   /*Scope*/ 13, /*->24411*/
/* 24398*/    OPC_CheckChild0Type, MVT::f64,
/* 24400*/    OPC_CheckType, MVT::v2f64,
/* 24402*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 24404*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SPLAT_F64x2), 0,
                  MVT::v2f64, 1/*#Ops*/, 0, 
              // Src: (splat_vector:{ *:[v2f64] } F64:{ *:[f64] }:$x) - Complexity = 3
              // Dst: (SPLAT_F64x2:{ *:[v2f64] } F64:{ *:[f64] }:$x)
/* 24411*/   0, /*End of Scope*/
/* 24412*/  0, /*End of Scope*/
/* 24413*/ /*SwitchOpcode*/ 66|128,1/*194*/, TARGET_VAL(ISD::SCALAR_TO_VECTOR),// ->24611
/* 24417*/  OPC_Scope, 119, /*->24538*/ // 2 children in Scope
/* 24419*/   OPC_MoveChild0,
/* 24420*/   OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
/* 24423*/   OPC_RecordMemRef,
/* 24424*/   OPC_RecordNode, // #0 = 'ld' chained node
/* 24425*/   OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/* 24426*/   OPC_Scope, 54, /*->24482*/ // 2 children in Scope
/* 24428*/    OPC_CheckChild1Type, MVT::i32,
/* 24430*/    OPC_CheckPredicate, 14, // Predicate_unindexedload
/* 24432*/    OPC_CheckPredicate, 15, // Predicate_load
/* 24434*/    OPC_SwitchType /*2 cases */, 21, MVT::i32,// ->24458
/* 24437*/     OPC_MoveParent,
/* 24438*/     OPC_CheckType, MVT::v4i32,
/* 24440*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/* 24442*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 24445*/     OPC_EmitMergeInputChains1_0,
/* 24446*/     OPC_EmitInteger, MVT::i32, 0, 
/* 24449*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (scalar_to_vector:{ *:[v4i32] } (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD_ZERO_I32x4_A32:{ *:[v4i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 24458*/    /*SwitchType*/ 21, MVT::i64,// ->24481
/* 24460*/     OPC_MoveParent,
/* 24461*/     OPC_CheckType, MVT::v2i64,
/* 24463*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/* 24465*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 24468*/     OPC_EmitMergeInputChains1_0,
/* 24469*/     OPC_EmitInteger, MVT::i32, 0, 
/* 24472*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (scalar_to_vector:{ *:[v2i64] } (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD_ZERO_I64x2_A32:{ *:[v2i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 24481*/    0, // EndSwitchType
/* 24482*/   /*Scope*/ 54, /*->24537*/
/* 24483*/    OPC_CheckChild1Type, MVT::i64,
/* 24485*/    OPC_CheckPredicate, 14, // Predicate_unindexedload
/* 24487*/    OPC_CheckPredicate, 15, // Predicate_load
/* 24489*/    OPC_SwitchType /*2 cases */, 21, MVT::i32,// ->24513
/* 24492*/     OPC_MoveParent,
/* 24493*/     OPC_CheckType, MVT::v4i32,
/* 24495*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/* 24497*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 24500*/     OPC_EmitMergeInputChains1_0,
/* 24501*/     OPC_EmitInteger, MVT::i32, 0, 
/* 24504*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (scalar_to_vector:{ *:[v4i32] } (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD_ZERO_I32x4_A64:{ *:[v4i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 24513*/    /*SwitchType*/ 21, MVT::i64,// ->24536
/* 24515*/     OPC_MoveParent,
/* 24516*/     OPC_CheckType, MVT::v2i64,
/* 24518*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/* 24520*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 24523*/     OPC_EmitMergeInputChains1_0,
/* 24524*/     OPC_EmitInteger, MVT::i32, 0, 
/* 24527*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (scalar_to_vector:{ *:[v2i64] } (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD_ZERO_I64x2_A64:{ *:[v2i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 24536*/    0, // EndSwitchType
/* 24537*/   0, /*End of Scope*/
/* 24538*/  /*Scope*/ 71, /*->24610*/
/* 24539*/   OPC_RecordChild0, // #0 = $x
/* 24540*/   OPC_Scope, 31, /*->24573*/ // 4 children in Scope
/* 24542*/    OPC_CheckChild0Type, MVT::i32,
/* 24544*/    OPC_SwitchType /*3 cases */, 7, MVT::v16i8,// ->24554
/* 24547*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SPLAT_I8x16), 0,
                   MVT::v16i8, 1/*#Ops*/, 0, 
               // Src: (scalar_to_vector:{ *:[v16i8] } I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SPLAT_I8x16:{ *:[v16i8] } ?:{ *:[i32] }:$x)
/* 24554*/    /*SwitchType*/ 7, MVT::v8i16,// ->24563
/* 24556*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SPLAT_I16x8), 0,
                   MVT::v8i16, 1/*#Ops*/, 0, 
               // Src: (scalar_to_vector:{ *:[v8i16] } I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SPLAT_I16x8:{ *:[v8i16] } ?:{ *:[i32] }:$x)
/* 24563*/    /*SwitchType*/ 7, MVT::v4i32,// ->24572
/* 24565*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SPLAT_I32x4), 0,
                   MVT::v4i32, 1/*#Ops*/, 0, 
               // Src: (scalar_to_vector:{ *:[v4i32] } I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SPLAT_I32x4:{ *:[v4i32] } ?:{ *:[i32] }:$x)
/* 24572*/    0, // EndSwitchType
/* 24573*/   /*Scope*/ 11, /*->24585*/
/* 24574*/    OPC_CheckChild0Type, MVT::i64,
/* 24576*/    OPC_CheckType, MVT::v2i64,
/* 24578*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SPLAT_I64x2), 0,
                  MVT::v2i64, 1/*#Ops*/, 0, 
              // Src: (scalar_to_vector:{ *:[v2i64] } I64:{ *:[i64] }:$x) - Complexity = 3
              // Dst: (SPLAT_I64x2:{ *:[v2i64] } ?:{ *:[i64] }:$x)
/* 24585*/   /*Scope*/ 11, /*->24597*/
/* 24586*/    OPC_CheckChild0Type, MVT::f32,
/* 24588*/    OPC_CheckType, MVT::v4f32,
/* 24590*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SPLAT_F32x4), 0,
                  MVT::v4f32, 1/*#Ops*/, 0, 
              // Src: (scalar_to_vector:{ *:[v4f32] } F32:{ *:[f32] }:$x) - Complexity = 3
              // Dst: (SPLAT_F32x4:{ *:[v4f32] } ?:{ *:[f32] }:$x)
/* 24597*/   /*Scope*/ 11, /*->24609*/
/* 24598*/    OPC_CheckChild0Type, MVT::f64,
/* 24600*/    OPC_CheckType, MVT::v2f64,
/* 24602*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SPLAT_F64x2), 0,
                  MVT::v2f64, 1/*#Ops*/, 0, 
              // Src: (scalar_to_vector:{ *:[v2f64] } F64:{ *:[f64] }:$x) - Complexity = 3
              // Dst: (SPLAT_F64x2:{ *:[v2f64] } ?:{ *:[f64] }:$x)
/* 24609*/   0, /*End of Scope*/
/* 24610*/  0, /*End of Scope*/
/* 24611*/ /*SwitchOpcode*/ 18|128,1/*146*/, TARGET_VAL(WebAssemblyISD::VEC_SHL),// ->24761
/* 24615*/  OPC_RecordChild0, // #0 = $lhs
/* 24616*/  OPC_Scope, 90, /*->24708*/ // 2 children in Scope
/* 24618*/   OPC_MoveChild1,
/* 24619*/   OPC_Scope, 26, /*->24647*/ // 5 children in Scope
/* 24621*/    OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 24624*/    OPC_MoveChild0,
/* 24625*/    OPC_CheckAndImm, 63, 
/* 24627*/    OPC_RecordChild0, // #1 = $rhs
/* 24628*/    OPC_MoveParent,
/* 24629*/    OPC_MoveParent,
/* 24630*/    OPC_CheckType, MVT::v2i64,
/* 24632*/    OPC_EmitNode1, TARGET_VAL(WebAssembly::I32_WRAP_I64), 0,
                  MVT::i32, 1/*#Ops*/, 1,  // Results = #2
/* 24639*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHL_I64x2), 0,
                  MVT::v2i64, 2/*#Ops*/, 0, 2, 
              // Src: (wasm_shl:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (trunc:{ *:[i32] } (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] }))) - Complexity = 14
              // Dst: (SHL_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (I32_WRAP_I64:{ *:[i32] } I64:{ *:[i64] }:$rhs))
/* 24647*/   /*Scope*/ 14, /*->24662*/
/* 24648*/    OPC_CheckAndImm, 7, 
/* 24650*/    OPC_RecordChild0, // #1 = $rhs
/* 24651*/    OPC_MoveParent,
/* 24652*/    OPC_CheckType, MVT::v16i8,
/* 24654*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHL_I8x16), 0,
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 7:{ *:[i32] })) - Complexity = 11
              // Dst: (SHL_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 24662*/   /*Scope*/ 14, /*->24677*/
/* 24663*/    OPC_CheckAndImm, 15, 
/* 24665*/    OPC_RecordChild0, // #1 = $rhs
/* 24666*/    OPC_MoveParent,
/* 24667*/    OPC_CheckType, MVT::v8i16,
/* 24669*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHL_I16x8), 0,
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 15:{ *:[i32] })) - Complexity = 11
              // Dst: (SHL_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 24677*/   /*Scope*/ 14, /*->24692*/
/* 24678*/    OPC_CheckAndImm, 31, 
/* 24680*/    OPC_RecordChild0, // #1 = $rhs
/* 24681*/    OPC_MoveParent,
/* 24682*/    OPC_CheckType, MVT::v4i32,
/* 24684*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHL_I32x4), 0,
                  MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (SHL_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 24692*/   /*Scope*/ 14, /*->24707*/
/* 24693*/    OPC_CheckAndImm, 63, 
/* 24695*/    OPC_RecordChild0, // #1 = $rhs
/* 24696*/    OPC_MoveParent,
/* 24697*/    OPC_CheckType, MVT::v2i64,
/* 24699*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHL_I64x2), 0,
                  MVT::v2i64, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 63:{ *:[i32] })) - Complexity = 11
              // Dst: (SHL_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 24707*/   0, /*End of Scope*/
/* 24708*/  /*Scope*/ 51, /*->24760*/
/* 24709*/   OPC_RecordChild1, // #1 = $x
/* 24710*/   OPC_SwitchType /*4 cases */, 10, MVT::v16i8,// ->24723
/* 24713*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 24715*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHL_I8x16), 0,
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHL_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x)
/* 24723*/   /*SwitchType*/ 10, MVT::v8i16,// ->24735
/* 24725*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 24727*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHL_I16x8), 0,
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHL_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x)
/* 24735*/   /*SwitchType*/ 10, MVT::v4i32,// ->24747
/* 24737*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 24739*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHL_I32x4), 0,
                  MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHL_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x)
/* 24747*/   /*SwitchType*/ 10, MVT::v2i64,// ->24759
/* 24749*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 24751*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHL_I64x2), 0,
                  MVT::v2i64, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHL_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x)
/* 24759*/   0, // EndSwitchType
/* 24760*/  0, /*End of Scope*/
/* 24761*/ /*SwitchOpcode*/ 18|128,1/*146*/, TARGET_VAL(WebAssemblyISD::VEC_SHR_S),// ->24911
/* 24765*/  OPC_RecordChild0, // #0 = $lhs
/* 24766*/  OPC_Scope, 90, /*->24858*/ // 2 children in Scope
/* 24768*/   OPC_MoveChild1,
/* 24769*/   OPC_Scope, 26, /*->24797*/ // 5 children in Scope
/* 24771*/    OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 24774*/    OPC_MoveChild0,
/* 24775*/    OPC_CheckAndImm, 63, 
/* 24777*/    OPC_RecordChild0, // #1 = $rhs
/* 24778*/    OPC_MoveParent,
/* 24779*/    OPC_MoveParent,
/* 24780*/    OPC_CheckType, MVT::v2i64,
/* 24782*/    OPC_EmitNode1, TARGET_VAL(WebAssembly::I32_WRAP_I64), 0,
                  MVT::i32, 1/*#Ops*/, 1,  // Results = #2
/* 24789*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_S_I64x2), 0,
                  MVT::v2i64, 2/*#Ops*/, 0, 2, 
              // Src: (wasm_shr_s:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (trunc:{ *:[i32] } (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] }))) - Complexity = 14
              // Dst: (SHR_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (I32_WRAP_I64:{ *:[i32] } I64:{ *:[i64] }:$rhs))
/* 24797*/   /*Scope*/ 14, /*->24812*/
/* 24798*/    OPC_CheckAndImm, 7, 
/* 24800*/    OPC_RecordChild0, // #1 = $rhs
/* 24801*/    OPC_MoveParent,
/* 24802*/    OPC_CheckType, MVT::v16i8,
/* 24804*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_S_I8x16), 0,
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 7:{ *:[i32] })) - Complexity = 11
              // Dst: (SHR_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 24812*/   /*Scope*/ 14, /*->24827*/
/* 24813*/    OPC_CheckAndImm, 15, 
/* 24815*/    OPC_RecordChild0, // #1 = $rhs
/* 24816*/    OPC_MoveParent,
/* 24817*/    OPC_CheckType, MVT::v8i16,
/* 24819*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_S_I16x8), 0,
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 15:{ *:[i32] })) - Complexity = 11
              // Dst: (SHR_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 24827*/   /*Scope*/ 14, /*->24842*/
/* 24828*/    OPC_CheckAndImm, 31, 
/* 24830*/    OPC_RecordChild0, // #1 = $rhs
/* 24831*/    OPC_MoveParent,
/* 24832*/    OPC_CheckType, MVT::v4i32,
/* 24834*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_S_I32x4), 0,
                  MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (SHR_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 24842*/   /*Scope*/ 14, /*->24857*/
/* 24843*/    OPC_CheckAndImm, 63, 
/* 24845*/    OPC_RecordChild0, // #1 = $rhs
/* 24846*/    OPC_MoveParent,
/* 24847*/    OPC_CheckType, MVT::v2i64,
/* 24849*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_S_I64x2), 0,
                  MVT::v2i64, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 63:{ *:[i32] })) - Complexity = 11
              // Dst: (SHR_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 24857*/   0, /*End of Scope*/
/* 24858*/  /*Scope*/ 51, /*->24910*/
/* 24859*/   OPC_RecordChild1, // #1 = $x
/* 24860*/   OPC_SwitchType /*4 cases */, 10, MVT::v16i8,// ->24873
/* 24863*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 24865*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_S_I8x16), 0,
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHR_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x)
/* 24873*/   /*SwitchType*/ 10, MVT::v8i16,// ->24885
/* 24875*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 24877*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_S_I16x8), 0,
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHR_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x)
/* 24885*/   /*SwitchType*/ 10, MVT::v4i32,// ->24897
/* 24887*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 24889*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_S_I32x4), 0,
                  MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHR_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x)
/* 24897*/   /*SwitchType*/ 10, MVT::v2i64,// ->24909
/* 24899*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 24901*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_S_I64x2), 0,
                  MVT::v2i64, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHR_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x)
/* 24909*/   0, // EndSwitchType
/* 24910*/  0, /*End of Scope*/
/* 24911*/ /*SwitchOpcode*/ 127|128,3/*511*/, TARGET_VAL(ISD::VSELECT),// ->25426
/* 24915*/  OPC_Scope, 103, /*->25020*/ // 4 children in Scope
/* 24917*/   OPC_MoveChild0,
/* 24918*/   OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
/* 24921*/   OPC_MoveChild0,
/* 24922*/   OPC_CheckOpcode, TARGET_VAL(ISD::BITCAST),
/* 24925*/   OPC_RecordChild0, // #0 = $rhs
/* 24926*/   OPC_SwitchType /*2 cases */, 44, MVT::v4f32,// ->24973
/* 24929*/    OPC_CheckChild0Type, MVT::v4i32,
/* 24931*/    OPC_MoveParent,
/* 24932*/    OPC_MoveChild1,
/* 24933*/    OPC_CheckOpcode, TARGET_VAL(ISD::BITCAST),
/* 24936*/    OPC_RecordChild0, // #1 = $lhs
/* 24937*/    OPC_CheckChild0Type, MVT::v4i32,
/* 24939*/    OPC_MoveParent,
/* 24940*/    OPC_CheckChild2CondCode, ISD::SETOLT,
/* 24942*/    OPC_MoveParent,
/* 24943*/    OPC_CheckType, MVT::v4i32,
/* 24945*/    OPC_Scope, 12, /*->24959*/ // 2 children in Scope
/* 24947*/     OPC_CheckChild1Same, 0,
/* 24949*/     OPC_CheckChild2Same, 1,
/* 24951*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::PMIN_F32x4), 0,
                   MVT::v4i32, 2/*#Ops*/, 1, 0, 
               // Src: (vselect:{ *:[v4i32] } (setcc:{ *:[v4i32] } (bitconvert:{ *:[v4f32] } V128:{ *:[v4i32] }:$rhs), (bitconvert:{ *:[v4f32] } V128:{ *:[v4i32] }:$lhs), SETOLT:{ *:[Other] }), V128:{ *:[v4i32] }:$rhs, V128:{ *:[v4i32] }:$lhs) - Complexity = 12
               // Dst: (PMIN_F32x4:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/* 24959*/    /*Scope*/ 12, /*->24972*/
/* 24960*/     OPC_CheckChild1Same, 1,
/* 24962*/     OPC_CheckChild2Same, 0,
/* 24964*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::PMAX_F32x4), 0,
                   MVT::v4i32, 2/*#Ops*/, 0, 1, 
               // Src: (vselect:{ *:[v4i32] } (setcc:{ *:[v4i32] } (bitconvert:{ *:[v4f32] } V128:{ *:[v4i32] }:$lhs), (bitconvert:{ *:[v4f32] } V128:{ *:[v4i32] }:$rhs), SETOLT:{ *:[Other] }), V128:{ *:[v4i32] }:$rhs, V128:{ *:[v4i32] }:$lhs) - Complexity = 12
               // Dst: (PMAX_F32x4:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/* 24972*/    0, /*End of Scope*/
/* 24973*/   /*SwitchType*/ 44, MVT::v2f64,// ->25019
/* 24975*/    OPC_CheckChild0Type, MVT::v2i64,
/* 24977*/    OPC_MoveParent,
/* 24978*/    OPC_MoveChild1,
/* 24979*/    OPC_CheckOpcode, TARGET_VAL(ISD::BITCAST),
/* 24982*/    OPC_RecordChild0, // #1 = $lhs
/* 24983*/    OPC_CheckChild0Type, MVT::v2i64,
/* 24985*/    OPC_MoveParent,
/* 24986*/    OPC_CheckChild2CondCode, ISD::SETOLT,
/* 24988*/    OPC_MoveParent,
/* 24989*/    OPC_CheckType, MVT::v2i64,
/* 24991*/    OPC_Scope, 12, /*->25005*/ // 2 children in Scope
/* 24993*/     OPC_CheckChild1Same, 0,
/* 24995*/     OPC_CheckChild2Same, 1,
/* 24997*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::PMIN_F64x2), 0,
                   MVT::v2i64, 2/*#Ops*/, 1, 0, 
               // Src: (vselect:{ *:[v2i64] } (setcc:{ *:[v2i64] } (bitconvert:{ *:[v2f64] } V128:{ *:[v2i64] }:$rhs), (bitconvert:{ *:[v2f64] } V128:{ *:[v2i64] }:$lhs), SETOLT:{ *:[Other] }), V128:{ *:[v2i64] }:$rhs, V128:{ *:[v2i64] }:$lhs) - Complexity = 12
               // Dst: (PMIN_F64x2:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/* 25005*/    /*Scope*/ 12, /*->25018*/
/* 25006*/     OPC_CheckChild1Same, 1,
/* 25008*/     OPC_CheckChild2Same, 0,
/* 25010*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::PMAX_F64x2), 0,
                   MVT::v2i64, 2/*#Ops*/, 0, 1, 
               // Src: (vselect:{ *:[v2i64] } (setcc:{ *:[v2i64] } (bitconvert:{ *:[v2f64] } V128:{ *:[v2i64] }:$lhs), (bitconvert:{ *:[v2f64] } V128:{ *:[v2i64] }:$rhs), SETOLT:{ *:[Other] }), V128:{ *:[v2i64] }:$rhs, V128:{ *:[v2i64] }:$lhs) - Complexity = 12
               // Dst: (PMAX_F64x2:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/* 25018*/    0, /*End of Scope*/
/* 25019*/   0, // EndSwitchType
/* 25020*/  /*Scope*/ 49, /*->25070*/
/* 25021*/   OPC_RecordChild0, // #0 = $c
/* 25022*/   OPC_RecordChild1, // #1 = $v1
/* 25023*/   OPC_RecordChild2, // #2 = $v2
/* 25024*/   OPC_SwitchType /*4 cases */, 9, MVT::v16i8,// ->25036
/* 25027*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                  MVT::v16i8, 3/*#Ops*/, 1, 2, 0, 
              // Src: (vselect:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2) - Complexity = 3
              // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 25036*/   /*SwitchType*/ 9, MVT::v8i16,// ->25047
/* 25038*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                  MVT::v8i16, 3/*#Ops*/, 1, 2, 0, 
              // Src: (vselect:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2) - Complexity = 3
              // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 25047*/   /*SwitchType*/ 9, MVT::v4i32,// ->25058
/* 25049*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                  MVT::v4i32, 3/*#Ops*/, 1, 2, 0, 
              // Src: (vselect:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2) - Complexity = 3
              // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 25058*/   /*SwitchType*/ 9, MVT::v2i64,// ->25069
/* 25060*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                  MVT::v2i64, 3/*#Ops*/, 1, 2, 0, 
              // Src: (vselect:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2) - Complexity = 3
              // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 25069*/   0, // EndSwitchType
/* 25070*/  /*Scope*/ 69|128,2/*325*/, /*->25397*/
/* 25072*/   OPC_MoveChild0,
/* 25073*/   OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
/* 25076*/   OPC_RecordChild0, // #0 = $rhs
/* 25077*/   OPC_Scope, 29|128,1/*157*/, /*->25237*/ // 2 children in Scope
/* 25080*/    OPC_CheckChild0Type, MVT::v4f32,
/* 25082*/    OPC_RecordChild1, // #1 = $lhs
/* 25083*/    OPC_Scope, 37, /*->25122*/ // 4 children in Scope
/* 25085*/     OPC_CheckChild2CondCode, ISD::SETOLT,
/* 25087*/     OPC_MoveParent,
/* 25088*/     OPC_CheckType, MVT::v4f32,
/* 25090*/     OPC_Scope, 14, /*->25106*/ // 2 children in Scope
/* 25092*/      OPC_CheckChild1Same, 0,
/* 25094*/      OPC_CheckChild2Same, 1,
/* 25096*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 25098*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::PMIN_F32x4), 0,
                    MVT::v4f32, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs, SETOLT:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 25106*/     /*Scope*/ 14, /*->25121*/
/* 25107*/      OPC_CheckChild1Same, 1,
/* 25109*/      OPC_CheckChild2Same, 0,
/* 25111*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 25113*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::PMAX_F32x4), 0,
                    MVT::v4f32, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOLT:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 25121*/     0, /*End of Scope*/
/* 25122*/    /*Scope*/ 37, /*->25160*/
/* 25123*/     OPC_CheckChild2CondCode, ISD::SETOLE,
/* 25125*/     OPC_MoveParent,
/* 25126*/     OPC_CheckType, MVT::v4f32,
/* 25128*/     OPC_Scope, 14, /*->25144*/ // 2 children in Scope
/* 25130*/      OPC_CheckChild1Same, 0,
/* 25132*/      OPC_CheckChild2Same, 1,
/* 25134*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 25136*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::PMIN_F32x4), 0,
                    MVT::v4f32, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs, SETOLE:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 25144*/     /*Scope*/ 14, /*->25159*/
/* 25145*/      OPC_CheckChild1Same, 1,
/* 25147*/      OPC_CheckChild2Same, 0,
/* 25149*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 25151*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::PMAX_F32x4), 0,
                    MVT::v4f32, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOLE:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 25159*/     0, /*End of Scope*/
/* 25160*/    /*Scope*/ 37, /*->25198*/
/* 25161*/     OPC_CheckChild2CondCode, ISD::SETOGT,
/* 25163*/     OPC_MoveParent,
/* 25164*/     OPC_CheckType, MVT::v4f32,
/* 25166*/     OPC_Scope, 14, /*->25182*/ // 2 children in Scope
/* 25168*/      OPC_CheckChild1Same, 1,
/* 25170*/      OPC_CheckChild2Same, 0,
/* 25172*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 25174*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::PMIN_F32x4), 0,
                    MVT::v4f32, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOGT:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 25182*/     /*Scope*/ 14, /*->25197*/
/* 25183*/      OPC_CheckChild1Same, 0,
/* 25185*/      OPC_CheckChild2Same, 1,
/* 25187*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 25189*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::PMAX_F32x4), 0,
                    MVT::v4f32, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs, SETOGT:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 25197*/     0, /*End of Scope*/
/* 25198*/    /*Scope*/ 37, /*->25236*/
/* 25199*/     OPC_CheckChild2CondCode, ISD::SETOGE,
/* 25201*/     OPC_MoveParent,
/* 25202*/     OPC_CheckType, MVT::v4f32,
/* 25204*/     OPC_Scope, 14, /*->25220*/ // 2 children in Scope
/* 25206*/      OPC_CheckChild1Same, 1,
/* 25208*/      OPC_CheckChild2Same, 0,
/* 25210*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 25212*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::PMIN_F32x4), 0,
                    MVT::v4f32, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOGE:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 25220*/     /*Scope*/ 14, /*->25235*/
/* 25221*/      OPC_CheckChild1Same, 0,
/* 25223*/      OPC_CheckChild2Same, 1,
/* 25225*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 25227*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::PMAX_F32x4), 0,
                    MVT::v4f32, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs, SETOGE:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 25235*/     0, /*End of Scope*/
/* 25236*/    0, /*End of Scope*/
/* 25237*/   /*Scope*/ 29|128,1/*157*/, /*->25396*/
/* 25239*/    OPC_CheckChild0Type, MVT::v2f64,
/* 25241*/    OPC_RecordChild1, // #1 = $lhs
/* 25242*/    OPC_Scope, 37, /*->25281*/ // 4 children in Scope
/* 25244*/     OPC_CheckChild2CondCode, ISD::SETOLT,
/* 25246*/     OPC_MoveParent,
/* 25247*/     OPC_CheckType, MVT::v2f64,
/* 25249*/     OPC_Scope, 14, /*->25265*/ // 2 children in Scope
/* 25251*/      OPC_CheckChild1Same, 0,
/* 25253*/      OPC_CheckChild2Same, 1,
/* 25255*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 25257*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::PMIN_F64x2), 0,
                    MVT::v2f64, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs, SETOLT:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 25265*/     /*Scope*/ 14, /*->25280*/
/* 25266*/      OPC_CheckChild1Same, 1,
/* 25268*/      OPC_CheckChild2Same, 0,
/* 25270*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 25272*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::PMAX_F64x2), 0,
                    MVT::v2f64, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOLT:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 25280*/     0, /*End of Scope*/
/* 25281*/    /*Scope*/ 37, /*->25319*/
/* 25282*/     OPC_CheckChild2CondCode, ISD::SETOLE,
/* 25284*/     OPC_MoveParent,
/* 25285*/     OPC_CheckType, MVT::v2f64,
/* 25287*/     OPC_Scope, 14, /*->25303*/ // 2 children in Scope
/* 25289*/      OPC_CheckChild1Same, 0,
/* 25291*/      OPC_CheckChild2Same, 1,
/* 25293*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 25295*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::PMIN_F64x2), 0,
                    MVT::v2f64, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs, SETOLE:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 25303*/     /*Scope*/ 14, /*->25318*/
/* 25304*/      OPC_CheckChild1Same, 1,
/* 25306*/      OPC_CheckChild2Same, 0,
/* 25308*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 25310*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::PMAX_F64x2), 0,
                    MVT::v2f64, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOLE:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 25318*/     0, /*End of Scope*/
/* 25319*/    /*Scope*/ 37, /*->25357*/
/* 25320*/     OPC_CheckChild2CondCode, ISD::SETOGT,
/* 25322*/     OPC_MoveParent,
/* 25323*/     OPC_CheckType, MVT::v2f64,
/* 25325*/     OPC_Scope, 14, /*->25341*/ // 2 children in Scope
/* 25327*/      OPC_CheckChild1Same, 1,
/* 25329*/      OPC_CheckChild2Same, 0,
/* 25331*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 25333*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::PMIN_F64x2), 0,
                    MVT::v2f64, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOGT:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 25341*/     /*Scope*/ 14, /*->25356*/
/* 25342*/      OPC_CheckChild1Same, 0,
/* 25344*/      OPC_CheckChild2Same, 1,
/* 25346*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 25348*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::PMAX_F64x2), 0,
                    MVT::v2f64, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs, SETOGT:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 25356*/     0, /*End of Scope*/
/* 25357*/    /*Scope*/ 37, /*->25395*/
/* 25358*/     OPC_CheckChild2CondCode, ISD::SETOGE,
/* 25360*/     OPC_MoveParent,
/* 25361*/     OPC_CheckType, MVT::v2f64,
/* 25363*/     OPC_Scope, 14, /*->25379*/ // 2 children in Scope
/* 25365*/      OPC_CheckChild1Same, 1,
/* 25367*/      OPC_CheckChild2Same, 0,
/* 25369*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 25371*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::PMIN_F64x2), 0,
                    MVT::v2f64, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOGE:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 25379*/     /*Scope*/ 14, /*->25394*/
/* 25380*/      OPC_CheckChild1Same, 0,
/* 25382*/      OPC_CheckChild2Same, 1,
/* 25384*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 25386*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::PMAX_F64x2), 0,
                    MVT::v2f64, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs, SETOGE:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 25394*/     0, /*End of Scope*/
/* 25395*/    0, /*End of Scope*/
/* 25396*/   0, /*End of Scope*/
/* 25397*/  /*Scope*/ 27, /*->25425*/
/* 25398*/   OPC_RecordChild0, // #0 = $c
/* 25399*/   OPC_RecordChild1, // #1 = $v1
/* 25400*/   OPC_RecordChild2, // #2 = $v2
/* 25401*/   OPC_SwitchType /*2 cases */, 9, MVT::v4f32,// ->25413
/* 25404*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                  MVT::v4f32, 3/*#Ops*/, 1, 2, 0, 
              // Src: (vselect:{ *:[v4f32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4f32] }:$v1, V128:{ *:[v4f32] }:$v2) - Complexity = 3
              // Dst: (BITSELECT:{ *:[v4f32] } ?:{ *:[v4f32] }:$v1, ?:{ *:[v4f32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 25413*/   /*SwitchType*/ 9, MVT::v2f64,// ->25424
/* 25415*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                  MVT::v2f64, 3/*#Ops*/, 1, 2, 0, 
              // Src: (vselect:{ *:[v2f64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2f64] }:$v1, V128:{ *:[v2f64] }:$v2) - Complexity = 3
              // Dst: (BITSELECT:{ *:[v2f64] } ?:{ *:[v2f64] }:$v1, ?:{ *:[v2f64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 25424*/   0, // EndSwitchType
/* 25425*/  0, /*End of Scope*/
/* 25426*/ /*SwitchOpcode*/ 18, TARGET_VAL(WebAssemblyISD::SWIZZLE),// ->25447
/* 25429*/  OPC_RecordChild0, // #0 = $src
/* 25430*/  OPC_CheckChild0Type, MVT::v16i8,
/* 25432*/  OPC_RecordChild1, // #1 = $mask
/* 25433*/  OPC_CheckChild1Type, MVT::v16i8,
/* 25435*/  OPC_CheckType, MVT::v16i8,
/* 25437*/  OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 25439*/  OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SWIZZLE), 0,
                MVT::v16i8, 2/*#Ops*/, 0, 1, 
            // Src: (wasm_swizzle:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, V128:{ *:[v16i8] }:$mask) - Complexity = 3
            // Dst: (SWIZZLE:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, V128:{ *:[v16i8] }:$mask)
/* 25447*/ /*SwitchOpcode*/ 47, TARGET_VAL(ISD::ABS),// ->25497
/* 25450*/  OPC_RecordChild0, // #0 = $v
/* 25451*/  OPC_SwitchType /*4 cases */, 9, MVT::v16i8,// ->25463
/* 25454*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 25456*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ABS_I8x16), 0,
                 MVT::v16i8, 1/*#Ops*/, 0, 
             // Src: (abs:{ *:[v16i8] } V128:{ *:[v16i8] }:$v) - Complexity = 3
             // Dst: (ABS_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$v)
/* 25463*/  /*SwitchType*/ 9, MVT::v8i16,// ->25474
/* 25465*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 25467*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ABS_I16x8), 0,
                 MVT::v8i16, 1/*#Ops*/, 0, 
             // Src: (abs:{ *:[v8i16] } V128:{ *:[v8i16] }:$v) - Complexity = 3
             // Dst: (ABS_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$v)
/* 25474*/  /*SwitchType*/ 9, MVT::v4i32,// ->25485
/* 25476*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 25478*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ABS_I32x4), 0,
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (abs:{ *:[v4i32] } V128:{ *:[v4i32] }:$v) - Complexity = 3
             // Dst: (ABS_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$v)
/* 25485*/  /*SwitchType*/ 9, MVT::v2i64,// ->25496
/* 25487*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 25489*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ABS_I64x2), 0,
                 MVT::v2i64, 1/*#Ops*/, 0, 
             // Src: (abs:{ *:[v2i64] } V128:{ *:[v2i64] }:$v) - Complexity = 3
             // Dst: (ABS_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$v)
/* 25496*/  0, // EndSwitchType
/* 25497*/ /*SwitchOpcode*/ 28, TARGET_VAL(ISD::SADDSAT),// ->25528
/* 25500*/  OPC_RecordChild0, // #0 = $lhs
/* 25501*/  OPC_RecordChild1, // #1 = $rhs
/* 25502*/  OPC_SwitchType /*2 cases */, 10, MVT::v16i8,// ->25515
/* 25505*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 25507*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADD_SAT_S_I8x16), 0,
                 MVT::v16i8, 2/*#Ops*/, 0, 1, 
             // Src: (saddsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (ADD_SAT_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 25515*/  /*SwitchType*/ 10, MVT::v8i16,// ->25527
/* 25517*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 25519*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADD_SAT_S_I16x8), 0,
                 MVT::v8i16, 2/*#Ops*/, 0, 1, 
             // Src: (saddsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (ADD_SAT_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 25527*/  0, // EndSwitchType
/* 25528*/ /*SwitchOpcode*/ 28, TARGET_VAL(ISD::UADDSAT),// ->25559
/* 25531*/  OPC_RecordChild0, // #0 = $lhs
/* 25532*/  OPC_RecordChild1, // #1 = $rhs
/* 25533*/  OPC_SwitchType /*2 cases */, 10, MVT::v16i8,// ->25546
/* 25536*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 25538*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADD_SAT_U_I8x16), 0,
                 MVT::v16i8, 2/*#Ops*/, 0, 1, 
             // Src: (uaddsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (ADD_SAT_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 25546*/  /*SwitchType*/ 10, MVT::v8i16,// ->25558
/* 25548*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 25550*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADD_SAT_U_I16x8), 0,
                 MVT::v8i16, 2/*#Ops*/, 0, 1, 
             // Src: (uaddsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (ADD_SAT_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 25558*/  0, // EndSwitchType
/* 25559*/ /*SwitchOpcode*/ 40, TARGET_VAL(ISD::SMIN),// ->25602
/* 25562*/  OPC_RecordChild0, // #0 = $lhs
/* 25563*/  OPC_RecordChild1, // #1 = $rhs
/* 25564*/  OPC_SwitchType /*3 cases */, 10, MVT::v16i8,// ->25577
/* 25567*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 25569*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MIN_S_I8x16), 0,
                 MVT::v16i8, 2/*#Ops*/, 0, 1, 
             // Src: (smin:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (MIN_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 25577*/  /*SwitchType*/ 10, MVT::v8i16,// ->25589
/* 25579*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 25581*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MIN_S_I16x8), 0,
                 MVT::v8i16, 2/*#Ops*/, 0, 1, 
             // Src: (smin:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (MIN_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 25589*/  /*SwitchType*/ 10, MVT::v4i32,// ->25601
/* 25591*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 25593*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MIN_S_I32x4), 0,
                 MVT::v4i32, 2/*#Ops*/, 0, 1, 
             // Src: (smin:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
             // Dst: (MIN_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 25601*/  0, // EndSwitchType
/* 25602*/ /*SwitchOpcode*/ 40, TARGET_VAL(ISD::UMIN),// ->25645
/* 25605*/  OPC_RecordChild0, // #0 = $lhs
/* 25606*/  OPC_RecordChild1, // #1 = $rhs
/* 25607*/  OPC_SwitchType /*3 cases */, 10, MVT::v16i8,// ->25620
/* 25610*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 25612*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MIN_U_I8x16), 0,
                 MVT::v16i8, 2/*#Ops*/, 0, 1, 
             // Src: (umin:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (MIN_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 25620*/  /*SwitchType*/ 10, MVT::v8i16,// ->25632
/* 25622*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 25624*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MIN_U_I16x8), 0,
                 MVT::v8i16, 2/*#Ops*/, 0, 1, 
             // Src: (umin:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (MIN_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 25632*/  /*SwitchType*/ 10, MVT::v4i32,// ->25644
/* 25634*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 25636*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MIN_U_I32x4), 0,
                 MVT::v4i32, 2/*#Ops*/, 0, 1, 
             // Src: (umin:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
             // Dst: (MIN_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 25644*/  0, // EndSwitchType
/* 25645*/ /*SwitchOpcode*/ 40, TARGET_VAL(ISD::SMAX),// ->25688
/* 25648*/  OPC_RecordChild0, // #0 = $lhs
/* 25649*/  OPC_RecordChild1, // #1 = $rhs
/* 25650*/  OPC_SwitchType /*3 cases */, 10, MVT::v16i8,// ->25663
/* 25653*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 25655*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MAX_S_I8x16), 0,
                 MVT::v16i8, 2/*#Ops*/, 0, 1, 
             // Src: (smax:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (MAX_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 25663*/  /*SwitchType*/ 10, MVT::v8i16,// ->25675
/* 25665*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 25667*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MAX_S_I16x8), 0,
                 MVT::v8i16, 2/*#Ops*/, 0, 1, 
             // Src: (smax:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (MAX_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 25675*/  /*SwitchType*/ 10, MVT::v4i32,// ->25687
/* 25677*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 25679*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MAX_S_I32x4), 0,
                 MVT::v4i32, 2/*#Ops*/, 0, 1, 
             // Src: (smax:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
             // Dst: (MAX_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 25687*/  0, // EndSwitchType
/* 25688*/ /*SwitchOpcode*/ 40, TARGET_VAL(ISD::UMAX),// ->25731
/* 25691*/  OPC_RecordChild0, // #0 = $lhs
/* 25692*/  OPC_RecordChild1, // #1 = $rhs
/* 25693*/  OPC_SwitchType /*3 cases */, 10, MVT::v16i8,// ->25706
/* 25696*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 25698*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MAX_U_I8x16), 0,
                 MVT::v16i8, 2/*#Ops*/, 0, 1, 
             // Src: (umax:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (MAX_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 25706*/  /*SwitchType*/ 10, MVT::v8i16,// ->25718
/* 25708*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 25710*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MAX_U_I16x8), 0,
                 MVT::v8i16, 2/*#Ops*/, 0, 1, 
             // Src: (umax:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (MAX_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 25718*/  /*SwitchType*/ 10, MVT::v4i32,// ->25730
/* 25720*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 25722*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MAX_U_I32x4), 0,
                 MVT::v4i32, 2/*#Ops*/, 0, 1, 
             // Src: (umax:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
             // Dst: (MAX_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 25730*/  0, // EndSwitchType
/* 25731*/ /*SwitchOpcode*/ 14, TARGET_VAL(WebAssemblyISD::TRUNC_SAT_ZERO_S),// ->25748
/* 25734*/  OPC_RecordChild0, // #0 = $vec
/* 25735*/  OPC_CheckChild0Type, MVT::v2f64,
/* 25737*/  OPC_CheckType, MVT::v4i32,
/* 25739*/  OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 25741*/  OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::trunc_sat_zero_s_I32x4), 0,
                MVT::v4i32, 1/*#Ops*/, 0, 
            // Src: (trunc_sat_zero_s:{ *:[v4i32] } V128:{ *:[v2f64] }:$vec) - Complexity = 3
            // Dst: (trunc_sat_zero_s_I32x4:{ *:[v4i32] } V128:{ *:[v2f64] }:$vec)
/* 25748*/ /*SwitchOpcode*/ 14, TARGET_VAL(WebAssemblyISD::TRUNC_SAT_ZERO_U),// ->25765
/* 25751*/  OPC_RecordChild0, // #0 = $vec
/* 25752*/  OPC_CheckChild0Type, MVT::v2f64,
/* 25754*/  OPC_CheckType, MVT::v4i32,
/* 25756*/  OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 25758*/  OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::trunc_sat_zero_u_I32x4), 0,
                MVT::v4i32, 1/*#Ops*/, 0, 
            // Src: (trunc_sat_zero_u:{ *:[v4i32] } V128:{ *:[v2f64] }:$vec) - Complexity = 3
            // Dst: (trunc_sat_zero_u_I32x4:{ *:[v4i32] } V128:{ *:[v2f64] }:$vec)
/* 25765*/ /*SwitchOpcode*/ 42, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_S),// ->25810
/* 25768*/  OPC_RecordChild0, // #0 = $vec
/* 25769*/  OPC_SwitchType /*3 cases */, 11, MVT::v8i16,// ->25783
/* 25772*/   OPC_CheckChild0Type, MVT::v16i8,
/* 25774*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 25776*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::extend_low_s_I16x8), 0,
                 MVT::v8i16, 1/*#Ops*/, 0, 
             // Src: (extend_low_s:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec) - Complexity = 3
             // Dst: (extend_low_s_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec)
/* 25783*/  /*SwitchType*/ 11, MVT::v4i32,// ->25796
/* 25785*/   OPC_CheckChild0Type, MVT::v8i16,
/* 25787*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 25789*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::extend_low_s_I32x4), 0,
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (extend_low_s:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec) - Complexity = 3
             // Dst: (extend_low_s_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec)
/* 25796*/  /*SwitchType*/ 11, MVT::v2i64,// ->25809
/* 25798*/   OPC_CheckChild0Type, MVT::v4i32,
/* 25800*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 25802*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::extend_low_s_I64x2), 0,
                 MVT::v2i64, 1/*#Ops*/, 0, 
             // Src: (extend_low_s:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
             // Dst: (extend_low_s_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec)
/* 25809*/  0, // EndSwitchType
/* 25810*/ /*SwitchOpcode*/ 42, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_S),// ->25855
/* 25813*/  OPC_RecordChild0, // #0 = $vec
/* 25814*/  OPC_SwitchType /*3 cases */, 11, MVT::v8i16,// ->25828
/* 25817*/   OPC_CheckChild0Type, MVT::v16i8,
/* 25819*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 25821*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::extend_high_s_I16x8), 0,
                 MVT::v8i16, 1/*#Ops*/, 0, 
             // Src: (extend_high_s:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec) - Complexity = 3
             // Dst: (extend_high_s_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec)
/* 25828*/  /*SwitchType*/ 11, MVT::v4i32,// ->25841
/* 25830*/   OPC_CheckChild0Type, MVT::v8i16,
/* 25832*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 25834*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::extend_high_s_I32x4), 0,
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (extend_high_s:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec) - Complexity = 3
             // Dst: (extend_high_s_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec)
/* 25841*/  /*SwitchType*/ 11, MVT::v2i64,// ->25854
/* 25843*/   OPC_CheckChild0Type, MVT::v4i32,
/* 25845*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 25847*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::extend_high_s_I64x2), 0,
                 MVT::v2i64, 1/*#Ops*/, 0, 
             // Src: (extend_high_s:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
             // Dst: (extend_high_s_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec)
/* 25854*/  0, // EndSwitchType
/* 25855*/ /*SwitchOpcode*/ 42, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_U),// ->25900
/* 25858*/  OPC_RecordChild0, // #0 = $vec
/* 25859*/  OPC_SwitchType /*3 cases */, 11, MVT::v8i16,// ->25873
/* 25862*/   OPC_CheckChild0Type, MVT::v16i8,
/* 25864*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 25866*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::extend_low_u_I16x8), 0,
                 MVT::v8i16, 1/*#Ops*/, 0, 
             // Src: (extend_low_u:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec) - Complexity = 3
             // Dst: (extend_low_u_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec)
/* 25873*/  /*SwitchType*/ 11, MVT::v4i32,// ->25886
/* 25875*/   OPC_CheckChild0Type, MVT::v8i16,
/* 25877*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 25879*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::extend_low_u_I32x4), 0,
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (extend_low_u:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec) - Complexity = 3
             // Dst: (extend_low_u_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec)
/* 25886*/  /*SwitchType*/ 11, MVT::v2i64,// ->25899
/* 25888*/   OPC_CheckChild0Type, MVT::v4i32,
/* 25890*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 25892*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::extend_low_u_I64x2), 0,
                 MVT::v2i64, 1/*#Ops*/, 0, 
             // Src: (extend_low_u:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
             // Dst: (extend_low_u_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec)
/* 25899*/  0, // EndSwitchType
/* 25900*/ /*SwitchOpcode*/ 42, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_U),// ->25945
/* 25903*/  OPC_RecordChild0, // #0 = $vec
/* 25904*/  OPC_SwitchType /*3 cases */, 11, MVT::v8i16,// ->25918
/* 25907*/   OPC_CheckChild0Type, MVT::v16i8,
/* 25909*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 25911*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::extend_high_u_I16x8), 0,
                 MVT::v8i16, 1/*#Ops*/, 0, 
             // Src: (extend_high_u:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec) - Complexity = 3
             // Dst: (extend_high_u_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec)
/* 25918*/  /*SwitchType*/ 11, MVT::v4i32,// ->25931
/* 25920*/   OPC_CheckChild0Type, MVT::v8i16,
/* 25922*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 25924*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::extend_high_u_I32x4), 0,
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (extend_high_u:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec) - Complexity = 3
             // Dst: (extend_high_u_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec)
/* 25931*/  /*SwitchType*/ 11, MVT::v2i64,// ->25944
/* 25933*/   OPC_CheckChild0Type, MVT::v4i32,
/* 25935*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 25937*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::extend_high_u_I64x2), 0,
                 MVT::v2i64, 1/*#Ops*/, 0, 
             // Src: (extend_high_u:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
             // Dst: (extend_high_u_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec)
/* 25944*/  0, // EndSwitchType
/* 25945*/ /*SwitchOpcode*/ 33, TARGET_VAL(WebAssemblyISD::NARROW_U),// ->25981
/* 25948*/  OPC_RecordChild0, // #0 = $left
/* 25949*/  OPC_SwitchType /*2 cases */, 13, MVT::v16i8,// ->25965
/* 25952*/   OPC_CheckChild0Type, MVT::v8i16,
/* 25954*/   OPC_RecordChild1, // #1 = $right
/* 25955*/   OPC_CheckChild1Type, MVT::v8i16,
/* 25957*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NARROW_U_I8x16), 0,
                 MVT::v16i8, 2/*#Ops*/, 0, 1, 
             // Src: (wasm_narrow_u:{ *:[v16i8] } V128:{ *:[v8i16] }:$left, V128:{ *:[v8i16] }:$right) - Complexity = 3
             // Dst: (NARROW_U_I8x16:{ *:[v16i8] } ?:{ *:[v8i16] }:$left, ?:{ *:[v8i16] }:$right)
/* 25965*/  /*SwitchType*/ 13, MVT::v8i16,// ->25980
/* 25967*/   OPC_CheckChild0Type, MVT::v4i32,
/* 25969*/   OPC_RecordChild1, // #1 = $right
/* 25970*/   OPC_CheckChild1Type, MVT::v4i32,
/* 25972*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NARROW_U_I16x8), 0,
                 MVT::v8i16, 2/*#Ops*/, 0, 1, 
             // Src: (wasm_narrow_u:{ *:[v8i16] } V128:{ *:[v4i32] }:$left, V128:{ *:[v4i32] }:$right) - Complexity = 3
             // Dst: (NARROW_U_I16x8:{ *:[v8i16] } ?:{ *:[v4i32] }:$left, ?:{ *:[v4i32] }:$right)
/* 25980*/  0, // EndSwitchType
/* 25981*/ /*SwitchOpcode*/ 14, TARGET_VAL(WebAssemblyISD::CONVERT_LOW_S),// ->25998
/* 25984*/  OPC_RecordChild0, // #0 = $vec
/* 25985*/  OPC_CheckChild0Type, MVT::v4i32,
/* 25987*/  OPC_CheckType, MVT::v2f64,
/* 25989*/  OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 25991*/  OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::convert_low_s_F64x2), 0,
                MVT::v2f64, 1/*#Ops*/, 0, 
            // Src: (convert_low_s:{ *:[v2f64] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
            // Dst: (convert_low_s_F64x2:{ *:[v2f64] } V128:{ *:[v4i32] }:$vec)
/* 25998*/ /*SwitchOpcode*/ 14, TARGET_VAL(WebAssemblyISD::CONVERT_LOW_U),// ->26015
/* 26001*/  OPC_RecordChild0, // #0 = $vec
/* 26002*/  OPC_CheckChild0Type, MVT::v4i32,
/* 26004*/  OPC_CheckType, MVT::v2f64,
/* 26006*/  OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 26008*/  OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::convert_low_u_F64x2), 0,
                MVT::v2f64, 1/*#Ops*/, 0, 
            // Src: (convert_low_u:{ *:[v2f64] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
            // Dst: (convert_low_u_F64x2:{ *:[v2f64] } V128:{ *:[v4i32] }:$vec)
/* 26015*/ /*SwitchOpcode*/ 14, TARGET_VAL(WebAssemblyISD::DEMOTE_ZERO),// ->26032
/* 26018*/  OPC_RecordChild0, // #0 = $vec
/* 26019*/  OPC_CheckChild0Type, MVT::v2f64,
/* 26021*/  OPC_CheckType, MVT::v4f32,
/* 26023*/  OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 26025*/  OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::demote_zero_F32x4), 0,
                MVT::v4f32, 1/*#Ops*/, 0, 
            // Src: (demote_zero:{ *:[v4f32] } V128:{ *:[v2f64] }:$vec) - Complexity = 3
            // Dst: (demote_zero_F32x4:{ *:[v4f32] } V128:{ *:[v2f64] }:$vec)
/* 26032*/ /*SwitchOpcode*/ 14, TARGET_VAL(WebAssemblyISD::PROMOTE_LOW),// ->26049
/* 26035*/  OPC_RecordChild0, // #0 = $vec
/* 26036*/  OPC_CheckChild0Type, MVT::v4f32,
/* 26038*/  OPC_CheckType, MVT::v2f64,
/* 26040*/  OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 26042*/  OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::promote_low_F64x2), 0,
                MVT::v2f64, 1/*#Ops*/, 0, 
            // Src: (promote_low:{ *:[v2f64] } V128:{ *:[v4f32] }:$vec) - Complexity = 3
            // Dst: (promote_low_F64x2:{ *:[v2f64] } V128:{ *:[v4f32] }:$vec)
/* 26049*/ 0, // EndSwitchOpcode
    0
  }; // Total Array size is 26051 bytes

  // Opcode Histogram:
  // #OPC_Scope                                = 331
  // #OPC_RecordNode                           = 185
  // #OPC_RecordChild                          = 807
  // #OPC_RecordMemRef                         = 39
  // #OPC_CaptureGlueInput                     = 1
  // #OPC_MoveChild                            = 566
  // #OPC_MoveParent                           = 846
  // #OPC_CheckSame                            = 0
  // #OPC_CheckChildSame                       = 127
  // #OPC_CheckPatternPredicate                = 661
  // #OPC_CheckPredicate                       = 531
  // #OPC_CheckOpcode                          = 490
  // #OPC_SwitchOpcode                         = 15
  // #OPC_CheckType                            = 517
  // #OPC_SwitchType                           = 178
  // #OPC_CheckChildType                       = 431
  // #OPC_CheckInteger                         = 0
  // #OPC_CheckChildInteger                    = 97
  // #OPC_CheckCondCode                        = 0
  // #OPC_CheckChild2CondCode                  = 142
  // #OPC_CheckValueType                       = 15
  // #OPC_CheckComplexPat                      = 318
  // #OPC_CheckAndImm                          = 27
  // #OPC_CheckOrImm                           = 0
  // #OPC_CheckImmAllOnesV                     = 44
  // #OPC_CheckImmAllZerosV                    = 1
  // #OPC_CheckFoldableChainNode               = 5
  // #OPC_EmitInteger                          = 345
  // #OPC_EmitStringInteger                    = 0
  // #OPC_EmitRegister                         = 0
  // #OPC_EmitConvertToTarget                  = 310
  // #OPC_EmitMergeInputChains                 = 414
  // #OPC_EmitCopyToReg                        = 0
  // #OPC_EmitNode                             = 9
  // #OPC_EmitNodeXForm                        = 0
  // #OPC_CompleteMatch                        = 32
  // #OPC_MorphNodeTo                          = 1149

  #undef TARGET_VAL
  SelectCodeCommon(N, MatcherTable,sizeof(MatcherTable));
}
#endif // GET_DAGISEL_BODY

#ifdef GET_DAGISEL_DECL
bool CheckPatternPredicate(unsigned PredNo) const override;
#endif
#if defined(GET_DAGISEL_BODY) || DAGISEL_INLINE
bool DAGISEL_CLASS_COLONCOLON CheckPatternPredicate(unsigned PredNo) const
#if DAGISEL_INLINE
  override
#endif
{
  switch (PredNo) {
  default: llvm_unreachable("Invalid predicate in table?");
  case 0: return (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics());
  case 1: return (Subtarget->hasAddr64()) && (Subtarget->hasAtomics());
  case 2: return (!Subtarget->hasAddr64());
  case 3: return (Subtarget->hasAddr64());
  case 4: return (Subtarget->hasReferenceTypes());
  case 5: return (Subtarget->hasExceptionHandling());
  case 6: return (Subtarget->hasSIMD128());
  case 7: return (Subtarget->hasSignExt());
  case 8: return (Subtarget->hasBulkMemory());
  case 9: return (Subtarget->hasRelaxedSIMD());
  case 10: return (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent());
  case 11: return (!Subtarget->hasAddr64()) && (TM.isPositionIndependent());
  case 12: return (Subtarget->hasAddr64()) && (!TM.isPositionIndependent());
  case 13: return (Subtarget->hasAddr64()) && (TM.isPositionIndependent());
  case 14: return (Subtarget->hasNontrappingFPToInt());
  case 15: return (!Subtarget->hasNontrappingFPToInt());
  }
}
#endif // GET_DAGISEL_BODY

#ifdef GET_DAGISEL_DECL
bool CheckNodePredicate(SDNode *Node, unsigned PredNo) const override;
#endif
#if defined(GET_DAGISEL_BODY) || DAGISEL_INLINE
bool DAGISEL_CLASS_COLONCOLON CheckNodePredicate(SDNode *Node, unsigned PredNo) const
#if DAGISEL_INLINE
  override
#endif
{
  switch (PredNo) {
  default: llvm_unreachable("Invalid predicate in table?");
  case 0: {
    // Predicate_atomic_cmp_swap_8
    // Predicate_atomic_load_add_8
    // Predicate_atomic_load_sub_8
    // Predicate_atomic_load_and_8
    // Predicate_atomic_load_or_8
    // Predicate_atomic_load_xor_8
    // Predicate_atomic_swap_8
    // Predicate_atomic_load_8
    // Predicate_atomic_store_8
    // Predicate_sextloadi8
    // Predicate_zextloadi8
    // Predicate_extloadi8
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i8) return false;
return true;

  }
  case 1: {
    // Predicate_atomic_cmp_swap_16
    // Predicate_atomic_load_add_16
    // Predicate_atomic_load_sub_16
    // Predicate_atomic_load_and_16
    // Predicate_atomic_load_or_16
    // Predicate_atomic_load_xor_16
    // Predicate_atomic_swap_16
    // Predicate_atomic_load_16
    // Predicate_atomic_store_16
    // Predicate_sextloadi16
    // Predicate_zextloadi16
    // Predicate_extloadi16
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i16) return false;
return true;

  }
  case 2: {
    // Predicate_atomic_cmp_swap_32
    // Predicate_atomic_load_add_32
    // Predicate_atomic_load_sub_32
    // Predicate_atomic_load_and_32
    // Predicate_atomic_load_or_32
    // Predicate_atomic_load_xor_32
    // Predicate_atomic_swap_32
    // Predicate_atomic_load_32
    // Predicate_atomic_store_32
    // Predicate_sextloadi32
    // Predicate_zextloadi32
    // Predicate_extloadi32
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i32) return false;
return true;

  }
  case 3: {
    // Predicate_LaneIdx16
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return 0 <= Imm && Imm < 16;
  }
  case 4: {
    // Predicate_unindexedstore
    SDNode *N = Node;
    (void)N;
if (cast<StoreSDNode>(N)->getAddressingMode() != ISD::UNINDEXED) return false;
return true;

  }
  case 5: {
    // Predicate_truncstore
    SDNode *N = Node;
    (void)N;
 if (!cast<StoreSDNode>(N)->isTruncatingStore()) return false;
return true;

  }
  case 6: {
    // Predicate_truncstorei8
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i8) return false;
 if (!cast<StoreSDNode>(N)->isTruncatingStore()) return false;
return true;

  }
  case 7: {
    // Predicate_LaneIdx8
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return 0 <= Imm && Imm < 8;
  }
  case 8: {
    // Predicate_truncstorei16
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i16) return false;
 if (!cast<StoreSDNode>(N)->isTruncatingStore()) return false;
return true;

  }
  case 9: {
    // Predicate_LaneIdx4
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return 0 <= Imm && Imm < 4;
  }
  case 10: {
    // Predicate_store
    SDNode *N = Node;
    (void)N;
 if (cast<StoreSDNode>(N)->isTruncatingStore()) return false;
return true;

  }
  case 11: {
    // Predicate_LaneIdx2
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return 0 <= Imm && Imm < 2;
  }
  case 12: {
    // Predicate_truncstorei32
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i32) return false;
 if (!cast<StoreSDNode>(N)->isTruncatingStore()) return false;
return true;

  }
  case 13: {
    // Predicate_atomic_store_64
    // Predicate_atomic_load_64
    // Predicate_atomic_load_add_64
    // Predicate_atomic_load_sub_64
    // Predicate_atomic_load_and_64
    // Predicate_atomic_load_or_64
    // Predicate_atomic_load_xor_64
    // Predicate_atomic_swap_64
    // Predicate_atomic_cmp_swap_64
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i64) return false;
return true;

  }
  case 14: {
    // Predicate_unindexedload
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getAddressingMode() != ISD::UNINDEXED) return false;
return true;

  }
  case 15: {
    // Predicate_load
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getExtensionType() != ISD::NON_EXTLOAD) return false;
return true;

  }
  case 16: {
    // Predicate_sextload
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getExtensionType() != ISD::SEXTLOAD) return false;
return true;

  }
  case 17: {
    // Predicate_zextload
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getExtensionType() != ISD::ZEXTLOAD) return false;
return true;

  }
  case 18: {
    // Predicate_extload
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getExtensionType() != ISD::EXTLOAD) return false;
return true;

  }
  case 19: {
    // Predicate_sextloadvi8
    // Predicate_zextloadvi8
    // Predicate_extloadvi8
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getMemoryVT().getScalarType() != MVT::i8) return false;
return true;

  }
  case 20: {
    // Predicate_sextloadvi16
    // Predicate_zextloadvi16
    // Predicate_extloadvi16
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getMemoryVT().getScalarType() != MVT::i16) return false;
return true;

  }
  case 21: {
    // Predicate_sextloadvi32
    // Predicate_zextloadvi32
    // Predicate_extloadvi32
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getMemoryVT().getScalarType() != MVT::i32) return false;
return true;

  }
  case 22: {
    // Predicate_bool_node
    SDNode *N = Node;
    (void)N;

  return CurDAG->computeKnownBits(SDValue(N, 0)).countMinLeadingZeros() == 31;

  }
  case 23: {
    // Predicate_ImmI8
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return -(1 << (8 - 1)) <= Imm && Imm < (1 << (8 - 1));
  }
  case 24: {
    // Predicate_ImmI16
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return -(1 << (16 - 1)) <= Imm && Imm < (1 << (16 - 1));
  }
  case 25: {
    // Predicate_LaneIdx32
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return 0 <= Imm && Imm < 32;
  }
  case 26: {
    // Predicate_add_nuw
    SDNode *N = Node;
    (void)N;
return N->getFlags().hasNoUnsignedWrap();
  }
  }
}
#endif // GET_DAGISEL_BODY

#ifdef GET_DAGISEL_DECL
bool CheckComplexPattern(SDNode *Root, SDNode *Parent,
      SDValue N, unsigned PatternNo,
      SmallVectorImpl<std::pair<SDValue, SDNode *>> &Result) override;
#endif
#if defined(GET_DAGISEL_BODY) || DAGISEL_INLINE
bool DAGISEL_CLASS_COLONCOLON CheckComplexPattern(SDNode *Root, SDNode *Parent,
      SDValue N, unsigned PatternNo,
      SmallVectorImpl<std::pair<SDValue, SDNode *>> &Result)
#if DAGISEL_INLINE
  override
#endif
{
  unsigned NextRes = Result.size();
  switch (PatternNo) {
  default: llvm_unreachable("Invalid pattern # in table?");
  case 0:
    Result.resize(NextRes+2);
  return SelectAddrOperands32(N, Result[NextRes+0].first, Result[NextRes+1].first);
  case 1:
    Result.resize(NextRes+2);
  return SelectAddrOperands64(N, Result[NextRes+0].first, Result[NextRes+1].first);
  }
}
#endif // GET_DAGISEL_BODY


#ifdef DAGISEL_INLINE
#undef DAGISEL_INLINE
#endif
#ifdef DAGISEL_CLASS_COLONCOLON
#undef DAGISEL_CLASS_COLONCOLON
#endif
#ifdef GET_DAGISEL_DECL
#undef GET_DAGISEL_DECL
#endif
#ifdef GET_DAGISEL_BODY
#undef GET_DAGISEL_BODY
#endif
